% File: Ch1_CaseStudy.m 
% Generates the data for Table 1.5 and plots the graphs in Figures 1.14 - 1.16
 

clear
clc
close all

Pop=[3 3.2276 4.5759 6.9570 8.7618 9.1536 11.2669 14.5153 16.5059 17.9563 19.5078];

Pm=25;
P0=3;
c=0.00125;

dt=1;
P(1)=P0;
x(1)=100;
for n=1:130
   P(n+1)=(1+c*dt*(Pm-P(n)))*P(n); 
end % n
P(50);P(51);P(52); % PA(49), PA(50), PA(51)

PP=P(1:10:131);

tt=0:10:100;
ttt=0:10:130;
plot(tt,Pop,'.r','MarkerSize',10)
grid on
hold on
figure(1) % Figure 1.14
plot(ttt,PP,'sk','MarkerSize',5,'MarkerFaceColor','k')
t=linspace(0,130,200);
num=Pm*P0;
den=P0+(Pm-P0)*exp(-c*Pm.*t);
P_anal=num./den;
plot(t,P_anal,'b','LineWidth',1.3)
xlabel('t  (year number)','FontSize',13)
ylabel('Population  (millions)','FontSize',13)
set(gca,'FontSize',11)
set(gca,'YTick',[0:2.5:25])
text(80,10,'P_{obs}(t)','FontSize',12)
plot(75,10,'r.','MarkerSize',12)
text(80,7.5,'P_A(n), n = 0,10,20,...,130','FontSize',12)
plot(75,7.5,'sk','MarkerFaceColor','k','MarkerSize',5)
text(80,5.3,'P(t)','FontSize',12)
plot([73 77],[5.3 5.3],'b','LineWidth',1.3)
text(80,2,'T = 1 year','FontSize',12)
title('Population vs. Time','FontSize',11)
T=0:10:130;
den=P0+(Pm-P0)*exp(-c*Pm.*T);
PP_anal=num./den;

figure(2) % Figure 1.15
Pi=linspace(0,50,200);
gPi=c*(Pm-Pi);
plot(Pi,gPi,'b','LineWidth',1.3)
grid on
hold on
plot([0 50],[0 0],'k',[25 25],[-0.04 0],'k--')
axis([0 50 -0.04 0.04])
xlabel(' P (millions)','FontSize',12)
ylabel ('g(P),  millions of individuals per year per individual','FontSize',12)
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:50])
title('Population Growth Rate vs Population','FontSize',11)
Pmin=3;
Pmax=P(131);
gPmin=c*(Pm-Pmin);
gPmax=c*(Pm-Pmax);
plot([Pmin Pmax],[gPmin gPmax],'k','LineWidth',1.3)
gP0=c*(Pm-P0);
plot(P0,gP0,'.r','MarkerSize',15)
gP130=c*(Pm-P(130));
plot(P(130),gP130,'.r','MarkerSize',15)
text(4.2,0.03,'g[P(0)]','FontSize',12)
text(23.2,0.0055,'g[P(130)]','FontSize',12)
text(11.5,-0.035,'P_m = 25 million','FontSize',12)

figure(3) % Figure 1.16
clear t P_anal
hold on
tf=180;
t=linspace(0,tf,1000);
for i=0:10 
  P0=5*i;
  num=Pm*P0;
  den=P0+(Pm-P0)*exp(-c*Pm.*t);
  P_anal=num./den;
  plot(t,P_anal,'LineWidth',1.3)
  axis([0 tf -1 2*Pm+1])
end 
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:5:50])
xlabel('t  (Year number)','FontSize',13)
ylabel('Population  (millions)','FontSize',13)
title('Logistic Growth for Initial Populations P(0) from 0 to 50 million','FontSize',11)
text(60,46,'Carrying Capacity: P_m = 25 million','FontSize',13)
text(60,2,'P(0) = 0','FontSize',13)
text(50,11.5,'P(0) = 5 million','FontSize',13)
text(21,36.5,'P(0) = 50 million','FontSize',13)


