% File name: Ch1_Ex1_1.m
% Computes the numerical values for Table 1.1
% and generates the graph in Figure 1.10

clc; close all; clear all;

T=0.25;
H0=4;
t(1)=0;
H(1)=H0;
HA(1)=H0;
A=10; R=2; F=5;
fact=1-(T/(A*R));
tau=A*R;
tfinal=5*tau;
ifinal=round(tfinal/T);

for i=1:ifinal-1
    HA(i+1)=fact*HA(i)+(T/A)*F;
    t(i+1)=i*T;
end % i

ti=linspace(0,tfinal,1000);
Hi=R*F+(H0-R*F)*exp(-ti/tau);
del=ifinal/50;
plot(t(1:del:end),HA(1:del:end),'r.','MarkerSize',10)
grid on
axis([0 100 0 11])
hold on
plot(ti,Hi,'k','LineWidth',1.3)
set(gca,'YTick',[0:11])
set(gca,'XTick',[0:10:100])
set(gca,'FontSize',11)
xlabel('t  (min)','FontSize',13)
ylabel('H  (ft)','FontSize',13)
text(60,2.22,'T = 0.25 min','FontSize',13)
title('Approximate and Exact Tank Level vs. Time','FontSize',11)


text(20,5.4,'H_A(n), n = 0,8,16,..','FontSize',13)
plot([16],[5.2],'r.','MarkerSize',10)
text(20,4.30,'H(t), t \geq 0','FontSize',13)
plot([15 17],[4.2 4.2],'b','LineWidth',1.3)




