% Ch1_Fig1_12.m
% Solves Equation 1.61 and plots Figure 1.12

clc; close all; clear all;

subplot(2,1,1)
n=0:6;
u=[25*ones(1,7)];
plot(n,u,'.k','MarkerSize',12)
axis([-1 6 0 30])
grid on
set(gca,'XTick',[-1:1:6])
set(gca,'FontSize',12)
ylabel('u(n)','FontSize',13)
title('Input of Inherently Discrete-time System','FontSize',11)
subplot(2,1,2)
y(1)=1;
u=25;

for n=1:7
    y(n+1)=0.5*(y(n)+u/y(n));
end
n=-1:6;
plot(n,y,'.k','MarkerSize',12)
hold on
plot(n,y,'b--')
grid on
set(gca,'XTick',[-1:1:6])
set(gca,'FontSize',12)
xlabel('n','FontSize',14)
ylabel('y(n)','FontSize',13)
title('Output of Inherently Discrete-time System','FontSize',11)
