% File: Ch1_Prob1_11
% Plots graphs in Problem 1.11

clc, close all, clear all

c=1.25e-9; Pm=25e6; dt=1;
P0=3e6;

Pfinal=0.98*Pm;
P=P0;
n=1; t(1)=0; 
PA(1)=P0;

while P<Pfinal
    PA(n+1)=(1+c*dt*(Pm-PA(n)))*PA(n);
    P=PA(n+1);
    n=n+1;
    t(n)=(n-1)*dt;
end

freq=5;
plot(t(1:freq:end),PA(1:freq:end),'.b','MarkerSize',9)
axis([0 t(end)+2 0 1.1*Pm])
hold on
plot([0 t(end)+2],[Pfinal Pfinal],'--k')
xlabel('t  (years)','FontSize',11)
title('Population vs Time','FontSize',11)
text(75,1e7,'P_{A}(n), n = 0,5,10,15,...','FontSize',11)
text(20,1.03*Pm,'0.98P_{m}=24.5 million','FontSize',11) 

t(1:20:180),PA(1:20:180)
t(131),PA(131)
t(181:end),PA(181:end)

%%%%% Part b)
P188=Pm*P0/(P0+(Pm-P0)*exp(-c*Pm*188))

%%%%% Part c)
P=linspace(0,30e6,1000);
GR=c*(Pm-P);
figure
plot(P,GR,'b','LineWidth',1.5)
hold on
xlabel('P','FontSize',11)
ylabel('g(P)','FontSize',11) 

ti=0:25:100; 
Pi=Pm*P0./(P0+(Pm-P0)*exp(-c*Pm*ti)); 
GRi=c*(Pm-Pi);
plot(Pi,GRi,'.r','MarkerSize',10)
text(0.37e7,0.028,'t=0, P(0)=3')
text(0.62e7,0.025,'t=25, P(25)=5.737')
text(1.02e7,0.02,'t=50, P(50)=9.854')
text(1.54e7,0.0135,'t=75, P(75)=14.673')
text(1.96e7,0.008,'t=100, P(100)=18.908')
title('Growth Rate vs Population','FontSize',11)

%%%%% Part d)
clear ti Pi
ti=linspace(0,160,1000);
figure

for fact=0.95:0.025:1.05
  P0=fact*Pm;
  Pi=Pm*P0./(P0+(Pm-P0)*exp(-c*Pm*ti)); 
  plot(ti,Pi,'LineWidth',1.5)
  set(gca,'XTick',[0:20:160])
  hold on
  plot(ti(1),Pi(1),'.k','MarkerSize',12)
end

xlabel('t  (years)','FontSize',11)
ylabel('P(t)', 'FontSize',11)
title('P(t) vs t for Different Initial Populations near P_{m}','FontSize',11)
text(3,2.51e7,'P_{m}','FontSize',10) 
text(3,2.56e7,'1.025P_{m}','FontSize',10) 
text(3,2.625e7,'1.05P_{m}','FontSize',10)
text(3,2.37e7,'0.95P_{m}','FontSize',10)
text(3,2.43e7,'0.975P_{m}','FontSize',10)

%%%%% Part e)
clear ti Pi
ti=linspace(0,500,1000);
figure 


for P0=0:5000:25000
  Pi=Pm*P0./(P0+(Pm-P0)*exp(-c*Pm*ti)); 
  plot(ti,Pi,'LineWidth',1.3)
  axis([0 500 -0.2e7 2.8e7])
  set(gca,'XTick',[0:50:500])
  hold on
  plot(ti(1),Pi(1),'.k','MarkerSize',12)
end
plot([0 500],[Pm Pm],'--k')

xlabel('t  (years)','FontSize',11)
ylabel('P(t)', 'FontSize',11)
title('P(t) vs t for Different Initial Populations near Zero','FontSize',11)
text(50,2.6e7,'P_{m}=25 million','FontSize',11)
text(300,0.12e7,'P_{0} = 0','FontSize',11)
text(300,1e7,'P_{0} = 5,000','FontSize',11)
text(80,1e7,'P_{0} = 25,000','FontSize',11)
plot([268  292],[1.02e7 1.02e7],'k')
plot([175 202],[1.02e7 1.02e7],'k')


