% File: Ch1_Prob_1_13.m
% Generates graph of simulated and exact bacteria populations in Part e)

clc, clear all close all

k=0.01; P0=10000;
ti=linspace(0,500,250);
Pi=P0*exp(k*ti);
plot(ti,Pi,'b','LineWidth',1.5)
xlabel('t  \rm(min)','FontSize',11)
title('Exact and Approximate Populations','FontSize',11)

PA(1)=P0; t(1)=0;
dt=0.5;
alpha=1+k*dt;
for n=1:1000
    t(n+1)=n*dt;
    PA(n+1)=alpha*PA(n);
end
hold on
plot(t(1:50:1001),PA(1:50:1001),'.r','MarkerSize',12)
set(gca,'YTick',[0:2.5e5:15e5])
legend('Exact: P(t)','Approximate: P_{A}(n), n = 0,50,100,...,1000','Location','best')