% File: Ch2_Case_Study.m
% Plots Figure 2.56 in Case Study 
% Final time is 8 sec instead of 12 sec

clear all; close all; clc

r=100;
KC=0.6; KI=0.1;
tau=10; Kthd=20; Kth=10;
T=0.0025;
r=100;
a11=-Kthd*KC*T/tau;    a12=(Kth-(Kthd/tau))*T;    a13=Kthd*KI*T/tau;
a21=-KC*T/tau;    a22=-T/tau;    a23=KI*T/tau;
a31=-T;    a32=0;    a33=0;
b1=Kthd*KC*T/tau;
b2=KC*T/tau;
b3=T;
c11=-KC;    c12=0;    c13=KI;
c21=-Kthd*KC/tau;    c22=Kth-(Kthd/tau);    c23=Kthd*KI/tau;
c31=1;    c32=0;    c33=0;
d1=KC;
d2=Kthd*KC/tau;
d3=0;
x1A(1)=0; x2A(1)=0; x3A(1)=0;
tfinal=8;
ifinal=round(tfinal/T);

for i=1:ifinal    
    t(i)=(i-1)*T;
    x1A(i+1)=x1A(i)+a11*x1A(i)+a12*x2A(i)+a13*x3A(i)+b1*r;
    x2A(i+1)=x2A(i)+a21*x1A(i)+a22*x2A(i)+a23*x3A(i)+b2*r;
    x3A(i+1)=x3A(i)+a31*x1A(i)+a32*x2A(i)+a33*x3A(i)+b3*r; 
    thetaA(i)=c11*x1A(i)+c12*x2A(i)+c13*x3A(i)+d1*r;
    vA(i)=c21*x1A(i)+c22*x2A(i)+c23*x3A(i)+d2*r;
    cA(i)=c31*x1A(i)+c32*x2A(i)+c33*x3A(i)+d3*r;
end
del=100;
subplot(3,1,1)
plot(t(1:del:end),thetaA(1:del:end),'b.')
grid on
set(gca,'XTick',[0:12])
set(gca,'FontSize',11)
ylabel('\theta_A  (deg)','FontSize',12)
title('Discrete-time Outputs \theta_A(n), v_A(n), c_A(n), n = 0,100,200,...','FontSize',11) 
text(5,50,'T = 0.0025 s','FontSize',12)

subplot(3,1,2)
plot(t(1:del:end),vA(1:del:end),'b.')
grid on
set(gca,'XTick',[0:12])
set(gca,'FontSize',11)
ylabel('v_A  (ft/s)','FontSize',12)
text(5,100,'T = 0.0025 s','FontSize',12)

subplot(3,1,3)
plot(t(1:del:end),cA(1:del:end),'b.')
grid on
set(gca,'XTick',[0:12])
set(gca,'FontSize',11)
ylabel('c_A  (ft)','FontSize',12)
xlabel('t  (s)','FontSize',12)
text(5,150,'T = 0.0025 s','FontSize',12)
