% File: Ch2_Ex2_10.m
% plots Figure 2.32

clear all
clc
close all

m=2; mu0=0.3; muS=0.1; g=32.2;
fB=mu0*m*g;
fS=muS*m*g;

t1=1;
T=0.025;
Tf=(0.25*t1/muS)*(7*mu0+2*muS);
nf=round(Tf/T);
t(1)=0;
vA(1)=0;
f(1)=0;
fmu(1)=0;
for n=2:nf
    t(n)=(n-1)*T;
    
    if t(n)<=0.5*t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=f(n);
    elseif t(n)>0.5*t1 & t(n)<=t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=fS;
    elseif t(n)>t1 & t(n)<=2*t1
        f(n)=2*fB*(2-t(n)/t1);
        fmu(n)=fS;
    else
        f(n)=0;
        fmu(n)=fS;
    end % if 
    
     
    vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
end % n

freq=4;
subplot(2,1,1)
plot([0 1 2 6],[0 max(f) 0 0],'b','LineWidt',1.3)
grid on
axis([0 6 -3 42])
set(gca,'FontSize',11)
set(gca,'YTick',[0:10:40])
ylabel('f  (lb)','FontSize',13)
text(2,33,'m = 2 slugs,  \mu_0= 0.3,  \mu_s = 0.1','FontSize',12)
text(2.75,13,'t_1 = 1 s','FontSize',12)
text(2.75,23,'f_B = \mu_0 mg','FontSize',12)
title('Applied Force','FontSize',11)

subplot(2,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.r','MarkerSize',9)
grid on
axis([0 1.0*Tf -1 13])
set(gca,'FontSize',11)
set(gca,'YTick',[0:2.5:10])
hold on
xlabel('t  (s)','FontSize',13)
ylabel('v_A(n)  (ft/s)','FontSize',13)
text(1.5,5,'T = 0.025 s','FontSize',12)
title('Velocity','FontSize',11)

ti=[0 0.5*t1];
vi=[0 0];
plot(ti,vi,'b','LineWidth',1.3)
hold on

ti=linspace(0.5*t1,t1,250);
a=g*mu0/t1;
b=-g*muS;
c=g*(2*muS-mu0)*t1/4;
vi=a*ti.^2 + b*ti +c;
plot(ti,vi,'b','LineWidth',1.3)

a=-mu0*g/t1;
b=(4*mu0-muS)*g;
c=(-0.25*g*t1)*(9*mu0-2*muS);

ti=linspace(t1,2*t1,250);
vi=a*ti.^2 + b*ti +c;
plot(ti,vi,'b','LineWidth',1.3)

Tf=(0.25*t1/muS)*(7*mu0+2*muS);
b=-muS*g;
c=(0.25*g*t1)*(7*mu0+2*muS);
ti=linspace(2*t1,Tf,250);
vi=b*ti + c;
plot(ti,vi,'b','LineWidth',1.3)

text(4.1,10.5,'v_A(n), n = 0,4,8,...','FontSize',12)
plot(3.80,10.5,'r.','MarkerSize',9)
text(4.2,8,'v(t)','FontSize',12)
plot([3.7 3.9],[8 8],'b')



