% File: Ch2_Ex2_11.m
% Plots Figure 2.44

clc; close all; clear all

R=0.0008; C=300; Qbar=36000;
tau=R*C;
T0=50; % outside temperature
Tinit=T0; % initial temperature
Tss=R*Qbar+T0;
Td=75; % desired temperature
del=3; % thermostat swing
T_low=Td-del; % low thermostat cutoff
T_high=Td+del; % high thermostat cutoff
t1=tau*log((Tss-T0)/(Tss-T_high));
t2=t1+tau*log((T_high-T0)/(T_low-T0));
t3=t2+tau*log((Tss-T_low)/(Tss-T_high));

Tstep=0.001;
Tfinal=t3;
nfinal=round(Tfinal/Tstep);
t(1)=0;
T_A(1)=Tinit;

%%%%% T(n) section %%%%%
for n=1:nfinal 
    t(n+1)=n*Tstep;
    
  if T_A(n) < T_low % check if T is below lower thermostat cutoff
      Q=Qbar; % furnace is on
  elseif T_A(n) > T_high % check if T is above upper thermostat cutoff
      Q=0; % furnace is off
  elseif T_low < T_A(n) & T_A(n) < T_high & T_A(n) > T_A(n-1) % check if T is in thermostat band and increasing
      Q=Qbar;
  else % T is in thermostat band and decreasing
      Q=0;
  end % if
    
  T_A(n+1)=(1-Tstep/tau)*T_A(n)+(Tstep/tau)*(R*Q+T0); % update T_A
    
end % for
freq=25;
plot(t(1:freq:end),T_A(1:freq:end),'.r','MarkerSize',10)
hold on
grid on
xlabel('t  (h)','FontSize',12)
ylabel('T  (\circ F)','FontSize',12)

%%%%% T(t) section %%%%%
ti=linspace(0,t1,100);
Ti=Tinit*exp(-ti/tau)+Tss*(1-exp(-ti/tau));
plot(ti,Ti,'b','LineWidth',1.3)
axis([0 1.5 50 82])
ti=linspace(t1,t2,50);
Ti=T_high*exp(-(ti-t1)/tau)+T0*(1-exp(-(ti-t1)/tau));
plot(ti,Ti,'b','LineWidth',1.3)
ti=linspace(t2,t3,100);
Ti=T_low*exp(-(ti-t2)/tau)+Tss*(1-exp(-(ti-t2)/tau));
plot(ti,Ti,'b','LineWidth',1.3)

plot([0 1.5],[T_low T_low],'k--')
plot([0 1.5],[T_high T_high],'k--')

set(gca,'FontSize',11)
set(gca,'XTick',[0:0.25:1.5])
text(0.5,64,'T_A(n), n = 0,25,50,...','FontSize',12)
plot([0.43],[64],'r.','MarkerSize',10)
text(0.5,61,'T(t), t \geq 0','FontSize',12)
plot([0.40 0.46],[61 61],'b','LineWidth',1.3)
text(0.5,56,'Step size \DeltaT = 0.001 h','FontSize',12)
text(0.1,73.4,'T_d - \Delta','FontSize',12)
text(0.1,79.4,'T_d + \Delta','FontSize',12)
title('Building Temperature vs Time','FontSize',11)
text(0.85,79.4,'t_1','FontSize',12)
text(0.91,70.5,'t_2','FontSize',12)
text(1.42,79.4,'t_3','FontSize',12)
 

