% File: Ch2_Ex2_12.m
% Plots Figures 2.51 and 2.52

clc, clear all, close all

m=1; k=2; c=0.5; F0=3;
T=0.001;
tfinal=15;
nfinal=round(tfinal/T);
max_x1=0; max_x2=0; min_x1=0; min_x2=0;
t=0:T:tfinal-T;
x10(1)=-1; x20(1)=-5;
x10(2)=-2; x20(2)=15;
x10(3)=2; x20(3)=5;
x10(4)=5; x20(4)=-20;

for i=1:4    
  x1(1)=x10(i); x2(1)=x20(i);
    for n=1:nfinal-1
      x1(n+1)=x1(n)+T*x2(n);
      x2(n+1)=x2(n)-(T/m)*(k*x1(n)+(c*(x1(n)^2)-F0)*x2(n));
    end % n
  M1=max(x1); M2=max(x2);
    if M1>max_x1
      max_x1=M1;
    end
    if M2>max_x2
      max_x2=M2;
    end
  m1=min(x1); m2=min(x2);  
   if m1<min_x1
      min_x1=m1;
    end
    if m2<min_x2
      min_x2=m2;
    end     
    
  figure(1)
  plot(x1,x2,'b','LineWidth',1.3)
  axis([1.1*min_x1 1.1*max_x1 1.1*min_x2 1.1*max_x2])
  hold on
  grid on
  plot(x10(i),x20(i),'.r','MarkerSize',12)    
end % i

set(gca,'FontSize',11)
set(gca,'XTick',[-6:6])
set(gca,'YTick',[-20:5:25])

xlabel('x_1','FontSize',13)
ylabel('x_2','FontSize',13)
title('Nonlinear System with Limit Cycle','FontSize',11)  
text(-5.5,24,'m = 1, k = 2, c = 0.5, F_0 = 3','FontSize',12)
text(-1.5,-2.6,'(-1,-5)','FontSize',12)
text(-3.8,15.5,'(-2,15)','FontSize',12)
text(0.8,5,'(2,5)','FontSize',11)
text(3.2,-19.5,'(5,-20)','FontSize',12)


figure(2)
subplot(2,1,1)
plot(t,x1,'b','LineWidth',1.3)
hold on
grid on
axis([-1 16 -6 6])
ylabel('x_1','FontSize',13)
title('x_1 vs t for System with Limit Cycle Starting at (5,-20)','FontSize',11)
text(9,-4.3,'period','FontSize',11)
plot([11.94 11.94],[0 -4.5],'--k')
plot([6.432 6.432],[0 -4.5],'--k')
plot([6.432 8.75],[-4.5 -4.5],'k')
plot([10.7 11.94],[-4.5 -4.5],'k')
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:16])
set(gca,'YTick',[-5:2.5:5])

subplot(2,1,2)
plot(t,x2,'b','LineWidth',1.3)
hold on
grid on
axis([-1 16 -22 18])
xlabel('t','FontSize',13)
ylabel('x_2','FontSize',13)
title('x_2 vs t for System with Limit Cycle Starting at (5,-20)','FontSize',11)
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:16])
set(gca,'YTick',[-20:10:10])

figure(1)
start=1700;
plot(x1(start:end),x2(start:end),'k','LineWidth',2)
grid on
text(-3,9,'Limit Cycle','FontSize',12)
