% File: Ch2_Ex2_2.m
% Plots Figure 2.6

close all
clc 
clear all

m=40/32.2;
k=45;
c=4;
wn=sqrt(k/m);
zeta=c/(2*sqrt(k*m));
wd=sqrt(1-zeta*zeta)*wn;
%T=5/(zeta*wn);
T=3;
K=1/k;
F=12; 
phi=atan(wd/(zeta*wn));
ti=linspace(0,T,300);
yi=K*F*(1-(wn/wd)*exp(-zeta*wn*ti).*sin(wd*ti+phi));
subplot(2,1,1)
plot(ti,yi,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.1:0.4])
ylabel('x(t), (ft)','FontSize',13)
title('Position Step Response','FontSize',11)

subplot(2,1,2)
x=wd*ti+phi;
% ydoti=K*(wn/wd)*exp(-zeta*wn*ti).*(zeta*wn*sin(x)-wd*cos(x));
ydoti=(K*wn^2/wd)*exp(-zeta*wn*ti).*(sin(wd*ti));
plot(ti,ydoti,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[-0.05:0.05:0.1])
axis([0 T -0.05 0.1])
xlabel ('t  (s)','FontSize',13)
ylabel('dx/dt (ft/s)','FontSize',13)
title('Velocity Response','FontSize',11)
hold on
L=0.04;
plot([0 T],[L L],'--k',[0,T],[-L -L],'--k')
text(1.25,0.055,'0.04 ft/s','FontSize',13)
text(1.25,-0.028,'-0.04 ft/s','FontSize',13)
 