% File: Ch2_Ex2_3.m
% Plots Figure 2.8

close all, clear all, clc

Q1=10;
Q2=5;
V1=15;
V2=15;
wn=sqrt(Q1*(Q1-Q2)/(V1*V2)) 
zeta=0.5*(Q1/wn)*((1/V1)+(1/V2)) 
K=1;
cbar=0.25;
a=[1 2*zeta*wn wn^2]; 
r=roots(a) 
s1=min(r);
s2=max(r);
tau1=-1/s1; 
tau2=-1/s2;
tfinal=5*tau2; 
ti=linspace(0,tfinal,1000);
ci=K*cbar*(1+(tau2.*exp(-ti/tau2)-tau1.*exp(-ti/tau1))/(tau1-tau2));
plot(ti,ci,'b','LineWidth',1.3)
tmin=-1; cmin=-0.01; cmax=1.1*cbar;
axis([tmin tfinal cmin cmax])
hold on
plot([tmin 0],[0 0],'k')
plot([0 0],[0 cbar],'k--')
plot([0 tfinal],[cbar cbar],'k')
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:25])
set(gca,'YTick',[0:0.05:0.25])
xlabel('t  (min)','FontSize',11)
ylabel('c_2(t),  lb salt per gal','FontSize',13)
title('Step Response of Salt Concentration in First Tank','FontSize',13)
text(0.5,0.2,'c(t)','FontSize',13)
text(6.5,0.15,'c_2(t)','FontSize',13)
text(3,0.26,'c = 0.25 lb salt per gal','FontSize',13)
text(3.05,0.273,'_','FontSize',13)