% Ch2_Fig2_1.m
% Plots Figure 2.1 in Chapter 2

clc, clear all, close all

K=5; A=2;
taumax=10;
hold on

tau = 0.5;
ti=linspace(0,5*taumax,1500);
yi=K*A*(1-exp(-ti/tau));
plot(ti,yi,'b','LineWidth',1.3)
grid on

tau = 2;
ti=linspace(0,5*taumax,400);
yi=K*A*(1-exp(-ti/tau));
plot(ti,yi,'r','LineWidth',1.3)

tau = 5;
ti=linspace(0,5*taumax,400);
yi=K*A*(1-exp(-ti/tau));
plot(ti,yi,'g','LineWidth',1.3)

tau = 10;
ti=linspace(0,5*taumax,400);
yi=K*A*(1-exp(-ti/tau));
plot(ti,yi,'k','LineWidth',1.3)

% legend('\tau = 0.5','\tau = 2','\tau = 5','\tau = 10','Location','SouthEast')

plot([-5 0],[0 0],'k')
plot([0 0],[0 A],'k')
plot([0 5*tau],[A A],'k','LineWidth',1.3)
v=[-2 5*tau -1 1.15*K*A];
axis(v)
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:50])
set(gca,'YTick',[0:10])
text(15,2.5,'Input u(t) = 2, t \geq 0','FontSize',12)

xlabel('t','FontSize',13)
ylabel('y(t)','FontSize',13)

text(3,10.5,'\tau = 0.5','FontSize',12)
text(6,9.3,'\tau = 2','FontSize',12)
text(7.6,7.5,'\tau = 5','FontSize',12)
text(9.0,5.4,'\tau = 10','FontSize',12)
text(25,10.6,'y(\infty) = K\cdot A = 10','FontSize',12)
title('First Order System Step Response for \tau = 0.5, 2, 5, 10 ','FontSize',11)


