% File: Ch2_Fig2_29.m
% Plots Figure 2.29

clc, close all, clear all

subplot(2,2,1)
x10=3; x20=4;
ti=linspace(0,5,500);
z1=exp(-ti); z2=exp(-2*ti);
a11=2*z1-z2;
a12=z1-z2;
a21=-2*z1+2*z2;
a22=-z1+2*z2;
x1i=a11*x10+a12*x20;
x2i=a21*x10+a22*x20;
plot(x1i,x2i,'b','LineWidth',1.3)
hold on
plot(x10,x20,'.r','MarkerSize',10)
xlabel('x_1','FontSize',12)
ylabel('x_2','FontSize',12)
axis([-5 5 -5 5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[-5:2.5:5])
set(gca,'YTick',[-5:2.5:5])
text(-2.5,6.5,'State Trajectories Starting from Different Initial States','FontSize',11)
text(-4,3,'x_1(0) = 3','FontSize',12)
text(-4,0.5,'x_2(0) = 4','FontSize',12)


subplot(2,2,2)
x10=3; x20=-4;
ti=linspace(0,5,500);
z1=exp(-ti); z2=exp(-2*ti);
a11=2*z1-z2;
a12=z1-z2;
a21=-2*z1+2*z2;
a22=-z1+2*z2;
x1i=a11*x10+a12*x20;
x2i=a21*x10+a22*x20;
plot(x1i,x2i,'b','LineWidth',1.3)
hold on
plot(x10,x20,'.r','MarkerSize',10)
xlabel('x_1','FontSize',12)
ylabel('x_2','FontSize',12)
axis([-5 5 -5 5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[-5:2.5:5])
set(gca,'YTick',[-5:2.5:5])
text(-4,3.2,'x_1(0) = 3','FontSize',12)
text(-4,0.7,'x_2(0) = - 4','FontSize',12)

subplot(2,2,3)
x10=-4; x20=-2;
ti=linspace(0,5,500);
z1=exp(-ti); z2=exp(-2*ti);
a11=2*z1-z2;
a12=z1-z2;
a21=-2*z1+2*z2;
a22=-z1+2*z2;
x1i=a11*x10+a12*x20;
x2i=a21*x10+a22*x20;
plot(x1i,x2i,'b','LineWidth',1.3)
hold on
plot(x10,x20,'.r','MarkerSize',10)
xlabel('x_1','FontSize',12)
ylabel('x_2','FontSize',12)
axis([-5 5 -5 5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[-5:2.5:5])
set(gca,'YTick',[-5:2.5:5])
text(0.5,-1.0,'x_1(0) = - 4','FontSize',12)
text(0.5,-3.5,'x_2(0) = - 2','FontSize',12)

subplot(2,2,4)
x10=-4; x20=2;
ti=linspace(0,5,500);
z1=exp(-ti); z2=exp(-2*ti);
a11=2*z1-z2;
a12=z1-z2;
a21=-2*z1+2*z2;
a22=-z1+2*z2;
x1i=a11*x10+a12*x20;
x2i=a21*x10+a22*x20;
plot(x1i,x2i,'b','LineWidth',1.3)
hold on
plot(x10,x20,'.r','MarkerSize',10)
xlabel('x_1','FontSize',12)
ylabel('x_2','FontSize',12)
axis([-5 5 -5 5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[-5:2.5:5])
set(gca,'YTick',[-5:2.5:5])
text(0.5,-1.0,'x_1(0) = - 4','FontSize',12)
text(0.5,-3.5,'x_2(0) = 2','FontSize',12)

