% File: Ch2_Fig2_31.m
% Plots Figure 2.31

clc
clear all
close all

t(1)=0;
yA1(1)=0;
yA2(1)=0;
zA1(1)=0;
zA2(1)=0;
tau=1;
T=0.05;

tf=5*tau;
nf=round(tf/T);
P=1;
for n=1:nf
    unT1=1;
    unT2=10;
    t(n+1)=n*T;
    yA1(n+1)=yA1(n)+(T/tau)*(unT1-yA1(n));
    yA2(n+1)=yA2(n)+(T/tau)*(unT2-yA2(n));
    zA1(n+1)=zA1(n)+(T/tau)*(unT1-zA1(n)*zA1(n));
    zA2(n+1)=zA2(n)+(T/tau)*(unT2-zA2(n)*zA2(n));
end % n
ms=5;    
freq=3;
ti=linspace(0,tf,500);

subplot(2,2,1)
plot(t(1:freq:end),yA1(1:freq:end),'.b','MarkerSize',ms)
grid on
axis([0 5 0 1.1])
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.25:1])
set(gca,'XTick',[0:5])
ylabel('y_A(nT)','FontSize',12)
text(1.3,0.4,'u(t) = 1, t \geq 0 ','FontSize',12)
text(1.3,0.2,'T = 0.05','FontSize',12)
% text(0.2,1.2,'First Order Linear and Nonlinear System Model Step Responses','FontSize',11)
title('First Order Linear System Response','FontSize',10)

subplot(2,2,2)
plot(t(1:freq:end),zA1(1:freq:end),'.b','MarkerSize',ms)
grid on
axis([0 3 0 1.1])
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.25:1])
ylabel('y_A(nT)','FontSize',12)
text(1.0,0.4,'u(t) = 1, t \geq 0','FontSize',12)
text(1.0,0.2,'T = 0.05','FontSize',12)
title('First Order Nonlinear System Response','FontSize',10)

subplot(2,2,3)
plot(t(1:freq:end),yA2(1:freq:end),'.b','MarkerSize',ms)
grid on
axis([0 5 0 11])
set(gca,'FontSize',11)
set(gca,'YTick',[0:2.5:10])
set(gca,'XTick',[0:5])
xlabel('t','FontSize',12)
ylabel('y_A(nT)','FontSize',12)
text(1.3,4,'u(t) = 10, t \geq 0','FontSize',12)
text(1.3,2,'T = 0.05','FontSize',12)
title('First Order Linear System Response','FontSize',10)

subplot(2,2,4)
plot(t(1:freq:end),zA2(1:freq:end),'.b','MarkerSize',ms)
grid on
axis([0 3 0 3.5])
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.5:3])
ylabel('y_A(nT)','FontSize',12)
text(0.65,1.5,'u(t) = 10, t \geq 0','FontSize',12)
text(0.65,0.9,'T = 0.05','FontSize',12)
xlabel('t','FontSize',12)
title('First Order Noninear System Response','FontSize',10)

