% File: Ch2_Fig2_4.m
close all
clc
clear all

K=1;
wn=10;
 
% Overdamped Case
subplot(2,2,1)
hold on
rho=[1.5 2 3];
for n=1:3
s1=(-rho(n)-sqrt(rho(n)*rho(n)-1))*wn;
s2=(-rho(n)+sqrt((rho(n)*rho(n))-1))*wn;
tau1=-1/s1;
tau2=-1/s2;
ti=linspace(0,20/wn,250);
wnti=wn*ti;
A=tau2*exp(-ti/tau2);
B=tau1*exp(-ti/tau1);
yi=1+((A-B)/(tau1-tau2));
plot(wnti,yi,'b','LineWidth',1.3)
grid on
axis([0 20 0 1.1])
end % n

plot([2.5 7.0],[0.8 0.5],'k')
plot([6.0 7.0],[0.5 0.5],'k')
plot([7.0 6.3],[0.5 0.60],'k')
set(gca,'FontSize',11)
set(gca,'XTick',[0:4:20])
set(gca,'YTick',[0:0.25:1])
ylabel('Step Response','FontSize',12)
title('Overdamped, \zeta = 1.5, 2, 3','FontSize',11)
text(8,0.45,'Increasing \zeta','FontSize',12)

% Underdamped Case
subplot(2,2,2)
hold on
for n=1:2:9
  rho=n/10;
  wd=sqrt(1-rho*rho)*wn;
  theta=atan(wd/(rho*wn));
  yi=1-(wn/wd)*exp(-rho*wn*ti).*sin(wd*ti+theta);
  plot(wnti,yi,'b','LineWidth',1.3)
grid on
end % n

plot([3.2 3.2],[0.4 1.85],'k')
plot([2.5 3.2],[0.5 0.4],'k')
plot([3.2 3.9],[0.4 0.5],'k')
set(gca,'FontSize',11)
set(gca,'XTick',[0:4:20])
set(gca,'YTick',[0:0.5:2])

ylabel('Step Response','FontSize',12)
title('   Underdamped, \zeta = 0.1, 0.3,..., 0.9','FontSize',11)
text(2.0,0.25,'Increasing \zeta','FontSize',12)

% Critically Damped Case
subplot(2,2,3)
yi=1-exp(-wn*ti).*(wn*ti+1);
plot(wnti,yi,'b','LineWidth',1.3)
grid on
axis([0 20 0 1.1])
set(gca,'FontSize',11)
set(gca,'XTick',[0:4:20])
set(gca,'YTick',[0:0.25:1])
xlabel('\omega_{\itn}t','FontSize',12)
ylabel('Step Response','FontSize',12)
title('Critically Damped, \zeta = 1','FontSize',11)

%Zero Damping Case
subplot(2,2,4)
yi=1-cos(wn*ti);
plot(wnti,yi,'b','LineWidth',1.3)
grid on
axis([0 20 -0.1 2.1])
set(gca,'FontSize',11)
set(gca,'XTick',[0:4:20])
set(gca,'YTick',[0:0.5:2])
xlabel('\omega_{\itn}t','FontSize',12)
ylabel('Step Response','FontSize',12)
title('Zero Damping, \zeta = 0','FontSize',11)




