% Ch2_Fig2_46_and_Fig2_47.m
% plots Figure 2.46 and Figure 2.47
clc, clear all, close all 
wn=1;
t=linspace(0,6*pi/wn,1000);

x0(1)=0.1; x0_dot(1)=0.1;
x0(2)=-0.3; x0_dot(2)=0.25;
x0(3)=-0.4; x0_dot(3)=-0.5;
x0(4)=0.85; x0_dot(4)=-0.2;
 
for i=1:4
   figure(1)
   hold on
   grid on
   x=x0(i)*cos(wn*t)+(x0_dot(i)/wn)*sin(wn*t);
   xdot=-wn*x0(i)*sin(wn*t)+x0_dot(i)*cos(wn*t);  
   
    switch i
    case 1        
         plot(x,xdot,'b','LineWidth',1.3)
         plot(x0(i),x0_dot(i),'.b','MarkerSize',15)
     case 2 
         plot(x,xdot,'r','LineWidth',1.3)
         plot(x0(i),x0_dot(i),'.r','MarkerSize',15)
    case 3
         plot(x,xdot,'g','LineWidth',1.3)
         plot(x0(i),x0_dot(i),'.g','MarkerSize',15)         
    case 4
         plot(x,xdot,'k','LineWidth',1.3)
         plot(x0(i),x0_dot(i),'.k','MarkerSize',15)
    end  
      
   axis equal
   axis([-1.1 1.1 -1.1 1.1])
   
  
  figure(2)
  subplot(2,1,1)
  hold on
  grid on
  
  switch i
    case 1
        plot(t,x,'b','LineWidth',1.3)
        text(0.22,0.26,'a','FontSize',11)
    case 2 
        plot(t,x,'r','LineWidth',1.3)
        text(2.35,0.52,'b','FontSize',11)
    case 3
        plot(t,x,'g','LineWidth',1.3)
        text(3.9,0.78,'c','FontSize',11)
    case 4
        plot(t,x,'k','LineWidth',1.3)
        text(5.9,1,'d','FontSize',11)
  end       
  
  axis([0 12 -1 1.1])
  ylabel('x','FontSize',13)
  set(gca,'FontSize',11)
  set(gca,'XTick',[0:12])
  set(gca,'YTick',[-1:0.5:1])
  title('Sustained Oscillations of x for Undamped Second-Order Systems','FontSize',11)
  
  subplot(2,1,2)
  hold on
  grid on
  
  switch i
    case 1
        plot(t,xdot,'b','LineWidth',1.3)
        text(1.5,-0.25,'a','FontSize',11)
    case 2 
        plot(t,xdot,'r','LineWidth',1.3)
        text(3.9,-0.55,'b','FontSize',11)
    case 3
        plot(t,xdot,'g','LineWidth',1.3)
        text(5.5,-0.77,'c','FontSize',11)
    case 4
        plot(t,xdot,'k','LineWidth',1.3)
        text(7.5,-1.01,'d','FontSize',11)
  end      
    
  axis([0 12 -1.15 1])
  xlabel('t','FontSize',13)
  ylabel('dx/dt','FontSize',13)
  set(gca,'FontSize',11)
  set(gca,'XTick',[0:12])
  set(gca,'YTick',[-1:0.5:1])
  title('Sustained Oscillations of dx/dt for Undamped Second-Order Systems','FontSize',11)   
end

figure(1)
grid on
plot([-1 1],[0 0],'k')
plot([0 0],[-1 1],'k')
xlabel('x','FontSize',13)
ylabel('dx/dt','FontSize',13)
set(gca,'FontSize',11)
set(gca,'XTick',[-1:0.5:1])
set(gca,'YTick',[-1:0.25:1])
title('State Trajectories of Undamped Second-Order Systems','FontSize',11)  
text(0.25,1.0,'\omega_n = 1 rad/s','FontSize',13)
text(0.05,-1,'Initial State: x(0), x(0)','FontSize',12)
plot([0.88],[-0.96],'.k','MarkerSize',8)
text(0.13,0.125,'a','FontSize',11)
text(-0.36,0.31,'b','FontSize',11) 
text(-0.45,-0.55,'c','FontSize',11) 
text(0.89,-0.20,'d','FontSize',11) 
 