% File: Ch2_Fig2_48_and_Fig2_49.m
% Plots Figures 2.48 and 2.49

clc, clear all, close all

a=10; b=2; c=4; d=12;
x1e=d/c; x2e=a/b;
T=0.00005;
tfinal=1.5;
nfinal=round(tfinal/T);
max_x1=1; max_x2=1;
t=0:T:tfinal-T;

x10(3)=1; x20(3)=2;
x10(1)=2; x20(1)=4;
x10(2)=5.5; x20(2)=8;
x10(4)=8; x20(4)=11;

for i=1:4 
  x1(1)=x10(i); x2(1)=x20(i);
    for n=1:nfinal-1
      x1(n+1)=x1(n)+T*x1(n)*(a-b*x2(n));
      x2(n+1)=x2(n)+T*x2(n)*(c*x1(n)-d);
    end % n
 
  figure(1)
  hold on
  grid on
  
  switch i
    case 1        
         plot(x1,x2,'b','LineWidth',1.3)
         plot(x10(1),x20(1),'.b','MarkerSize',15)
     case 2 
         plot(x1,x2,'r','LineWidth',1.3)
         plot(x10(2),x20(2),'.r','MarkerSize',15)
    case 3
         plot(x1,x2,'g','LineWidth',1.3)
         plot(x10(3),x20(3),'.g','MarkerSize',15)         
    case 4
         plot(x1,x2,'k','LineWidth',1.3)
         plot(x10(4),x20(4),'.k','MarkerSize',15)
    end  
    
  axis([0 12 0 20])
    
  figure(2)
    subplot(2,1,1)
    hold on
    grid on
    
    switch i
    case 1
        plot(t,x1,'b','LineWidth',1.3)
        text(0.26,5.4,'a','FontSize',12)
    case 2 
        plot(t,x1,'r','LineWidth',1.3)
        text(1.17,7.15,'b','FontSize',12)
    case 3
        plot(t,x1,'g','LineWidth',1.3)
        text(0.94,9.1,'c','FontSize',12)
    case 4
        plot(t,x1,'k','LineWidth',1.3)
        text(0.64,10.60,'d','FontSize',12)
  end 
        
    axis([0 1.5 0 11])
    set(gca,'FontSize',11)
    set(gca,'XTick',[0:0.25:1.5])
    set(gca,'YTick',[0:2.5:10])
    ylabel('\itx_{\rm1}','FontSize',13)
    title('Sustained Oscillations of \itx_{\rm1} \rmfor Nonlinear Second Order System','FontSize',11)
    
    subplot(2,1,2)
    hold on
    grid on
    
    switch i
    case 1
        plot(t,x2,'b','LineWidth',1.3)
        text(0.38,9.4,'a','FontSize',12)
    case 2 
        plot(t,x2,'r','LineWidth',1.3)
        text(1.27,12.7,'b','FontSize',12)
    case 3
        plot(t,x2,'g','LineWidth',1.3)
        text(1.03,16.5,'c','FontSize',12)
    case 4
        plot(t,x2,'k','LineWidth',1.3)
        text(0.72,19.3,'d','FontSize',12)
  end 
  
    axis([0 1.5 0 21]) 
    set(gca,'FontSize',11)
    set(gca,'XTick',[0:0.25:1.5])
    set(gca,'YTick',[0:5:20])
    xlabel('t','FontSize',13)
    ylabel('x_2','FontSize',13)
    title('Sustained Oscillations of x_2 for Nonlinear Second Order System','FontSize',11)
     
end % i

figure(1)
xlabel('x_1','FontSize',13)
ylabel('x_2','FontSize',13)
title('Closed Orbits of Nonlinear Second Order System','FontSize',11)  
text(6.5,19,'a = 10, b = 2, c = 4, d = 12','FontSize',12)
text(06.5,16.5,'x_{1,e} = d/c = 3, x_{2,e} = a/b = 5','FontSize',12)
x1e=d/c; x2e=a/b;
plot([x1e],[x2e],'+k','MarkerSize',10)
text(4.68,5,'a','FontSize',12)
text(6.4,5,'b','FontSize',12) 
text(8.33,5,'c','FontSize',12) 
text(9.86,5,'d','FontSize',12) 
text(1,18.7,'Initial State: x_1(0), x_2(0)','FontSize',12)
plot([0.75],[19.0],'.k','MarkerSize',15)
text(9.8,10.6,'(x_{1,e},x_{2,e})','FontSize',12)
plot([x1e 9.5],[x2e 10],'k','LineWidth',1.15)
set(gca,'FontSize',11)
set(gca,'YTick',[0:2:20])
set(gca,'XTick',[0:12])

