% File: Ch2_Prob2_23.m

clear all, clc, close all

m=2; 
mu0=0.3; 
g=32.2;
fB=mu0*m*g;
t1=1;
t(1)=0;
vA(1)=0;
f(1)=0;
fmu(1)=0;

alpha=2; beta=0.5;
T=0.1;
Tf=10;
nf=round(Tf/T);

for n=2:nf
    t(n)=(n-1)*T;
    
    if t(n)<=0.5*t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=f(n);
    elseif t(n)>0.5*t1 & t(n)<=t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=alpha*vA(n-1)^beta;
    elseif t(n)>t1 & t(n)<=2*t1
        f(n)=2*fB*(2-t(n)/t1);
        fmu(n)=alpha*vA(n-1)^beta;
    else
        f(n)=0;
        fmu(n)=alpha*vA(n-1)^beta;
    end % if    
     
vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
end % n

subplot(2,1,1)
plot([0 1 2 Tf],[0 max(f) 0 0],'b','LineWidth',1.3)
hold on
grid on
plot(t,fmu,'r','LineWidth',1.3)
axis([0 Tf -3 42])
ylabel('f  (lbs)','FontSize',11)
title('Applied Force f and Friction Force f_\mu','FontSize',11)
text(4,25,'\alpha = 2, \beta = 0.5','FontSize',11)
legend('f','f_\mu','Location','NorthEast')

freq=1;
subplot(2,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.k')
grid on
axis([0 Tf -1 16])
xlabel('t (sec)','FontSize',11)
ylabel('v_A(n)  (ft/sec)','FontSize',11)
% text(1.5,5,'\itT\rm = 0.025 sec','FontSize',11)
title('Velocity','FontSize',11)
text(6,10,'T = 0.1','FontSize',11)
  
figure(2)
alpha=1; beta=1;
T=0.1;
Tf=10;
nf=round(Tf/T);
for n=2:nf
    t(n)=(n-1)*T;
    
    if t(n)<=0.5*t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=f(n);
    elseif t(n)>0.5*t1 & t(n)<=t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=alpha*vA(n-1)^beta;
    elseif t(n)>t1 & t(n)<=2*t1
        f(n)=2*fB*(2-t(n)/t1);
        fmu(n)=alpha*vA(n-1)^beta;
    else
        f(n)=0;
        fmu(n)=alpha*vA(n-1)^beta;
    end % if 
         
vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
end % n

subplot(2,1,1)
plot([0 1 2 Tf],[0 max(f) 0 0],'b','LineWidth',1.3)
hold on
plot(t,fmu,'r','Linewidth',1.3)
grid on
axis([0 Tf -3 42])
ylabel('f  (lbs)','FontSize',11)
title('Applied Force f and Friction Force f_{\mu}','FontSize',11)
text(4,25,'\alpha = 1, \beta = 1','FontSize',11)
legend('f','f_\mu','Location','NorthEast')

freq=1;
subplot(2,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.k')
grid on
axis([0 Tf -1 16])
xlabel('t (sec)','FontSize',11)
ylabel('\itv_{\rmA}\rm(\itn\rm)  (ft/sec)','FontSize',11)
text(6,10,'T = 0.1','FontSize',11)
title('Velocity','FontSize',11)

figure(3)
alpha=2; beta=2;
T=0.05;
Tf=5;
nf=round(Tf/T);
for n=2:nf
    t(n)=(n-1)*T;
    
    if t(n)<=0.5*t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=f(n);
    elseif t(n)>0.5*t1 & t(n)<=t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=alpha*vA(n-1)^beta;
    elseif t(n)>t1 & t(n)<=2*t1
        f(n)=2*fB*(2-t(n)/t1);
        fmu(n)=alpha*vA(n-1)^beta;
    else
        f(n)=0;
        fmu(n)=alpha*vA(n-1)^beta;
    end % if 
         
vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
end % n

subplot(2,1,1)
plot([0 1 2 Tf],[0 max(f) 0 0],'b','LineWidth',1.3)
grid on
hold on
plot(t,fmu,'r','LineWidth',1.3)
axis([0 Tf -3 42])
ylabel('f  (lbs)','FontSize',11)
title('Applied Force f and Friction Force f_{\mu}','FontSize',11)
text(2.5,25,'\alpha = 2, \beta = 2','FontSize',11)
legend('f','f_\mu','Location','NorthEast')


freq=1;
subplot(2,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.k')
grid on
axis([0 Tf -1 5])
xlabel('t (sec)','FontSize',11)
ylabel('\itv_{\rmA}\rm(\itn\rm)  (ft/sec)','FontSize',11)
title('Velocity','FontSize',11)
text(3,3,'T = 0.05','FontSize',11)






