% File: Ch2_Prob2_25.m

clear all, clc, close all
m=2; mu0=0.3; muS=0.1; g=32.2;
fB=mu0*m*g;
fS=muS*m*g;

t1=1;
T=0.025;
Tf=7;
nf=round(Tf/T);
t(1)=0;
vA(1)=0; xA(1)=0;
f(1)=0;
fmu(1)=0;
for n=2:nf+1
    t(n)=(n-1)*T;
    
    if t(n)<=0.5*t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=f(n);
    elseif t(n)>0.5*t1 & t(n)<=t1
        f(n)=2*fB*t(n)/t1;
        fmu(n)=fS;
    elseif t(n)>t1 & t(n)<=2*t1
        f(n)=2*fB*(2-t(n)/t1);
        fmu(n)=fS;
    else
        f(n)=0;
        fmu(n)=fS;
    end % if     
     
    vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
    if vA(n)<0
       vA(n)=0;
    end
    
    xA(n)=xA(n-1)+T*vA(n-1);
    
end % n

freq=4;

subplot(3,1,1)
plot([0 1 2 Tf],[0 max(f) 0 0],'b','LineWidth',1.3)
grid on
axis([0 6 -3 42])
ylabel('f  \rm(lbs)','FontSize',11)
title('Applied Force','FontSize',11)

subplot(3,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.b')
grid on
axis([0 1.0*Tf -1 15])
hold on
ylabel('v_A(n)  (ft/sec)','FontSize',11)
text(1.5,5,'T = 0.025 sec','FontSize',11)
title('Velocity','FontSize',11)
hold on
text(4.2,10.5,'v_A(n), n = 0,4,8,...','FontSize',11)
plot(4,10.5,'b.')

subplot(3,1,3)
plot(t(1:freq:end),xA(1:freq:end),'.b')
hold on
axis([0 1.0*Tf -3 40])
xlabel('t (sec)','FontSize',11)
title('Displacement','FontSize',11)
text(4.2,14,'x_A(n), n = 0,4,8,...','FontSize',11)
plot(4,14,'b.')
ylabel('x_A(n)   (ft)','FontSize',11)

