% File: Ch2_Prob2_26.m

clear all, clc, close all
m=2; mu0=0.3; muS=0.1; g=32.2;
fB=mu0*m*g;
fS=muS*m*g;
t1=1;
T=0.025;
Tf=16;
nf=round(Tf/T);
t(1)=0;
vA(1)=0;
f(1)=0;
fmu(1)=0;
t1=(4/pi)*asin(1/2);

for n=2:nf
    t(n)=(n-1)*T;
    
    if t(n)<=t1
        f(n)=2*fB*sin(0.25*pi*t(n));
        fmu(n)=f(n);
    elseif t(n)>t1 & t(n)<=4
        f(n)=2*fB*sin(0.25*pi*t(n));
        fmu(n)=fS;
    elseif t(n)>4 
        f(n)=0;
        fmu(n)=fS;
    end % if     
     
    vA(n)=vA(n-1)+(T/m)*(f(n)-fmu(n));
    
    if vA(n)<0
       vA(n)=0;
    end    
    
end % n

freq=10;
subplot(2,1,1)
plot(t,f,'b','LineWidth',1.3)
grid on
hold on
axis([0 Tf 0 41])
ylabel('f  (lbs)','FontSize',11)
title('Applied Force','FontSize',11)
text(4.5,20,'f_{B} = 19.32 lbs, f_{S} = 6.44 lbs,  t_{1} = 0.6667 sec','FontSize',11)
plot(t1,fB,'k.','MarkerSize',10) 
plot([0 t1],[fB fB],'--k')
plot([t1 t1],[0 fB],'--k')
text(0.6667,-4,'t_{1}')

subplot(2,1,2)
plot(t(1:freq:end),vA(1:freq:end),'.r','MarkerSize',10)
grid on
hold on
xlabel('t  (sec)','FontSize',11)
ylabel('v_{A}(n),  v(t)   (ft/sec)','FontSize',11)
text(4,10,'T\rm = 0.025 sec','FontSize',11)
title('Velocity','FontSize',11)

t_1=[0 t1];
v_1=[0 0];
w=0.25*pi;
t_2=linspace(t1,4,500);
A=cos(w*t1)*(1-cos(w*(t_2-t1)));
B=sin(w*t1)*sin(w*(t_2-t1));
v_2=(2*fB/(m*w))*(A+B)-(fS/m)*(t_2-t1);
t_3=linspace(4,16,500);
v_3=v_2(end)-(fS/m)*(t_3-4);

for i=1:length(v_3)
    if v_3(i)<0
        v_3(i)=0;
    end
end

tt=[t_1 t_2 t_3];
vv=[v_1 v_2 v_3];
plot(tt,vv,'b','LineWidth',1.3)
legend('v_{A}(n)','v(t)')

 








