% File: Ch2_Prob2_28.m 

clc; close all; clear all
R=0.0008; C=300; Qbar=36000;
tau=R*C;
T0=50; % outside temperature
Tinit=T0; % initial temperature
Tss=R*Qbar+T0;

i=0;
for Td=68:71  % desired temperature  
  i=i+1;  
  del=3; % thermostat swing
  T_low=Td-del; % low thermostat cutoff
  T_high=Td+del; % high thermostat cutoff
  t1=tau*log((Tss-T0)/(Tss-T_high));
  t2=t1+tau*log((T_high-T0)/(T_low-T0));
  t3=t2+tau*log((Tss-T_low)/(Tss-T_high));
  time1(i)=t1; time2(i)=t2; time3(i)=t3;
  time_on(i)=time3(i)-time2(i);*-
  time_off(i)=time2(i)-time1(i);
  duty_cycle(i)=time_on(i)/(time_off(i)+time_on(i));  
  furnace_cycle(i)=time3(i)-time1(i);
  Tstep=0.001;
  Tfinal=t3;
  nfinal=round(Tfinal/Tstep);
  ti=linspace(0,t1,100);
  Ti=Tinit*exp(-ti/tau)+Tss*(1-exp(-ti/tau));
  subplot(2,2,i)
  plot(ti,Ti,'b','LineWidth',1.3)
  hold on
  grid on
  axis([0 1.1 50 80])
  set(gca,'XTick',[0:0.25:1.5])
  ti=linspace(t1,t2,50); 
  Ti=T_high*exp(-(ti-t1)/tau)+T0*(1-exp(-(ti-t1)/tau));  
  plot(ti,Ti,'b','LineWidth',1.3)     
  ti=linspace(t2,t3,100);
  Ti=T_low*exp(-(ti-t2)/tau)+Tss*(1-exp(-(ti-t2)/tau)); 
  plot(ti,Ti,'b','LineWidth',1.3)    
  plot([0 1.5],[T_low T_low],'k--')
  plot([0 1.5],[T_high T_high],'k--')   
  ylabel('T  (deg F)','FontSize',11)
  text(0.5,62,'\Delta = 3 deg F','FontSize',11)
  
  if i==1
      title('T_d = 68 deg F')
  elseif i==2
      title('T_d = 69 deg F')
  elseif i==3
      title('T_d = 70 deg F')
      xlabel('t  (hrs)','FontSize',11)
  elseif i==4
      title('T_d = 71 deg F')
      xlabel('t  (hrs)','FontSize',11)
  end % if i==1  
  
end % for Td

i=4;
figure(2)
for Td=72:75  % desired temperature  
  i=i+1;  
  del=3; % thermostat swing
  T_low=Td-del; % low thermostat cutoff
  T_high=Td+del; % high thermostat cutoff
  t1=tau*log((Tss-T0)/(Tss-T_high));
  t2=t1+tau*log((T_high-T0)/(T_low-T0));
  t3=t2+tau*log((Tss-T_low)/(Tss-T_high));
  time1(i)=t1; time2(i)=t2; time3(i)=t3;
  time_on(i)=time3(i)-time2(i);
  time_off(i)=time2(i)-time1(i);
  duty_cycle(i)=time_on(i)/(time_off(i)+time_on(i));  
  furnace_cycle(i)=time3(i)-time1(i);
  Tstep=0.001;
  Tfinal=t3;
  nfinal=round(Tfinal/Tstep);
  ti=linspace(0,t1,100);
  Ti=Tinit*exp(-ti/tau)+Tss*(1-exp(-ti/tau));  
  subplot(2,2,i-4)
  plot(ti,Ti,'b','LineWidth',1.3)
  hold on
  grid on
  axis([0 1.40 50 80])
  set(gca,'XTick',[0:0.25:1.5])
  ti=linspace(t1,t2,50); 
  Ti=T_high*exp(-(ti-t1)/tau)+T0*(1-exp(-(ti-t1)/tau));
  plot(ti,Ti,'b','LineWidth',1.3)     
  ti=linspace(t2,t3,100);
  Ti=T_low*exp(-(ti-t2)/tau)+Tss*(1-exp(-(ti-t2)/tau)); 
  plot(ti,Ti,'b','LineWidth',1.3)    
  plot([0 1.5],[T_low T_low],'k--')
  plot([0 1.5],[T_high T_high],'k--')   
  ylabel('T  (deg F)','FontSize',11)
  text(0.5,62,'\Delta = 3 deg F','FontSize',11)
  
  if i==5
      title('T_d = 72 deg F')
  elseif i==6
      title('T_d = 73 deg F')
  elseif i==7
      title('T_d = 74 deg F')
      xlabel('t  (hrs)','FontSize',11)
  elseif i==8
      title('T_d = 75 deg F')
      xlabel('t  (hrs)','FontSize',11)
  end % if i==1  
  
end % for Td


figure(3)
i=0;
for Td=68:75
  i=i+1;
  plot(Td,furnace_cycle(i)','b.','MarkerSize',12)
  hold on
  grid on
  xlabel('T_{d}  (deg F)','Fontsize',11)
  ylabel('Furnace Cycle Time  (hrs)','FontSize',11)
  title('Furnace Cycle Time vs. Thermostat Setting','Fontsize',11)
end % for Td


figure(4)
i=0;
for Td=68:75
  i=i+1;
  plot(Td,100*duty_cycle(i)','b.','MarkerSize',12)
  axis([68 75 50 100])
  hold on  
  grid on
  xlabel('T_{d}  (deg F)','Fontsize',11)
  ylabel('Duty Cycle  (%)','FontSize',11)
  title('Duty Cycle (%) vs. Thermostat Setting','Fontsize',11)
end % for Td












