% File: Ch2_Prob2_29.m
 
clc; close all; clear all

%%%%% Part a)
R=0.0008; C=500; Qbar=36000;
tau=R*C; % time constant
Td=72; % desired temperature
del=3; % thermostat swing
T_low=Td-del; % low thermostat cutoff
T_high=Td+del; % high thermostat cutoff
Tfinal=50;
Tstep=0.01; % simulation time step
nfinal=round(Tfinal/Tstep);
T_A(1)=50;
Q(1)=Qbar;
T0(1)=50;
t(1)=0;

for n=1:nfinal 
    t(n+1)=n*Tstep;
    tt=t(n+1);
    T0(n+1)=50+5*sin(pi*(tt-9)/12);
    
  if T_A(n) < T_low % check if T is below lower thermostat cutoff
      Q(n+1)=Qbar; % furnace is on
  elseif T_A(n) > T_high % check if T is above upper thermostat cutoff
      Q(n+1)=0; % furnace is off
  elseif T_low < T_A(n) & T_A(n) < T_high & T_A(n) > T_A(n-1) % check if T is in thermostat band and increasing
      Q(n+1)=Qbar;
  else % T is in thermostat band and decreasing
      Q(n+1)=0;
  end % if
    
  T_A(n+1)=(1-Tstep/tau)*T_A(n)+(Tstep/tau)*(R*Q(n)+T0(n)); % update T_A
    
end % for

plot(t,T0,'r','LineWidth',1.3)
grid on
grid on
hold on
axis([-1 Tfinal 40 78])
plot(t,T_A,'b','LineWidth',1.3)
plot([-1 Tfinal],[T_low T_low],'--k')
plot([-1 Tfinal],[T_high T_high],'--k')
plot([0 Tfinal],[50 50],'k--')
xlabel('t  \rm(hrs)','FontSize',11)
ylabel('T(t)  and  T_{0}(t),  (deg F)','FontSize',11)
title('Inside and Outside Temperature (deg F) vs Time (hrs)','FontSize',11)
text(-1.5,36.5,'6 AM','FontSize',9)
text(33,56,'T_{0}(t)','FontSize',10)
text(25,66.5,'T(t)','FontSize',11)
text(5,60,'T_{d} = 72 deg F','FontSize',11)

%%%% Part b)
%% Find the amount of time the furnace is on from t=24 to t=48 hrs
t1=24;
n1=t1/Tstep;
t2=48;
n2=t2/Tstep;
cnt=0;
for n=n1:n2
   if Q(n)==Qbar
     cnt=cnt+1;
   end % if
end % for
duty_cycle=cnt/(n2-n1) 
Btu_per_day=Qbar*duty_cycle*24;
Energy_cost_per_day=(Btu_per_day/1000)*(1.75/100) % $ per day
% 
% 
%%%%% Part c)  Td=70 deg F
Td=70; % desired temperature
T_low=Td-del; % low thermostat cutoff
T_high=Td+del; % high thermostat cutoff

for n=1:nfinal 
    t(n+1)=n*Tstep;
    tt=t(n+1);
    T0(n+1)=50+5*sin(pi*(tt-9)/12);
    
  if T_A(n) < T_low % check if T is below lower thermostat cutoff
      Q(n+1)=Qbar; % furnace is on
  elseif T_A(n) > T_high % check if T is above upper thermostat cutoff
      Q(n+1)=0; % furnace is off
  elseif T_low < T_A(n) & T_A(n) < T_high & T_A(n) > T_A(n-1) % check if T is in thermostat band and increasing
      Q(n+1)=Qbar;
  else % T is in thermostat band and decreasing
      Q(n+1)=0;
  end % if
    
  T_A(n+1)=(1-Tstep/tau)*T_A(n)+(Tstep/tau)*(R*Q(n)+T0(n)); % update T_A
    
end % for

figure(2)
plot(t,T0,'r','LineWidth',1.3)
hold on
axis([-1 Tfinal 40 75])
plot(t,T_A,'b','LineWidth',1.3)
grid on
plot([-1 Tfinal],[T_low T_low],'--k')
plot([-1 Tfinal],[T_high T_high],'--k')
plot([0 Tfinal],[50 50],'k--')
xlabel('\itt  \rm(hrs)','FontSize',11)
ylabel('T(t)  and  T_{0}(t),  (deg F)','FontSize',11)
title('Inside and Outside Temperature (deg F) vs Time (hrs)','FontSize',11)
text(-1.5,36.5,'6 AM','FontSize',9)
text(33,56,'T_{0}(t)','FontSize',11)
text(25,64,'T(t)','FontSize',11)
text(5,60,'T_{d} = 70 deg F','FontSize',11)

cnt=0;
for n=n1:n2
   if Q(n)==Qbar
     cnt=cnt+1;
   end % if
end % for
duty_cycle=cnt/(n2-n1) 
Btu_per_day=Qbar*duty_cycle*24;
% Energy_cost_per_day=(Btu_per_day/1000)*(1.75/100) % $ per day
% 
% 
% %%%%% Part c)  Td=75 deg F
Td=75; % desired temperature
T_low=Td-del; % low thermostat cutoff
T_high=Td+del; % high thermostat cutoff

for n=1:nfinal 
    t(n+1)=n*Tstep;
    tt=t(n+1);
    T0(n+1)=50+5*sin(pi*(tt-9)/12);  
    
  if T_A(n) < T_low % check if T is below lower thermostat cutoff
      Q(n+1)=Qbar; % furnace is on
  elseif T_A(n) > T_high % check if T is above upper thermostat cutoff
      Q(n+1)=0; % furnace is off
  elseif T_low < T_A(n) & T_A(n) < T_high & T_A(n) > T_A(n-1) % check if T is in thermostat band and increasing
      Q(n+1)=Qbar;
  else % T is in thermostat band and decreasing
      Q(n+1)=0;
  end % if   
  
  T_A(n+1)=(1-Tstep/tau)*T_A(n)+(Tstep/tau)*(R*Q(n)+T0(n)); % update T_A    
end % for

figure(3)
plot(t,T0,'r','LineWidth',1.3)
grid on
hold on
axis([-1 Tfinal 40 80])
plot(t,T_A,'b','LineWidth',1.3)
plot([-1 Tfinal],[T_low T_low],':k')
plot([-1 Tfinal],[T_high T_high],':k')
plot([0 Tfinal],[50 50],'k:')
xlabel('\itt  \rm(hrs)','FontSize',11)
ylabel('T(t)  and  T_{0}(t),  (deg F)','FontSize',11)
title('Inside and Outside Temperature (deg F) vs Time (hrs)','FontSize',11)
text(-1.5,36.5,'6 AM','FontSize',9)
text(33,56,'T_{0}(t)','FontSize',11)
text(25,69,'T(t)','FontSize',11)
text(5,60,'T_{d} = 75 deg F','FontSize',11)

cnt=0;
for n=n1:n2
   if Q(n)==Qbar
     cnt=cnt+1;
   end % if
end % for
duty_cycle=cnt/(n2-n1) 
Btu_per_day=Qbar*duty_cycle*24;
Energy_cost_per_day=(Btu_per_day/1000)*(1.75/100) % $ per day








  

