 % Fie: Ch2_Prob2_30.m
 
close all; clc; clear all

m=6; % mass (kg)
k=300; % spring constant (N/m)
mu=0.20; % friction
g=9.81; % gravitational constant (m/sec sq)
wn=sqrt(k/m); % natural frequency  (rad/sec)
F=mu*m*g; % magnitude of friction force (N)
x0=-1; % initial displacement (m)
x0dot=0; % initial velocity (m/sec)
Tf=4; % final time (sec)
T=0.001;
nf=round(Tf/T);
x1A(1)=x0;
x2A(1)=0;
t(1)=0;
fmu(1)=-F;
   
for n=1:nf-1
  t(n+1)=n*T;
  x1A(n+1)=x1A(n)+T*x2A(n);
  x2A(n+1)=x2A(n)+(T/m)*(fmu(n)-k*x1A(n));
  fmu(n+1)=-sign(x2A(n+1))*F; 
end

t1=pi/wn;
ti1=linspace(0,t1,500);
xi1=(x0+F/k)*cos(wn*ti1)-F/k;
x1=-x0-2*F/k;
t2=t1+pi/wn;
ti2=linspace(t1,t2,500);
xi2=(x1-F/k)*cos(wn*(ti2-t1))+F/k;
ti=[ti1 ti2];
xi=[xi1 xi2];

%subplot(2,1,1)
figure(1)
freq=50;
plot(t(1:freq:end),x1A(1:freq:end),'b.','MarkerSize',10)
grid on
axis([0 4*t2 -1.1 1.1])
hold on
plot(ti,xi,'r','LineWidth',1.3)
legend('x_{1,A}(n), n = 0,50,100,...','x(t)','Location','SouthEast')
title('Approximate Position and Exact Position','FontSize',11)
text(2.0,0.85,'T = 0.001 sec','FontSize',11)

%subplot(2,1,2)
figure(2)
freq=50;
plot(t(1:freq:end),x2A(1:freq:end),'b.','MarkerSize',10)
grid on
axis([0 4*t2 -19 15])
hold on
plot(t,fmu,'k','LineWidth',1.3)
plot([0 4*t2],[0 0],'k')
title('Approximate Velocity and Coulomb Friction Force','FontSize',11)
xlabel('time (sec)','FontSize',11)
legend('x_{2,A}(n), n = 0,50,100,...','f_{\mu}','Location','SouthEast')

