% File: Ch3_Ex3_11.m
% Solves difference equations in Example 3.11 and plots Figure 3.31, Figure 3.32 and Figure 3.33

clc, clear all, close all

m=0.25; r=0.75;  g=32.2;
T=0.0025;
J=m*r*r;
Tf=10;
nf=round(Tf/T);

% begin Figure 3.31
c=0.1;
x10=pi/6;  
x20=0;  
x1A(1)=x10;
x2A(1)=x20;
t(1)=0;
mgr=m*g*r;
for n=1:nf
    t(n+1)=n*T;
    x1A(n+1)=x1A(n)+T*x2A(n);
    x2A(n+1)=x2A(n)-(T/J)*(mgr*sin(x1A(n))+c*x2A(n));
end % n

subplot(2,1,1)
 freq=20;
plot(t(1:freq:end),x1A(1:freq:end),'b.','MarkerSize',8)
grid on
axis([0 Tf -0.6 0.6])
set(gca,'YTick',[-0.6:0.3:0.6])
set(gca,'XTick',[0:10])
set(gca,'FontSize',11)
ylabel('x_{1,A}(n),  rad','FontSize',12)
title('Discrete Nonlinear Damped Pendulum Response  (T = 0.0025 s)','FontSize',11)
text(4,0.40,'x_{1,A}(0) = x(0) = \pi/6 rad','FontSize',12')
text(4,-0.4,'c  = 0.1 ft lb/rad/s','FontSize',12)

subplot(2,1,2)
plot(t(1:freq:end),x2A(1:freq:end),'b.','MarkerSize',8)
grid on
axis([0 Tf -4 4])
set(gca,'XTick',[0:10])
set(gca,'FontSize',11)
ylabel('x_{2,A}(n),  rad/s','FontSize',12)
xlabel('t  (s)','FontSize',12)
text(4,2.75,'x_{2,A}(0) = dx(0)/dt = 0 rad/s','FontSize',12')


%% begin Figure 3.32
figure(2)
c=0.1;
x10=0;  
x20=0.5;  
x1A(1)=x10;
x2A(1)=x20;
t(1)=0;
mgr=m*g*r;
for n=1:nf
    t(n+1)=n*T;
    x1A(n+1)=x1A(n)+T*x2A(n);
    x2A(n+1)=x2A(n)-(T/J)*(mgr*sin(x1A(n))+c*x2A(n));
end % n

subplot(2,1,1)
plot(t(1:freq:end),x1A(1:freq:end),'.b','MarkerSize',8)
grid on
axis([0 Tf -0.08 0.08])
set(gca,'YTick',[-0.08:0.04:0.08])
set(gca,'XTick',[0:10])
set(gca,'FontSize',11)
ylabel('x_{1,A}(n),  rad','FontSize',12)
title('Discrete Nonlinear Damped Pendulum Response  (T = 0.0025 s)','FontSize',11)
text(4,0.06,'x_{1,A}(0) = x(0) = 0 rad','FontSize',12')
text(4,-0.06,'c = 0.1 ft lb/rad/s ','FontSize',12)

subplot(2,1,2)
plot(t(1:freq:end),x2A(1:freq:end),'b.','MarkerSize',8)
grid on
axis([0 Tf -0.5 0.5])
set(gca,'XTick',[0:10])
set(gca,'FontSize',11)
set(gca,'YTick',[-0.5:0.25:0.5])
ylabel('x_{2,A}(n),  rad/s','FontSize',12)
xlabel('t  (s)','FontSize',12)
text(4,0.35,'x_{2,A}(0) = dx(0)/dt = 0.5 rad/s','FontSize',12')

% begin Figure 3.33
figure(3)
c=0;  
x10=pi/6;  
x20=0;  
x1A(1)=x10;
x2A(1)=x20;
t(1)=0;
mgr=m*g*r;
Tf=20;
nf=round(Tf/T);
for n=1:nf
    t(n+1)=n*T;
    x1A(n+1)=x1A(n)+T*x2A(n);
    x2A(n+1)=x2A(n)-(T/J)*(mgr*sin(x1A(n))+c*x2A(n));
end % n

x1A(1)=x10;
x2A(1)=x20;
t(1)=0;
mgr=m*g*r;
for n=1:nf
    t(n+1)=n*T;
    x1A(n+1)=x1A(n)+T*x2A(n);
    x2A(n+1)=x2A(n)-(T/J)*(mgr*sin(x1A(n))+c*x2A(n));
end % n

subplot(2,1,1)
plot(t(1:freq:end),x1A(1:freq:end),'b.','MarkerSize',8)
grid on
axis([0 Tf -2 2])
set(gca,'XTick',[0:2:20])
set(gca,'YTick',[-2:2])
set(gca,'FontSize',11)
ylabel('x_{1,A}(n),  rad','FontSize',12)
title('Discrete Nonlinear Undamped Pendulum Response  (T=0.0025 s)','FontSize',11)
text(1,-1.35,'c  = 0 ft lb/rad/s','FontSize',12)
text(1,1.5,'x_{1,A}(0) = x(0) = \pi/6 rad','FontSize',12')

subplot(2,1,2)
plot(t(1:freq:end),x2A(1:freq:end),'b.','MarkerSize',8)
grid on
axis([0 Tf -10 10])
set(gca,'XTick',[0:2:20])
set(gca,'YTick',[-10:5:10])
set(gca,'FontSize',11)
ylabel('x_{2,A}(n),  rad/s','FontSize',12)
xlabel('t  (s)','FontSize',12)
text(1,7,'x_{2,A}(0) = dx\rm(0)/dt = 0 rad/s','FontSize',12')



