% CRC File: Ch3_Ex_3_2.m
% Finds numerical values for TABLE 3.3 and plots FIGURE 3.6

clear all
close all
clc

w=2*pi;

subplot(2,1,1)
plot([0 1],[0 0],'k')
grid on
hold on

%%%%% use for area under sine function for text
ti=linspace(0,0.4,300);
ui=sin(w*ti);
plot(ti,ui,'k','LineWidth',1.3)
num=100;
for i=1:num
    t=(i/num)*0.4;
    u=sin(w*t);
    plot([t t],[0 u],'k','LineWidth',1.3)
end % for i=1:num
    

%%%%% comment out for text
%area(ti,ui)


ti=linspace(0,1,300);
ui=sin(w*ti);
plot(ti,ui,'r','LineWidth',1.5)
axis([0 1 -1.1 1.1])
set(gca,'XTIck',[0:0.1:1],'FontSize',11)
set(gca,'YTIck',[-1:0.5:1],'FontSize',11)
ylabel('u(t)','FontSize',12)
title('Integrator Input  u(t) = sin2\pit','FontSize',11)

subplot(2,1,2)
t4=0.4;
xt4=(1/w)*(1-cos(w*t4));
plot(t4,xt4,'r.','MarkerSize',15)
grid on
hold on
plot([t4 t4],[0 xt4],'k--')
xi=(1/w)*(1-cos(w*ti));
plot(ti,xi,'b','LineWidth',1.3)
set(gca,'XTIck',[0:0.1:1],'FontSize',11)
set(gca,'YTIck',[0:0.1:0.4],'FontSize',11)
xlabel('t','FontSize',12)
ylabel('x(t)','FontSize',12)
text(0.02,0.30,'Area under input','FontSize',11)
text(0.02,0.25,'from t = 0 to t = 0.4','FontSize',11)
title('Integrator Output x(t) = (1/2\pi)(1-cos2\pit)','FontSize',11)
plot([0.3 0.4],[0.29 0.29],'k')

%%%%% begin explicit Euler
for T=[0.005 0.01 0.025 0.05]
    
    xAe(1)=0;
    nfinal=t4/T;
    xAe(1)=0;
        
   for n=1:nfinal
      u(n)=sin(2*pi*(n-1)*T);
      xAe(n+1)=xAe(n)+T*u(n);
   end % n
   
   T;nfinal;xAe(nfinal+1);
   pct_err=100*(xAe(nfinal+1)-xt4)/xt4;
    
end % for T


%%%%% begin implicit Euler
for T=[0.005 0.01 0.025 0.05]
    
    xAi(1)=0;
    nfinal=t4/T;
    xAi(1)=0;
        
   for n=1:nfinal
      u(n)=sin(2*pi*n*T);
      xAi(n+1)=xAi(n)+T*u(n);
   end % n
   
   T;nfinal;xAi(nfinal+1);
   pct_err=100*(xAi(nfinal+1)-xt4)/xt4;
    
end % for T


    






