% File: Ch3_Ex3_4.m
% Plots Figure 3.9

clc, close all, clear all

T=0.01;
tfinal=1;
nfinal=round(tfinal/T);

xA(1)=1; % initial condition
for n=1:nfinal+1
    t(n)=(n-1)*T;
    un=-1.5*((n-1)*T)^2;
    unplus1=-1.5*(n*T)^2;
    c1=(T/2)*(un-2*(n-1)*T*xA(n))/(((n-1)*T)^2+xA(n));
    c2=(T/2)*unplus1;
    c3=n*T^2;
    c4=(n*T)^2;
    b=-c1+c3+c4-xA(n);
    c=-c2-c4*(xA(n)+c1);
    disc=(b^2)-4*c;
    xA(n+1)=(-b+sqrt(disc))/2;
    y(n)=-t(n)^2 + sqrt(t(n)^4 - t(n)^3 +1);
end

del=2;
plot(t(1:del:end),xA(1:del:end-1),'.r','MarkerSize',10)
grid on
xlabel('t','FontSize',12)
hold on
plot(t,y,'b','LineWidth',1.3)
axis([0 1 -0.05 1.05])
text(0.3,0.13,'T = 0.01','FontSize',12)
title('Trapezoidal Integration of Nonlinear Time-Varying System','FontSize',11)
text(0.13,0.54,'x_A(n), n = 0,2,4,...,100','FontSize',12)
text(0.13,0.43,'x(t)','FontSize',12)    
plot([0.08],[0.54],'.r','MarkerSize',10)
plot([0.06 0.1],[0.43 0.43],'b','LineWidth',1.3)
    