% File: Ch3_Ex3_5.m
% Generates numerical values for TABLE 3.3 and plots Figure 3.10

clear all, close all, clc

g=32.2; W=350; FB=275; c=0.8;
tau=W/(c*g);
T=0.5;
a0=c*g/W; b0=(g/W)*(W-FB);

tfinal=75;
    
nfinal=round(tfinal/T);
alpha=(1-(a0*T/2))/(1+(a0*T/2));
beta=2*(b0*T/2)/(1+(a0*T/2)); 


%%%%% begin parts b) and c)
vA(1)=0;  
 for n=1:nfinal
   t(n)=(n-1)*T;
   tn=t(n);
   vA(n+1)=alpha*vA(n)+beta;
   v(n)=((W-FB)/c)*(1-exp(-tn/tau)); 
 end % n
    
t(nfinal+1)=nfinal*T;
tn=t(nfinal+1);
v(nfinal+1)=((W-FB)/c)*(1-exp(-tn/tau));


% sprintf('vA = %.4f \n',vA(1:10:end))
% sprintf('v = %.4f \n',v(1:10:end))

for n=1:10:151
s=sprintf('n = %.0f    vA = %.4f   v = %.4f ',n-1,vA(n),v(n));
disp(s)
end % for n


%%%%% begin part d)
plot(t(1:5:end),vA(1:5:end),'.r','MarkerSize',12)
grid on
hold on
plot(t,v,'b','LineWidth',1.3)
set(gca,'FontSize',11)
xlabel('t  (s)','FontSize',13)
ylabel('v(t), v_A(n)   ft/s','FontSize',13)
title('Discrete (Trapezoidal) and Continuous Responses','FontSize',13) 
text(40,65,'v_A(n), n = 0,5,10,...,150','FontSize',13)
text(40,55,'v(t), 0 \leq t \leq75','FontSize',13)
text(40,17,'T = 0.5 s','FontSize',13)
text(40,36,'v(t) = 93.75 (1-e^{-t /13.587} )','FontSize',13)
plot([37],[65],'.r','MarkerSize',12)
plot([36 38],[55 55],'b','LineWidth',1.3)
 
 
 
 
 
 
 
 