% Ch3_Ex3_6.m
% Generates numerical values in Table 3.6 and plots Figure 3.11

clc
clear all
close all

W=350;
g=32.2;
c=0.8;
FB=275;

vA(1)=0;
nf=6000;
for n=1:nf
    x=vA(n)-0.0736;
    vA(n+1)=(x+sqrt(x*x+27.6))/2;
end

for n = 1:1000:6001
s=sprintf('n = %.0f     VA = %.4f',n-1,vA(n));
disp(s)
end % for i

vi=linspace(0,93.75,300);
x1=W-FB;
x2=(x1-c*vi)/x1;
x3=(x1/(c*c))*log(x2);
yi=-(W/g)*((vi/c)+x3);
plot(yi,vi,'b','LineWidth',1.3)
grid on
axis([0 6000 0 100])
hold on
set(gca,'YTick',[0:10:100])
set(gca,'FontSize',11)

for n=1:1000:6001
   plot([n-1],[vA(n)],'r.','MarkerSize',12) 
   plot([n-1 n-1],[0 vA(n)],'k--')   
end % for n

plot([2250],[42],'r.','MarkerSize',12)
text(2450,42,'v_A(n), n = 0,1000,2000,...,6000','FontSize',13)
plot([2150 2350],[32 32],'b','LineWidth',1.3)
text(2450,32,'v(y),   0 \leq y \leq 6000','FontSize',13)

xlabel('y  (ft)','FontSize',12)
ylabel('v  (ft/s)','FontSize',12)
title('Actual Velocity v(y) vs Depth y','FontSize',11)



