% File: Ch3_Ex3_7.m
% Generates numerical values and plots Figure 3.15

close all, clc, clear all

R1=10000; R2=5000; C1=7.5e-6; C2=2.5e-6;
tau1=R1*C1; tau2=R2*C2; tau12=R1*C2;
a0=1/(tau1*tau2);
a1=(tau1+tau12+tau2)/(tau1*tau2);
b0=a0; 
b1=(tau1+tau2)/(tau1*tau2); 
b2=1;
A=[0 1; -a0 -a1];
eig(A)
B=[0; 1];
C=[b0-a0*b2 b1-a1*b2];
D=b2;
T=0.001;
G=eye(2)+T*A;
H=T*B;
xA(1,1)=0; x1A(1)=0;
xA(2,1)=0; x2A(1)=0;
tfinal =1;
nfinal=round(tfinal/T);
u=1;

for n=1:nfinal  
    t(n)=(n-1)*T;
    yA(n)=C*xA+D*u;
    xA=G*xA+H*u;
    x1A(n+1)=xA(1,1);
    x2A(n+1)=xA(2,1);
end
subplot(2,1,1)
plot(t(1:25),yA(1:25),'.b','MarkerSize',9)
grid on
hold on
plot(t(26:10:end),yA(26:10:end),'r.','MarkerSize',9)
axis([0 0.5 0.78 1.02])
ylabel('v_0(n)   (V)','FontSize',12)
title('v_0(n) vs t using states x_1, x_2 from simulation diagram','FontSize',11)


% comment out for text book
% text(0.25,0.93,'v_0(n), n = 0,1,2,...,24','FontSize',12)
% plot([0.23],[0.93],'.b','MarkerSize',10)
% text(0.25,0.87,'v_0(n), n = 25,35,45,...','FontSize',12)
% plot([0.23],[0.87],'.r','MarkerSize',10)

% use for text book
text(0.20,0.87,'v_0(n), n = 0,1,2,...,24,25,35,45,...','FontSize',12)
plot([0.18],[0.87],'.k','MarkerSize',10)



%%%%% alternate state equations
clear A B C D t yA xA

A=[(-1/C1)*((1/R1)+(1/R2)) -1/(R2*C1); -1/tau2 -1/tau2];
eig(A)
B=[1/(R2*C1); 1/tau2];
C=[-1 0];
D=1;
G=eye(2)+T*A;
H=T*B;
xA(1,1)=0; x1A(1)=0;
xA(2,1)=0; x2A(1)=0;
tfinal =1;
nfinal=round(tfinal/T);
u=1;

for n=1:nfinal  
    t(n)=(n-1)*T;
    yA(n)=C*xA+D*u;
    xA=G*xA+H*u;
    x1A(n+1)=xA(1,1);
    x2A(n+1)=xA(2,1);
end
subplot(2,1,2)
plot(t(1:25),yA(1:25),'.b','MarkerSize',10)
grid on
hold on
plot(t(26:10:end),yA(26:10:end),'.r','MarkerSize',10)

axis([0 0.5 0.78 1.02])
xlabel('t  (s)','FontSize',12)
ylabel('v_0(n)   (V)','FontSize',12)
title('v_0(n) vs t using states v_{C1}, v_{C2}','FontSize',11)

% comment out for text book
% text(0.25,0.93,'v_0(n), n = 0,1,2,...,24','FontSize',12)
% plot([0.23],[0.93],'.b','MarkerSize',10)
% text(0.25,0.87,'v_0(n), n = 25,35,45,...','FontSize',12)
% plot([0.23],[0.87],'.r','MarkerSize',10)

% use for text book
text(0.20,0.87,'v_0(n), n = 0,1,2,...,24,25,35,45,...','FontSize',12)
plot([0.18],[0.87],'.k','MarkerSize',10)
