% File: Ch3_Ex3_9.m
% Generates numerical values in Example 3.9 and plots Figure 3.20 and Figure 3.21

clc
clear all
close all

w=1;
T=0.25;
wT=w*T;

m=input('Enter method: 1=Euler 2=Heun ');
switch m
   
case 1
G(1,1)=1;
G(1,2)=T;
G(2,1)=-w*wT;
G(2,2)=G(1,1);
   
case 2
G(1,1)=1-(wT*wT)/2;
G(1,2)=T;
G(2,1)=-w*wT;
G(2,2)=G(1,1);

end % case

x0=1;
nf=50;

for n=1:nf
    P=(G^n);
    x1A(n)=P(1,1)*x0;
    x2A(n)=P(2,1)*x0;
end % n
    
period=2*pi/w;
ti=linspace(0,2*period,500);
x1i=x0*cos(w*ti);
x2i=-w*x0*sin(w*ti);
n=1:nf;
t=n*T;

subplot(2,1,1)
hold on
t=[0 t]; x1A=[x0 x1A];
plot(t,x1A,'.r','MarkerSize',10)
grid on
plot(ti,x1i,'b','LineWidth',1.3)
axis([0 t(end) -4 6])
set(gca,'XTick',[0:12],'FontSize',11)
set(gca,'YTick',[-4:2:6],'FontSize',11)
xlabel('t  (s)','FontSize',12)
text(1,4.75,'x_{1,A}(n), n = 0,1,2,...,50','FontSize',11)
plot([0.75],[4.75],'.r','MarkerSize',10)
text(1,2.6,'x_1(t), 0 \leq t \leq 2\pi','FontSize',11)
plot([0.6 0.9],[2.6 2.6],'b','LineWidth',1.3)
if m==1
  title('Explicit Euler (T = 0.25 s)','FontSize',11)
else
  title('Improved Euler (T= 0.25 s)','FontSize',11)
end % if
ylabel('x_1','FontSize',12)

subplot(2,1,2)
hold on
x2A=[0 x2A];
plot(t,x2A,'r.','MarkerSize',10)
grid on
plot(ti,x2i,'b','LineWidth',1.3)
axis([0 t(end) -4 6])
set(gca,'XTick',[0:12],'FontSize',11)
set(gca,'YTick',[-4:2:6],'FontSize',11)
xlabel('t  (s)','FontSize',11)
text(1,4.75,'x_{2,A}(n), n = 0,1,2,...,50','FontSize',11)
text(1,2.5,'x_2(t), 0 \leq t \leq 2\pi','FontSize',11)
plot([0.75],[4.75],'r.','MarkerSize',10)
plot([0.6 0.9],[2.5 2.5],'b','LineWidth',1.3)
ylabel('x_2','FontSize',12)

