% m-file Ch4_CaseStudy1.m

clc, close all, clear all
warning off
v0=500;
alpha_bar=0.05;
theta_bar=0.05;
u_bar=v0*cos(theta_bar);

A=[-0.04 11.59 0 -32.2; -0.00073 -0.65 1 0; 0.000048 -0.49 -0.58 0; 0 0 1 0];
B=[0 1; 0 0; -0.0141 0; 0 0];
C=eye(4);
D=[0 0; 0 0; 0 0; 0 0];
eig(A);
[numG denG]=ss2tf(A,B,C,D,1);
numG_u=numG(1,:);
numG_alpha=numG(2,:);
numG_q=numG(3,:);
numG_theta=numG(4,:);
sys_u=tf(numG_u,denG);
sys_alpha=tf(numG_alpha,denG);
sys_q=tf(numG_q,denG);
sys_theta=tf(numG_theta,denG); 
% figure(1)
% hold on
% step(sys_u)
% figure(2)
% hold on
% step(sys_alpha)
% figure(3)
% hold on
% step(sys_q)
% figure(4)
% hold on
% step(sys_theta)

roots_denG=roots(denG); 
root1_denG=roots_denG(1);
root2_denG=roots_denG(2);
root3_denG=roots_denG(3);
root4_denG=roots_denG(4);
quadratic1_denG=conv([1 -root1_denG],[1 -root2_denG]);
quadratic2_denG=conv([1 -root3_denG],[1 -root4_denG]);

%%%%% find K_theta,c1,c2 in numerator K_theta*(s+c1)*(s+c2)
numG_theta=numG_theta(3:5);
roots_numG_theta=roots(numG_theta);
root1_numG_theta=roots_numG_theta(1);
root2_numG_theta=roots_numG_theta(2);
K_theta=numG_theta(1);
c1=-root1_numG_theta;
c2=-root2_numG_theta;

%%%%% find a1,b1,a2,b2
a1=quadratic1_denG(2);
b1=quadratic1_denG(3);
a2=quadratic2_denG(2);
b2=quadratic2_denG(3);

%%%%% find residues and poles for theta step response
num_theta_step=numG_theta/K_theta;
den_step=[denG 0];
theta_step=tf(num_theta_step,den_step);
[R,P]=residue(num_theta_step,den_step);
R1_theta=R(1); R2_theta=R(2); R3_theta=R(3); R4_theta=R(4); R5_theta=R(5);
p1=P(1); p2=P(2); p3=P(3); p4=P(4); p5=P(5);

%%%%% find short period and phugoid parameters wn, zeta and envelope tau
wn_quadratic1_denG=sqrt(b1);
zeta_quadratic1_denG=0.5*a1/wn_quadratic1_denG;
tau_envelope_quadratic1_denG=1/(zeta_quadratic1_denG*wn_quadratic1_denG);
wn_quadratic2_denG=sqrt(b2);
zeta_quadratic2_denG=0.5*a2/wn_quadratic2_denG;
tau_envelope_quadratic2_denG=1/(zeta_quadratic2_denG*wn_quadratic2_denG);

%%%%% plot theta step response
tfinal=5.5*tau_envelope_quadratic2_denG;
ti=linspace(0,tfinal,2000);
alpha1=real(p1); beta1=imag(p1);
ReR1=real(R1_theta); ImR1=imag(R1_theta);
alpha3=real(p3); beta3=imag(p3);
ReR3=real(R3_theta); ImR3=imag(R3_theta);
theta_step_ss=K_theta*R5_theta; 
theta_step_ss_deg=theta_step_ss*180/pi; 
theta_step_short_period=K_theta*2*exp(alpha1*ti).*(ReR1*cos(beta1*ti)-ImR1*sin(beta1*ti));
theta_step_phugoid=K_theta*2*exp(alpha3*ti).*(ReR3*cos(beta3*ti)-ImR3*sin(beta3*ti));
thetai=theta_step_short_period+theta_step_phugoid+theta_step_ss;

figure(1)
plot(ti,thetai,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([0 400 -0.12 0.02]) 
xlabel('t  (s)','FontSize',12)
ylabel('\Delta\theta(t)   (rad)','FontSize',12)
title('Linearized Aircraft Pitch Response to 1 deg Elevator Deflection','FontSize',11)
text(200,-0.07,'v_0 = 500 ft/s','FontSize',12)
text(200,-0.085,'\alpha = \theta = 0.05 rad','FontSize',12)
text(201,-0.08,'_','FontSize',12)
text(227.5,-0.0785,'_','FontSize',12)

%%%%% plot theta short period and phugoid responses
figure(2)
subplot(2,1,1)
plot(ti,theta_step_short_period,'b','LineWidth',1.3)

grid on
set(gca,'FontSize',11)
axis([0 10 -0.001 0.007])
ylabel('\Delta\theta_{short period}(t)  (rad)','FontSize',12)
title('Short Period Oscillation','FontSize',11)
text(5,2.4e-3,'\Delta\delta_{e} = 1 deg','FontSize',13)

subplot(2,1,2)
plot(ti,theta_step_phugoid,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([0 400 -0.085 0.06])
xlabel('t  (s)','FontSize',12)
ylabel('\Delta\theta_{phugoid}(t)  (rad)','FontSize',12)
title('Phugoid Mode','FontSize',12)
text(200,-0.042,'\Delta\delta_e = 1 deg','FontSize',13)

%%%%%find K_alpha,d1,d0 in numerator K_alpha*(s^2 + d1*s +d0)
numG_alpha=numG_alpha(3:5);
roots_numG_alpha=roots(numG_alpha);
K_alpha=numG_alpha(1); 
d1=numG_alpha(2)/K_alpha; 
d0=numG_alpha(3)/K_alpha; 

%%%%%%%%%% begin find zdot step response %%%%%%%%%%
%%%% find lambda0, lambda1, lambda2 in numerator elev*[lambda2*s^2 + lambda1*s + lambd0] of
%%%% zdot(s)
elev=1; % elevator deflection (deg)
lambda2=-u_bar*(K_alpha-K_theta); 
lambda1=-u_bar*(K_theta*(c1+c2)-K_alpha*d1);
lambda0=-u_bar*(K_theta*c1*c2-K_alpha*d0); 
num_zdot=elev*[lambda2 lambda1 lambda0];
den_zdot=den_step;
zdot_step=tf(num_zdot,den_zdot);
zdot_ss=elev*lambda0/(b1*b2);
[R,P]=residue(num_zdot,den_zdot);
R1_zdot=R(1); R2_zdot=R(2); R3_zdot=R(3); R4_zdot=R(4); R5_zdot=R(5);
ReR1=real(R1_zdot); ImR1=imag(R1_zdot);
ReR3=real(R3_zdot); ImR3=imag(R3_zdot); 
z1i=2*exp(alpha1*ti).*(ReR1*cos(beta1*ti)-ImR1*sin(beta1*ti));
z2i=2*exp(alpha3*ti).*(ReR3*cos(beta3*ti)-ImR3*sin(beta3*ti));
zdot_step=z1i+z2i+R5_zdot;

figure(3)
subplot(2,1,1)
plot(ti,zdot_step,'b','LineWidth',1.3)
grid on
axis([0 400 -25 50])
set(gca,'FontSize',11)
ylabel('dz^{''}/dt (ft/s)','FontSize',12)
title('Rate of Change of Altitude vs Time','FontSize',11)
text(250,23,'\Delta\delta_e = 1 deg','FontSize',12)
text(100,37,'v_0 = 500 ft/s','FontSize',12)
text(100,24,'\alpha = \theta = 0.05 rad','FontSize',12)
text(101,31.0,'_','FontSize',12)
text(128.50,33,'_','FontSize',12)

 %%%%%%%%%% begin find z step response %%%%%%%%%%
num_z=num_zdot;
den_z=[den_zdot 0];
z_step=tf(num_z,den_z);
[R,P]=residue(num_z,den_z);
R1_z=R(1); R2_z=R(2); R3_z=R(3); R4_z=R(4); R5_z=R(5); R6_z=R(6);
ReR1=real(R1_z); ImR1=imag(R1_z);
ReR3=real(R3_z); ImR3=imag(R3_z); 
z1i=2*exp(alpha1*ti).*(ReR1*cos(beta1*ti)-ImR1*sin(beta1*ti));
z2i=2*exp(alpha3*ti).*(ReR3*cos(beta3*ti)-ImR3*sin(beta3*ti));
z_step=z1i+z2i+R6_z*ti+R5_z;

subplot(2,1,2)
plot(ti,z_step,'b','LineWidth',1.3)
grid on
axis([0 400 0 3000])
set(gca,'FontSize',11)
xlabel('t  (s)','FontSize',12)
ylabel('\Deltaz^{''}(t)  (ft)','FontSize',12)
title('Change in Altitude from Steady-State vs Time','FontSize',11)
text(250,1100,'\Delta\delta_e = 1 deg','FontSize',12)
text(50,2300,'v_0 = 500 ft/s','FontSize',12)
text(50,1600,'\alpha = \theta = 0.05 rad','FontSize',12)
text(51,1900,'_','FontSize',12)
text(78.0,1950,'_','FontSize',12)

%%%%% find z pulse response %%%%%
%% pulse duration is T_pulse
T_pulse=30; pulse_amp=5; % elevator pulse amplitude (deg)
tfinal=500;
dt=0.1;
ifinal=round(tfinal/dt);
for i=1:ifinal
  t=(i-1)*dt;   
  tau(i)=t;
  z1=2*exp(alpha1*t)*(ReR1*cos(beta1*t)-ImR1*sin(beta1*t));
  z2=2*exp(alpha3*t)*(ReR3*cos(beta3*t)-ImR3*sin(beta3*t));
  zA=z1+z2+R6_z*t+R5_z; 
  
  if t < T_pulse
      zB=0;
  else
      tt=t-T_pulse;
      z1_delay=2*exp(alpha1*tt)*(ReR1*cos(beta1*tt)-ImR1*sin(beta1*tt));
      z2_delay=2*exp(alpha3*tt)*(ReR3*cos(beta3*tt)-ImR3*sin(beta3*tt));  
      zB=z1_delay+z2_delay+R6_z*tt+R5_z;
  end       
  z(i)=pulse_amp*(zA-zB);
 
end % for

figure(4)
plot(tau,z,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([0 500 -1400 4100])
xlabel('t  (s)','FontSize',12)
ylabel('\Deltaz  (ft)','FontSize',12)
title('Open and Closed-Loop Aircraft Altitude Response vs Time','FontSize',11)
text(41,3100,'open-loop response: \Delta\delta_e = 5 deg pulse of 30 s duration','FontSize',12)
text(198,2100,'\Deltaz_{ss} = 927.5 ft','FontSize',12)

%%%%% begin altitude control system response %%%%%
Ka=1;
Kzdot=0.01;
Kc_hat=0.001;
mu4=a1+a2;
mu3=a1*a2+b1+b2;
mu2=a1*b2+a2*b1+Kzdot*Ka*lambda1;
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;

num_cs_z=Kc_hat*Ka*[lambda1 lambda0];
den_cs_z=[1 mu4 mu3 mu2 mu1 mu0];
roots(den_cs_z); 
sys_cs_z=tf(num_cs_z,den_cs_z);
T=linspace(0,500,1000);
[Y,T]=step(sys_cs_z,T); % unit step response of control system
z_com=927.5;
z_cs=z_com*Y; % response to z_com
hold on
plot(T,z_cs,'r')
text(175,300,'closed-loop response: \Deltaz_{com} \rm= 927.5 ft','FontSize',12)
text(366.5,-25,'\wedge')
text(365,-300,'K_C = 0.001','FontSize',12)
text(353.5,-800,'\Deltaz_{ss} = 927.5 ft','FontSize',12) 

%%%% begin closed-loop system elevator response %%%%%
figure(5)
Kc_hat=0.001;
n=conv([1 a1 b1],[1 a2 b2]);
n=Kc_hat*Ka*conv([1 0],n);
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
d=[1 mu4 mu3 mu2 mu1 mu0];
roots(d);
sys=tf(n,d); 
[Y,T]=step(sys,T);
elev=z_com*Y;

hold on
plot(T,elev,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([-100 400 -1.5 5.5])
text(-95,0.9,'K_C = 0.001','FontSize',12)
text(-94.0,1.25,'\wedge')
text(-94.0,3.05,'\wedge')
text(-94.0,4.85,'\wedge')

Kc_hat=0.003;
n=conv([1 a1 b1],[1 a2 b2]);
n=Kc_hat*Ka*conv([1 0],n);
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
d=[1 mu4 mu3 mu2 mu1 mu0];
roots(d); 
sys=tf(n,d); 
[Y,T]=step(sys,T);
elev=z_com*Y;
plot(T,elev,'r','LineWidth',1.3)
text(-95,2.7,'K_C = 0.003','FontSize',12)
 
Kc_hat=0.005;
n=conv([1 a1 b1],[1 a2 b2]);
n=Kc_hat*Ka*conv([1 0],n);
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
d=[1 mu4 mu3 mu2 mu1 mu0];
roots(d); 
sys=tf(n,d); 
[Y,T]=step(sys,T);
elev=z_com*Y;
plot(T,elev,'k','LineWidth',1.3)
text(-95,4.5,'K_C = 0.005','FontSize',12)
  
plot([-100 0 0 T_pulse T_pulse 400],[0 0 5 5 0 0],'k','LineWidth',2)
text(-90,0.25,'open-loop','FontSize',12) 
xlabel('t  (s)','FontSize',12)
title('Open and Closed-loop Elevator Deflections for Different Controller Gains','FontSize',11)
ylabel('\Delta\delta_e(t)  (deg)','FontSize',12)
text(175,4.1,'v_0 = 500 ft/s','FontSize',12)
text(175,3.2,'\alpha = \theta = 0.05 rad','FontSize',12)
text(176,3.44,'_','FontSize',12)
text(211,3.55,'_','FontSize',12)
text(175,2.1,'\Deltaz_{com} = 927.5 ft','FontSize',12)
 
% %%%%% begin multiple plots for altitude response %%%%%
figure(6)
Kc_hat=0.001;
mu4=a1+a2;
mu3=a1*a2+b1+b2;
mu2=a1*b2+a2*b1+Kzdot*Ka*lambda1;
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
num_cs_z=Kc_hat*Ka*[lambda1 lambda0];
den_cs_z=[1 mu4 mu3 mu2 mu1 mu0];
roots(den_cs_z);
sys_cs_z=tf(num_cs_z,den_cs_z);
T=linspace(0,400,1000);
[Y,T]=step(sys_cs_z,T); % unit step response of control system
z_com=927.5;
z_cs=z_com*Y; % response to z_com
hold on
plot(T,z_cs,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([0 400 -1300 4050])

Kc_hat=0.003;
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
num_cs_z=Kc_hat*Ka*[lambda1 lambda0];
den_cs_z=[1 mu4 mu3 mu2 mu1 mu0];
roots(den_cs_z);
sys_cs_z=tf(num_cs_z,den_cs_z);
T=linspace(0,400,1000);
[Y,T]=step(sys_cs_z,T); % unit step response of control system
z_com=927.5;
z_cs=z_com*Y; % response to z_com
TT=T;
zz=z_cs;
plot(T,z_cs,'r','LineWidth',1.3)

Kc_hat=0.005;
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
num_cs_z=Kc_hat*Ka*[lambda1 lambda0];
den_cs_z=[1 mu4 mu3 mu2 mu1 mu0];
roots(den_cs_z);
sys_cs_z=tf(num_cs_z,den_cs_z);
sys_z_CL=sys_cs_z;
T=linspace(0,400,2000);
[Y,T]=step(sys_cs_z,T); % unit step response of control system
z_com=927.5;
z_cs=z_com*Y; % response to z_com
plot(T,z_cs,'g','LineWidth',1.3)
plot(tau,z,'k','LineWidth',1.3)
xlabel('t  (s)','FontSize',12)
ylabel('\Deltaz  (ft)','FontSize',12)
title('Open and Closed-loop Altitude Responses for Different Controller Gains','FontSize',11)

text(50,3150,'open-loop','FontSize',12)
text(100,2150,'K_C = 0.005','FontSize',12)
text(125,100,'K_C = 0.003','FontSize',12)
text(250,300,'K_C = 0.001','FontSize',12)
text(100,2400,'\wedge')
text(125.0,350,'\wedge')
text(250,550,'\wedge')

text(250,3100,'v_0 = 500 ft/s','FontSize',12)
text(250,2600,'\alpha = \theta = 0.05 rad','FontSize',12)
text(250,2100,'\Deltaz_{com} = 927.5 ft','FontSize',12)
text(251,2820,'_','FontSize',12)
text(278.0,2880,'_','FontSize',12)

%%%%% begin frequency response %%%%%
%% open-loop zdot
figure(7)
N_zdot_OL=[lambda1 lambda0];
D_zdot_OL=denG;
sys_zdot_OL=tf(N_zdot_OL,D_zdot_OL);
%% open-loop z
N_z_OL=[lambda1 lambda0];
D_z_OL=den_step;
sys_z_OL=tf(N_z_OL,D_z_OL); 
wmin=0.001; wmax=10;
bodemag(sys_zdot_OL,'b',sys_z_OL,'r',sys_z_CL,'g',{wmin,wmax})
grid on
hold on
set(gca,'FontSize',11)
set(gca,'YTick',[-120:20:80])
plot([1e-3 0.28],[-3 -3],'k--')
plot([0.28 0.28],[-120 -3],'k--')
text(3.0e-1,48.5,'|\Deltaz(j\omega)/\Delta\delta_e(j\omega)|','FontSize',12)
text(1.1e-3,28,'|z(j\omega)/\Delta\delta_e(j\omega)|','FontSize',12)
plot(1.3e-3,35,'.k','MarkerSize',7)
text(1.75e-1,-60,'K_C = 0.005','FontSize',12)
text(1.25e-1,-80,'|\Deltaz(j\omega)/\Deltaz_{com}(j\omega)|','FontSize',12)
text(3.5e-1,-100,'\omega_{BW} = 0.28 rad/s','FontSize',12)
text(0.2,-125,'\omega_{BW}','FontSize',12)
text(1.75e-1,-48.5,'\wedge')

%%%%% begin numerical integration of altitude response %%%%%
Kc_hat=0.003;
mu1=b1*b2+Kzdot*Ka*lambda0+Kc_hat*Ka*lambda1;
mu0=Kc_hat*Ka*lambda0;
A=927.5;
T=0.1;
gamma4=-5+mu4*T;
gamma3=10-4*mu4*T+mu3*T^2;
gamma2=-10+6*mu4*T-3*mu3*T^2+mu2*T^3;
gamma1=5-4*mu4*T+3*mu3*T^2-2*mu2*T^3+mu1*T^4;
gamma0=-1+mu4*T-mu3*T^2+mu2*T^3-mu1*T^4+mu0*T^5;

delz(1)=0; delz(2)=0; delz(3)=0; delz(4)=0;
delz(5)=Kc_hat*Ka*(T^4)*lambda1*A;
delz(6)=Kc_hat*Ka*(T^4)*A*(-gamma4*lambda1+lambda0*T);
tfinal=400;
ifinal=round(tfinal/T);

clear t
t(1)=0; t(2)=T; t(3)=2*T; t(4)=3*T; t(5)=4*T; t(6)=5*T;
for i=7:ifinal
    t(i)=(i-1)*T;
    delz(i)=-gamma4*delz(i-1)-gamma3*delz(i-2)-gamma2*delz(i-3)-gamma1*delz(i-4)-gamma0*delz(i-5)+Kc_hat*Ka*(T^5)*A*lambda0;
end

figure(8)
hold on
plot(TT,zz,'b','LineWidth',1.3) % plot continuous altitude
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:100:1000])
del=10;
plot(t(1:del:end),delz(1:del:end),'r.','MarkerSize',8) % plot simulated (Euler) altitude
xlabel('t  (s)','FontSize',12)
ylabel('\Deltaz  (ft)','FontSize',12)
title('Analytical and Simulated Closed-loop System Altitude Response','FontSize',12)
text(200,650,'v_0 = 500 ft/s','FontSize',12)
text(200,550,'\alpha = \theta = 0.05 rad','FontSize',12)
text(201,585,'_','FontSize',11)
text(228,597.0,'_','FontSize',11)
text(200,450,'\Deltaz_{com} = 927.5 ft','FontSize',12)
text(200,325,'K_C = 0.003','FontSize',12) 
text(200.5,375,'\wedge')
text(75,215,'\Deltaz (t),  t\geq 0','FontSize',12)
plot([60 70],[212 212],'b','LineWidth',1.3)
text(75,115,'\Deltaz_k,  k = 0,10,20,...,','FontSize',12)
plot([65],[115],'.r','MarkerSize',8)


%%%%% begin state space simulation using trapezoidal integration %%%%%
clear A t
A=[-0.04 11.59 0 -32.2; -0.00073 -0.65 1 0; 0.000048 -0.49 -0.58 0; 0 0 1 0];
B=[0 0.1; 0 0; -0.0141 0; 0 0];
T=1;
I=eye(4);
H=inv((I-0.5*T*A))*(I+0.5*T*A);
G=T*inv((I-0.5*T*A))*B;
ifinal=round(tfinal/T);
t(1)=0;
delx(1:4,1)=[0; 0; 0; 0];
delu=[5; 0];
for i=2:ifinal
    t(i)=(i-1)*T;
    delx(1:4,i)=H*delx(1:4,i-1)+G*delu;
end
del_u=delx(1,:);
del_alpha=delx(2,:);
q=delx(3,:);
del_theta=delx(4,:); 

figure(9)
subplot(2,2,1)
plot(t,del_u,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:100:400])
set(gca,'YTick',[0:50:200])
hold on
xlabel('t  (s)','FontSize',12)
ylabel('\Deltau  (ft/s)','FontSize',12)
text(-15,250,'Simulation of State Vector Using Trapezoidal Integration (\Delta\delta_e = 5 deg)','FontSize',11)
axis([0 tfinal 0 220])
text(178,175,'T = 1 s','FontSize',11)
plot([184 184],[128.5 160],'b','LineWidth',1.3)
text(172,50,'T = 10 s','FontSize',11)
plot([180 180],[70 98],'r','LineWidth',1.3)

subplot(2,2,2)
plot(t,del_alpha,'b','LineWidth',1.3)
grid on
hold on
set(gca,'FontSize',11)
set(gca,'XTick',[0:100:400])
set(gca,'YTick',[-0.2:0.05:0])
xlabel('t  (s)','FontSize',12)
ylabel('\Delta\alpha  (rad)','FontSize',12)
text(150,-0.085,'T = 1 s','FontSize',11)
plot([159 159],[-0.1 -0.1256],'b','LineWidth',1.3)
text(140,-0.18,'T = 10 s')
plot([150 150],[-0.165 -0.1455],'r','LineWidth',1.3)

subplot(2,2,3)
plot(t,q,'b','LineWidth',1.3)
grid on
hold on
set(gca,'FontSize',11)
set(gca,'XTick',[0:100:400])
xlabel('t  (s)','FontSize',12)
ylabel('\Deltaq  (rad/s)','FontSize',12)
axis([0 tfinal -0.1 0.065])
text(127,0.04,'T = 1 s','FontSize',11)
plot([135 135],[0.01 0.03],'b','LineWidth',1.3)
text(111,-0.053,'T = 10 s','FontSize',11)
plot([120 120],[-0.038 -0.02],'r','LineWidth',1.3)

subplot(2,2,4)
plot(t,del_theta,'b','LineWidth',1.3)
grid on
hold on
set(gca,'FontSize',11)
set(gca,'XTick',[0:100:400])
xlabel('t  (s)','FontSize',12)
ylabel('\Delta\theta  (rad)','FontSize',12)
axis([0 tfinal -0.7 0.15])
text(139,0.02,'T = 1 s','FontSize',11)
plot([148.3 148.3],[-0.04 -0.127],'b','LineWidth',1.3)
text(125,-0.47,'T = 10 s','FontSize',11)
plot([135 135],[-0.4 -0.303],'r','LineWidth',1.3)

% %%%% repeat with different step size
% clear t delx    
% T=5;
% H=inv((I-0.5*T*A))*(I+0.5*T*A);
% G=T*inv((I-0.5*T*A))*B;
% t(1)=0;
% delx(1:4,1)=[0; 0; 0; 0];
% ifinal=round(tfinal/T);
% for i=2:ifinal
%     t(i)=(i-1)*T;
%     delx(1:4,i)=H*delx(1:4,i-1)+G*delu;
% end
% del_u=delx(1,:);
% del_alpha=delx(2,:);
% q=delx(3,:);
% del_theta=delx(4,:); 
% subplot(2,2,1)
% hold on
% plot(t,del_u,'r')
% subplot(2,2,2)
% hold on
% plot(t,del_alpha,'r')
% subplot(2,2,3)
% hold on
% plot(t,q,'r')
% subplot(2,2,4)
% hold on
% plot(t,del_theta,'r')

%%%% repeat with different step size
clear t delx    
T=10;
H=inv((I-0.5*T*A))*(I+0.5*T*A);
G=T*inv((I-0.5*T*A))*B;
t(1)=0;
delx(1:4,1)=[0; 0; 0; 0];
ifinal=round(tfinal/T);
for i=2:ifinal
    t(i)=(i-1)*T;
    delx(1:4,i)=H*delx(1:4,i-1)+G*delu;
end
del_u=delx(1,:);
del_alpha=delx(2,:);
q=delx(3,:);
del_theta=delx(4,:); 
subplot(2,2,1)
hold on
plot(t,del_u,'r','LineWidth',1.3)
subplot(2,2,2)
hold on
plot(t,del_alpha,'r','LineWidth',1.3)
subplot(2,2,3)
hold on
plot(t,q,'r','LineWidth',1.3)
subplot(2,2,4)
hold on
plot(t,del_theta,'r','LineWidth',1.3)
% 
% %%%% find state at steady-state
% delx_ss1=-inv(A)*B*delu 
% delx_ss2=inv(I-inv(I-0.5*T*A)*(I+0.5*T*A))*inv(I-0.5*T*A)*T*B*delu

