% Matlab file Ch4_Ex4_11.m
% Plots Figure 4.16

clc;close all; clear all

k12=0.8; k21=0.005; k23=0.01; k34=0.3; k14=0.15; k41=0.5; ku=1.2; kf=0.02;
k1=k12+k14;
k2=k21+k23;
k3=k34+kf;
k4=k41+ku;

alpha0=k12*k23*k41;  
beta0=k1*k2*k3-k12*k21*k3; 
beta1=k1*k2+k1*k3+k2*k3-k12*k21;
beta2=k1+k2+k3;
gamma0=k12*k41*k3;  
gamma1=k12*k41; 
delta0=k41*k2*k3; 
delta1=k41*(k2+k3);
delta2=k41;

a4=1;
a3=k1+k2+k3+k4;
a2=k1*k2 + k1*k3 + k1*k4 + k2*k3 + k2*k4 + k3*k4 - k12*k21 - k14*k41;
a1=k1*k2*k3 + k1*k2*k4 + k1*k3*k4 + k2*k3*k4 - k14*k41*k2 -(k12*k21+k14*k41)*k3 - k12*k21*k4;
a0=k1*k2*k3*k4 - k14*k41*k2*k3 - k12*k21*k3*k4 - k12*k23*k34*k41;  

A=[-k1 k21 0 k41; k12 -k2 0 0; 0 k23 -k3 0; k14 0 k34 -k4];
B=[0 0; 0 0; 1 0; 0 1];
C=[1 1 1 1; 0 0 kf ku];
D=[0 0; 0 0];
u=[0;150];

xss=-inv(A)*B*u 
sum_xss=sum(xss);

Q4_minus=150; Q4_plus=50;
x20=xss(2) 

n1=Q4_plus*[gamma1 gamma0] 
d1=[1 a3 a2 a1 a0 0] 
n2=[x20 a3*x20 a2*x20 a1*x20-gamma1*Q4_minus] 
d2=[1 a3 a2 a1 a0]

[R1 P1]=residue(n1,d1)
[R2 P2]=residue(n2,d2)

P=P1 
R=R1+[R2; 0]


c1=R(1); c2=R(2); c3=R(3); c4=R(4); c5=R(5);
p1=P(1); p2=P(2); p3=P(3); p4=P(4); p5=P(5);
ti=linspace(1,625,1000);
x2i=c1*exp(p1*ti)+c2*exp(p2*ti)+c3*exp(p3*ti)+c4*exp(p4*ti)+c5*exp(p5*ti);
plot(ti,x2i,'b','LineWidth',1.3)
grid on
axis([0 625 1500 5000])
set(gca,'FontSize',11)
xlabel('t  (days)','FontSize',13)
ylabel('x_2(t),  \mug','FontSize',13)
title('Response of x_2(t) Following Step Change in q_4(t) from 150 to 50 \mug/day','FontSize',11) 











