% Matlab file CH4_Ex4_12.m
% Plots Figure 4.23 and Figure 4.24

clc; clear all; close all

A=1; w0=2; K=3; tau=0.5;

t=0:0.0025:8;
u=A*sin(w0*t);
ytr=((K*A*w0*tau)/(1+(w0*tau)^2))*exp(-t/tau);
phi=-atan(w0*tau);
yss=((K*A)/sqrt((1+(w0*tau)^2)))*sin(w0*t+phi);
y=ytr+yss;
plot(t,u,t,y,'LineWidth',1.3)
grid on
hold on
plot([0 8],[0 0],'k')
axis([0 8 -2.75 2.75])
set(gca,'FontSize',11)
xlabel('t  (s)','FontSize',12)
text(0.25,-0.5,'u(t) = sin2t','FontSize',12)
text(1.0,-2.3,'y(t) = 1.5e^{-2t} + 1.5\surd2sin(2t - \pi/2)','FontSize',12)
title('Sinusoidal Response of First Order System, H(s)=K / (\taus + 1)','FontSize',11)

figure(2)
plot(t,u,t,y,'LineWidth',1.3)
hold on
plot([0 8],[0 0],'k')
grid on
axis([3.6 5.2 0 2.2])
set(gca,'FontSize',11)
set(gca,'XTick',[3.6:0.1:5.2])
set(gca,'YTick',[0:0.2:2.2])
xlabel('\itt  \rm(s)','FontSize',12)
plot([3.925 3.925],[0 1],'k--')
plot([4.318 4.318],[0 2.121],'k--')
plot([3.925 4.318],[0.4 0.4],'k')
text(4.1,0.475,'T')
title('Close-up Showing Output Lag Time T','FontSize',11)
text(4.5,0.55,'Input u(t)','FontSize',12)
text(4.7,1.7,'Output y(t)','FontSIze',12)
