% m-file Ch4_Ex4_14.m
% Plots Figure 4.35

clc; close all; clear all

tau=1;
t=0:0.01:5*tau;
y=exp(-t/tau);
plot(t,y,'--')
grid on
axis([-1 6 -0.2 1.2])
set(gca,'XTick',[0:6])
set(gca,'YTick',[0:0.2:1])
set(gca,'FontSize',11)
hold on
tsamp=0:0.25:5*tau;
ysamp=exp(-tsamp/tau);
plot(tsamp,ysamp,'.','MarkerSize',12)
plot([0 5],[0 0],'k')
plot([0 0],[0 1],'k')
plot([0.25 0.25],[0 0.025],'k')
plot([0.5 0.5],[0 0.025],'k')
plot([0.75 0.75],[0 0.025],'k')
plot([1 1],[0 0.025],'k')

xlabel('t  (s)','FontSize',12)
title('Uniform Sampling of a Continuous-time Exponential Function','FontSize',11)
text(0.1,1,'u_0','FontSize',12)
text(0.4,0.78,'u_1','FontSize',12)
text(0.6,0.62,'u_2','FontSize',12)
text(0.90,0.48,'u_3','FontSize',12)
text(5.2,0,'k')
text(2,1.0,'u(t) = e^{-at},  t \geq 0','FontSize',12)
text(3,0.85,'a = 1','FontSize',12)
text(2,0.5,'u_k = e^{-akT}, k = 0,1,2,3,...','FontSize',12)
text(3,0.35,'T = 0.25 s','FontSize',12)
text(0,-0.05,'0')
text(0.2,-0.05,'1')
text(0.475,-0.05,'2')
text(0.725,-0.05,'3')
text(0.98,-0.05,'4')
text(1.2,-0.05,'..............................','FontSize',12)
