% m-file Ch4_Ex4_16.m
% Plots Figure 4.37 and Figure 4.38

clc; close all; clear all

w=3; % rad/sec
tfinal=2*pi;
t=linspace(0,tfinal,500);
x=sin(w*t);
v=[-0.5,tfinal+0.5,-1.1,1.1];
subplot(2,1,1)
plot(t,x,'--')
grid on
axis(v)
hold on
T=pi/6;
kfinal=round(tfinal/T);
k=1:kfinal;
tk=(k-1)*T;
xk=sin(w*tk);
plot(tk,xk,'.r')
for i=1:kfinal
    plot([tk(i) tk(i)],[-0.05 0.05],'k')
    text(tk(i)-0.05,-0.2,num2str(i-1))
end % k
text(tfinal,-0.2,'k')
plot([0 tfinal],[0 0],'k')
title('x(t) = sin3t, t \geq 0   and  x_{k} = x(kT), k = 0,1,2,3,...  T = \pi/6 s','FontSize',11)
legend('x(t)','x_k')
subplot(2,1,2)
plot(t,x,'--')
grid on
axis(v)
hold on
T=pi/3;
kfinal=round(tfinal/T);
k=1:kfinal;
tk=(k-1)*T;
xk=sin(w*tk);
plot(tk,xk,'.r','MarkerSize',12)
for i=1:kfinal
    plot([tk(i) tk(i)],[-0.05 0.05],'k')
    text(tk(i)-0.05,-0.2,num2str(i-1))
end % k
text(tfinal,-0.2,'k')
plot([0 tfinal],[0 0],'k')
xlabel('t  (s)','FontSize',11)
title('x(t) = sin3t, t  \geq 0  and  x_k = x(kT), k = 0,1,2,3,...  T = \pi/3 s','FontSize',11)
legend('x(t)','x_k')

figure(2)
w=pi;
tfinal=12*pi/w;
t=linspace(0,tfinal,500);
x=cos(w*t);
plot(t,x,'--')
grid on
axis(v)
hold on
T=2*pi/w;
kfinal=round(tfinal/T);
k=1:kfinal+1;
tk=(k-1)*T;
xk=cos(w*tk);
plot(tk,xk,'.r','MarkerSize',12)
v=[-0.5,tfinal+0.5,-1.1,1.4];
axis(v)
set(gca,'XTick',[])
for i=1:kfinal
    plot([tk(i) tk(i)],[-0.04 0.04],'k')
    text(tk(i)-0.05,-0.15,num2str(i-1))
end % k
plot([tk(i+1) tk(i+1)],[-0.04 0.04],'k')
text(tfinal,-0.15,'k','FontSize',11)
plot([0 tfinal],[0 0],'k')
xlabel('t  (s)','FontSize',12)
set(gca,'FontSize',11)
for i=2:kfinal-1
    text(tk(i)+0.15,-1.59,'\pi/\omega','FontSize',11)
end % i
for i=kfinal:kfinal+1
    text(tk(i)+0.25,-1.59,'\pi/\omega','FontSize',11)
end % i

title('x(t) = cos\omegat, t \geq 0   and  x_k = x(kT), k = 0,1,2,3,... T = 2\pi/\omega s','FontSize',11)
legend('x(t)','x_k')



 
