% m-file Ch4_Ex4_26.m
% Plots Figure 4.50

clc; close all; clear all

wn=2; zeta=0.5; K=1;
T=0.025; 
wnT=wn*T; wnTsq=wnT*wnT;
a1=2*(1-zeta*wnT);
a2=-(1-2*zeta*wnT+wnTsq);
b2=K*wnTsq;
tfinal=5;
kfinal=round(tfinal/T);

y(1)=0;
t(1)=0;
y(2)=K*wnT*wnT;
t(2)=T;
for k=3:kfinal
  t(k)=(k-1)*T;
  y(k)=a1*y(k-1)+a2*y(k-2)+b2;
end % k
incr=2;
plot(t(1:incr:end),y(1:incr:end),'.r')
grid on
axis([0 5 0 1.25])
xlabel('t  (s)','FontSize',12)

wd=sqrt(1-zeta^2)*wn;
t=linspace(0,tfinal,500);
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)));
hold on
plot(t,ycont,'b','LineWidth',1.3)
    
title('Step Response of Discrete and Continuous Second-Order Systems','FontSize',11)
text(2.5,0.83,'y_k ,  k = 0,2,4,6,...200','FontSize',12)
plot(2.3,0.83,'.r')
text(2.5,0.63,'y(t),  0 \leq t \leq 5','FontSize',12)
plot([2.2 2.4],[0.63 0.63],'b','LineWidth',1.3)
text(1.5,0.23,'Explicit Euler Integration, T = 0.025 s','FontSize',12)
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])

t=0:0.25:5;
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)))
y(1:10:end)