% m-file Ch4_Ex4_27.m
% Plots Figure 4.51

clc; close all; clear all

wn=2; zeta=0.5; K=1;
T=0.025; 
wnT=wn*T; wnTsq=wnT*wnT;
b0=1; b1=2; b2=1;
a0=4*(1-zeta*wnT)+wnTsq;
a1=2*(wnTsq-4);
a2=4*(1+zeta*wnT)+wnTsq;
tfinal=5;
kfinal=round(tfinal/T);

y(1)=0; % k=0
t(1)=0;
y(2)=(wnTsq/a2)*(b2+b1); % k=1
t(2)=T;

for k=3:kfinal % k=2,3,...
  t(k)=(k-1)*T;
  y(k)=(1/a2)*(-a1*y(k-1)-a0*y(k-2)+wnTsq*(b0+b1+b2));
end % k
incr=2;
plot(t(1:incr:end),y(1:incr:end),'.r','MarkerSize',9)
grid on
axis([0 5 0 1.25])
xlabel('t  (s)','FontSize',12)
y(1:10:end)

wd=sqrt(1-zeta^2)*wn;
t=linspace(0,tfinal,500);
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)));
hold on
plot(t,ycont,'b','LineWidth',1.3)
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
    
title('Step Response of Discrete and Continuous Second-Order Systems','FontSize',11)
text(2.5,0.84,'y_k , k = 0,2,4,6,...200','FontSize',13)
plot(2.3,0.84,'r.','MarkerSize',9)
text(2.5,0.64,'y(t), 0 \leq t \leq 5','FontSize',13)
plot([2.2 2.4],[0.64 0.64],'b','LineWidth',1.3)
text(1.5,0.25,'Trapezoidal Integration, T = 0.025 s','FontSize',13)

t=0:0.25:5;
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)))

t=0:T:10*T;
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)))
