% m-file Chap4_Ex4_28.m
% Plots Figure 4.60

clear all ; close all; clc
alpha=0.5; beta=0.25;
a1=-(1+alpha);
a2=alpha-beta;
a3=beta;
A=[0 1 0; 0 0 1; -a3 -a2 -a1];
eig(A);
d=[1 -1.5 0.25 0.25]; 
rts=roots(d);  
p1=rts(1); p2=rts(2); p3=rts(3);
q=conv([1 -p1],[1 -p2]);
d_check=conv(q,[1 -p3]); 
A1=1/((p1-p2)*(p1-p3))  
A2=1/((p2-p1)*(p2-p3))  
A3=1/((p3-p1)*(p3-p2))  
num=1;
den=[1 -1.5 0.25 0.25];
[R P K]=residue(num,den) % check on partial fraction coefficients A1,A2,A3
B1=p1/((p1-p2)*(p1-p3)) 
B2=p2/((p2-p1)*(p2-p3)) 
B3=p3/((p3-p1)*(p3-p2))
num=[1 0];
[R P K]=residue(num,den) % check on partial fraction coefficients B1,B2,B3
C1=(p1^2)/((p1-p2)*(p1-p3)) 
C2=(p2^2)/((p2-p1)*(p2-p3)) 
C3=(p3^2)/((p3-p1)*(p3-p2))
num=[1 0 0];
[R P K]=residue(num,den) % check on partial fraction coefficients C1,C2,C3
P0=100;
k=0:21;
phi_13=A1*(p1.^k)+A2*(p2.^k)+A3*(p3.^k);
phi_23=B1*(p1.^k)+B2*(p2.^k)+B3*(p3.^k);
phi_33=C1*(p1.^k)+C2*(p2.^k)+C3*(p3.^k);
yk=(-a3*phi_13 - a2*phi_23 - a1*phi_33)*P0;
k=[-3 -2 -1 k];
yk=[0 0 P0 yk];
plot(k,yk,'.','MarkerSize',10) 


v=[-5,21,-25 yk(end)+50];    
axis(v)
hold on
plot([-5 21],[400 400],'--','LineWidth',1.3)
set(gca,'XTick',[-3:1:21])
xlabel('year k','FontSize',12)
ylabel('y_k,   $')
title('Fund Value vs. Time','FontSize',11)
text(-4.5,0,'y_{-3}','FontSize',12)
text(-1.5,0,'y_{-2}','FontSize',12)
text(-0.5,100,'y_{-1}','FontSize',12)
text(0.5,150,'y_0','FontSize',12)
text(1.5,200,'y_1','FontSize',12)
text(2.5,238,'y_2','FontSize',12)
text(7.5,150,'y_k , k = -3,-2,-1,0,1,2,...','FontSize',12)
text(0,420,'y_\infty','FontSize',12)



    
    