% m-file Ch4_Ex4_31.m
% Plots Figure 4.67
% two versions


%%%%% Version 1 %%%%%
clc; close all; clear all;
A=1; B=3;

subplot(3,1,1)
a=-0.25; b=0.5;
[theta,r]=cart2pol(a,b) 
a1_1=-2*r*cos(theta); a0_1=r^2; 
p1=a+j*b;  p2=a-j*b; 
coef_1=conv([1 -p1],[1 -p2]);
c1=(A*r*cos(theta)+B)/(r*sin(theta))  
c2=A 
kfinal=10;
k=0:kfinal;
hk=(r.^k).*(c1*sin(k*theta)+c2*cos(k*theta));
stem(k,hk,':.k','MarkerSize',9)
grid on
axis([-0.5 kfinal+0.5 -2 3])
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
ylabel('h_k','FontSize',12)
title('Impulse Response Sequences for Systems with Complex Poles of H(z)','FontSize',11)
text(3,1.65,'Poles of H(z) at z = - 0.25 \pm j0.5','FontSize',12)

subplot(3,1,2)
a=0.5; b=0.5*sqrt(3); 
[theta,r]=cart2pol(a,b)  
a1_2=-2*r*cos(theta); a0_2=r^2; 
p1=a+j*b;  p2=a-j*b; 
coef_2=conv([1 -p1],[1 -p2]); 
c1=(A*r*cos(theta)+B)/(r*sin(theta))  
c2=A 
kfinal=10;
k=0:kfinal;
hk=(r.^k).*(c1*sin(k*theta)+c2*cos(k*theta));
stem(k,hk,':.k','MarkerSize',9)
grid on
axis([-0.5 kfinal+0.5 -7 7])
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
ylabel('h_k','FontSize',12)
text(1.5,5,'Poles of H(z) at z = 0.5 \pm j0.5','FontSize',12) 

subplot(3,1,3)
a=1; b=1; 
[theta,r]=cart2pol(a,b)  
a1_3=-2*r*cos(theta); a0_3=r^2;
p1=a+j*b; p2=a-j*b; 
coef_3=conv([1 -p1],[1 -p2]); 
c1=(A*r*cos(theta)+B)/(r*sin(theta))  
c2=A 
kfinal=10;
k=0:kfinal;
hk=(r.^k).*(c1*sin(k*theta)+c2*cos(k*theta));
stem(k,hk,':.k','MarkerSize',9)
grid on
axis([-0.5 kfinal+0.5 -50 150])
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
xlabel('k','FontSize',12)
ylabel('h_k','FontSize',12)
text(3,75,'Poles of H(z) at z = 1 \pm j','FontSize',12) 

%%%%% Version 2 %%%%%
figure(2)
subplot(3,1,1)
k=0:10;
hk1=(0.5990.^k).*(5.5*sin(2.0344*k)+cos(2.0344*k));
stem(k,hk1,':.')
axis([0 10 -2 3.5])
ylabel('\ith_{k}','FontSize',11)
text(3,2.0,'Poles of H(z) at \itz \rm= -0.25 \pm \itj \rm0.5','FontSize',11) 
title('Impulse Response Sequences for Systems with Complex Poles of \itH\rm(\itz\rm)','FontSize',11)

subplot(3,1,2)
k=0:10;
hk2=4.0415*sin(1.0472*k)+cos(1.0472*k);
stem(k,hk2,':.')
axis([0 10 -7 7])
ylabel('\ith_{k}','FontSize',11)
text(1.6,4.8,'Poles of H(z) at \itz \rm= 0.5 \pm \itj \rm0.5\surd3','FontSize',11) 

subplot(3,1,3)
k=0:10;
hk3=(sqrt(2).^k).*(4*sin(0.25*k*pi)+cos(0.25*k*pi));
stem(k,hk3,':.')
axis([0 10 -125 150])
ylabel('\ith_{k}','FontSize',11)
text(3,75,'Poles of H(z) at \itz \rm= 1 \pm \itj','FontSize',11) 
xlabel('\itk','FontSize',11)