% m-file Ch4_Ex4_32.m
% Plots Figure 4.71

clc; close all; clear all

wn=10; zeta=1; K=1;
KP=0.5; KI=2;
alpha2s=2*zeta*wn;
alpha1s=(wn^2)*(1+K*KP);
alpha0s=K*KI*wn^2;
Ns=[K*(wn^2)*KP K*(wn^2)*KI];
Ds=[1 alpha2s alpha1s alpha0s];
SYS_s=tf(Ns,Ds);
[ys,ts]=step(SYS_s,2.5);
del(1)=5;del(2)=1; del(3)=1;
for i=1:3
   if i==1
     T=0.01;
   elseif i==2
     T=0.05;
   else
     T=0.1;
   end % if
   wnT=wn*T; wnTsq=wnT^2;
   alpha2z=-3+2*zeta*wnT;
   alpha1z=3-4*zeta*wnT+wnTsq*(1+K*(KP+0.5*KI*T));
   alpha0z=-1+2*zeta*wnT+wnTsq*(-1+K*(-KP+0.5*KI*T));
   A=K*wnTsq;
   a1=2*KP+KI*T;
   a0=-2*KP+KI*T;
   yz_ss=0.5*A*(a1+a0)/(1+alpha2z+alpha1z+alpha0z);
   Nz=0.5*A*[a1 a0];
   Dz=[1 alpha2z alpha1z alpha0z];
   roots(Dz)
   SYS_z=tf(Nz,Dz,T);
   [yz,tz]=step(SYS_z,2.5);
   
   subplot(3,1,i)
   plot(ts,ys,'b','LineWidth',1.3)
   if i==1
     title('Continuous and Discrete Step Response','FontSize',11)
     text(0.5,0.25,'T = 0.01 s','FontSize',12)
   end % if
   if i==2
      text(0.5,0.25,'T = 0.05 s','FontSize',12)
   end % if
   if i==3
      text(0.5,0.25,'T = 0.1 s','FontSize',12)
   end % if   
   hold on
   plot(tz(1:del(i):end),yz(1:del(i):end),'.r','MarkerSize',9)
   grid on
   set(gca,'FontSize',11)
   set(gca,'XTick',[0:0.25:2.5])
   text(1.5,0.60,'y(t), t \geq 0','FontSize',12)
   plot([1.35 1.45],[0.57 0.57],'b','LineWidth',1.3)
   
   if T==0.01
      text(1.5,0.25,'y_k, k = 0,5,10,...','FontSize',12)
   else
      text(1.5,0.25,'y_k, k = 0,1,2,...','FontSize',12)
   end % if T
      
   plot(1.4,0.25,'.r','MarkerSize',9)
end % for
xlabel('t  (s)','FontSize',12)






