% m-file Ch4_Ex4_34.m
% Plots Figures 4.79 - 4.81
clc, close all, clear all

tau=5; T=0.25;

figure
subplot(2,1,1)
w=pi;
tauw=tau*w;
tfinal=8;
t=linspace(0,tfinal,1000);
u=sin(w*t);
plot(t,u,'b','LineWidth',1.3)
hold on
grid on
axis([0 tfinal+0.5 -1.1 1.1])
tk=0:T:tfinal;
uk=sin(w*tk);
plot(tk,uk,'.r','MarkerSize',9)
set(gca,'XTick',[0:1:8])
set(gca,'YTick',[-1:0.5:1])
set(gca,'FontSize',11)
title('u(t) = sin(\omegat), u_k = sin(\omegakT),  \omega = \pi rad/s,  T = 0.25 s','FontSize',12)
text(7.8,0.75,'u(t)','FontSize',12)
plot([7.5 7.7],[0.75 0.75],'b','LineWidth',1.3)
text(7.8,0.35,'u_k','FontSize',12)
plot(7.6,0.4,'.r','MarkerSize',9)

subplot(2,1,2)
y=(tauw/(1+tauw^2))*(exp(-t/tau)-cos(w*t)+(1/tauw)*sin(w*t));
plot(t,y,'b','LineWidth',1.3)
grid on
set(gca,'XTick',[0:1:8])
set(gca,'FontSize',11)
axis([0 tfinal+0.5 -0.06 0.125])
hold on
c=1/(2*tau+T);
ifinal=round(tfinal/T);
tt(1)=0; yk(1)=0; u(1)=0;
for i=2:ifinal+1
    tt(i)=(i-1)*T;
    ti=tt(i);
    u(i)=sin(w*ti);
    yk(i)=c*((2*tau-T)*yk(i-1)+T*(u(i)+u(i-1)));
end
plot(tt,yk,'.r','MarkerSize',9)
text(7.8,0.1,'y(t)','FontSize',12)
plot([7.5 7.7],[0.1 0.1],'b','LineWidth',1.3)
text(7.8,0.065,'y_k','FontSize',12)
plot(7.6,0.065,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)
title('Continuous Output y(t) and Discrete Output y_k','FontSize',12)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(2)
subplot(2,1,1)
w=7*pi;
tauw=tau*w;
tfinal=4;
t=linspace(0,tfinal,1000);
u=sin(w*t);
plot(t,u,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal+0.5 -1.1 1.1])
tk=0:T:tfinal;
uk=sin(w*tk);
plot(tk,uk,'.r','MarkerSize',9)
set(gca,'FontSize',11)
set(gca,'YTick',[-1:0.5:1])
title('u(t) = sin(\omegat),  u_k = sin(\omegakT),  \omega = 7\pi rad/s, T = 0.25 s','FontSize',12)
text(4.2,0.75,'u(t)','FontSize',12)
plot([4.05 4.15],[0.70 0.70],'b','LineWidth',1.3)
text(4.2,0.4,'u_k','FontSize',12)
plot(4.1,0.4,'.r','MarkerSize',9)
ww=pi;
uu=-sin(ww*t);
plot(t,uu,'--k')

subplot(2,1,2)
y=(tauw/(1+tauw^2))*(exp(-t/tau)-cos(w*t)+(1/tauw)*sin(w*t));
plot(t,y,'b','LineWidth',1.3)
axis([0 tfinal+0.5 -0.125 0.045])
grid on
hold on
clear tt yk
c=1/(2*tau+T);
ifinal=round(tfinal/T);
tt(1)=0; yk(1)=0; u(1)=0;
for i=2:ifinal+1
    tt(i)=(i-1)*T;
    ti=tt(i);
    u(i)=sin(w*ti);
    yk(i)=c*((2*tau-T)*yk(i-1)+T*(u(i)+u(i-1)));
end
set(gca,'FontSize',11)
plot(tt,yk,'.r','MarkerSize',9)
text(4.1,-0.07,'y(t)','FontSize',12)
plot([3.95 4.05],[-0.075 -0.075],'b','LineWidth',1.3)
text(4.1,-0.1,'y_k','FontSize',12)
plot(4.0,-0.1,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)
title('Continuous Output y(t) and Discrete Output y_k','FontSize',12)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(3)
subplot(2,1,1)
w=8*pi;
tauw=tau*w;
tfinal=3;
t=linspace(0,tfinal,1000);
u=sin(w*t);
plot(t,u,'b','LineWidth',1.3)
set(gca,'XTick',[0:0.5:3])
set(gca,'YTick',[-1:0.5:1])
set(gca,'FontSize',11)
grid on
hold on
axis([0 tfinal+0.35 -1.1 1.1])
tk=0:T:tfinal;
uk=sin(w*tk);
plot(tk,uk,'.r','MarkerSize',9)
title('u(t) = sin(\omegat),  u_k = sin(\omegakT),  \omega = 8\pi rad/s,  T = 0.25 s','FontSize',12)
text(3.1,0.75,'u(t)','FontSize',12)
plot([2.98 3.06],[0.70 0.70],'b','LineWidth',1.3)
text(3.1,0.35,'u_k','FontSize',12)
plot(3.02,0.35,'.r','MarkerSize',9)
ww=0;
uu=-sin(ww*t);
plot(t,uu,'--k')

subplot(2,1,2)
y=(tauw/(1+tauw^2))*(exp(-t/tau)-cos(w*t)+(1/tauw)*sin(w*t));
plot(t,y,'b','LineWidth',1.3)
grid on
set(gca,'XTick',[0:0.5:3])
set(gca,'FontSize',11)
axis([0 tfinal+0.35 -0.005 0.018])
hold on
clear tt yk
c=1/(2*tau+T);
ifinal=round(tfinal/T);
tt(1)=0; yk(1)=0; u(1)=0;
for i=2:ifinal+1
    tt(i)=(i-1)*T;
    ti=tt(i);
    u(i)=sin(w*ti);
    yk(i)=c*((2*tau-T)*yk(i-1)+T*(u(i)+u(i-1)));
end
plot(tt,yk,'.r','MarkerSize',9)
text(3.1,15e-3,'y(t)','FontSize',12)
plot([3.0 3.06],[14.5e-3 14.5e-3],'b','LineWidth',1.3)
text(3.1,11e-3,'y_k','FontSize',12)
plot(3.03,11e-3,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)
text(0.4,21e-3,'Continuous Output y(t) and Discrete Output y_k','FontSize',12)
