% m-file Ch4_Ex4_35.m
% Plots Figure4.83

clc; close all; clear all
%%%%%%%%%%%%%%%Moving Average Digital Filter%%%%%%%%%%%%%%%%%%
P=12; % period in months
w0=2*pi/P; % frequency in rad/month
A=0.25; % deg per yr
A=A/12; % deg per month
Tbar=5;
T0=65;
N=1.0;
n=[1 1 1 1 1 1 1 1 1 1 1 1];
d=[12 0 0 0 0 0 0 0 0 0 0 0 0];
Ts=1;
SYS=tf(n,d,Ts); 
%Bode(SYS)
[Mag,Phase]=bode(SYS,pi/6);
wN=pi/Ts;
ifinal=750;
for i=1:ifinal
    w(i)=(wN/ifinal)*i;
    [M,P]=bode(SYS,w(i));
    Mag(i)=M;
end
plot(w,Mag,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.1:1])
set(gca,'XTick',[ ]')
text(0.45,-0.04,'\pi/6          2\pi/6         3\pi/6         4\pi/6         5\pi/6           \pi','FontSize',11)
text(1.4,-0.095,'\omega  (rad/month)','FontSize',12)
ylabel('|H(e^{ j\omegaT})|','FontSize',12)
title('Magnitude Function vs Frequency for Smoothing Filter (T = 1 month)','FontSize',11)
text(1,0.55,'H(z) = (1/12) [z^{-1} + z^{-2} + ... + z^{-12}]','FontSize',13)

figure(2)
tfinal=25;
kfinal=12*tfinal;
for k=1:kfinal;
    t(k)=k;
    %n(k)=N*randn;
    %T(k)=A*k+(T0+Tbar*sin(k*w0))+n(k);
end
%T=[T0 T];
% save Chap4_Temp T
load Ch4_LakeTemp T
t=[0 t];
plot(t(1:end),T(1:end),':.b')
grid on
hold on
axis([0 300 58 78])
set(gca,'FontSize',11)
set(gca,'YTick',[58:2:78])
xlabel('Month','FontSize',12)
ylabel('Temperature  (\circ F)','FontSize',12)
title('Digital Filtering Using Moving Average','FontSize',12)

clear k t
for k=12:kfinal
    t(k)=k;
    T_smooth(k)=sum(T(k-11:k))/12;
end
plot(t(12:end),T_smooth(12:end),'.r')
text(50,76.3,'T_k  (Monthly Temperature)','FontSize',12) 
plot([45],[76.4],'.b')
text(150.5,60.2,'T_k  (Filter Output)','FontSize',12)
text(151.7,61.2,'\wedge')
plot([100 147],[66.8 60.5],'k')
m1=(T_smooth(kfinal)-T_smooth(12))/(tfinal-1)  

%%%%%%%%%%%%%%%%%%%%First Order Digital Filter%%%%%%%%%%%%%%%%%%%%%%
figure(3)
alpha=0.99;
Ts=1;
[Mag,Phase]=bode(SYS,pi/6);
Mag=20*log10(Mag);
w=logspace(-4,0,1000);
z=exp(j*w*Ts);
H=(1-alpha)*z./(z-alpha);
magH=20*log10(abs(H));
argH=angle(H);
semilogx(w,magH,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[-39:3:0])
hold on
axis([5e-4 1 -40 2.5])
xlabel('\omega  (rad/month)','FontSize',12)
ylabel('20 log |H(e^{ j\omegaT}|   (db)','FontSize',12)
title('Gain of First Order Digital Filter (\alpha = 0.99)','FontSize',11)
a=0.3+2*log10(1-alpha); 
b=1+alpha^2-10^(a); 
w_cutoff=(1/Ts)*acos(0.5*b/alpha);
plot([5e-4 w_cutoff],[-3 -3],'--k')
plot([w_cutoff w_cutoff],[-40 -3],'--k')
w0=pi/6;
z0=exp(j*w0*Ts);
H0=(1-alpha)*z0/(z0-alpha);
magH0=20*log10(abs(H0));
plot([5e-4 w0],[magH0 magH0],'--k')
plot([w0 w0],[-40 magH0],'--k')
text(2.9e-3,-37.5,'\omega_c = 0.01','FontSize',12)
text(0.15,-37.5,'\omega_0 = \pi/6','FontSize',12)

figure(4)
clear k t
T_hat(1)=T0;
for k=2:kfinal
    t(k)=k-1;
    T_hat(k)=alpha*T_hat(k-1)+(1-alpha)*T(k);
end
t=[0 t];
T_hat=[T0 T_hat];
plot(t(1:end),T(1:end),':.b')
grid on
hold on
plot(t(1:end),T_hat(1:end),'.r')
xlabel('Month','FontSize',12)
ylabel('Temperature  (\circ F)','FontSize',12)
title('Digital Filtering Using First-Order Filter (\alpha = 0.99)','FontSize',11)
text(50,76.3,'T_k  (Monthly Temperature)','FontSize',12) 
plot(45,76.5,'.b')
text(150.5,60.2,'T_k  (Filter Output)','FontSize',12)
text(151.7,61.2,'\wedge')
plot([100 147],[66.8 60.5],'k')
x=10^(0.3+2*log10(1-alpha));
wc=acos((1+alpha^2-x)/(2*alpha));    
m2=(T_hat(end)-T_hat(151))/12.5    
    