% m-file Chap4_Ex4_36.m
% Plots Figure 4.97 - 4.99 

clc, close all, clear all

KP=15; tau1=3; tau2=15; KT=0.5; tauT=0.25; KC=1;
denG=conv([tau1 1],[tau2 1])
G=tf(KP,denG) 
denH=[tauT 1];
H=tf(KT,denH);
sys=KC*series(G,H) 

bode(sys,'b')
grid on
hold on
set(gca,'FontSize',11)



figure(2)
rlocus(sys,'b')
grid on
set(gca,'FontSize',11)
Kcr=10^(20.5/20) % Kcr based on gain margin from Bode plot is 20.5
[R,K]=rlocus(sys,Kcr) 

format long
wsq=(tau1+tau2+tauT)/(tau1*tau2*tauT);
w=sqrt(wsq)
KCR=((tau1*tau2+tauT*(tau1+tau2))*wsq-1)/(KP*KT) % exact value for Kcr
char_poly=[0 0 0 KCR*KP*KT]+conv(denG,denH) % characteristic polynomial
roots(char_poly) % closed-loop system poles

% figure(3)
% for i=1:4
% subplot(2,2,i)
% sys_cl=feedback(0.25*i*KCR*G,H); % closed-loop system
% step(sys_cl,'b') % step response
% grid on
% set(gca,'FontSize',11)
%   if i==1
%     axis([0 30 0 4])
%     set(gca,'YTick',[0:4])
%     set(gca,'XTick',[0:5:30])
%     title('Step Response: K_C = 0.25K_{cr}','FontSize',11)
%     ylabel('Amplitude','FontSize',12)
%   elseif i==2
%     axis([0 50 0 4])
%     set(gca,'YTick',[0:4])
%     set(gca,'XTick',[0:10:50])
%     title('Step Response: K_C = 0.5K_{cr}','FontSize',11)
%     ylabel('Amplitude','FontSize',12)
%   elseif i==3
%     axis([0 80 0 4]) 
%     set(gca,'YTick',[0:4])
%     set(gca,'XTick',[0:20:80])
%     title('Step Response: K_C = 0.75K_{cr}','FontSize',11)
%     ylabel('Amplitude','FontSize',12)
%   else
%     axis([0 20 0 4])
%     set(gca,'YTick',[0:4])
%     set(gca,'XTick',[0:5:20])
%     title('Step Response: K_C = K_{cr}','FontSize',11)
%     ylabel('Amplitude','FontSize',12)
%   end % if
% end % for