% m-file Ch4_Ex4_37.m


clc, clear, close all

% load clean_ecg_60sec.txt % loads 60 sec of clean ecg signal
% t=clean_ecg_60sec(1:2501,1); % stores first 10 sec of sampled times in array t
% s=clean_ecg_60sec(1:2501,2); % stores first 10 sec of clean ecg signal in array s
% plot(t,s)
% axis([0 5 0 1.5])
% xlabel('\itt  \rm(sec)')
% ylabel('\its\rm(\itt\rm)')
% title('ECG Signal')
% save clean_ecg_10sec t s % save 10 sec of clean ecg signal in data-file clean_ecg_10sec.mat  

load Ch4_clean_ecg_10sec t s % loads 10 sec of clean ecg signal sampled every T=0.004 sec  

%%%%% begin create ecg signal with 25 Hz square wave noise of 0.25 amplitude
Amp_square=0.25; % amplitude of square wave noise 
Ts=0.004; % sampling period (sec)
ifinal=round(t(end)/Ts);
for i=1:ifinal+1
    if mod(i,10)>=1 & mod(i,10)<=5
        square_noise(i)=Amp_square; %sampled noise at Ts=0.004 sec intervals
    else
        square_noise(i)=-Amp_square; %sampled noise at Ts=0.004 sec intervals
    end
end
square_noise=square_noise'; % make dimensions of square_noise compatible with s
square_noisy_ecg=s+square_noise;
save square_noisy_ecg_data  t square_noisy_ecg % saves 10 sec of square noisy ecg signal 
figure(1)
subplot(2,1,1)
plot(t,square_noise,'b','LineWidth',1.0)
grid on
set(gca,'FontSize',11)
axis([0 5 -0.4 0.4])
set(gca,'XTick',[0:0.5:5])
set(gca,'YTick',[-0.4:0.2:0.4])
ylabel('n(t)','FontSize',12)
title('25 Hz Square Wave Noise','FontSize',11)

subplot(2,1,2)
plot(t,square_noisy_ecg,'b','LineWidth',1.0)
grid on
axis([0 5 -0.25 1.75])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
xlabel('t  (s)','FontSize',12)
ylabel('s(t) + n(t)','FontSize',12)
title('ECG Signal with 25 Hz Square Wave Noise','FontSize',11) 
Ts=0.004; % sampling time
f0=25; % notch fundamental frequency (Hz)
w0=2*pi*f0;  % notch fundamental frequency (rad/sec)

%%%% begin HA(z) notch filter coeffs for removing w0=25 Hz square wave noise 
Q=10;
wA=w0;  % notch fundamental frequency (rad/sec
b_A=1/(1+tan(0.5*wA*Ts/Q));
b2=1;
b1_A=-2*cos(wA*Ts);
b0=1;
a1_A=-2*b_A*cos(wA*Ts);
a0_A=2*b_A-1;
w_nyq=pi/Ts; % nyquist frequency
wmax=w_nyq;
x2=log10(wmax);
wmin=1;
x1=log10(wmin);
w=logspace(x1,x2,1000);
z=exp(j*w*Ts);
Hz_A=b_A*(b2*z.^2 + b1_A*z+b0)./(z.^2 +a1_A*z +a0_A); % frequency response function HA(z)
MagHz_A=20*log10(abs(Hz_A));  % magnitude of H(z)
wHz=w/(2*pi); % frequency in Hz
figure(2)
semilogx(wHz,MagHz_A,'b')
grid on
set(gca,'FontSize',11)
axis([wmin 1.25*w_nyq/(2*pi) -36 5])
xlabel('\omega  (Hz)','FontSize',12)
ylabel('|H\rm(e^{ j\omegaT_s} \rm)|   (db)','FontSize',12)
text(18.0,-34,'\omega_0 = 25 Hz','FontSize',13)
text(2,-12,'T_s = 0.004 s','FontSize',13)
text(2,-17,'Q = 10','FontSize',13)
text(2,7,'Magnitude Function (db) for Notch Filter H_{\omega_0}(z)','FontSize',11)

%%%% begin HB(z) notch filter coeffs for removing 3w0=75 Hz square wave noise
Q=30;
wB=3*w0;  % notch fundamental frequency (rad/sec
b_B=1/(1+tan(0.5*wB*Ts/Q));
b2=1;
b1_B=-2*cos(wB*Ts);
b0=1;
a1_B=-2*b_B*cos(wB*Ts);
a0_B=2*b_B-1;
Hz_B=b_B*(b2*z.^2 + b1_B*z+b0)./(z.^2 +a1_B*z +a0_B); % frequency response function HB(z)
MagHz_B=20*log10(abs(Hz_B));  % magnitude of H(z)
figure(3)
semilogx(wHz,MagHz_B,'b')
grid on
set(gca,'FontSize',11)
axis([wmin 1.25*w_nyq/(2*pi) -17 2])
xlabel('\omega  (Hz)','FontSize',12)
ylabel('|H(e^{ j\omegaT_s})|   (db)','FontSize',12)
    
%%%%% begin HC(z) notch filter coeffs for removing 5w0=125 Hz square wave noise
Q=50;
wC=5*w0;  % notch fundamental frequency (rad/sec
b_C=1/(1+tan(0.5*wC*Ts/Q));
b2=1;
b1_C=-2*cos(wC*Ts);
b0=1;
a1_C=-2*b_C*cos(wC*Ts);
a0_C=2*b_C-1;
Hz_C=b_C*(b2*z.^2 + b1_C*z+b0)./(z.^2 +a1_C*z +a0_C); % frequency response function HC(z)
MagHz_C=20*log10(abs(Hz_C));  % magnitude of H(z)
figure(4)
semilogx(wHz,MagHz_C)
axis([wmin 1.25*w_nyq/(2*pi) -12 1])
xlabel('\omega  (Hz)','FontSize',11)
ylabel('|\itH\rm(e^{ \itj\omegaT_{s}} \rm)|   (db)','FontSize',11) 

%%%%% begin Hz_AB=Hz_A*Hz_B %%%%%
Hz_AB=Hz_A.*Hz_B;
MagHz_AB=20*log10(abs(Hz_AB));
figure(5)  
semilogx(wHz,MagHz_AB,'b')
grid on
set(gca,'FontSize',11)
axis([wmin 1.25*w_nyq/(2*pi) -37 5])
xlabel('\omega  (Hz)','FontSize',12)
ylabel('|H(e^{ j\omegaT_s})|   (db)','FontSize',12) 
text(18.5,-34,'\omega_0 = 25 Hz','FontSize',12) 
text(51.0,-17,'3\omega_0 = 75 Hz','FontSize',12) 
text(2,-14,'T_s = 0.004 s','FontSize',13)
text(1.2,7,'Magnitude Function (db) for Multi-notch Filter H_{\omega_0}(z) H_{3\omega_0}(z)','FontSize',12)  

%%%%% begin Hz_ABC=Hz_A*Hz_B*Hz_C %%%%% 
Hz_ABC=Hz_A.*Hz_B.*Hz_C;
MagHz_ABC=20*log10(abs(Hz_ABC));
figure(6)
semilogx(wHz,MagHz_ABC,'b')
grid on
set(gca,'FontSize',11)
axis([wmin 2.3*w_nyq/(2*pi) -37 5])
xlabel('\omega  (Hz)','FontSize',12)
ylabel('|H(e^{ j\rm\omegaT_s} \rm)|   (db)','FontSize',12) 
text(18.0,-34,'\omega_0 = 25 Hz','FontSize',12) 
text(47.5,-17,'3\omega_0 = 75 Hz','FontSize',12) 
text(80.5,-12,'5\omega_0 = 125 Hz','FontSize',12) 
text(2,-14.3,'T_s = 0.004 s','FontSize',12)
text(1,7,'Magnitude Function (db) for Multi-notch Filter H_{\omega_0}(z) H_{3\omega_0}(z) H_{5\omega_0}(z)','FontSize',12)
 
%%%%% begin filter Hz_A output
load square_noisy_ecg_data  t square_noisy_ecg
yA(1)=0; yA(2)=0; % initialize filter Hz_A outputs
u=square_noisy_ecg;  % store filter input in array u
for n=3:length(t)  
    yA(n)=-a1_A*yA(n-1)-a0_A*yA(n-2)+b_A*(b2*u(n)+b1_A*u(n-1)+b0*u(n-2)); % filter Hz_A output
end
figure(7)
subplot(2,1,1)
plot(t,square_noisy_ecg,'b')
grid on
set(gca,'FontSize',11)
axis([0 5 0 1.75])
set(gca,'XTick',[0:0.5:5])
ylabel('s(t) + n(t)','FontSize',12)
title('ECG Signal with 25 Hz Square Wave Noise','FontSize',11)

subplot(2,1,2)
plot(t,yA,'b')  
grid on
set(gca,'FontSize',11)
axis([0 5 0 1.75])
set(gca,'XTick',[0:0.5:5])
xlabel('t  (s)','FontSize',12)
ylabel('y_1(t)','FontSize',12)
text(1.55,1.95,'Output of Notch Filter H_{\omega_0}(z)','FontSize',12)

%%% begin filter Hz_AB output
u=yA; % store output of filter Hz_A in array u for input to filter Hz_AB
yAB(1)=0; yAB(2)=0; % initialize filter Hz_AB outputs
for n=3:length(t)  
    yAB(n)=-a1_B*yAB(n-1)-a0_B*yAB(n-2)+b_B*(b2*u(n)+b1_B*u(n-1)+b0*u(n-2)); % filter Hz_AB output
end

figure(8)
subplot(2,1,1)
plot(t,square_noisy_ecg,'b')
grid on
set(gca,'FontSize',11)
axis([0 5 0 1.75])
set(gca,'XTick',[0:0.5:5])
ylabel('s(t) + n(t)','FontSize',12)
title('ECG Signal with 25 Hz Square Wave Noise','FontSize',11)

subplot(2,1,2)
plot(t,yAB,'b')
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
axis([0 5 0 1.75])
xlabel('t  (s)','FontSize',12)
ylabel('y_2(t)','FontSize',12)
text(0.94,1.95,'Output of Multi-notch Filter H_{\omega_0}(z) H_{3\omega_0}(z)','FontSize',12)

%%% begin filter Hz_ABC output
u=yAB; % store output of filter Hz_AB in array u for input to filter Hz_ABC
yABC(1)=0; yABC(2)=0; % initialize filter Hz_ABC outputs
for n=3:length(t)  
    yABC(n)=-a1_C*yABC(n-1)-a0_C*yABC(n-2)+b_C*(b2*u(n)+b1_C*u(n-1)+b0*u(n-2)); % filter Hz_ABC output
end

figure(9)
subplot(2,1,1)
plot(t,square_noisy_ecg,'b')
grid on
set(gca,'FontSize',11)
axis([0 5 0 1.75])
set(gca,'XTick',[0:0.5:5])
ylabel('s(t) + n(t)','FontSize',12)
title('ECG Signal with 25 Hz Square Wave Noise','FontSize',12)

subplot(2,1,2)
plot(t,yABC,'b')
grid on
set(gca,'FontSize',11)
axis([0 5 0 1.75])
set(gca,'XTick',[0:0.5:5])
xlabel('t  (s)','FontSize',12)
ylabel('y_3(t)','FontSize',12)
text(0.50,1.95,'Output of Multi-notch Filter H_{\omega_0}(z) H_{3\omega_0}(z) H_{5\omega_0}(z)','FontSize',12)