% Matlab file Ch4_Fig4_21.m
% Plots Figure 4.21
clc, clear all, close all

KC=166.19;
n=5*[5*KC 5*KC];
d=[1.5 22.7 78 5*(KC+2) 5*KC 0];
[R P]=residue(n,d)
t=linspace(0,4,1000);
theta=R(1)*exp(P(1)*t)+R(2)*exp(P(2)*t)+R(3)*exp(P(3)*t)+R(4)*exp(P(4)*t)+R(5)*exp(P(5)*t);
plot(t,theta,'b','LineWidth',1.3)
grid on
axis([0 4 -3 11.5])
hold on
xlabel('t  (s)','FontSize', 13) 
ylabel('\theta(t)),  (deg)','FontSize', 13)
title('Marginally Stable and Unstable Heading Control System Responses','FontSize',11)
text(2.27,-1.5,'K_C = 166.19','FontSize',12)
plot([2.33 2.33],[-1.0 1],'k')
plot([2.227 2.33],[1 1],'k')

KC=175;
n=5*[5*KC 5*KC];
d=[1.5 22.7 78 5*(KC+2) 5*KC 0];
[R P]=residue(n,d)
t=linspace(0,4,1000);
theta=R(1)*exp(P(1)*t)+R(2)*exp(P(2)*t)+R(3)*exp(P(3)*t)+R(4)*exp(P(4)*t)+R(5)*exp(P(5)*t);
plot(t,theta,'r','LineWidth',1.3)
text(3.3,-0.75,'K_C = 175','FontSize',12)
plot([3.135 3.26],[-0.62 -0.62],'k')
set(gca,'FontSize',11)