% m-file Ch4_Fig4_25.m
% Plots Figure 4.25

clc, clear all, close all

wb=100;
%n=wb^3;
%d=conv([1 wb],[1 wb wb]);

w=logspace(0,4,1000);
s=j*w;
%H=n./polyval(d,s);
H=wb^3./(s.^3 + 2*wb*(s.^2) + 2*(wb^2)*s + wb^3);
subplot(2,1,1)
magH=abs(H); magH_db=20*log10(magH);
semilogx(w,magH_db,'b','LineWidth',1.3)
grid on
xlabel('\omega  (rad/s)','FontSize',12)
axis([1 1e4 -150 10])
set(gca,'FontSize',11)
title('Bode Plot for 3rd Order Butterworth Low Pass Filter (\omega_b = 100 rad/s)','FontSize',12)
ylabel('|H(j\omega|,  db','FontSize',12)

subplot(2,1,2)
argH_deg=(180/pi)*angle(H);

for i=1:length(argH_deg)
    if argH_deg(i)>=0
      argH_deg(i)=argH_deg(i)-360;
    end % if
end % for
    
semilogx(w,argH_deg,'b','LineWidth',1.3)
grid on
xlabel('\omega  (rad/s)','FontSize',12)
ylabel('Arg [H(j\omega)],  deg','FontSize',12)
axis([1 1e4 -300 20])
set(gca,'FontSize',11)
