% m-file Chap4_Fig4_27.m
% Plots Figure 4.27

clc, close all, clear all
KC=5; KI=2; KD=40;
K=1;
wn=sqrt(0.5625);
zeta=2.25/(2*wn);
w=logspace(-2,2.5,1000);
s=j*w;

n=K*(KC*s+KI);
d=s.^3 + 2*zeta*wn*(s.^2) + (wn^2+K*KC)*s + K*KI;
H=n./d; % H=T_R(s)
den=[1 2*zeta*wn wn^2+K*KC K*KI]
roots(den)

nn=KD*K*s;
dd=d;
HH=nn./dd; % HH=T_D(s)

subplot(2,1,1)
magH_db=20*log10(abs(H));
magHH_db=20*log10(abs(HH));
semilogx(w,magH_db,'b','LineWidth',1.3)
grid on
axis([1e-2 2.3e2 -75 30])
set(gca,'FontSize',11)
text(2e-1,-13,'|T_R(j\omega)|','FontSize',12)
hold on
plot([1e-2 6.2e1],[-40 -40],'k--')
plot([6.2e1 6.2e1],[-80 -40],'k--')
semilogx(w,magHH_db,'k','LineWidth',1.3)
text(10,5,'|T_D(j\omega)|','FontSize',12)
title('Bode Plots of T_R(j\omega) and T_D(j\omega)','FontSize',11)
ylabel('Gain  (db)','FontSize',12)
xlabel('\omega (rad/s)','FontSize',12)

subplot(2,1,2)
argH_deg=(180/pi)*angle(H);
argHH_deg=(180/pi)*angle(HH);
semilogx(w,argH_deg,'b','LineWidth',1.3)
grid on
axis([1e-2 2.5e2 -200 120])
set(gca,'FontSize',11)
text(3e-2,-35,'Arg [T_R(j\omega)]','FontSize',12)
hold on
semilogx(w,argHH_deg,'k','LineWidth',1.3)
text(5e-1,60,'Arg [T_D(j\omega)]','FontSize',12)
ylabel('Phase Angle (deg)','FontSize',12)
xlabel('\omega (rad/s)','FontSize',12)

w0=0.25; % reference frequency (cycles/sec)
w0=0.25*2*pi  % reference frequency (rad/sec)
s=j*w0;
n0=KD*K*s;
d0=s^3 + 2*zeta*wn*(s^2) + (wn^2+K*KC)*s + K*KI;
H0=n0/d0;  
ArgH0_deg=(180/pi)*angle(H0)