% m-file Chap4_Fig4_28.m
% Plots Figure 4.28

clc, close all; clear all

wn=1; K=1;
zeta1=0.25; zeta2=1; zeta3=2;

min=-2; max=2;
w=logspace(min,max,1000);
s=j*w;
n=K*wn^2;
d1=s.^2 + 2*zeta1*wn*s + wn^2;
d2=s.^2 + 2*zeta2*wn*s + wn^2;
d3=s.^2 + 2*zeta3*wn*s + wn^2;
G1=n./d1; magG1=20*log10(abs(G1)); ArgG1=(180/pi)*angle(G1);
G2=n./d2; magG2=20*log10(abs(G2)); ArgG2=(180/pi)*angle(G2);
G3=n./d3; magG3=20*log10(abs(G3)); ArgG3=(180/pi)*angle(G3);

subplot(2,2,1)
semilogx(w,magG1,'b','LineWidth',1.3)
grid on
hold on
axis([10^min 10^max -80 15])
semilogx(w,magG2,'r','LineWidth',1.3)
semilogx(w,magG3,'k','LineWidth',1.3)
set(gca,'FontSize',11)
xlabel('\omega (rad/s)','FontSize',12)
ylabel('|\itG (j\omega)|  (db)','FontSize',12)
title('Bode Plots of 3 Second-Order Systems','FontSize',11)
text(0.095,-13,'\zeta = 2','FontSize',12)
text(0.465,-30,'\zeta = 1','FontSize',12)
text(2.5,0,'\zeta = 0.25','FontSize',12)
plot([1 1],[-25 -6],'k')

subplot(2,2,3)
semilogx(w,ArgG1,'b','LineWidth',1.3)
grid on
hold on
semilogx(w,ArgG2,'r','LineWidth',1.3)
semilogx(w,ArgG3,'k','LineWidth',1.3)
set(gca,'FontSize',11)
plot([0.1 0.32],[-65 -34],'k')
axis([10^min 10^max -190 10])
ylabel('Arg [G (j\omega)]  (deg)','FontSize',12)
xlabel('\omega (rad/s)','FontSize',12)
text(0.02,-35,'\zeta = 2','FontSize',12)
text(0.05,-75,'\zeta = 1','FontSize',12)
text(1,-25,'\zeta = 0.25','FontSize',12)

subplot(2,2,2)
semilogx(w,magG1,'b','LineWidth',1.3)
grid on
hold on
semilogx(w,magG2,'r','LineWidth',1.3)
semilogx(w,magG3,'k','LineWidth',1.3)
set(gca,'FontSize',11)
plot([0.1 1.4845],[-3 -3],'k--','LineWidth',0.7)
plot([1.4845 1.4845],[-7.5 -3],'k--','LineWidth',0.7)
plot([0.6436 0.6436],[-7.5 -3],'k--','LineWidth',0.7)
plot([0.2666 0.2666],[-7.5 -3],'k--','LineWidth',0.7)
plot([0.15 0.15],[-4.2 -1.2],'k')
axis([0.1 2 -7.5 7.5])
xlabel('\omega (rad/s)','FontSize',12)
ylabel('|\itG (j\omega)|  (db)','FontSize',12)
title('Close-up of Bode Plots','FontSize',12)
text(0.115,-5,'\zeta = 2','FontSize',12)
text(0.53,-0.5,'\zeta = 1','FontSize',12)
text(0.25,5,'\zeta = 0.25','FontSize',12)
text(0.079,-3,'-3')

subplot(2,2,4)
semilogx(w,ArgG1,'b','LineWidth',1.3)
grid on
hold on
semilogx(w,ArgG2,'r','LineWidth',1.3)
semilogx(w,ArgG3,'k','LineWidth',1.3)
set(gca,'FontSize',11)
axis([0.1 2 -150 00])
ylabel('Arg [G(j\omega)]  (deg)','FontSize',12)
xlabel('\omega (rad/s)','FontSize',12)
text(0.15,-60,'\zeta = 2','FontSize',12)
text(0.3,-24,'\zeta = 1','FontSize',12)
text(0.73,-21,'\zeta = 0.25','FontSize',12)

%%%%% find bandwidths of the 3 2nd order systems
a=1-2*zeta1^2;
b=sqrt(2-4*zeta1^2+4*zeta1^4);
wb1=sqrt(a+b)*wn
a=1-2*zeta2^2;
b=sqrt(2-4*zeta2^2+4*zeta2^4);
wb2=sqrt(a+b)*wn
a=1-2*zeta3^2;
b=sqrt(2-4*zeta3^2+4*zeta3^4);
wb3=sqrt(a+b)*wn













