% m-file Ch4_Fig4_29.m
% Plots Figure 4.29

clc, close all; clear all

wn=1; K=1;
zeta1=0.25; zeta2=1; zeta3=2;

min=-2; max=2;
w=logspace(min,max,1000);
s=j*w;
n=K*wn^2;
d1=s.^2 + 2*zeta1*wn*s + wn^2;
d2=s.^2 + 2*zeta2*wn*s + wn^2;
d3=s.^2 + 2*zeta3*wn*s + wn^2;
G1=n./d1; magG1=20*log10(abs(G1)); ArgG1=(180/pi)*angle(G1);
G2=n./d2; magG2=20*log10(abs(G2)); ArgG2=(180/pi)*angle(G2);
G3=n./d3; magG3=20*log10(abs(G3)); ArgG3=(180/pi)*angle(G3);

den1=[1 2*zeta1*wn wn^2];
den2=[1 2*zeta2*wn wn^2];
den3=[1 2*zeta3*wn wn^2];

dt=0.01; tfinal=20;
sys1=tf(n,den1);
t=0:dt:tfinal;
[y1,t]=step(sys1,t);
sys2=tf(n,den2);
[y2,t]=step(sys2,t);
sys3=tf(n,den3);
[y3,t]=step(sys3,t);

figure
subplot(3,2,1)
hold on
plot(t,y1,'b','LineWidth',1.3)
axis([0 tfinal 0 1.6])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:20])
set(gca,'YTick',[0:0.5:1.5])
ylabel('y(t)','FontSize',12)
text(2.6,1.9,'Step Response and Rise Times of 3 Second-Order Systems','FontSize',12)
text(10,0.5,'\zeta = 0.25','FontSize',12)

subplot(3,2,2)
hold on
plot(t,y1,'b','LineWidth',1.3)
grid on
axis([0 2 0 1])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.4:2],'YTick',[0.1 0.5 0.9])
ylabel('y(t)','FontSize',12)
plot([0 0.475],[0.1 0.1],'k--')
plot([0.475 0.475],[0 0.1],'k--')
plot([0 1.725],[0.9 0.9],'k--')
plot([1.725 1.725],[0 0.9],'k--')
text(0.2,0.6,'t_r = 1.25 s','FontSize',12)

subplot(3,2,3)
hold on
plot(t,y2,'b','LineWidth',1.3)
axis([0 tfinal 0 1.1])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:20])
set(gca,'YTick',[0:0.5:1])
ylabel('y(t)','FontSize',12)
ylabel('y(t)','FontSize',12)
text(10,0.5,'\zeta = 1','FontSize',12)

subplot(3,2,4)
hold on
plot(t,y2,'b','LineWidth',1.3)
grid on
axis([0 5 0 1])
set(gca,'FontSize',11)
set(gca,'XTick',[0:5],'YTick',[0.1 0.5 0.9])
ylabel('y(t)','FontSize',12)
plot([0 0.527],[0.1 0.1],'k--')
plot([0.527 0.527],[0 0.1],'k--')
plot([0 3.85],[0.9 0.9],'k--')
plot([3.85 3.85],[0 0.9],'k--')
text(1.5,0.25,'t_r = 3.32 s','FontSize',12)

subplot(3,2,5)
hold on
plot(t,y3,'b','LineWidth',1.3)
axis([0 tfinal 0 1.1])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:20])
set(gca,'YTick',[0:0.5:1])
ylabel('y(t)','FontSize',12)
xlabel('t  (s)','FontSize',12)
text(10,0.5,'\zeta = 2','FontSize',12)

subplot(3,2,6)
hold on
plot(t,y3,'b','LineWidth',1.3)
grid on
axis([0 10 0 1])
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:10],'YTick',[0.1 0.5 0.9])
ylabel('y(t)','FontSize',12)
plot([0 0.642],[0.1 0.1],'k--')
plot([0.642 0.642],[0 0.1],'k--')
plot([0 8.88],[0.9 0.9],'k--')
plot([8.88 8.88],[0 0.9],'k--')
xlabel('t  (s)','FontSize',12)
ylabel('y(t)','FontSize',12)
text(3.5,0.3,'t_r = 8.24 s','FontSize',12)
