% m-file Ch4_Fig4_57.m
% Plots Figure 4.57

clc 
close all 
clear all

T=0.025;
wn=1; zeta=0.1; K=1;
wnT=wn*T;
wnTsq=wnT*wnT;
d=4*(1+zeta*wnT)+wnTsq;
a1=2*(wnTsq-4)/d;
a0=(4*(1-zeta*wnT)+wnTsq)/d;
b2=wnTsq/d;
b1=2*b2;
b0=b2;
A2=[-a1 -a0;1 0];
B2=[1;0];
C2=[b1-a1*b2 b0-a0*b2];
D2=[b2];

tfinal=20;
kfinal=round(tfinal/T);
u=1;
x1(1)=0;  x2(1)=0; % k=0
y(1)=b2*u; % k=0
for k=1:kfinal
x1(k+1)=-a1*x1(k)-a0*x2(k)+u;    
x2(k+1)=x1(k);
y(k+1)=(b1-a1*b2)*x1(k+1)+(b0-a0*b2)*x2(k+1)+b2*u;
end % k
k=0:kfinal;
tk=k*T;
incr=10;
subplot(2,1,1)
plot(tk(1:incr:end),y(1:incr:end),'.r','MarkerSize',9)
grid on
wd=sqrt(1-zeta^2)*wn;
t=linspace(0,tfinal,500);
ycont=K*(1-exp(-zeta*wn.*t).*(cos(wd*t)+(zeta*wn/wd)*sin(wd*t)));
hold on
plot(t,ycont,'b','LineWidth',1.3)
%xlabel('t  (s)','FontSize',12)
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.5:2])
set(gca,'XTick',[0:2:20])
text(-0.25,2.2,'Trapezoidal Integration of Underdamped Second-Order System','FontSize',12)
text(10,0.35,'K =1, \omega_n = 1 rad/s, \zeta = 0.1','FontSize',12)
text(2,0.25,'T = 0.025 s','FontSize',12)
text(12.5,1.75,'y_k, k = 0,10,20,...800','FontSize',12)
plot(11.8,1.75,'r.','MarkerSize',9)
text(12.5,1.4,'y(t), 0 \leq t \leq 20','FontSize',12)
plot([11.6 12.0],[1.4 1.4],'b','LineWidth',1.3)

zeta=2.5;
d=4*(1+zeta*wnT)+wnTsq;
a1=2*(wnTsq-4)/d;
a0=(4*(1-zeta*wnT)+wnTsq)/d;
b2=wnTsq/d;
b1=2*b2;
b0=b2;
A3=[-a1 -a0;1 0];
B3=[1;0];
C3=[b1-a1*b2 b0-a0*b2];
D3=[b2];
tfinal=20;
kfinal=round(tfinal/T);
x1(1)=0;  x2(1)=0; % k=0
y(1)=b2*u; % k=0
for k=1:kfinal
x1(k+1)=-a1*x1(k)-a0*x2(k)+u;    
x2(k+1)=x1(k);
y(k+1)=(b1-a1*b2)*x1(k+1)+(b0-a0*b2)*x2(k+1)+b2*u;
end % k
k=0:kfinal;
tk=k*T;
incr=20;

subplot(2,1,2)
plot(tk(1:incr:end),y(1:incr:end),'.r','MarkerSize',9) 
grid on
axis([0 20 0 1.1])
s1=-zeta*wn-sqrt(zeta^2 - 1)*wn;
s2=-zeta*wn+sqrt(zeta^2 - 1)*wn;
tau1=-1/s1;  tau2=-1/s2;
t=linspace(0,tfinal,500);
z1=tau2*exp(-t/tau2);
z2=tau1*exp(-t/tau1);
ycont=K*(1+(z1-z2)/(tau1-tau2));
hold on
plot(t,ycont,'b','LineWidth',1.3)
xlabel('t  (s)','FontSize',12)
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.20:1])
set(gca,'XTick',[0:2:20])
text(10,0.25,'K = 1, \omega_n = 1 rad/s, \zeta = 2.5','FontSize',12)
text(3,0.25,'T = 0.025 s','FontSize',12)
text(12.5,0.75,'y_k, k = 0,10,20,...800','FontSize',12)
plot(11.8,0.75,'r.','MarkerSize',9)
text(12.5,0.55,'y(t), 0 \leq t \leq 20','FontSize',12)
plot([11.6 12.0],[0.55 0.55],'b','LineWidth',1.3)
text(-0.25,1.2,'Trapezoidal Integration of Overdamped Second-Order System','FontSize',12)
