% m-file Ch4_Fig4_62.m
% Plots Figure 4.62

clear all ; close all; clc
alpha1=0.3; alpha2=0.7; alpha3=0.9;
kfinal=20;
hold on
ct=0;
for alpha=[alpha1 alpha2 alpha3]
  ct=ct+1;
  beta=1-alpha;
  h0=beta;
  k=1:kfinal;
  h=beta*(alpha).^k;  
  k=[0 k];
  h=[h0 h];
  
  subplot(2,1,1)
  hold on  
  if ct==1 
    plot(k,h,'sr--','MarkerSize',4,'MarkerFaceColor','k')     
    v=[-1 kfinal+1 -0.05 0.8];
    axis(v)
  elseif ct==2
    plot(k,h,'*b--','MarkerSize',5)
  else
    plot (k,h,'.k--','MarkerSize',9)
  end % if 
  grid on
  text(21,-0.14,'k','FontSize',12)
ylabel('h_k','FontSize',13)
set(gca,'FontSize',11)
set(gca,'YTick',[0:0.2:0.8])
set(gca,'XTick',[0:2:20])
text(1,0.88,'Weighting Sequence  h_k = \beta\alpha^k,  k = 0,1,2,...  (\beta = 1 - \alpha)','FontSize',11)
text(8,0.65,'\alpha = 0.3 (fast)','FontSize',12)
plot(7,0.65,'sr','MarkerSize',4,'MarkerFaceColor','k')
text(8,0.45,'\alpha = 0.7 (moderate)','FontSize',12)
plot(7,0.45,'*b','MarkerSize',5)
text(8,0.25,'\alpha = 0.9 (slow)','FontSize',12)
plot(7,0.25,'.k','MarkerSize',9)

y=1-alpha.^(k+1);

  subplot(2,1,2)
  hold on
  if ct==1 
    plot([-1 k],[0 y],'sr--','MarkerSize',4,'MarkerFaceColor','k')     
    v=[-1 kfinal+1 -0.05 1.1];
    axis(v)
  elseif ct==2
    plot([-1 k],[0 y],'*b--','MarkerSize',5)
  else
    plot ([-1 k],[0 y],'.k--','MarkerSize',9)
  end % if 
  grid on
 text(21,-0.17,'k','FontSize',12)
 ylabel('y_k','FontSize',13)
 set(gca,'FontSize',11)
 set(gca,'YTick',[0:0.2:1])
 set(gca,'XTick',[0:2:20])
 text(-1,1.19,'Unit Step Response of  y_k = \betau_k + \alphay_{k-1},  k = 0,1,2,3,....  (\beta = 1-\alpha)','FontSize',11)
 text(13.5,0.5,'\alpha = 0.3 (fast)','FontSize',12)
 plot(12.5,0.5,'sr','MarkerSize',4,'MarkerFaceColor','k')
 text(13.5,0.3,'\alpha = 0.7 (moderate)','FontSize',12)
 plot(12.5,0.3,'*b','MarkerSize',5)
 text(13.5,0.1,'\alpha = 0.9 (slow)','FontSize',12)
 plot(12.5,0.1,'.k','MarkerSize',9)
  
end % alpha