% m-file Ch4_Fig4_70.m
% Plots Figure 4.70

clc; close all; clear all

wn=10; zeta=1; K=1;
KP=0.5; KI=2;
T=0.05;
wnT=wn*T; wnTsq=wnT^2;
alpha2s=2*zeta*wn;
alpha1s=(wn^2)*(1+K*KP);
alpha0s=K*KI*wn^2;
ps=roots([1 alpha2s alpha1s alpha0s]) 
z=exp(T*ps);

subplot(2,3,1)
plot(ps,'x','MarkerSize',9)
grid on
hold on
axis([-12 5 -8 8])
plot([-12 5],[0 0],'k','LineWidth',1.3)
plot([0 0],[-8 8],'k','LineWidth',1.3)
set(gca,'FontSize',11)
xlabel('Real Axis')
ylabel('Imag Axis')
title('H(s) Poles, Row 1','FontSize',11)
alpha2z=-3+2*zeta*wnT;
alpha1z=3-4*zeta*wnT+wnTsq*(1+K*(KP+0.5*KI*T));
alpha0z=-1+2*zeta*wnT+wnTsq*(-1+K*(-KP+0.5*KI*T));
pz=roots([1 alpha2z alpha1z alpha0z]) 
mag_pz=abs(pz)

subplot(2,3,4)
plot(pz,'x','MarkerSize',9)
grid on
hold on
theta=linspace(0,2*pi,500);
x=cos(theta);
y=sin(theta);
plot(x,y,'k')
sc=1.5;
axis([-sc sc -sc sc])
plot([-sc sc],[ 0 0],'k','LineWidth',1.3)
plot([0 0],[-sc sc],'k','LineWidth',1.3)
set(gca,'FontSize',11)
axis square
set(gca,'FontSize',11)
xlabel('Real Axis')
ylabel('Imag Axis')
title('H(z) Poles, Row 1','FontSize',11)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn=5; zeta=0.5124; K=1;
KP=1; KI=3;
T=0.075;
wnT=wn*T; wnTsq=wnT^2;
alpha2s=2*zeta*wn;
alpha1s=(wn^2)*(1+K*KP);
alpha0s=K*KI*wn^2;
ps=roots([1 alpha2s alpha1s alpha0s])
z=exp(T*ps);

subplot(2,3,2)
plot(ps,'x','MarkerSize',9)
grid on
hold on
axis([-12 5 -8 8])
plot([-12 5],[0 0],'k','LineWidth',1.3)
plot([0 0],[-8 8],'k','LineWidth',1.3)
set(gca,'FontSize',11)
xlabel('Real Axis')
title('H(s) Poles, Row 2','FontSize',11)
alpha2z=-3+2*zeta*wnT;
alpha1z=3-4*zeta*wnT+wnTsq*(1+K*(KP+0.5*KI*T));
alpha0z=-1+2*zeta*wnT+wnTsq*(-1+K*(-KP+0.5*KI*T));
pz=roots([1 alpha2z alpha1z alpha0z]) 
mag_pz=abs(pz) 

subplot(2,3,5)
plot(pz,'x','MarkerSize',9)
grid on
hold on
theta=linspace(0,2*pi,500);
x=cos(theta);
y=sin(theta);
plot(x,y,'k')
sc=1.5;
axis([-sc sc -sc sc])
plot([-sc sc],[ 0 0],'k','LineWidth',1.3)
plot([0 0],[-sc sc],'k','LineWidth',1.3)
set(gca,'FontSize',11)
axis square
xlabel('Real Axis')
%ylabel('Imag Axis')
title('H(z) Poles, Row 2','FontSize',11)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

wn=20; zeta=0.15; K=1;
KP=1; KI=3;
T=0.025;
wnT=wn*T; wnTsq=wnT^2;
alpha2s=2*zeta*wn;
alpha1s=(wn^2)*(1+K*KP);
alpha0s=K*KI*wn^2;
ps=roots([1 alpha2s alpha1s alpha0s]) 
z=exp(T*ps);

subplot(2,3,3)
plot(ps,'x','MarkerSize',9)
grid on
hold on
axis([-12 5 -35 35])
plot([-12 5],[0 0],'k','LineWidth',1.3)
plot([0 0],[-35 35],'k','LineWidth',1.3)
set(gca,'FontSize',11)
xlabel('Real Axis')
title('H(s) Poles, Row 3','FontSize',11)
alpha2z=-3+2*zeta*wnT;
alpha1z=3-4*zeta*wnT+wnTsq*(1+K*(KP+0.5*KI*T));
alpha0z=-1+2*zeta*wnT+wnTsq*(-1+K*(-KP+0.5*KI*T));
pz=roots([1 alpha2z alpha1z alpha0z]) 
mag_pz=abs(pz) 

subplot(2,3,6)
plot(pz,'x','MarkerSize',9)
grid on
hold on
theta=linspace(0,2*pi,500);
x=cos(theta);
y=sin(theta);
plot(x,y,'k')
sc=1.5;
axis([-sc sc -sc sc])
plot([-sc sc],[ 0 0],'k','LineWidth',1.3)
plot([0 0],[-sc sc],'k','LineWidth',1.3)
set(gca,'FontSize',11)
axis square
xlabel('Real Axis')
title('H(z) Poles, Row 3','FontSize',11)

    