% m-file Ch4_Fig4_77.m
% Plots Figure 4.77

clc, close all, clear all

tau=0.25; 
T=tau/10;
w_s=2*pi/T;
wN=0.5*w_s;
w_nyq=pi/T;

w=linspace(0,3*w_s,1000);
z=exp(j*w*T);
H=(T/tau)./(z-1+(T/tau));
magH=abs(H);
ArgH=(180/pi)*angle(H);

subplot(2,1,1)
plot(w,magH,'b','LineWidth',1.3)
grid on
hold on
axis([0 3*w_s 0 1.05])
set(gca,'FontSize',11)
ylabel('|H(e^{ j\omegaT})|','FontSize',12)
title('Frequency Response Function H(e^{j\omegaT})','FontSize',11)
plot([w_nyq w_nyq],[0 1.05],'--k')
plot([3*w_nyq 3*w_nyq],[0 1.05],'--k')
plot([5*w_nyq 5*w_nyq],[0 1.05],'--k')
text(120,-0.3,'\omega_N','FontSize',12)
text(360,-0.3,'3\omega_N','FontSize',12)
text(610,-0.3,'5\omega_N','FontSize',12)
text(248,-0.3,'\omega_s','FontSize',12)
text(485,-0.3,'2\omega_s','FontSize',12)
text(735,-0.3,'3\omega_s','FontSize',12)

subplot(2,1,2)
clear w z ArgH
w=linspace(0,wN,1000);
z=exp(j*w*T);
H=(T/tau)./(z-1+(T/tau));
ArgH=(180/pi)*angle(H);
plot(w,ArgH,'b','LineWidth',1.3)
grid on
axis([0 3*w_s -190 190])
set(gca,'FontSize',11)
set(gca,'YTick',[-180:45:180])
hold on
%plot([0 3*w_s],[0 0],'k')
plot([wN wN],[-180 180],'--k') 

clear w z H ArgH
w=linspace(wN+0.01,3*wN-0.01,1000);
z=exp(j*w*T);
H=(T/tau)./(z-1+(T/tau));
ArgH=(180/pi)*angle(H);
plot(w,ArgH,'b','LineWidth',1.3)
plot([3*wN 3*wN],[-180 180],'--k')

clear w z H ArgH
w=linspace(3*wN+0.01,5*wN-0.01,1000);
z=exp(j*w*T);
H=(T/tau)./(z-1+(T/tau));
ArgH=(180/pi)*angle(H);
plot(w,ArgH,'b','LineWidth',1.3)
plot([5*wN 5*wN],[-180 180],'--k')

clear w z H ArgH
w=linspace(5*wN+0.01,7*wN-0.01,1000);
z=exp(j*w*T);
H=(T/tau)./(z-1+(T/tau));
ArgH=(180/pi)*angle(H);
plot(w,ArgH,'b','LineWidth',1.3)
plot([7*wN 7*wN],[-180 180],'--k')

ylabel('Arg H(e^{ j\omegaT})   (deg)','FontSize',12)
xlabel('\omega   (rad/s)','FontSize',12)
