% m-file Ch4_Fig4_78.m
% Plots Figure 4.78

clc, close all, clear all

subplot(3,1,1)
w=0.2*pi; % frequency of actual sinusoid
t=linspace(0,20,1000);
u=sin(w*t); % actual sinusoid
plot(t,u,'b','LineWidth',1.3)
grid on
hold on
axis([0 20 -1.1 1.1])
ti=0:20;
ui=sin(w*ti); % sampled sinusoid (1 sample per sec)
plot(ti,ui,'r.','MarkerSize',9)
set(gca,'FontSize',11)
set(gca,'YTick',[-1:1:1])
set(gca,'XTick',[0:2:20])
title('Effect of Sampling sin\omegat (\omega = 0.2\pi, 1.4\pi, 2.2\pi rad/s) at \omega_s = 2\pi rad/s','FontSize',11)

subplot(3,1,2)
clear u ui
w=1.4*pi; % frequency of actual sinusoid
u=sin(w*t); % actual sinusoid
plot(t,u,'b','LineWidth',1.3)
grid on
hold on
axis([0 20 -1.1 1.1])
ti=0:20;
ui=sin(w*ti); % sampled sinusoid (1 sample per s)
plot(ti,ui,'r.','MarkerSize',9)
ww=0.6*pi; % frequency of apparent sinusoid
tii=linspace(0,20,1000);
uii=-sin(ww*tii); % apparent sinusoid
plot(tii,uii,':k')
set(gca,'FontSize',11)
set(gca,'YTick',[-1:1:1])
set(gca,'XTick',[0:2:20])

subplot(3,1,3)
clear u ui
w=2.2*pi; % frequency of actual sinusoid
u=sin(w*t); % actual sinusoid
plot(t,u,'b','LineWidth',1.3)
grid on
hold on
axis([0 20 -1.1 1.1])
ti=0:20;
ui=sin(w*ti); % sampled sinusoid (1 sample per sec)
plot(ti,ui,'r.','MarkerSize',9)
ww=0.2*pi; % frequency of apparent sinusoid
tii=linspace(0,20,1000);
uii=sin(ww*tii); % apparent sinusoid
plot(tii,uii,':k')
set(gca,'FontSize',11)
set(gca,'YTick',[-1:1:1])
set(gca,'XTick',[0:2:20])
xlabel('t  (s)','FontSize',12)