% m-file Ch4_Fig4_82.m
% Plots Figure 4.82

clc, close all, clear all

tau=5; T=0.25;


w=pi;
tauw=tau*w;
tfinal=25;
t=linspace(0,tfinal,1000);
y=(tauw/(1+tauw^2))*(exp(-t/tau)-cos(w*t)+(1/tauw)*sin(w*t));
plot(t,y,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:25])
axis([0 tfinal+1 -0.075 0.125])
hold on

c=1/(2*tau+T);
ifinal=round(tfinal/T);
tt(1)=0; yk(1)=0; u(1)=0;
for i=2:ifinal+1
    tt(i)=(i-1)*T;
    ti=tt(i);
    u(i)=sin(w*ti);
    yk(i)=c*((2*tau-T)*yk(i-1)+T*(u(i)+u(i-1)));
end
plot(tt,yk,'.r','MarkerSize',9)
text(22,0.11,'y(t)','FontSize',12)
plot([20.5 21.5],[0.108 0.108],'b','LineWidth',1.3)
text(22,0.095,'y_k','FontSize',12')
plot(21,0.095,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)
title('Continuous Response y(t) and Discrete Response y_k','FontSize',11)
text(10,0.11,'u(t) = sin\pit','FontSize',12)
text(10,0.09,'H(s) = 1/(5s+1)','FontSize',12)