% m-file Ch4_Bode.m
clc, close all, clear all

tau1=1; tau2=0.01; n=3;
sys1=tf(1,[tau1 1]);
sys2=tf([1 0],[tau2 1]);
for i=1:n-1
sysG1=series(sys1,sys1);
sysG2=series(sys2,sys2);
end
sysG12=series(sysG1,sysG2);
bodemag(sysG1,'b',sysG2,'r',sysG12,'k')
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0.01 0.1 1 10 100 1000 10000])
axis([1e-2 1e4 -175 100])
text(0.03,12,'|G_1(j\omega)|','FontSize',12)
text(700,65,'|G_2(j\omega)|','FontSize',12)
text(7,12,'|G_{12}(j\omega)|','FontSize',12)

figure(2)  % begin bode plot for band-pass filters
T=pi/1e4; % sample time to make wN = 10^4 rad/sec
sysG12_d=c2d(sysG12,T,'tustin'); % converts G12(s) to G12(z)
bodemag(sysG12_d,'r') % plot gain of discrete-time band-pass filter
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0.01 0.1 1 10 100 1000 10000])
hold on
bodemag(sysG12,'b') % plot gain of continuous-time band-pass filter
axis([1e-2 1e4 -120 10])
text(3e2,-77,'|G_{12}(j\omega)|','FontSize',12)
plot([2.5e3 8.45e3],[-77 -77],'k') 
text(3e2,-95,'|G_{12}(e^{j\omegaT})|','FontSize',12)
plot([3.8e3 8.55e3],[-95 -95],'k') 