% m-file CH4_call_invert_Fz.m 
% This script file calls the function invertFz.m
% to invert F(z) 
% See Chapter 4, Section 6, Prob 4.42

clc, close all, clear all

% F(z) in Example 4.24
% b3=0; b2=3; b1=1; b0=0;
% a1=2; a0=2;
% p1=1;

% F(z) after Example 4.24
% b3=2; b2=1; b1=4; b0=5;
% a1=2; a0=4;
% p1=3; 

% F(z) in Case III complex poles example in Chapter 4, Section 6 
b3=0; b2=1; b1=1; b0=0;
a1=-3; a0=9;
p1=1;

% A test example
b3=2; b2=1; b1=-3; b0=4;
a1=2; a0=3;
p1=2;

[A1,C,R,theta,phi,F0]=invertFz(p1,a1,a0,b3,b2,b1,b0) 

kmax=5; % upper index of discrete-time signal f(k)   
k=1:kmax;        
fk=A1*(p1.^k)+2*C*(R.^k).*cos(k*theta+phi); % fk, k=1,2,3,...
k=0:kmax
fk=[F0 fk] % fk, k=0,1,2,3,...    
