% m-file Ch4_feedback_yaw.m

clc;
%clear all; 
close all

Ks=0.5; taus=7.5;
Kp=10; taup=0.2;
Kc=10;
K0=Kc*Kp*Ks;
n=[Kp*Ks Kp*Ks];
%d=[taup*taus taup+taus+10*taup*taus 1+10*(taup+taus) 10 0] 
d=conv([taup 1],[taus 1]);
d=conv(d,[1 10]);
d=conv(d,[1 0]); 
sys=tf(n,d);  % open loop GH
rlocus(sys)
R1=rlocus(sys,Kc)   % char roots
%a_char_poly=[taup*taus taup+taus+10*taup*taus 1+10*(taup+taus) 10+K0 K0]; % closed loop char polynomial
a_char_poly=d+[0 0 0 K0 K0] 
R2=roots(a_char_poly)   % char roots
p=R1(3);
pc=conj(p);
a_quadratic=conv([1 -p],[1 -pc]);
wn=sqrt(a_quadratic(3));
zeta=a_quadratic(2)/(2*wn);
wd=sqrt(1-zeta^2)*wn;
tau_eff=1/(zeta*wn);
cl_num=[5*K0 5*K0] ;
cl_den=conv(a_char_poly,[1 0]);
[R,P]=residue(cl_num,cl_den); 

t=0:0.01:40;
theta_CL_1=5 + R(1)*exp(P(1)*t) + R(2)*exp(P(2)*t); 
theta_CL_2=exp(-t/tau_eff).*(2*real(R(3))*cos(wd*t)-2*imag(R(3))*sin(wd*t)); 
theta_CL=theta_CL_1+theta_CL_2; 

figure
plot(t,theta_CL,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
xlabel('t  (s)','FontSize', 12) 
ylabel('\theta(t), (deg)','FontSize', 12)
hold on

a=conv([1 5],[1 1/7.5]);
a=conv(a,[1 0 0]);
[r,p]=residue([1],a); 
c1=r(1); c2=r(2); c3=r(3); c4=r(4);
p1=p(1); p2=p(2); p3=p(3); p4=p(4);

A=0.1; T=10;
i=0;
for t=0:0.05:40
    i=i+1;
    tt(i)=t;
    u=(t>=T);
    z1=c1*(exp(p1*t)-exp(p1*(t-T))*u);
    z2=c2*(exp(p2*t)-exp(p2*(t-T))*u);
    z3=c3*(1-u);
    z4=c4*(t-(t-T)*u);
    theta_OL(i)=(10*A/3)*(z1+z2+z3+z4);
end % for t

plot(tt,theta_OL,'b','LineWidth',1.3)
text(15,5.5,'closed-loop, K_C = 10','FontSize', 12)
text(15.5,3,'open-loop, A = 0.1, T = 10','FontSize', 12)
title('Open-Loop and Stable Closed-Loop Ship Heading Response','FontSize', 11)

% for Kc=166.1:0.01:166.2;
%    K0=Kc*Kp*Ks;
%    a_char_poly=d+[0 0 0 K0 K0];
%    aa=roots(a_char_poly);
%    real_part=real(aa(3));
%    Kc,real_part
% end % for Kc
    

% subplot(1,2,1)
% x=theta1(:,1);
% y=theta1(:,2);
% plot(x,y,'b')
% axis([0 5 -2 12])
% xlabel('\itt\rm (sec)'),ylabel('\theta\rm(\itt\rm), (deg)')
% text(0.5,11,'closed-loop, \itK_{C} = \rm166.19')
% title('Marginally Stable System')
% hold on
% subplot(1,2,2)
% x=theta2(:,1);
% y=theta2(:,2);
% plot(x,y,'r')
% axis([0 5 -2 12])
% xlabel('\itt\rm (sec)'),ylabel('\theta\rm(\itt\rm), (deg)')
% text(0.3,11.25,'closed-loop, \itK_{C} = \rm175')
% title('Unstable System')










