% Chap4_make_noisy_ecg.m
% starts with 10 sec of clean ecg signal sampled every T=0.004 sec  
% adds 25 Hz square wave noise of 0.25 amplitude
% saves noisy ecg signal in 'noisy_ecg.mat'

clc, clear, close all

% load clean_ecg_60sec.txt % loads 60 sec of clean ecg signal
% t=clean_ecg_60sec(1:2501,1); % stores first 10 sec of sampled times in array t
% s=clean_ecg_60sec(1:2501,2); % stores first 10 sec of clean ecg signal in array s
% plot(t,s)
% axis([0 5 0 1.5])
% xlabel('\itt  \rm(sec)')
% ylabel('\its\rm(\itt\rm)')
% title('ECG Signal')
% save clean_ecg_10sec t s % save 10 sec of clean ecg signal in data-file clean_ecg_10sec.mat  

load clean_ecg_10sec t s

%%%%% begin create ecg signal with square wave noise
Amp_square=0.25; % amplitude of square wave noise 
Ts=0.004; % sampling period (sec)
ifinal=round(t(end)/Ts);

for i=1:ifinal+1
    %t(i)=(i-1)*Ts;
    if mod(i,10)>=1 & mod(i,10)<=5
        square_noise(i)=Amp_square; %sampled noise at Ts=0.004 sec intervals
    else
        square_noise(i)=-Amp_square; %sampled noise at Ts=0.004 sec intervals
    end
end
square_noise=square_noise'; % make dimensions of square_noise compatible with s
square_noisy_ecg=s+square_noise;

subplot(2,1,1)
plot(t,square_noise)
axis([0 5 -0.5 0.5])
ylabel('\itn\rm(\itt\rm)','FontSize',11)
title('25 Hz Square Wave Noise','FontSize',11)

subplot(2,1,2)
plot(t,square_noisy_ecg)  
axis([0 5 -0.25 1.75])
xlabel('\itt  \rm(sec)','FontSize',11)
ylabel('\its\rm(\itt\rm) + \itn\rm(\itt\rm)','FontSize',11)
title('ECG Signal with 25 Hz Square Wave Noise','FontSize',11)

save noisy_ecg  t square_noisy_ecg % saves noisy ecg signal 
        
    
    
    
    
    
    
    
 