% m-file "CH5_EX5_1.m"
% Runs sim model 'SubDepth_C' and plots Figure 5.23
clc, close all, clear all

sim('SubDepth_C')

t=v(:,1);
vsim=v(:,2);
vanal=v(:,3);
vdiff=v(:,4);

subplot(3,1,1)
plot(t,vsim,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
ylabel('vsim (ft/s)','FontSize',12)
axis([0 30 0 30])
set(gca,'YTick',[0:10:30])
%set(gca,'XTick',[])
title('Simulated Depth Rate vs Time','FontSize',11)

subplot(3,1,2)
plot(t,vanal,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
ylabel('vanal (ft/s)','FontSize',12)
axis([0 30 0 30])
set(gca,'YTick',[0:10:30])
%set(gca,'XTick',[])
title('Analytical Depth Rate vs Time','FontSize',11)

subplot(3,1,3)
plot(t,vdiff,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
ylabel('vsim - vanal (ft/s)','FontSize',12)
axis([0 30 -0.01 0.01])
set(gca,'YTick',[-0.01 0.01])
set(gca,'XTick',[0:5:30])
title('Simulated - Analytical Depth Rate vs Time','FontSize',11)
xlabel('time  (s)','FontSize',12)