% m-file "Ch5_Ex5_2.m"
% plots Figures 5.27 and 5.28

clc, close all, clear all

Ch5_VehParams
sim('CarDynamics')

t=uf_ur(:,1);
uf=uf_ur(:,2);
ur=uf_ur(:,3);

figure(1) % begin Figure 5.27
subplot(2,1,1)
plot(t,uf,'b','LineWidth',1.3)
grid on
set(gca,'XTick',[1.8:0.05:2.4],'YTick',[0:4],'FontSize',11)
ylabel('u_f   (in)','FontSize',13)
axis([1.75 2.45 -0.5 4.5])
set(gca,'XTick',[1.8:0.05:2.4],'YTick',[0:4])
title('Front Tire Displacement vs Time','FontSize',11)

subplot(2,1,2)
plot(t,ur,'b','LineWidth',1.3)
grid on
ylabel('u_r   (in)','FontSize',13)
axis([1.75 2.45 -0.5 4.5])
set(gca,'XTick',[1.8:0.05:2.4],'YTick',[0:4],'FontSize',11)
xlabel('t  (s)','FontSize',12)
title('Rear Tire Displacement vs Time','FontSize',11)

figure(2)  % begin Figure 5.28
y=yy(:,2);
min(y), max(y)
yf=yy(:,3);
yr=yy(:,4);
theta=yy(:,5)*(180/pi);
min(theta), max(theta)

subplot(4,1,1)
plot(t,y,'b','LineWidth',1.3)
grid on
ylabel('y  (in)','FontSize',12)
axis([1.5 3.5 -0.5 4])
set(gca,'YTick',[0 1 2 3],'FontSize',11)
set(gca,'XTick',[])
text(2,4.7,'Vehicle c.g. Displacement vs Time','FontSize',11)

subplot(4,1,2)
plot(t,yf,'b','LineWidth',1.3)
grid on
ylabel('y_f  (in)','FontSize',12)
axis([1.5 3.5 -0.5 4])
set(gca,'YTick',[0 1 2 3],'FontSize',11)
set(gca,'XTick',[])
text(2,4.7,'Front Axle Displacement vs Time','FontSize',11)

subplot(4,1,3)
plot(t,yr,'b','LineWidth',1.3)
grid on
ylabel('y_r  (in)','FontSize',12)
axis([1.5 3.5 -0.5 4])
set(gca,'YTick',[0 1 2 3],'FontSize',11)
set(gca,'XTick',[])
text(2,4.7,'Rear Axle Displacement vs Time','FontSize',11)

subplot(4,1,4)
plot(t,theta,'b','LineWidth',1.3)
grid on
ylabel('\theta  (deg)','FontSize',12)
axis([1.5 3.5 -0.5 0.5])
set(gca,'YTick',[-0.5:0.5:0.5],'FontSize',11)
set(gca,'XTick',[1.5:0.25:3.5],'FontSize',11)
text(2,0.65,'Vehicle Pitch Angle vs Time','FontSize',11)
xlabel('t  (s)','FontSize',12)