% m-file Ch5_Fi5_85.m
% plots Figure 5.85

clear all, close all, clc

sim('Explicit_Implicit')
t=tx(:,1);
x1A=tx(:,2); % explicit Euler - explicit Euler
x1B=tx(:,3); %explicit Euler - implicit Trapezoidal
x1C=tx(:,4); % exact

plot(t,x1A,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
hold on
plot(t,x1B,'r','LineWidth',1.3)
plot(t,x1C,'k','LineWidth',1.3)
title('Centralized, non-Centralized Integration and Exact Step Response','FontSize',11)
xlabel('t', 'FontSize',13)
ylabel('y(t)','FontSize',13)
text(2.35,1.1,'exact','FontSize',13)
hold on
plot([2.54 2.54],[1.03 0.8516],'k')
text(0.27,0.24,'explicit Euler - explicit Euler','FontSize',13)
plot([1.27 1.27],[0.47 0.32],'b')
text(2.0,1.45,'explicit Euler - implicit trapezoidal','FontSize',13)
plot([3.77 3.77],[0.91 1.35],'r')

text(3.5,0.64,'\zeta = 0.15','FontSize',13)
text(3.5,0.44,'\omega_n = 5 rad/s','FontSize',13)
text(3.5,0.24,'T = 0.02 s','FontSize',13)