% script file 'Chap5_MonteCarlo_stone.m'
% sets parameter values for SIMULINK file 'stone.mdl'
% plots Figure E5.47

clc; close all; clear all
hold on
g=32.17;
aA=9e-4; nA=1.0; % stone drag properties

wA=0.5;  % baseline wt of stone, (lbs)
%for wA=6:2:10;   
mA=(wA/g); % mass of stone, slugs

xA0=0; % initial x coordinate of stone, ft
yA0=6; % initial y coordinate of stone, ft

%v0_low=60; v0_high=90; % limits on initial speed of stone, ft/sec
%v0=v0_low+(v0_high-v0_low)*rand;  % initial speed of stone, uniformly distributed over (v0_low, v0_high), ft/sec
v0=75; % initial speed of stone
theta0=45; % angle of departure, deg
theta0=theta0*pi/180; % angle of departure of stone, rad
xAd0=v0*cos(theta0); % initial speed of stone in x-direction
yAd0=v0*sin(theta0); % initial speed of stone in y-direction
T=0.001; % integration step size

sim('stone')
t=xAyA(:,1);
xA=xAyA(:,2);
yA=xAyA(:,3);
plot(xA,yA,'b','LineWidth',1.3)  % plot flight path of stone
grid on
set(gca,'FontSize',11)
axis([0 1.05*max(xA) 0 1.05*max(yA)])
%axis equal
xlabel('Horizontal Distance of Stone, x  (ft)','FontSize',13)
ylabel('Height of Stone, y  (ft)','FontSize',13)
title('Trajectory of Stone','FontSize',12)                            

%end % for




