% m-file Ch5_VehParams.m
% MATLAB script file for entering vehicle parameters in Chapter 5, Ex 5.2

clc; clear all; close all

g=32.2;
W=4200; % lbs
M=W/(12*g);
Wf=125; % lbs
Mf=Wf/(12*g);
Wr=125; % lbs
Mr=Wr/(12*g);
Kfs=120; % lb/in
Krs=180; % lb/in
Bf=25; % lb-sec/in
Br=35; % lb-sec/in
Kft=1100; % lb/in
Krt=1100; % lb/in
J=40000; % lb-in-sec sq
Lf=55; % in
Lr=65; % in

% Enter 8x8 System Matrix
A(8)=0;
A(1,2)=1;
A(2,1)=-(Kfs+Krs)/M;
A(2,2)=-(Bf+Br)/M;
A(2,3)=Kfs/M;
A(2,4)=Bf/M;
A(2,5)=Krs/M;
A(2,6)=Br/M;
A(2,7)=(Krs*Lr-Kfs*Lf)/M;
A(2,8)=(Br*Lr-Bf*Lf)/M;
A(3,4)=1;
A(4,1)=Kfs/Mf;
A(4,2)=Bf/Mf;
A(4,3)=-(Kfs+Kft)/Mf;
A(4,4)=-Bf/Mf;
A(4,7)=(Kfs*Lf)/Mf;
A(4,8)=(Bf*Lf)/Mf;
A(5,6)=1;
A(6,1)=Krs/Mr;
A(6,2)=Br/Mr;
A(6,5)=-(Krs+Krt)/Mr;
A(6,6)=-Br/Mr;
A(6,7)=-(Krs*Lr)/Mr;
A(6,8)=-(Br*Lr)/Mr;
A(7,8)=1;
A(8,1)=(Krs*Lr-Kfs*Lf)/J;
A(8,2)=(Br*Lr-Bf*Lf)/J;
A(8,3)=(Kfs*Lf)/J;
A(8,4)=(Bf*Lf)/J;
A(8,5)=-(Krs*Lr)/J;
A(8,6)=-(Br*Lr)/J;
A(8,7)=-(Kfs*Lf*Lf+Krs*Lr*Lr)/J;
A(8,8)=-(Bf*Lf*Lf+Br*Lr*Lr)/J;

% Enter 8x2 Input Matrix
B(8,2)=0;   
B(4,1)=Kft/Mf;
B(6,2)=Krt/Mr;


% Enter 4x8 Output Matrix
C(4,8)=0;
C(1,1)=1;
C(2,3)=1;
C(3,5)=1;
C(4,7)=1;

% Enter 4x2 Direct Transmission Matrix
D(4,2)=0;

v0=20*(88/60); % ft/sec
Ab=4; % in 
L=1; % ft
D0=2*v0+L; % ft







