% m-file  "call_Algebraic_Eqs_Solver_A.m"
% calls "Algebraic_Eqs_Solver_A.m" and plots Figures 5.36 and 5.37

clc
close all 
clear all

sim('Algebraic_Eqs_Solver_A')
t=x(:,1);
x=x(:,2);
y=y(:,2);

subplot(2,1,1)
plot(t,x,'b','LineWidth',1.3)
axis([0 2.25 0 8])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.25:2.25])
set(gca,'YTick',[0:2:8])
xlabel('t','FontSize',13)
ylabel('x','FontSize',13)
title('x vs t','FontSize',12)

subplot(2,1,2)
plot(t,y,'b','LineWidth',1.3)
axis([0 2.25 0 8])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.25:2.25])
set(gca,'YTick',[0:2:8])
xlabel('t','FontSize',13)
ylabel('y','FontSize',13)
title('y vs t','FontSize',12)

figure(2)
plot(x,y,'b','LineWidth',1.3)
hold on
axis([-1 10 -1 7])
plot(0,0,'r.','MarkerSize',13)
plot(x(end),y(end),'r.','MarkerSize',13)
grid on
set(gca,'FontSize',11)
xlabel('x(t)','FontSize',12)
ylabel('y(t)','FontSize',12)
title('y(t) vs. x(t)','FontSize',11)
text(0.4,0.25,'[x(0), y(0)]','FontSize',12)
text(8.2,6.4,'(x_0, y_0)','FontSize',12)






