% m-file "Ch5_call_Loan.m"
% prints Figures 5.74 and 5.75

clc
close all
clear all

sim('Loan')
k=y(:,1);
y=y(:,2);
plot(k,y,'b','LineWidth',1.3)
grid on
axis([0 360 0 125000])
set(gca,'FontSize',11)
xlabel('k  (month)','FontSize',12)
ylabel('y(k),  ($)','FontSize',12)
title('Unpaid Balance for a Loan','FontSize',11)
text(50,8.3e4,'P_0 = $125,000','FontSize',13)
text(50,6.3e4,'i = 8% per year','FontSize',13)
text(50,4.3e4,'n = 30 months','FontSize',13)

figure(2)
A=AIP(:,2);
I=AIP(:,3);
P=AIP(:,4);
plot(k(2:end),A(2:end),'b','LineWidth',1.3)
grid on
hold on
axis([0 360 0 1000])
set(gca,'FontSize',11)
set(gca,'XTick',[1 50:50:360])
set(gca,'YTick',[0:100:1000])
plot(k(2:end),I(2:end),'b','LineWidth',1.3)
plot(k(2:end),P(2:end),'b','LineWidth',1.3)
xlabel('k  (month)','FontSize',12)
ylabel('A, I, P  ($)','FontSize',12)
title('A, I(k) and P(k) vs. k','FontSize',11)
text(100,950,'A','FontSize',13)
text(150,750,'I(k)','FontSize',13)
text(125,150,'P(k)','FontSize',13)







