% m-file "Ch5_call_UnitStepResponse_A.m"
% runs model UnitStepResponse_A.mdl" and plots Figure 5.10

clc
close all
clear all

sim('UnitStepResponse_A')

t=y(:,1);

figure(1)
ydd=ydd(:,2);
plot(t,ydd,'b','LineWidth',1.3)
grid on
axis([0 5 -6 17])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5],'YTick',[-5:2.5:15])
ylabel('d^2y/dt^2','FontSize',13)
xlabel('t  (s)','FontSize',13)
title('Second Derivative d^2y/dt^2 vs. Time','FontSize',11) 
text(1.75,5.4,'K = 1,  \omega_n = 4 rad/s,  \zeta = 0.5','FontSize',13)


figure(2)
yd=yd(:,2);
plot(t,yd,'b','LineWidth',1.3)
grid on
axis([0 5 -0.5 2.5])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5],'YTick',[-0.5:0.5:2.5])
ylabel('dy/dt','FontSize',13)
xlabel('t  (s)','FontSize',13)
title('First Derivative dy/dt vs. Time','FontSize',11) 
text(2.1,0.55,'K = 1,  \omega_n = 4 rad/s,  \zeta = 0.5','FontSize',13)


figure(3)
y=y(:,2);
plot(t,y,'b','LineWidth',1.3)
grid on
axis([0 5 -0.1 1.3])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5],'YTick',[0:0.2:1.2])
ylabel('y','FontSize',13)
xlabel('t  (s)','FontSize',13)
title('y(t) vs. Time','FontSize',11) 
text(1.75,0.43,'K = 1,  \omega_n = 4 rad/s,  \zeta = 0.5','FontSize',13)

