% m-file  "Ch5_call_vehicleIncline.m"
% calls sim 'vehicleIncline.mdl' and plots Figures 5.79 - 5.81

clc
close all 
clear all

sim('VehicleIncline')

t=x(:,1);
Fmu=Fmu(:,2);
FW=FW(:,2);
FD=FD(:,2);
xdd=xdd(:,2);
xd=xd(:,2);
x=x(:,2);
theta=theta(:,2);


figure(1)  % begin plot Figure 5.79
subplot(3,1,1)
plot(t,Fmu,'b','LineWidth',1.3)
axis([0 25 294 301])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[294:2:300])
ylabel('F_{\mu}  (lb)','FontSize',12)
title('F_{\mu} vs. t','FontSize',11)

subplot(3,1,2)
plot(t,FW,'b','LineWidth',1.3)
axis([0 25 -100 600])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:200:600])
ylabel('F_W  (lb)','FontSize',12)
title('F_W vs. t','FontSize',11)

subplot(3,1,3)
plot(t,FD,'b','LineWidth',1.3)
axis([0 25 0 20])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:10:20])
xlabel('t  (s)','FontSize',12)
ylabel('F_D  (lb)','FontSize',12)
title('F_D vs. t','FontSize',11)


figure(2)  % begin Figure 5.80
subplot(3,1,1)
plot(t,xdd,'b','LineWidth',1.3)
axis([0 25 -5 5])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[-5 0 5])
ylabel('xdd  (ft/s^2)','FontSize',12)
title('xdd vs. t','FontSize',11)

subplot(3,1,2)
plot(t,xd,'b','LineWidth',1.3)
axis([0 25 0 40])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:20:40])
ylabel('xd  (ft/s)','FontSize',12)
title('xd vs. t','FontSize',11)

subplot(3,1,3)
plot(t,x,'b','LineWidth',1.3)
axis([0 25 0 400])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[0:200:400])
xlabel('t  (s)','FontSize',12)
ylabel('x  (ft)','FontSize',12)
title('x vs. t','FontSize',11)

figure(3)  % begin Figure 5.81
plot(t,theta,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
axis([0 25 -1 11])
set(gca,'YTick',[0:2:10])
ylabel('\theta  (deg)','FontSize',13)
xlabel('t  (s)','FontSize',13)
title('\theta(t) vs. t','FontSize',11)



















