% Chap5_cfparams1.m
% must be run before car_following.mdl
% It sets the values of the following parameters
% G: Desired gap (sec)
% L: Vehicle Length (ft)
% amin: Min vehicle acceleration, i.e. max deceleration (ft per sec sq)
% amax: Maximum vehicle acceleration (ft per sec sq)
% vmax: Maximum vehicle speed
% SL: Speed limit 
% delta: Excess above speed limit  
% K1a: K1 gain when e1>0 and x1d <= SL+delta
% K1d: K1 gain when e1<=0
% Kgd: Kg gain when eg>0
% Kga: Kg gain when eg<0 and x1d <= SL+delta
% T0: Time when lead vehicle begins constant acceleration (sec)
% T1: Time when lead vehicle maximum speed is attained
% A1: Lead vehicle speed at time T1 (sec)
% T2: Final time for interpolation data points
% A2: Lead vehicle speed at time T2 (sec)
G=2;
L=15;
amin=-15;
amax=10;
vmax=90*(5280/3600); % ft/sec
SL=60; % mph
SL=SL*5280/3600; % ft/sec
delta=10; % mph
delta=delta*5280/3600; % ft/sec
K1a=5;
K1d=4;
Kgd=-4;
Kga=-5;
T0=0; 
T1=30;
T2=120;
A1=60; % mph
A1=A1*5280/3600; % ft/sec
A2=60; % mph
A2=A2*5280/3600; % ft/sec
