% script file Chap5_cfparams2.m
% which must be run before car_following_platoon.mdl
% Sets the values of the following parameters
% G: Desired gap (sec)
% L: Vehicle Length (ft)
% amin: Min vehicle acceleration, i.e. max deceleration (ft per sec sq)
% amax: Maximum vehicle acceleration (ft per sec sq)
% vmax: Maximum vehicle speed (ft per sec)
% SL: Speed limit (mph)
% delta: Excess above speed limit  (mph) 
% K1a: K1 gain when e1>0 and x1d <= SL+delta
% K1d: K1 gain when e1<=0
% Kgd: Kg gain when eg>0
% Kga: Kg gain when eg<0 and x1d <= SL+delta
% T0: zero
% T1: Time when lead vehicle begins to decelerate, (sec)
% T2: Time when lead vehicle reaches speed 'SL-10' mph, (sec) 
% T3: Time when lead vehicle begins to acccelerate, sec
% T4: Time when lead vehicle reaches speed 'SL+10' mph, (sec)
% T5: Final time for Look-Up table, (sec)
% v0: Lead vehicle speed at time T0, (mph)
% v1: Lead vehicle speed at time T1, (mph)
% v2: Lead vehicle speed at time T2, (mph)
% v3: Lead vehicle speed at time T3, (mph)
% v4: Lead vehicle speed at time T4, (mph)
% v5: Lead vehicle speed at time T5, (mph)

clc; clear all; close all
G=2;
L=15;
amin=-15;
amax=10;
vmax=90*5280/3600;
SL=60; % mph
SL=SL*5280/3600; % ft/sec
delta=10; % mph
delta=delta*5280/3600; % ft/sec
K1a=5;
K1d=4;
Kgd=-4;
Kga=-5;
T0=0; T1=15; T2=30; T3=150; T4=165; T5=500;
v0=SL; v1=v0; v2=SL-15*(5280/3600); v3=v2; v4=v1; v5=v4;

