%  m-file Ch5_dig_cont.m
% set values for SIMULINK file 'digital_control_system.mdl'

TR=125; % commanded temp, (deg F)
T0=75; % ambient temp and initial chamber temp, (deg F)
KS=0.25; % gain of temperature sensor (volts/deg F)
Re=1.25; % heater resistance (ohms)
alpha=56.896/(1000*Re); % factor used in SIMULINK model to compute Q(t)
C=50; % thermal capacitance of chamber, (Btu/deg F)
vmax=100; % max heater voltage, (volts)
R=0.175; % thermal resistance of chamber, (deg F per Btu/min)
KP=2; KI=2.0; KD=0.25;
integ_step=0.002; % integration step size
T=0.02; % sample time, (min)
c1=KP+(KI*T/2)+(KD/T);
c2=(KI*T/2)-KP-(2*KD/T);
c3=KD/T;
TimeSpan=60;
