function ISTATE = CNTRL(phi_1,phi_2)
% Determines whether state vector is in Region S1 or S2
% S1 - pendulum bob in liquid, i.e. |x1|<= theta_L
% S2 - pendulum bob in air, i.e. |x1|> theta_L

% Inputs: phi_1, phi_2 - discontinuity functions
% Output: ISTATE - marker indicating if state is in Region S1 or S2 
  
if phi_1 <=0 & phi_2 < 0
  ISTATE=1; % state is in Region S1
else
  ISTATE=2; % state is in Region S2
end 