%m-file Ch6_Ex6_1.m
% plots Figure 6.4
% function deriv_f_Ex6_1.m uses 2 sets of parameter values, one for Example 6.1 and another for Example 6.2

clc, clear all, close all

m0=1; c=0.05; alpha=0.25;
F=10;
v0=0;
T=0.5;

i_final=30;
% Taylor Series
vA(1)=0;
for i=1:i_final
   t(i)=(i-1)*T; 
   z1=(F-alpha*vA(i))/(m0-c*t(i)); 
   z2=((c-alpha)/2)*z1/(m0-c*t(i)); 
   vA(i+1)=vA(i) + z1*T + z2*T^2; 
end % for
t(i_final+1)=t(i_final)+T;
plot(t,vA,'rd')
set(gca,'FontSize',11)
set(gca,'XTick',[0:15])
xlabel('t','FontSize',13)
ylabel('v(t),   v_A(i)','FontSize',13)
vA_TS=vA;
hold on

% Euler
vA(1)=v0;
for i=1:i_final
  t(i)=(i-1)*T;  
  vA(i+1)=vA(i)+T*deriv_f_Ex6_1(t(i),vA(i));
end % for
t(i_final+1)=t(i_final)+T;
plot(t,vA,'b.','MarkerSize',10)
vA_euler=vA;

% Improved Euler
vA(1)=v0;
for i=1:i_final
  t(i)=(i-1)*T;  
  v_hat=vA(i)+T*deriv_f_Ex6_1(t(i),vA(i));
  vA(i+1)=vA(i)+(T/2)*(deriv_f_Ex6_1(t(i),vA(i))+deriv_f_Ex6_1(t(i)+T,v_hat));
end % for
t(i_final+1)=t(i_final)+T;
plot(t,vA,'g*')
vA_improved=vA;

% Modified Euler
vA(1)=v0;
for i=1:i_final    
  t(i)=(i-1)*T;
  v_half=vA(i)+(T/2)*deriv_f_Ex6_1(t(i),vA(i));
  vA(i+1)=vA(i)+T*(deriv_f_Ex6_1(t(i)+(T/2),v_half));
end % for
t(i_final+1)=t(i_final)+T;
plot(t,vA,'ms')
vA_modified=vA;

% Exact solution
ti=linspace(0,15,400);
a=F/alpha;
b=a-v0;
d=1-(c/m0)*ti;
vi=a-b*d.^(alpha/c);

plot(ti,vi,'k','LineWidth',1.3)
grid on
text(6,20,'Taylor Series Method','FontSize',12)
plot(5.25,20,'dr')
text(6,17,'Euler (RK-1), \itT \rm= 0.5 min','FontSize',12)
plot(5.25,17,'.b','MarkerSize',10)
text(6,14,'Improved Euler (RK-2), \itT \rm= 0.5 min','FontSize',12)
plot(5.25,14,'*g')
text(6,11,'Modified Euler (RK-2), \itT \rm= 0.5 min','FontSize',12)
plot(5.25,11,'sm')
text(6,8,'Exact','FontSize',12)
plot([5 5.5],[8 8],'k','LineWidth',1.3)

title('Comparison of Numerical Integrators and Exact Solution','FontSize',11)