% m-file Ch6_Ex6_10.m
% plots Figures 6.34 - 6.38,6.40 and 6.41 
clc; close all; clear all;

R=0.20; % ohms
L=1e-4; % henries
KT=8e-3; % lb-ft/Amp
J=4.5e-3; % lb-ft-sec^2
B=1.0e-2; % lb-ft/rad/sec
Kb=5e-2; % volt-sec/rad;
w_ref=1;
TL_amp=0;
omega_TL=0;

%%%%% Parts b)-e)
Km=KT/(B*R+Kb*KT);
wn=sqrt((B*R+Kb*KT)/(J*L));
zeta=0.5*(B*L+J*R)/sqrt(J*L*(B*R+Kb*KT));
a2=L*J; a1=B*L+R*J; a0=R*B+Kb*KT;
char_poly=[a2 a1 a0]; % characteristic polynomial
P=roots(char_poly); 
p1=P(1); p2=P(2); % characteristic roots
tau1=-1/p1; tau2=-1/p2; % second order motor time constants
z1=B*L+J*R;
z2=4*J*L*(B*R+Kb*KT);
s1=(-1/(2*J*L))*(z1+sqrt(z1^2 - z2));  % check on characteristic roots
s2=(-1/(2*J*L))*(z1-sqrt(z1^2 - z2));
stiffness=max(-P)/min(-P); 
tau=J*R/(R*B+Kb*KT); % first order motor time constant 

%%%%% Part f)
T=0.001;
t_step=0.25;
tfinal=5*tau+t_step;
sim('dc_motor')
t=w2_w1(:,1);
w2=w2_w1(:,2);
w1=w2_w1(:,3);

% figure(1) % plot Figure 6.34
% subplot(2,1,1)
% plot(t,w2,'b','LineWidth',1.3)
% axis([0 tfinal -0.3 1.05*Km])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.25:2])
% % xlabel('\itt  \rm(sec)')
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('Step Response of Motor (L = 0.1 mH)','FontSize',11)
% text(0.8,1.23,'Euler Integration, T = 0.001 s','FontSize',13)
% 
% subplot(2,1,2)
% plot(t,w1,'b','LineWidth',1.3)
% axis([0 tfinal -0.3 1.05*Km])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.25:2])
% xlabel('t  (s)','FontSize',13)
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('Step Response of Motor (L = 0 mH)','FontSize',11)
% text(0.8,1.23,'Euler Integration, T = 0.001 s','FontSize',13)

% figure(2) % plot Figure 6.35
% T=0.001001;
% sim('dc_motor')
% t=w2_w1(:,1);
% w2=w2_w1(:,2);
% 
% subplot(2,1,1)
% plot(t,w2,'b','LineWidth',1.3)
% axis([0 2.1 -0.5 6])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.25:2])
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('Step Response of Motor (L = 0.1 mH)','FontSize',11)
% text(0.1,4.5,'Euler Integration, T = 0.001001 s','FontSize',13)
% T=0.001002;
% sim('dc_motor')
% t=w2_w1(:,1);
% w2=w2_w1(:,2);
% 
% subplot(2,1,2)
% plot(t,w2,'b','LineWidth',1.3)
% axis([0 2.1 -0.5 6])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.25:2])
% xlabel('t  (s)','FontSize',13)
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('Step Response of Motor (L = 0.1 mH)','FontSize',11)
% text(0.1,4.5,'Euler Integration, T = 0.001002 s','FontSize',13)
   
% figure(3) % plot Figure 6.36
% T=0.1; tfinal=10;
% sim('dc_motor')
% t=w2_w1(:,1);
% w1=w2_w1(:,3); 
% 
% subplot(2,2,1)
% plot(t,w1,'b','LineWidth',1.3)
% axis([0 tfinal -0.5 4])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:2:10])
% set(gca,'YTick',[0:1:4])
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% text(3,1.25,'T = 0.1 s','FontSize',13)
% text(0,4.5,'Simulated Response of DC motor (L = 0) using Euler Integration','FontSize',11)
% 
% T=0.25;
% sim('dc_motor')
% t=w2_w1(:,1);
% w1=w2_w1(:,3);
% 
% subplot(2,2,2)
% plot(t,w1,'b.--','MarkerSize',8)
% axis([0 tfinal -0.5 4])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:2:10])
% set(gca,'YTick',[0:1:4])
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% text(3,1.25,'T = 0.25 s','FontSize',13)
% 
% T=0.75;
% sim('dc_motor')
% t=w2_w1(:,1);
% w1=w2_w1(:,3);
% 
% subplot(2,2,3)
% plot(t,w1,'.b--','MarkerSize',10)
% axis([0 tfinal -1 10])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:2:10])
% set(gca,'YTick',[0:2:10])
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% xlabel('t  (s)','FontSize',13)
% text(3,8.65,'T = 0.75 s','FontSize',13)
% 
% T=1;
% sim('dc_motor')
% t=w2_w1(:,1);
% w1=w2_w1(:,3);
% 
% subplot(2,2,4)
% plot(t,w1,'.b--','MarkerSize',10)
% axis([0 tfinal -250 400])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:2:10])
% set(gca,'YTick',[-200:100:400])
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% xlabel('t  (s)','FontSize',13)
% text(2.5,233,'T = 1 s','FontSize',13)

% %%%%% Part g)
% figure(4) % plot Figure 6.37
% [sizes,x0,states]=dc_motor([],[],[],0);
% T=0.0005; 
% TimeSpan=t_step+5*tau;
% Options=simset('Solver','ode1','FixedStep',T);
% tt=cputime;
% %tic
% [t,x,y]=sim('dc_motor',TimeSpan,Options);
% %toc
% t_Euler=cputime-tt;
% num_steps=length(t)-1; 
% 
% w2=y(:,2);
% subplot(2,2,1)
% plot(t,w2,'b','LineWidth',1.3)
% axis([0 TimeSpan -0.2 3.75])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.5:2])
% % xlabel('t  (s)','FontSize',13)
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('ode1 (Euler), T = 0.0005 s','FontSize',11)
% text(1,1.2,[num2str(num_steps) ' steps'],'FontSize',13)
% 
% i2=y(:,1);
% subplot(2,2,3)
% plot(t,i2,'b','LineWidth',1.3)
% axis([0 TimeSpan -0.4 5.5])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.5:2])
% set(gca,'YTick',[0:5])
% xlabel('t  (s)','FontSize',13)
% ylabel('i(t)  (A)','FontSize',13)
% title('ode1 (Euler), T = 0.0005 s','FontSize',11)
% text(1,2.3,[num2str(num_steps) ' steps'],'FontSize',13)
% 
% [sizes,x0,states]=dc_motor([],[],[],0);
% Options=simset('Solver','ode15s');
% tt=cputime;
% %tic
% [t,x,y]=sim('dc_motor',TimeSpan,Options);
% %toc
% t_stiff=cputime-tt;
% num_steps=length(t)-1;
% 
% w2=y(:,2);
% subplot(2,2,2)
% plot(t,w2,'.b','MarkerSize',8)
% axis([0 TimeSpan -0.2 3.75])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.5:2])
% %xlabel('t  (s)','FontSize',13)
% ylabel('\omega(t)  (rad/s)','FontSize',13)
% title('ode15s (stiff)','FontSize',11)
% text(1,1.25,[num2str(num_steps) ' steps'],'FontSize',13)
% 
% i2=y(:,1);
% subplot(2,2,4) 
% plot(t,i2,'.b','MarkerSize',8)
% axis([0 TimeSpan -0.4 5.5])
% grid on
% set(gca,'FontSize',11)
% set(gca,'XTick',[0:0.5:2])
% set(gca,'YTick',[0:5])
% ylabel('i(t)  (A)','FontSize',11)
% xlabel('t  (s)','FontSize',13)
% title('ode15s (stiff)','FontSize',11)
% text(1,2.3,[num2str(num_steps) ' steps'],'FontSize',13)
  
% % % % Part h) Frequency response
% figure(5)
%%%%% Bode Plots %%%%%

%%%%% W(jw)/Eo(jw)
% second order model, L=0.1
set(gca,'FontSize',11)
hold on
% w=logspace(-1,5,1000);
% s=j*w;
% Gw2=(Km*wn^2)./(s.^2 + 2*zeta*wn*s + wn^2);
% Mag_Gw2=20*log10(abs(Gw2)); % magnitude in db
% Arg_Gw2=angle(Gw2)*180/pi; % phase in degrees
% 
% % first order model, L=0
% Gw1=Km./(tau*s+1);
% Mag_Gw1=20*log10(abs(Gw1)); % magnitude in db
% Arg_Gw1=angle(Gw1)*180/pi; % phase in degrees
% 
% subplot(2,1,1)
% semilogx(w,Mag_Gw2,'b','LineWidth',1.3)
% grid on
% semilogx(w,Mag_Gw1,'r','LineWidth',1.3)
% xlabel('\omega  (rad/s)','FontSize',13)
% ylabel('|G_\Omega (j\omega)|,   db','FontSize',13)
% title('G_\Omega (j\omega), First-order and Second-Order System Models','FontSize',11)
% text(2e4,-40,'L = 0','FontSize',13)
% text(2000,-120,'L = 0.1 mH','FontSize',13)
% 
% subplot(2,1,2)
% semilogx(w,Arg_Gw2,'b')
% grid on
% set(gca,'FontSize',11)
% hold on
% semilogx(w,Arg_Gw1,'r','LineWidth',1.3)
% xlabel('\omega  (rad/s)','FontSize',13)
% ylabel('Arg [G_\Omega (j\omega)],   deg ','FontSize',13)
% text(5e3,-70,'L = 0','FontSize',13)
% text(120,-150,'L = 0.1 mH','FontSize',13)

%%%%% I(jw)/Eo(jw)
% second order model, L=0.1
% GI2=KT*(J*s+B)./((L*s+R).*(J*s+B)+Kb*KT);
% Mag_GI2=20*log10(abs(GI2)); % magnitude in db
% Arg_GI2=angle(GI2)*180/pi; % phase in degrees
% 
% % first order model, L=0
% GI1=KT*(J*s+B)./(R*(J*s+B)+Kb*KT);      
% Mag_GI1=20*log10(abs(GI1)); % magnitude in db
% Arg_GI1=angle(GI1)*180/pi; % phase in degrees
% % 
% figure(6)
% subplot(2,1,1)
% semilogx(w,Mag_GI2,'b')
% hold on
% semilogx(w,Mag_GI1,'r')
% xlabel('\omega  (rad/sec)','FontSize',11)
% ylabel('|\itG_{\rmI} \rm(j\omega\rm)|,   db','FontSize',11)
% title('\itG_{\rmI} \rm(j\omega\rm), First and Second Order System Models','FontSize',11)
% text(2e4,-25,'\itL \rm= 0','FontSize',11)
% text(1500,-50,'\itL \rm= 0.1 mH','FontSize',11)
% 
% subplot(2,1,2)
% semilogx(w,Arg_GI2,'b')
% hold on
% semilogx(w,Arg_GI1,'r')
% axis([1e-1,1e5,-100,25])
% xlabel('\omega  (rad/sec)','FontSize',11)
% ylabel('Arg [\itG_{\rmI} \rm(j\omega\rm)],    deg ','FontSize',11)
% text(2e4,10,'\itL \rm= 0','FontSize',11)
% text(250,-65,'\itL \rm= 0.1 mH','FontSize',11)
% % 
% %%%%% Part i)
% uses SIMULINK model dc_motor_2
L1=1e-3; % 1 mH
L2=1e-4; % 0.1 mH
w_ref=0;
TL_amp=1;
omega_TL=2*pi;
T=0.0001; 
TimeSpan=8*tau;
Options=simset('Solver','ode4','FixedStep',T);
[t,x,y]=sim('dc_motor_2',TimeSpan,Options);
i_L0=y(:,5);
i_L1=y(:,1);
i_L2=y(:,3);
w_L0=y(:,6);
w_L1=y(:,2);
w_L2=y(:,4);

% figure(7) % plot Figure 6.40
% subplot(2,1,1)
% plot(t,i_L0,'b','LineWidth',1.3)
% grid on
% set(gca,'FontSize',11)
% set(gca,'YTick',[-10:5:10])
% axis([0 TimeSpan -15 10])
% hold on
% plot(t,i_L1,'r','LineWidth',1.3)
% plot(t,i_L2,'k','LineWidth',1.3)
% axis([0 3 -12 15])
% ylabel('i(t), (A)','FontSize',13)
% title('Motor Current,  \omega_L = 2\pi rad/sec','FontSize',12)
% text(0.75,11.75,'L = 0, 0.1,1 mH','FontSize',13)
% plot([0.78 0.78],[3.5 9],'k','LineWidth',1.1)
% 
% subplot(2,1,2)
% plot(t,w_L0,'b','LineWidth',1.3)
% axis([0 TimeSpan -40 60])
% grid on
% set(gca,'FontSize',11)
% hold on
% plot(t,w_L1,'r','LineWidth',1.3)
% plot(t,w_L2,'k','LineWidth',1.3)
% axis([0 3 -40 60])
% xlabel('t  (s)','FontSize',13)
% ylabel('\omega(t), rad/s','FontSize',13)
% title('Motor Speed,  \omega_L = 2\pi rad/s','FontSize',12)
% text(0.65,46.5,'L = 0, 0.1, 1 mH','FontSize',13)
% plot([0.675 0.675],[7 37],'k','LineWidth',1.1)

omega_TL=200;
TimeSpan=0.3;
Options=simset('Solver','ode4','FixedStep',T);
[t,x,y]=sim('dc_motor_2',TimeSpan,Options);
i_L0=y(:,5);
i_L1=y(:,1);
i_L2=y(:,3);
w_L0=y(:,6);
w_L1=y(:,2);
w_L2=y(:,4);

figure(8)
subplot(2,1,1)
plot(t,i_L0,'b','LineWidth',1.3)
hold on
plot(t,i_L1,'r','LineWidth',1.3)
plot(t,i_L2,'k','LineWidth',1.3)
axis([0 0.3 -0.62 0.20])
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[-0.6:0.2:0.2])
ylabel('i(t), (A)','FontSize',13)
title('Motor Current,  \omega_L = 200 rad/s','FontSize',11)
text(0.01,0.12,'L = 1 mH','FontSize',13)
plot([0.013 0.013],[-0.31 0.05],'k')
text(0.226,-0.53,'L = 0, 0.1 mH','FontSize',13)
plot([0.2275 0.2275],[-0.45 -0.14],'k')

subplot(2,1,2)
plot(t,w_L0,'b','LineWidth',1.3)
axis([0 0.2 -1.25 2.5])
grid on
set(gca,'FontSize',11)
hold on
plot(t,w_L1,'r','LineWidth',1.3)
plot(t,w_L2,'k','LineWidth',1.3)
axis([0 0.3 -0.7 2.5])
xlabel('t  (s)','FontSize',13)
ylabel('\omega(t), rad/s','FontSize',13)
title('Motor Speed,  \omega_L = 200 rad/s','FontSize',11)
text(0.2078,2.2,'L = 0, 0.1, 1 mH','FontSize',13)
plot([0.2088 0.2088],[1.3 1.89],'k')





