% m-file Ch6_Ex6_11.m
% calls Simulink model temp_cylinder.mdl
% plots Figure 6.45 and Figure 6.46

clc, clear all, close all

L=10; D=2; 
dz=L/5;
A=pi*(D/2)^2;
c=2.93; k=224; rho=17.3;
V=A*dz;
C=c*rho*V;
R1=dz/(2*k*A);
R=dz/(k*A);

A=zeros(5);
A(1,1)=-(1/C)*(1/R1+1/R);
A(1,2)=1/(R*C);
A(2,1)=1/(R*C);
A(2,2)=-2/(R*C);
A(2,3)=1/(R*C);
A(3,2)=1/(R*C);
A(3,3)= -2/(R*C);
A(3,4)=1/(R*C);
A(4,3)=1/(R*C);
A(4,4)=-2/(R*C);
A(4,5)=1/(R*C);
A(5,4)=1/(R*C);
A(5,5)=-1/(R*C);

B=[1/(R1*C);0;0;0;0];
CC=eye(5);
D(1:5)=0;
D=D';
Tbar=200;
dt=0.01; tfinal=30;
sim('temp_cylinder')

figure(1) % plot Figure 6.45
T1=T(:,1);
plot(t,T1,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'YTick',[60:20:200])
set(gca,'XTick',[0:5:30])
hold on
T2=T(:,2);
plot(t,T2,'r','LineWidth',1.3)
T3=T(:,3);
plot(t,T3,'g','LineWidth',1.3)
T4=T(:,4);
plot(t,T4,'m','LineWidth',1.3)
T5=T(:,5);
plot(t,T5,'k','LineWidth',1.3)
xlabel('t  (h)','FontSize',13)
ylabel('T(\circF)','FontSize',13)
axis([0 tfinal 60 200])
text(2,189,'T_1(t)','FontSize',12)
text(4,168,'T_2(t)','FontSize',12)
text(5,151,'T_3(t)','FontSize',12)
text(7,110,'T_4(t)','FontSize',12)
text(9.5,130,'T_5(t)','FontSize',12)
plot([4.2,6.8],[110,110],'k')
plot([7.5,9.2],[130,130],'k')
title('Cylinder Node Temperatures vs Time','FontSize',11)

figure(2)
zi=1:5;
n=1+round(0/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'b.--','MarkerSize',12)
hold on
grid on
set(gca,'FontSize',11)
n=1+round(2.5/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'r.--','MarkerSize',12)
n=1+round(5/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'g.--','MarkerSize',12)
n=1+round(10/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'m.--','MarkerSize',12)
n=1+round(20/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'c.--','MarkerSize',12)
n=1+round(30/dt);
Tn=[T1(n) T2(n) T3(n) T4(n) T5(n)];
plot(zi,Tn,'k.--','MarkerSize',12)
axis([1 5 60 220])
xlabel('node','FontSize',13)
set(gca,'XTick',[1:5])
ylabel('T(\circF)','FontSize',13)
title('Temperature Profiles Along Cylinder at Various Times','FontSize',11)
text(1.3,83.5,'t = 0 hr','FontSize',13)
text(1.6,123.5,'t = 2.5 hr','FontSize',13)
text(2.85,143.7,'t = 5 hr','FontSize',13)
text(3.5,164,'t = 10 hr','FontSize',13) 
text(3.9,177,'t = 20 hr','FontSize',13)
text(4.3,203.5,'t = 30 hr','FontSize',13)

