% m-file Ch6_Ex6_4.m
% plots Figure 6.7

clc
clear all
close all

Tfinal=5;
T0=1000;
T_RK1=0.1;
num=3;

% Exact
T=0.005;
TA(1)=T0;
i_final4=round(Tfinal/T);
for i=1:i_final4
   t_exact(i)=(i-1)*T;
   k1=deriv_f_Ex6_4(0,TA(i));
   k2=deriv_f_Ex6_4(0,TA(i)+0.5*k1*T);
   k3=deriv_f_Ex6_4(0,TA(i)+0.5*k2*T);
   k4=deriv_f_Ex6_4(0,TA(i)+k3*T);
   TA(i+1)=TA(i)+(T/6)*(k1+2*k2+2*k3+k4);
end % for
t_exact(i+1)=i*T;
TA_exact=TA;

subplot(2,1,1)
hold on
plot(t_exact,TA_exact,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
axis([0 5 400 1000])
ylabel('T   (\circR)','FontSize',13)
title('RK-1 Integration with Step Size T = 0.3 h','FontSize',11)

% RK-1 with T=0.3

clear t TA
T=num*T_RK1;
i_final1=round(Tfinal/T);
TA(1)=T0;

  for i=1:i_final1
    t(i)=(i-1)*T;
    TA(i+1)=TA(i)+T*deriv_f_Ex6_4(0,TA(i));    
  end % for i
  
t(i+1)=i*T;
TA_RK1=TA;
plot(t(1:1:end),TA_RK1(1:1:end),'.r','MarkerSize',10) 
text(3.5,832,'Exact','FontSize',13)
plot([3.1 3.3],[830 830],'b','LineWidth',1.3)
text(3.5,632,'T = 0.3 h','FontSize',13)
plot(3.2,632,'.r','MarkerSize',10) 

% % RK-2  not used
% subplot(2,2,2)
% plot(t_exact,TA_exact,'k')
% hold on
% axis(v)
% xlabel('\itt \rm(hrs)','FontSize',11)
% ylabel('\itT \rm(deg R)','FontSize',11)
% text(1,850,'RK-2','FontSize',11)
% for j=1:num
%   clear t TA
%   T=j*T_RK1;
%   i_final2=round(Tfinal/T);
%   TA(1)=T0;
%   TA_euler(1)=T0;
%   for i=1:i_final2
%     t(i)=(i-1)*T; 
%     TA_euler(i+1)=TA_euler(i)+T*deriv_f_Ex2_4(0,TA_euler(i));
%     TA(i+1)=TA(i)+(T/2)*(deriv_f_Ex2_4(0,TA(i)) + deriv_f_Ex2_4(0,TA_euler(i+1)));
%   end % for i
% t(i+1)=i*T;
% TA_RK2=TA;
%   switch j
%     case 1
%     plot(t(1:6:end),TA_RK2(1:6:end),'.k','MarkerSize',5)
%     case 2
%     plot(t(1:3:end),TA_RK2(1:3:end),'diamondk','MarkerSize',3,'MarkerFaceColor','k')
%     case 3
%     plot(t(1:2:end),TA_RK2(1:2:end),'squarek','MarkerSize',3,'MarkerFaceColor','k')   
%   end % switch
% end % for j
% legend('Exact','\itT\rm = 0.1','\itT \rm= 0.2','\itT \rm= 0.3')
% 
% 
% % RK-3  not used
% subplot(2,2,3)
% plot(t_exact,TA_exact,'k')
% hold on
% axis(v)
% xlabel('\itt  \rm(hrs)','FontSize',11)
% ylabel('\itT  \rm(deg R)','FontSize',11)
% text(1,850,'RK-3','FontSize',11)
% for j=1:num
% clear t TA
% T= 3*j*T_RK1;
% i_final3=round(Tfinal/T);
% TA(1)=T0;
%   for i=1:i_final3
%     t(i)=(i-1)*T; 
%     k1=deriv_f_Ex2_4(0,TA(i));
%     k2=deriv_f_Ex2_4(0,TA(i)+0.5*k1*T);
%     k3=deriv_f_Ex2_4(0,TA(i)-k1*T+2*k2*T);
%     TA(i+1)=TA(i)+(T/6)*(k1+4*k2+k3);
%   end % for i
% t(i+1)=i*T;
% TA_RK3=TA;
%   switch j
%     case 1
%     plot(t(1:1:end),TA_RK3(1:1:end),'.k','MarkerSize',5)
%     case 2
%     plot(t(1:1:end),TA_RK3(1:1:end),'diamondk','MarkerSize',3,'MarkerFaceColor','k')
%     case 3
%     plot(t(1:1:end),TA_RK3(1:1:end),'squarek','MarkerSize',3,'MarkerFaceColor','k')   
%   end % switch
% end % for j
% legend('Exact','\itT\rm = 0.2','\itT \rm= 0.4','\itT \rm= 0.6')
% 

% RK-4 with T=0.8
subplot(2,1,2)
plot(t_exact,TA_exact,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
hold on
axis([0 5 400 1000])
xlabel('t  (h)','FontSize',13)
ylabel('T   (\circR)','FontSize',13)

clear t TA
T= 8*T_RK1 
i_final4=round(Tfinal/T);
TA(1)=T0;

for i=1:i_final4
  t(i)=(i-1)*T;
  k1=deriv_f_Ex6_4(0,TA(i));
  k2=deriv_f_Ex6_4(0,TA(i)+0.5*k1*T);
  k3=deriv_f_Ex6_4(0,TA(i)+0.5*k2*T);
  k4=deriv_f_Ex6_4(0,TA(i)+k3*T);
  TA(i+1)=TA(i)+(T/6)*(k1+2*k2+2*k3+k4);
end % for i

t(i+1)=i*T;
TA_RK4=TA;    
plot(t(1:1:end),TA_RK4(1:1:end),'r.','MarkerSize',10)        
title('RK- 4 Integration with Step Size T = 0.8 h','FontSize',11)
text(3.5,832,'Exact','FontSize',13)
plot([3.1 3.3],[830 830],'b','LineWidth',1.3)
text(3.5,632,'T = 0.8 h','FontSize',13)
plot(3.2,632,'.r','MarkerSize',10) 








 
