% m-file Ch6_Ex6_5.m
% plots Figure 6.10

clc; close all; clear all

% RK-4
alpha=0.01;
F=pi;
h0=10;
c=4*F/pi;
tol_1=1e-13;
tol_2=1e-11;
t_final=1600;
hA(1)=h0;
T(1)=1;
hA_temp(1)=hA(1);
t(1)=0; lte(1)=0;
i=1;

% Analytical Solution
 h=h0:0.005:19;
 A=(60-3*h)./(h+20);
 tt=100*(10-h-10*log(A));
 plot(tt,h,'b','LineWidth',1.3)
 grid on
 set(gca,'FontSize',11) 
 set(gca,'YTick',[10:20])
 xlabel('t  (min)','FontSize',13)
 ylabel('h(t), h_A   (ft)','FontSize',13)
 hold on

while hA(end) < 19
    
   k1=c/(hA(i)^2)-alpha;
   k2=c/((hA(i)+0.5*k1*T(i))^2)-alpha;
   k3=c/((hA(i)+0.5*k2*T(i))^2)-alpha;
   k4=c/((hA(i)+k3*T(i))^2)-alpha;
   hA_one_step(i+1)=hA(i)+(T(i)/6)*(k1+2*k2+2*k3+k4); 

   T(i)=T(i)/2;
   k1=c/(hA(i)^2)-alpha;
   k2=c/((hA(i)+0.5*k1*T(i))^2)-alpha;
   k3=c/((hA(i)+0.5*k2*T(i))^2)-alpha;
   k4=c/((hA(i)+k3*T(i))^2)-alpha;
   hA_mid=hA(i)+(T(i)/6)*(k1+2*k2+2*k3+k4);    
   k1=c/(hA_mid^2)-alpha;
   k2=c/((hA_mid+0.5*k1*T(i))^2)-alpha;
   k3=c/((hA_mid+0.5*k2*T(i))^2)-alpha;
   k4=c/((hA_mid+k3*T(i))^2)-alpha;
   hA_two_steps(i+1)=hA_mid+(T(i)/6)*(k1+2*k2+2*k3+k4); 
   
   T(i)=2*T(i);   
   t(i+1)=t(i)+T(i);
   lte(i+1)=(hA_two_steps(i+1)-hA_one_step(i+1))/15; 
   hA(i+1)=(16*hA_two_steps(i+1)-hA_one_step(i+1))/15; 
   
   if abs(lte(i+1))<tol_1
      T(i+1)=2*T(i);
   elseif abs(lte(i+1)) > tol_2 
      T(i+1)=T(i)/2;
   else T(i+1)=T(i);
   end % if 
   
   i=i+1;
      
end % while

plot(t(1:4:end),hA(1:4:end),'.r','MarkerSize',10)
text(800,14.2,'h(t)','FontSize',13)
plot([720 780],[14.2 14.2],'b','LineWidth',1.3)
text(800,13.15,'h_A(i), i = 0,3,7,...','FontSize',13)
plot([750],[13.2],'.r','MarkerSize',10)
title('Simulated and Analytical Tank Level vs. Time','FontSize',11)
