% m-file Ch6_Ex6_7.m
% plots Figure 6.17

clc; close all; clear all;

lambda=0.2; alpha=0.02;
V0=1000;

%%%%% Analytical Solution V(t) %%%%%
tfinal=10/alpha;
T=0.25;
t=0:T:tfinal;
z=(lambda/alpha)*(1-exp(-alpha*t));
V=V0*exp(z);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%% AB-2 and AM-3 %%%%%
clear t
lt=lambda*T;
V_AB(1)=V0; V_AB(2)=V(2);
V_AM(1)=V0; V_AM(2)=V(2);
df(1)=V_AM(1)-V_AB(1);
df(2)=V_AM(2)-V_AB(2);
t(1)=0; t(2)=T;
j=2;
i=j-1; % i is discrete time variable
while t(j)<tfinal
    a0_AB=1+1.5*lt*exp(-alpha*T*i); 
    a1_AB=0.5*lt*exp(-alpha*T*(i-1)); 
    V_AB(j+1)=a0_AB*V_AB(j)-a1_AB*V_AB(j-1); 
    
    d=1-(5/12)*lt*exp(-alpha*T*(i+1));
    a0_AM=(1+(2/3)*lt*exp(-alpha*T*i))/d;
    a1_AM=(1/12)*lt*exp(-alpha*T*(i-1))/d;
    V_AM(j+1)=a0_AM*V_AB(j)-a1_AM*V_AM(j-1);
    
    df(j)=V_AM(j)-V_AB(j); % Difference between AM-3 and AB-2 integrators
    
    t(j+1)=t(j)+T;
    j=j+1;
    i=j-1;
end % while

subplot(2,1,1)
plot(t,V,'b','LineWidth',1.3)
axis([0 500 0 2.3e7])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:500])
ylabel('Number of Cells','FontSize',13)
hold on
del=50;
plot(t(1:del:end),V_AB(1:del:end),'.r','MarkerSize',10)
text(275,1.75e7,'Exact: V(t)','FontSize',12)
plot([240 260],[1.75e7 1.75e7],'b','LineWidth',1.3)
text(275,1.25e7,'AB-2: V_A(i), i = 0,50,100,...','FontSize',12)
plot([250],[1.3e7],'.r','MarkerSize',10)
title('Tumor Growth, Exact and AB-2','FontSize',12)
text(150,0.4e7,'Note: V_A(1) for AB-2 from exact solution','FontSize',12) 
text(275,0.85e7,'T = 0.25 weeks','FontSize',12)


subplot(2,1,2)
plot(t,V,'b','LineWidth',1.3)
axis([0 500 0 2.3e7])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:500])
xlabel('t  (weeks)','FontSize',13)
ylabel('Number of Cells','FontSize',13)
hold on
plot(t(1:del:end),V_AM(1:del:end),'.r','MarkerSize',10)
text(275,1.75e7,'Exact: V(t)','FontSize',12)
plot([240 260],[1.75e7 1.75e7],'b','LineWidth',1.3)
text(275,1.25e7,'AM-3: V_A(i), i = 0,50,100,...','FontSize',12)
plot(250,1.30e7,'.r','MarkerSize',10)
title('Tumor Growth, Exact and AM-3','FontSize',11)
text(150,0.4e7,'Note: V_A(1) for AM-3 from exact solution','FontSize',12) 
text(275,0.85e7,'T = 0.25 weeks','FontSize',12)

    