% m-file Ch6_Ex6_8.m
% plots Figure 6.18

clc; clear all; close all;
warning off

global a b K

p0=180000;
price=200000; demand=16;
a=price*demand;
price=250000; supply=25;
b=supply/sqrt(price);
T=0.5;
K=2000;

%%%%% Part A) %%%%%
pA(1)=p0;
for i=1:3
   t(i)=(i-1)*T;
   k1=deriv_car(t(i),pA(i));
   k2=deriv_car(t(i)+0.5*T,pA(i)+0.5*k1*T);
   k3=deriv_car(t(i)+0.5*T,pA(i)+0.5*k2*T);
   k4=deriv_car(t(i)+T,pA(i)+k3*T);
   pA(i+1)=pA(i)+(T/6)*(k1+2*k2+2*k3+k4); % Starting value for AB-4/AM-3
end % for
t(4)=3*T;

tfinal=15;
ifinal=round(tfinal/T);
pA_AM(1:4)=pA(1:4); % Initialize pA_AB for AB-4

for i=4:ifinal
    t(i+1)=i*T; 
    pA_AB(i+1)=pA_AM(i)+(T/24)*(55*deriv_car(t(i),pA_AM(i))-59*deriv_car(t(i-1),pA_AM(i-1))+...
               37*deriv_car(t(i-2),pA_AM(i-2))-9*deriv_car(t(i-3),pA_AM(i-3)));  % Predictor
    pA_AM(i+1)=pA_AM(i)+(T/24)*(9*deriv_car(t(i+1),pA_AB(i+1))+19*deriv_car(t(i),pA_AM(i))...
               -5*deriv_car(t(i-1),pA_AM(i-1))+deriv_car(t(i-2),pA_AM(i-2)));  % Corrector
 end % for
       
 %%%%% Part B %%%%%
 
 plot(t,pA_AM,'.r','MarkerSize',11)
 axis([0 15 1.59e5 1.81e5])
 grid on
 set(gca,'FontSize',11)
 set(gca,'XTick',[0:15])
 set(gca,'YTick',[1.6e5:0.02e5:1.8e5])
 xlabel('t  (months)','FontSize',13)
 ylabel('Car Price  ($)','FontSize',13)
 hold on
 pA_AM(1:2:end);
 
 T=0.01;
 ifinal=round(tfinal/T);
 pA(1)=p0;
for i=1:ifinal
   t(i)=(i-1)*T;
   k1=deriv_car(t(i),pA(i));
   k2=deriv_car(t(i)+0.5*T,pA(i)+0.5*k1*T);
   k3=deriv_car(t(i)+0.5*T,pA(i)+0.5*k2*T);
   k4=deriv_car(t(i)+T,pA(i)+k3*T);
   pA(i+1)=pA(i)+(T/6)*(k1+2*k2+2*k3+k4); % Exact solution estimate
end % for
t(i+1)=i*T;
plot(t,pA,'b','LineWidth',1.3)
text(8,1.685e5,'p(t)','FontSize',13)
plot([7 7.6],[1.683e5 1.683e5],'b','LineWidth',1.3)
text(8,1.664e5,'p_A(i)','FontSize',13)
plot([7.3],[1.663e5],'.r','MarkerSize',11)
title('Price of Luxury Automobiles vs. Time','FontSize',11)
