% m-file Ch6_stiffsys_approx.m
% call Simulink model stiff_approx_1.mdl
% plots Figure 6.28

clc, close all, clear all

KC=2; 
K=5; zeta=0.7; wn=1.5;
wnsq=wn^2;
KS=0.75; tau=0.00125;
KL=3;

%%%%% Begin GR(s) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% 3rd order
% b1_GR_3=KC*K*tau;
% b0_GR_3=KC*K;
% a3_GR_3=tau;
% a2_GR_3=1+2*zeta*wn*tau;
% a1_GR_3=2*zeta*wn+wnsq*tau;
% a0_GR_3=wnsq+KC*K*KS;
% num_GR_3=[b1_GR_3 b0_GR_3];
% den_GR_3=[a3_GR_3 a2_GR_3 a1_GR_3 a0_GR_3];
% sys_GR_3=tf(num_GR_3,den_GR_3) 
% P_3=roots(den_GR_3) 
% stiffness=-P_3(1)/abs(P_3(2)) 
% GR_3_ss_gain_r=b0_GR_3/a0_GR_3 
% res_freq=10^(0.44)  % resonant freq (rad/sec)
% [MAG_GR_3_res_freq,PHASE_GR_3_res_freq]=bode(sys_GR_3,res_freq) 
% Gain_GR_3_res_freq=20*log10(MAG_GR_3_res_freq) 
% 
% % 2nd order (tau=0)
% b0_GR_2=KC*K;
% a2_GR_2=1;
% a1_GR_2=2*zeta*wn;
% a0_GR_2=wnsq+KC*K*KS;
% num_GR_2=[b0_GR_2];
% den_GR_2=[a2_GR_2 a1_GR_2 a0_GR_2];
% sys_GR_2=tf(num_GR_2,den_GR_2) 
% P_2=roots(den_GR_2) 
% GR_2_ss_gain=b0_GR_2/a0_GR_2 
% 
% % Bode plot for GR_3 and GR_2
% wmin=0.1; wmax=5000;
% X1=log10(wmin); X2=log10(wmax);
% w=logspace(X1,X2,1000);
% figure(1)
% bode(sys_GR_3,'r',sys_GR_2,'b')
% 
% %%%% End GR(s) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% 
% %%%% Begin GD(s) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% % 3rd order
% b3_GD_3=KL*tau;
% b2_GD_3=KL*(1+2*zeta*wn*tau);
% b1_GD_3=KL*(wnsq*tau+2*zeta*wn);
% b0_GD_3=KL*wnsq;
% a3_GD_3=tau;
% a2_GD_3=1+2*zeta*wn*tau;
% a1_GD_3=wnsq*tau+2*zeta*wn;
% a0_GD_3=wnsq+K*KC*KS;
% num_GD_3=[b3_GD_3 b2_GD_3 b1_GD_3 b0_GD_3];
% den_GD_3=[a3_GD_3 a2_GD_3 a1_GD_3 a0_GD_3];
% sys_GD_3=tf(num_GD_3,den_GD_3) 
% GD_3_ss_gain=b0_GD_3/a0_GD_3 
% GD_3_highfreq_gain=b3_GD_3/a3_GD_3 
% 
% [R_GD_3,P_GD_3,K_GD_3]=residue(num_GD_3,den_GD_3)
% num_roots_GD_3=roots(num_GD_3)
% den_roots_GD_3=roots(den_GD_3)
% n=conv([1 -num_roots_GD_3(2)],[1 -num_roots_GD_3(3)])
% d=conv([1 -den_roots_GD_3(2)],[1 -den_roots_GD_3(3)])
% sysA=tf(n,d)
% nn=[1 -num_roots_GD_3(1)]
% dd=[1 -den_roots_GD_3(1)]
% sysB=tf(nn,dd)
% wmin=10; wmax=1e5;
% X1=log10(wmin); X2=log10(wmax);
% w=logspace(X1,X2,100000); 
% 
% % 2nd order (tau=0)
% b2_GD_2=KL;
% b1_GD_2=KL*2*zeta*wn;
% b0_GD_2=KL*wnsq;
% a2_GD_2=1;
% a1_GD_2=2*zeta*wn;
% a0_GD_2=wnsq+K*KC*KS;
% num_GD_2=[b2_GD_2 b1_GD_2 b0_GD_2];
% den_GD_2=[a2_GD_2 a1_GD_2 a0_GD_2];
% sys_GD_2=tf(num_GD_2,den_GD_2) 
% [R_GD_2,P_GD_2,K_GD_2]=residue(num_GD_2,den_GD_2)
% num_roots_GD_2=roots(num_GD_2)
% den_roots_GD_2=roots(den_GD_2)
% GD_2_ss_gain=b0_GD_2/a0_GD_2 
% GD_2_highfreq_gain=b2_GD_2/a2_GD_2 
% 
% % Bode plot for GD_3 and GD_2
% figure(2)
% wmin=0.1; wmax=2000;
% X1=log10(wmin); X2=log10(wmax);
% w=logspace(X1,X2,1000);
% bode(sys_GD_3,'b',sys_GD_2,'r') 
% 
% %%%% End GD(s) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%% step response of GR_3(s)
figure(3) % begin Figure 6.28
Amp_signal=0; freq_signal=0; A=1; % unit step reference input 
Amp_dist=0; freq_dist=0; % zero disturbance input 
T=0.0034; tfinal=5;
sim('stiff_approx_1')
t=y(:,1);
y=y(:,2);

subplot(2,1,1)
plot(t,y,'b','LineWidth',1.3)
axis([0 5 0 1.5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
ylabel('y(t)','FontSize',13)
title('Step Response of Stiff Third Order System','FontSize',11)
text(2,0.59,'RK-4 with T = 0.0034 s','FontSize',13)
T=0.0035; tfinal=5;
sim('stiff_approx_1')
t=y(:,1);
y=y(:,2);

subplot(2,1,2)
plot(t,y,'b','LineWidth',1.3)
axis([0 5 -1000 12000])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
ylabel('y(t)','FontSize',13)
xlabel('t  (s)','FontSize',13)
title('Step Response of Stiff Third Order System','FontSize',11)
text(2,5850,'RK-4 with T = 0.0035 s','FontSize',13)


%%%% step responses of GR_3(s) and GR_2(s) R to Y
figure(4) % begin Figure 6.30
T=0.001; 
sim('stiff_approx_2')
t=y3_y2(:,1);
y3=y3_y2(:,2);
y2=y3_y2(:,3);

subplot(2,2,1)
plot(t,y3,'b','LineWidth',1.3)
grid on
axis([0 5 0 1.5])
set(gca,'FontSize',11)
set(gca,'XTick',[0:5])
set(gca,'YTick',[0:0.25:1.5])
text(0.25,1.65,'y(t), Third-order System','FontSize',11)
ylabel('y(t)','FontSize',13)

subplot(2,2,3)
plot(t,y2,'b','LineWidth',1.3) 
grid on
axis([0 5 0 1.5])
set(gca,'FontSize',11)
set(gca,'XTick',[0:5])
set(gca,'YTick',[0:0.25:1.5])
xlabel('t  (s)','FontSize',13)
text(0.0,1.65,'y(t), Second-order System','FontSize',11)
ylabel('y(t)','FontSize',13)

x3=x3_x2(:,2);
x2=x3_x2(:,3);

subplot(2,2,2)
plot(t,x3,'b','LineWidth',1.3)
grid on
axis([0 5 0 1.5])
set(gca,'FontSize',11)
set(gca,'XTick',[0:5])
set(gca,'YTick',[0:0.25:1.5])
text(0.2,1.65,'x(t), Third-order System','FontSize',11)
ylabel('x(t)','FontSize',13)

subplot(2,2,4)
plot(t,x2,'b','LineWidth',1.3) 
grid on
axis([0 5 0 1.5])
set(gca,'FontSize',11)
set(gca,'XTick',[0:5])
set(gca,'YTick',[0:0.25:1.5])
xlabel('t  (s)','FontSize',13)
ylabel('x(t)','FontSize',13)
text(0.0,1.65,'x(t), Second-order System','FontSize',11)


