function [x1_new, x2_new]=RK4(T,x1_old,x2_old,ISTATE)
% RK-4 numerical integrator for updating state

% Inputs: T  integration step size
%         x1_old,x2_old: starting values of state components
%         ISTATE: marker indicating region in state space of (x1_old,x2_old)

% Outputs: x1_new,x2_new: updated state vector

global g R m J gamma r alpha

[k11 k12]=f(x1_old,x2_old,ISTATE);
x1_half=x1_old+(T/2)*k11;
x2_half=x2_old+(T/2)*k12;
[k21 k22]=f(x1_half,x2_half,ISTATE);
x1_half_hat=x1_old+(T/2)*k21;
x2_half_hat=x2_old+(T/2)*k22;
[k31 k32]=f(x1_half_hat,x2_half_hat,ISTATE);
x1_full_hat=x1_old+T*k31;
x2_full_hat=x2_old+T*k32;
[k41 k42]=f(x1_full_hat,x2_full_hat,ISTATE);
x1_new=x1_old+(T/6)*(k11+2*k21+2*k31+k41);
x2_new=x2_old+(T/6)*(k12+2*k22+2*k32+k42);

