function [f1, f2]=f(x1,x2,ISTATE)

% Inputs: x1,x2 - components of state
%         ISTATE - marker indicating if state is in region S1 or S2 
% Outputs: f1,f2 - state derivatives

global g R m J gamma r alpha

f1=x2;
if ISTATE==1
    f2=((-m*g+(4/3)*(gamma*pi*r^3))*R*sin(x1)-alpha*(R^2)*x2)/J; 
elseif ISTATE==2
    f2=(-m*g*R*sin(x1))/J; 
end

    

