% m-file Ch7_Cap.m
% 

clc,close all,clear all

E0=48; % volts
r=20; % radius in mm
A=pi*r^2; % area in mm sq
L=4; % separation between diaphragm and fixed plate when x=0, in mm
C0=5e-6 % nominal capacitance when x=0, in F
B=C0*L 
% B=(1e-12)*(8.854e-3)*A; % F-mm
R=100; % ohms
% C0=B/L;
tau0=R*C0 
m=25e-6; % N/(mm/sec sq), 30 g
mu=0.01; % N/(mm/sec)
k=2; % N/mm
wn=sqrt(k/m) 
zeta=mu/(2*sqrt(m*k)) 
tau_eff=1/(zeta*wn)
P=0.001; % Input pressure (psi)
a=4.448/(25.4^2); % factor to convert psi to N per sq mm
F=(a*P)*A
a3=k;
a2=-(F+2*k*L);
a1=L*(k*L+2*F);
a0=-(L^2)*F+0.5*B*(E0^2);
r=roots([a3 a2 a1 a0])
x_bar=r(3) % Output #1
VC_bar=E0 %  Output #2
h_bar=L-x_bar
C_bar=B/h_bar % Output#3
Fc_bar=0.5*B*(E0/h_bar)^2 % Output #4
F_bar=F % Output #5
VR_bar=E0-VC_bar % Output #6
Q_bar=C_bar*VC_bar % Output#7

[sizes,x0,states]=cap_transducer([],[],[],0)
x0=[0;C0*E0;0];
u0=[E0;P];
y0=[0;E0;C0;0;0;0;C0*E0];
ix=[ ];
iu=[1,2];
iy=[ ];
[x,u,y,dx]=trim('cap_transducer',x0,u0,y0,ix,iu,iy)



