% m-file Ch7_Ex4_2.m
% calls Simulink model Lin2Tanks.mdl
% plots Figures 7.69 - 7.73

clc, close all, clear all

A1=25; A2 =15;
c1=3; c2=4;
F0=12; % Input flow to first tank
H1ss=(F0/c1)^2; 
H2ss=(F0/c2)^2; 
H1_bar=0.5*H1ss; 
F1_bar=c1*sqrt(H1_bar);
F0_bar=F1_bar;
F2_bar=F1_bar;
H2_bar=(F2_bar/c2)^2;
H1_init=0;
H2_init=0;
% H1_init=H1_bar;
% H2_init=H2_bar;

a11=-c1/(2*A1*sqrt(H1_bar)); 
a12=0;
a21=c1/(2*A2*sqrt(H1_bar)); 
a22=-c2/(2*A2*sqrt(H2_bar)); 
b1=1/A1; 
b2=0;
dF0=F0-F0_bar;
dH1_init=H1_init-H1_bar;
dH2_init=H2_init-H2_bar;
d=b1*dF0/a11;
e=dH1_init+d;
f=(a21*d/a22);
g=(a21*dH1_init+a21*d)/(a11-a22);
h=dH2_init + a21*(dH1_init+b1*dF0/a22)/(a22-a11); 
tau1=-1/a11;
tau2=-1/a22;
Tfinal=350;  % stop time in Simulink model
t=linspace(0,Tfinal,1000);
dH1=-d+e*exp(a11*t);
H1=H1_bar+dH1;
dH2=f+g*exp(a11*t)+h*exp(a22*t);
H2=H2_bar+dH2;
H1(end), H2(end)

sim('Lin2Tanks')
tt=H1_sim(:,1);
H1_sim=H1_sim(:,2);
H2_sim=H2_sim(:,2);

figure(1) % plot Figure 7.69
subplot(2,1,1)
plot(t,H1,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:350])
set(gca,'YTick',[0:5:15])
axis([0 Tfinal 0 18])
hold on
plot(tt,H1_sim,'r','LineWidth',1.3)
text(70,16.0,'nonlinear','FontSize',13)
text(225,12.7,'linear','FontSize',13)
ylabel('H_1(t),  (ft)','FontSize',13)
title('Tank 1 Level Response','FontSize',12)

subplot(2,1,2)
plot(t,H2,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:350])
set(gca,'YTick',[0:2.5:10])
hold on
plot(tt,H2_sim,'r','LineWidth',1.3)
axis([0 Tfinal 0 10])
text(55,8.0,'nonlinear','FontSize',13)
text(225,7,'linear','FontSize',13)
xlabel('t  (min)','FontSize',13)
ylabel('H_2(t),  (ft)','FontSize',13)
title('Tank 2 Level Response','FontSize',12)

figure(2) % plot Figure 7.70
plot(H1,H2,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:16])
set(gca,'YTick',[0:10])
hold on
plot(H1_sim,H2_sim,'r','LineWidth',1.3)
axis([0 1.1*H1ss 0 1.15*H2ss])
xlabel('H_1(t)   (ft)','FontSize',13)
ylabel('H_2(t)   (ft)','FontSize',13)
plot(H1_bar,H2_bar,'.k','MarkerSize',13)
text(5.0,4.5,'(H_1,H_2)','FontSize',13)
text(5.29,5.20,'_','FontSize',13)
text(6.3,5.20,'_','FontSize',13)
text(6.5,1.5,'linear','FontSize',13)
text(0.8,1.5,'nonlinear','FontSize',13)
plot([H1ss H1ss],[0 H2ss],'k--','LineWidth',1.2)
plot([0 H1ss],[H2ss H2ss],'k--','LineWidth',1.2)
text(4,9.5,'(H_2)_{ss} = 9 ft','FontSize',13)
text(11.5,3.2,'(H_1)_{ss} = 16 ft','FontSize',13)
text(6.85,11.45,'_','FontSize',13)
text(9.41,11.45,'_','FontSize',13)
text(-2,10.75,'State Trajectories of Linearized (H_1 = 8 ft, H_2 = 4.5 ft) and Nonlinear Systems','FontSize',11)


%%%%% begin multiple linearization
clear t

H1_init_R1=0; H2_init_R1=0;
% begin set Region I (0 < H1 <4 ) parameters
R=1;
H1_bar_R1=2;  
F1_bar_R1=c1*sqrt(H1_bar_R1);
F0_bar_R1=F1_bar_R1; 
F2_bar_R1=F1_bar_R1;
H2_bar_R1=(F2_bar_R1/c2)^2;  
a11_R1=-c1/(2*A1*sqrt(H1_bar_R1)); 
a12=0;
a21_R1=c1/(2*A2*sqrt(H1_bar_R1)); 
a22_R1=-c2/(2*A2*sqrt(H2_bar_R1)); 
b1=1/A1; 
b2=0;
dF0_R1=F0-F0_bar_R1;
dH1_init_R1=H1_init_R1-H1_bar_R1;
dH2_init_R1=H2_init_R1-H2_bar_R1;
d_R1=b1*dF0_R1/a11_R1;
e_R1=dH1_init_R1+d_R1;
f_R1=(a21_R1*d_R1/a22_R1);
g_R1=(a21_R1*dH1_init_R1+a21_R1*d_R1)/(a11_R1-a22_R1);
h_R1=dH2_init_R1 + a21_R1*(dH1_init_R1+b1*dF0_R1/a22_R1)/(a22_R1-a11_R1);  

tfinal=350;
del_t=0.1;
ifinal=round(tfinal/del_t);

for i=1:ifinal
   t(i)=(i-1)*del_t;   
   dH1=-d_R1+e_R1*exp(a11_R1*t(i));
   H1_R1(i)=H1_bar_R1+dH1;
   dH2=f_R1+g_R1*exp(a11_R1*t(i))+h_R1*exp(a22_R1*t(i));
   H2_R1(i)=H2_bar_R1+dH2;    
   
   if H1_R1(i)>0.25*H1ss
      i_R1_end=i; 
      H1_R1_end=H1_R1(i); 
      H2_R1_end=H2_R1(i); 
      break % out of for i loop
   end % if   
     
end % i

% begin set Region II (4 < H1 < 8) parameters 
R=2;
H1_bar_R2=6;  
F1_bar_R2=c1*sqrt(H1_bar_R2);
F0_bar_R2=F1_bar_R2; 
F2_bar_R2=F1_bar_R2;
H2_bar_R2=(F2_bar_R2/c2)^2;       
a11_R2=-c1/(2*A1*sqrt(H1_bar_R2)); 
a21_R2=c1/(2*A2*sqrt(H1_bar_R2)); 
a22_R2=-c2/(2*A2*sqrt(H2_bar_R2));  
dF0_R2=F0-F0_bar_R2;
H1_init_R2=H1_R1_end; 
H2_init_R2=H2_R1_end; 
dH1_init_R2=H1_init_R2-H1_bar_R2; 
dH2_init_R2=H2_init_R2-H2_bar_R2; 
d_R2=b1*dF0_R2/a11_R2;
e_R2=dH1_init_R2+d_R2;
f_R2=(a21_R2*d_R2/a22_R2);
g_R2=(a21_R2*dH1_init_R2+a21_R2*d_R2)/(a11_R2-a22_R2);
h_R2=dH2_init_R2 + a21_R2*(dH1_init_R2+b1*dF0_R2/a22_R2)/(a22_R2-a11_R2); 
i_R2_start=i_R1_end+1;

j=1;
for i=i_R2_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R2_start*del_t; 
    dH1=-d_R2+e_R2*exp(a11_R2*t0);
    H1_R2(j)=H1_bar_R2+dH1; 
    dH2=f_R2+g_R2*exp(a11_R2*t0)+h_R2*exp(a22_R2*t0);
    H2_R2(j)=H2_bar_R2+dH2;     
   
   if H1_R2(j)>0.5*H1ss 
      i_R2_end=i; 
      H1_R2_end=H1_R2(j); 
      H2_R2_end=H2_R2(j); 
      break % out of for i loop
   end % if
   
   j=j+1;
end % i     

% begin set Region III (8 < H1 < 12) parameters 
R=3;
H1_bar_R3=10;  
F1_bar_R3=c1*sqrt(H1_bar_R3);
F0_bar_R3=F1_bar_R3; 
F2_bar_R3=F1_bar_R3;
H2_bar_R3=(F2_bar_R3/c2)^2;       
a11_R3=-c1/(2*A1*sqrt(H1_bar_R3)); 
a21_R3=c1/(2*A2*sqrt(H1_bar_R3)); 
a22_R3=-c2/(2*A2*sqrt(H2_bar_R3));  
dF0_R3=F0-F0_bar_R3;
H1_init_R3=H1_R2_end; 
H2_init_R3=H2_R2_end; 
dH1_init_R3=H1_init_R3-H1_bar_R3; 
dH2_init_R3=H2_init_R3-H2_bar_R3; 
d_R3=b1*dF0_R3/a11_R3;
e_R3=dH1_init_R3+d_R3;
f_R3=(a21_R3*d_R3/a22_R3);
g_R3=(a21_R3*dH1_init_R3+a21_R3*d_R3)/(a11_R3-a22_R3);
h_R3=dH2_init_R3 + a21_R3*(dH1_init_R3+b1*dF0_R3/a22_R3)/(a22_R3-a11_R3); 
i_R3_start=i_R2_end+1;

j=1;
for i=i_R3_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R3_start*del_t; 
    dH1=-d_R3+e_R3*exp(a11_R3*t0);
    H1_R3(j)=H1_bar_R3+dH1; 
    dH2=f_R3+g_R3*exp(a11_R3*t0)+h_R3*exp(a22_R3*t0);
    H2_R3(j)=H2_bar_R3+dH2;     
   
   if H1_R3(j)>0.75*H1ss 
      i_R3_end=i; 
      H1_R3_end=H1_R3(j); 
      H2_R3_end=H2_R3(j); 
      break % out of for i loop
   end % if
   
   j=j+1;
end % i  

% begin set Region IV (12 < H1 < 16) parameters 
R=4;
H1_bar_R4=14;  
F1_bar_R4=c1*sqrt(H1_bar_R4);
F0_bar_R4=F1_bar_R4; 
F2_bar_R4=F1_bar_R4;
H2_bar_R4=(F2_bar_R4/c2)^2;       
a11_R4=-c1/(2*A1*sqrt(H1_bar_R4)); 
a21_R4=c1/(2*A2*sqrt(H1_bar_R4)); 
a22_R4=-c2/(2*A2*sqrt(H2_bar_R4));  
dF0_R4=F0-F0_bar_R4;
H1_init_R4=H1_R3_end; 
H2_init_R4=H2_R3_end; 
dH1_init_R4=H1_init_R4-H1_bar_R4; 
dH2_init_R4=H2_init_R4-H2_bar_R4; 
d_R4=b1*dF0_R4/a11_R4;
e_R4=dH1_init_R4+d_R4;
f_R4=(a21_R4*d_R4/a22_R4);
g_R4=(a21_R4*dH1_init_R4+a21_R4*d_R4)/(a11_R4-a22_R4);
h_R4=dH2_init_R4 + a21_R4*(dH1_init_R4+b1*dF0_R4/a22_R4)/(a22_R4-a11_R4); 
i_R4_start=i_R3_end+1;

j=1;
for i=i_R4_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R4_start*del_t; 
    dH1=-d_R4+e_R4*exp(a11_R4*t0);
    H1_R4(j)=H1_bar_R4+dH1; 
    dH2=f_R4+g_R4*exp(a11_R4*t0)+h_R4*exp(a22_R4*t0);
    H2_R4(j)=H2_bar_R4+dH2;  
    j=j+1;
end % i  

figure(3) % plot Figure 7.71
H1=[H1_R1 H1_R2 H1_R3 H1_R4]; 
plot(t,H1,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:350])
set(gca,'YTick',[0:2:16])
hold on
plot(tt,H1_sim,'r','LineWidth',1.3)
axis([0 tfinal 0 17])
plot([0 tfinal],[0.25*H1ss 0.25*H1ss],'--k','LineWidth',1.2)
plot([0 tfinal],[0.5*H1ss 0.5*H1ss],'--k','LineWidth',1.2)
plot([0 tfinal],[0.75*H1ss 0.75*H1ss],'--k','LineWidth',1.2)
plot([0 tfinal],[H1ss H1ss],'--k','LineWidth',1.2)
text(180,1.5,'Region I','FontSize',13)
text(180,5.5,'Region II','FontSize',13)
text(180,9.5,'Region III','FontSize',13)
text(180,13.5,'Region IV','FontSize',13)
xlabel('t  (min)','FontSize',13)
ylabel('H_1(t),   (ft)','FontSize',12)
title('Tank 1 Level Linearized and Nonlinear System Responses','FontSize',12)
text(275,15,'linearized','FontSize',13)
text(85,15.2,'nonlinear','FontSize',13)
text(-59,15.85,'(H_1)_{ss}=','FontSize',12)
% 
figure(4) % plot Figure 7.72
H2=[H2_R1 H2_R2 H2_R3 H2_R4];
plot(t,H2,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:350])
set(gca,'YTick',[0:9])
hold on
plot(tt,H2_sim,'r','LineWidth',1.3)

plot([0 tfinal],[0.25*H2ss 0.25*H2ss],'--k','LineWidth',1.2)
plot([0 tfinal],[0.5*H2ss 0.5*H2ss],'--k','LineWidth',1.2)
plot([0 tfinal],[0.75*H2ss 0.75*H2ss],'--k','LineWidth',1.2)
plot([0 tfinal],[H2ss H2ss],'--k','LineWidth',1.2)
text(220,1.3,'Region I','FontSize',13)
text(220,3.5,'Region II','FontSize',13)
text(220,5.7,'Region III','FontSize',13)
text(220,7.8,'Region IV','FontSize',13)

axis([0 tfinal 0 9.5])
xlabel('t  (min)','FontSize',13)
ylabel('H_2(t),   (ft)','FontSize',12)
plot([0 tfinal],[H2ss H2ss],'--k','LineWidth',1.2)
title('Tank 2 Level Linearized and Nonlinear System Responses','FontSize',12)
text(275,14.6,'linearized','FontSize',13)
text(95,15.15,'nonlinear','FontSize',13)
text(-50,15.85,'(\itH_{\rm1})_{\rmss}=','FontSize',12) 
text(-59,8.9,'(H_2)_{ss}=','FontSize',13)
text(80,4.2,'linearized','FontSize',12)
plot([48 70],[4.15 4.15],'b','LineWidth',1.2)
text(25,7.2,'nonlinear','FontSize',12) 
plot([85 110],[7.15 7.15],'r','LineWidth',1.2)

figure(5) 
x=linspace(0,H1ss,500);
y=c1*sqrt(x);

subplot(1,2,1) % plot Figure 7.73a
plot(x,y,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:4:16])
set(gca,'YTick',[0:2:12])
hold on
axis([0 H1ss 0 c1*sqrt(H1ss)])
xlabel('H_1  (ft)','FontSize',13)
ylabel('F_1   (ft^3/min)','FontSize',13)
plot([H1_bar_R1],[c1*sqrt(H1_bar_R1)],'.r','MarkerSize',14)
plot([H1_bar_R2],[c1*sqrt(H1_bar_R2)],'.r','MarkerSize',14)
plot([H1_bar_R3],[c1*sqrt(H1_bar_R3)],'.r','MarkerSize',14)
plot([H1_bar_R4],[c1*sqrt(H1_bar_R4)],'.r','MarkerSize',14)
text(4.0,4.3,'F_1 = c_1H_1^{1/2}','FontSize',13)
text(-1,12.70,'Tank 1 and Tank 2 Nonlinear System Operating Characteristic','FontSize',12)
plot(5.0,2.3,'.r','MarkerSize',14)
text(6.0,2.3,'(H_1, F_1)','FontSize',13)
text(6.62,3.10,'_','FontSize',13)
text(9.20,3.10,'_','FontSize',13)
x=linspace(0,H2ss,500);
y=c2*sqrt(x);

subplot(1,2,2) % plot Figure 7.73b
plot(x,y,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:8])
set(gca,'YTick',[0:2:12])
hold on
axis([0 H2ss 0 c2*sqrt(H2ss)])
xlabel('H_2  (ft)','FontSize',13)
ylabel('F_2   (ft^3/min)','FontSize',13)
plot([H2_bar_R1],[c2*sqrt(H2_bar_R1)],'.r','MarkerSize',14)
plot([H2_bar_R2],[c2*sqrt(H2_bar_R2)],'.r','MarkerSize',14)
plot([H2_bar_R3],[c2*sqrt(H2_bar_R3)],'.r','MarkerSize',14)
plot([H2_bar_R4],[c2*sqrt(H2_bar_R4)],'.r','MarkerSize',14)
text(2,4.25,'F_2 = c_2H_2^{1/2}','FontSize',13)
plot(3.3,2.3,'.r','MarkerSize',14)
text(4.0,2.20,'(H_2, F_2)','FontSize',13)
text(4.42,3.02,'_','FontSize',13)
text(5.85,3.02,'_','FontSize',13)

figure(7) % plot Figure 7.74
plot(H1,H2,'b','LineWidth',1.3)
grid on
axis([-2 H1ss+2 -2 H2ss+2])
set(gca,'FontSize',11)
set(gca,'XTick',[0:2:16])
set(gca,'YTick',[0:2:10])
hold on
plot(H1_sim,H2_sim,'r','LineWidth',1.3)
ylabel('H_2   (ft)','FontSize',13)
xlabel('H_1   (ft)','FontSize',13)
plot([H1_bar_R1],[H2_bar_R1],'.r','MarkerSize',14)
plot([H1_bar_R2],[H2_bar_R2],'.r','MarkerSize',14)
plot([H1_bar_R3],[H2_bar_R3],'.r','MarkerSize',14)
plot([H1_bar_R4],[H2_bar_R4],'.r','MarkerSize',14)
plot([0 0],[0 H2ss],'k--','LineWidth',1.2)
plot([H1_R2_end H1_R2_end],[0 H2ss],'k--','LineWidth',1.2)
plot([H1_R3_end H1_R3_end],[0 H2ss],'k--','LineWidth',1.2)
plot([H1ss H1ss],[0 H2ss],'k--','LineWidth',1.2)
text(-1,11.5,'State Trajectories of Linearized and Nonlinear Systems','FontSize',12)
plot(1.5,9,'.r','MarkerSize',14)
text(2,9,'(H_1, H_2)','FontSize',13)
text(2.35,9.85,'_','FontSize',13)
text(3.69,9.85,'_','FontSize',13)
plot(H1_init_R1,H2_init_R1,'sk','MarkerSize',6,'MarkerFaceColor','k')
plot(H1ss,H2ss,'sk','MarkerSize',6,'MarkerFaceColor','k')
text(-1,-1,'H_1(0), H_2(0)','FontSize',13)
text(13,9.7,'(H_1)_{ss}, (H_2)_{ss}','FontSize',13)
text(8.25,1.9,'linear','FontSize',13)
plot([5.7 7.6],[1.9 1.9],'b')
text(1.2,2.53,'nonlinear','FontSize',13)
plot([4.75 6.60],[2.45 2.45],'r','MarkerSize',14)
