% m-file Ch7_Ex7_1.m
% calls Simulink models fishery_1.mdl and fishery_2.mdl
% plots Figure 7.10 and Figure 7.11

clc, close all, clear all

k=4;
r=2;
eps=0.1; 

%%%%% Case A: 1 xe pt (3.4740)
uR_bar=0.3; % input #1
uE_bar=10; % input #2

a3=1;
a2=-k;
a1=(eps*k*uE_bar)/r;
a0=-k*uR_bar/r;
rr=roots([a3 a2 a1 a0])

% A.1 Given uR_bar and uE_bar, find xe
x0=10; % initial guess
u0=[uR_bar;uE_bar];
y0=0;
ix=[];
iu=[1,2];
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy) 
  
% A.2 Given uR_bar and xe, find uE_bar
x0=rr(1) % sets x0=3.4740
u0=[uR_bar;0];
y0=0;
ix=1;
iu=1;
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy)
 
% A.3 Given uE_bar and xe, find uR_bar
x0=rr(1) % sets x0=3.4740
u0=[0;uE_bar];
y0=0;
ix=1;
iu=2;
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy)

%%%%% Case B: 3 xe pts (0.1814, 1.3278, 2.4908)
uR_bar=0.3; % input #1
uE_bar=20; % input #2
a1=(eps*k*uE_bar)/r;
rr=roots([a3 a2 a1 a0])

% B.1 Given uR_bar and uE_bar, find xe at 0.1814
x0=0;
u0=[uR_bar;uE_bar];
y0=0;
ix=[];
iu=[1,2];
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy)

opts=simset('InitialState',x0);
tfinal=5;
sim('fishery_2')

figure(1) % plot Figure 7.10
subplot(3,1,1)
t=tout; x=xout;
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
ylabel('x  (tons/sq mile)','FontSize',12)
title('x \rm vs \itt','FontSize',13)
text(2.5,0.08,'(x_e)_1 = 0.1814 (stable)','FontSize',13)

% B.2 Given uR_bar and uE_bar, Find xe at 1.3278
x0=2;
u0=[uR_bar;uE_bar];
y0=0;
ix=[];
iu=[1,2];
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy)
opts=simset('InitialState',x0);
tfinal=10;
sim('fishery_2')

subplot(3,1,2)
t=tout; x=xout;
plot(t,x,'b','LineWidth',1.3)
hold on
grid on
axis([0 10 0 3])
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
set(gca,'YTick',[0:3])
ylabel('x  (tons/sq mile)','FontSize',13)
x0=1;
sim('fishery_2')
t=tout; x=xout;
plot(t,x,'r','LineWidth',1.3)
x0=1.3;
sim('fishery_2')
t=tout; x=xout;
plot(t,x,'m','LineWidth',1.3)
x0=1.35;
sim('fishery_2')
t=tout; x=xout;
plot(t,x,'k','LineWidth',1.3)
ylabel('x  (tons/sq mile)','FontSize',12)
text(5.35,1.4,'(x_e)_2 = 1.3278 (unstable)','FontSize',13)
 
% B.3  Given uR_bar and uE_bar, find xe at 2.4908
x0=5;
u0=[uR_bar;uE_bar];
y0=0;
ix=[];
iu=[1,2];
iy=[];
[x,u,y,dx]=trim('fishery_1',x0,u0,y0,ix,iu,iy)
opts=simset('InitialState',x0);
tfinal=5;
sim('fishery_2')

subplot(3,1,3)
t=tout; x=xout;
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:5])
set(gca,'YTick',[2:6])
xlabel('t  (yr)','FontSize',12)
ylabel('x  (tons/sq mile)','FontSize',12)
text(2.5,4.3,'(x_e)_3 = 2.4908 (stable)','FontSize',13)

%%%% Part g)
k=4; r=2; eps=0.1;
uR=0.3; uE=20;
a3=-r/k; a2=r; a1=-eps*uE; a0=uR;
rts=roots([a3 a2 a1 a0]);
r1=rts(1); r2=rts(2); r3=rts(3);
x=linspace(0.01,3.5,500);
g_x=(uR./x)+r*x.*(1-x/k)-eps*uE;

figure(2) % plot Figure 7.10
plot(x,g_x,'b','LineWidth',1.3)
axis([0 3.5 -1 3])
hold on
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.5:3.5])
set(gca,'YTick',[-1:0.5:3])
plot([0 3.5],[0 0],'k')
plot(r1,0,'r.','MarkerSize',20)
plot(r2,0,'m.','MarkerSize',20)
plot(r3,0,'k.','MarkerSize',20)
text(0.2,0.2,'(x_e)_1 = 0.1814','FontSize',13)
text(1.3,-0.2,'(x_e)_2 = 1.3278','FontSize',13)
text(2.55,0.2,'(x_e)_3 = 2.4908','FontSize',13)
text(1.5,2.6,'(x_e)_1 - stable','FontSize',13)
text(1.5,2.1,'(x_e)_2 - unstable','FontSize',13)
text(1.5,1.6,'(x_e)_3 - stable','FontSize',13)
xlabel('x,  tons per sq mile','FontSize',13)
ylabel('g(x),  yr^{-1}','FontSize',13)
title('Growth Rate of Fish vs Fish Density','FontSize',11)



