% m-file Ch7_Ex7_3.m
% calls Simulink model Lin2Tanks.mdl
% plots Figures  *** - ***


clc, close all, clear all

A1=25; A2 =15;
c1=3; c2=4;
F0=12; % Input flow to first tank
H1ss=(F0/c1)^2; 
H2ss=(F0/c2)^2; 
H1_bar=0.5*H1ss; 
F1_bar=c1*sqrt(H1_bar);
F0_bar=F1_bar;
F2_bar=F1_bar;
H2_bar=(F2_bar/c2)^2;
H1_init=0;
H2_init=0;
% H1_init=H1_bar;
% H2_init=H2_bar;

a11=-c1/(2*A1*sqrt(H1_bar)); 
a12=0;
a21=c1/(2*A2*sqrt(H1_bar)); 
a22=-c2/(2*A2*sqrt(H2_bar)); 
b1=1/A1; 
b2=0;
dF0=F0-F0_bar;
dH1_init=H1_init-H1_bar;
dH2_init=H2_init-H2_bar;
d=b1*dF0/a11;
e=dH1_init+d;
f=(a21*d/a22);
g=(a21*dH1_init+a21*d)/(a11-a22);
h=dH2_init + a21*(dH1_init+b1*dF0/a22)/(a22-a11); 
tau1=-1/a11;
tau2=-1/a22;
Tfinal=350;  % stop time in Simulink model
t=linspace(0,Tfinal,1000);
dH1=-d+e*exp(a11*t);
H1=H1_bar+dH1;
dH2=f+g*exp(a11*t)+h*exp(a22*t);
H2=H2_bar+dH2;
H1(end), H2(end)

sim('Lin2Tanks')
tt=H1_sim(:,1);
H1_sim=H1_sim(:,2);
H2_sim=H2_sim(:,2);
figure(1)

subplot(2,1,1)
plot(t,H1,'r')
hold on
plot(tt,H1_sim,'b')
axis([0 Tfinal 0 18])
text(75,15.5,'nonlinear','FontSize',11)
text(225,12.7,'linear','FontSize',11)
ylabel('\itH_{\rm1}\rm(\itt\rm),   ft','FontSize',11)
title('Tank 1 Level Response','FontSize',11)

subplot(2,1,2)
plot(t,H2,'r')
hold on
plot(tt,H2_sim,'b')
axis([0 Tfinal 0 10])
text(75,8.3,'nonlinear','FontSize',11)
text(225,7,'linear','FontSize',11)
xlabel('\itt  \rm(min)','FontSize',11)
ylabel('\itH_{\rm2}\rm(\itt\rm),   ft','FontSize',11)
title('Tank 2 Level Response','FontSize',11)

figure(2)
plot(H1,H2,'r')
hold on
plot(H1_sim,H2_sim,'b')
axis([0 1.1*H1ss 0 1.15*H2ss])
xlabel('\itH_{\rm1}  \rm(ft)','FontSize',11)
ylabel('\itH_{\rm2}  \rm(ft)','FontSize',11)
plot([H1_bar],[H2_bar],'.k','MarkerSize',12)
text(5.5,4.5,'(\itH_{\rm1},\itH_{\rm2}\rm)','FontSize',11)
text(5.85,5.08,'_')
text(6.7,5.08,'_')
text(6.5,1.5,'linear','FontSize',11)
text(1.25,1.5,'nonlinear','FontSize',11)
plot([H1ss H1ss],[0 H2ss],'b:')
plot([0 H1ss],[H2ss H2ss],'b:')
text(4,9.5,'(\itH_{\rm2}\rm)_{\rmss} = 9 ft','FontSize',11)
text(12.0,3,'(\itH_{\rm1}\rm)_{\rmss} = 16 ft','FontSize',11)
text(7.35,11.5,'_')
text(9.87,11.5,'_')
title('State Trajectories of Linearized (\itH_{\rm1}\rm = 8 ft, \itH_{\rm2}\rm = 4.5 ft) and Nonlinear Systems','FontSize',11)


%%%%% begin multiple linearization
clear t

H1_init_R1=0; H2_init_R1=0;
% begin set Region I (0 < H1 <4 ) parameters
R=1;
H1_bar_R1=2;  
F1_bar_R1=c1*sqrt(H1_bar_R1);
F0_bar_R1=F1_bar_R1; 
F2_bar_R1=F1_bar_R1;
H2_bar_R1=(F2_bar_R1/c2)^2;  
a11_R1=-c1/(2*A1*sqrt(H1_bar_R1)); 
a12=0;
a21_R1=c1/(2*A2*sqrt(H1_bar_R1)); 
a22_R1=-c2/(2*A2*sqrt(H2_bar_R1)); 
b1=1/A1; 
b2=0;
dF0_R1=F0-F0_bar_R1;
dH1_init_R1=H1_init_R1-H1_bar_R1;
dH2_init_R1=H2_init_R1-H2_bar_R1;
d_R1=b1*dF0_R1/a11_R1;
e_R1=dH1_init_R1+d_R1;
f_R1=(a21_R1*d_R1/a22_R1);
g_R1=(a21_R1*dH1_init_R1+a21_R1*d_R1)/(a11_R1-a22_R1);
h_R1=dH2_init_R1 + a21_R1*(dH1_init_R1+b1*dF0_R1/a22_R1)/(a22_R1-a11_R1);  

tfinal=350;
del_t=0.1;
ifinal=round(tfinal/del_t);

for i=1:ifinal
   t(i)=(i-1)*del_t;   
   dH1=-d_R1+e_R1*exp(a11_R1*t(i));
   H1_R1(i)=H1_bar_R1+dH1;
   dH2=f_R1+g_R1*exp(a11_R1*t(i))+h_R1*exp(a22_R1*t(i));
   H2_R1(i)=H2_bar_R1+dH2;    
   
   if H1_R1(i)>0.25*H1ss
      i_R1_end=i; 
      H1_R1_end=H1_R1(i); 
      H2_R1_end=H2_R1(i); 
      break % out of for i loop
   end % if   
     
end % i

% begin set Region II (4 < H1 < 8) parameters 
R=2;
H1_bar_R2=6;  
F1_bar_R2=c1*sqrt(H1_bar_R2);
F0_bar_R2=F1_bar_R2; 
F2_bar_R2=F1_bar_R2;
H2_bar_R2=(F2_bar_R2/c2)^2;       
a11_R2=-c1/(2*A1*sqrt(H1_bar_R2)); 
a21_R2=c1/(2*A2*sqrt(H1_bar_R2)); 
a22_R2=-c2/(2*A2*sqrt(H2_bar_R2));  
dF0_R2=F0-F0_bar_R2;
H1_init_R2=H1_R1_end; 
H2_init_R2=H2_R1_end; 
dH1_init_R2=H1_init_R2-H1_bar_R2; 
dH2_init_R2=H2_init_R2-H2_bar_R2; 
d_R2=b1*dF0_R2/a11_R2;
e_R2=dH1_init_R2+d_R2;
f_R2=(a21_R2*d_R2/a22_R2);
g_R2=(a21_R2*dH1_init_R2+a21_R2*d_R2)/(a11_R2-a22_R2);
h_R2=dH2_init_R2 + a21_R2*(dH1_init_R2+b1*dF0_R2/a22_R2)/(a22_R2-a11_R2); 
i_R2_start=i_R1_end+1;

j=1;
for i=i_R2_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R2_start*del_t; 
    dH1=-d_R2+e_R2*exp(a11_R2*t0);
    H1_R2(j)=H1_bar_R2+dH1; 
    dH2=f_R2+g_R2*exp(a11_R2*t0)+h_R2*exp(a22_R2*t0);
    H2_R2(j)=H2_bar_R2+dH2;     
   
   if H1_R2(j)>0.5*H1ss 
      i_R2_end=i; 
      H1_R2_end=H1_R2(j); 
      H2_R2_end=H2_R2(j); 
      break % out of for i loop
   end % if
   
   j=j+1;
end % i     

% begin set Region III (8 < H1 < 12) parameters 
R=3;
H1_bar_R3=10;  
F1_bar_R3=c1*sqrt(H1_bar_R3);
F0_bar_R3=F1_bar_R3; 
F2_bar_R3=F1_bar_R3;
H2_bar_R3=(F2_bar_R3/c2)^2;       
a11_R3=-c1/(2*A1*sqrt(H1_bar_R3)); 
a21_R3=c1/(2*A2*sqrt(H1_bar_R3)); 
a22_R3=-c2/(2*A2*sqrt(H2_bar_R3));  
dF0_R3=F0-F0_bar_R3;
H1_init_R3=H1_R2_end; 
H2_init_R3=H2_R2_end; 
dH1_init_R3=H1_init_R3-H1_bar_R3; 
dH2_init_R3=H2_init_R3-H2_bar_R3; 
d_R3=b1*dF0_R3/a11_R3;
e_R3=dH1_init_R3+d_R3;
f_R3=(a21_R3*d_R3/a22_R3);
g_R3=(a21_R3*dH1_init_R3+a21_R3*d_R3)/(a11_R3-a22_R3);
h_R3=dH2_init_R3 + a21_R3*(dH1_init_R3+b1*dF0_R3/a22_R3)/(a22_R3-a11_R3); 
i_R3_start=i_R2_end+1;

j=1;
for i=i_R3_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R3_start*del_t; 
    dH1=-d_R3+e_R3*exp(a11_R3*t0);
    H1_R3(j)=H1_bar_R3+dH1; 
    dH2=f_R3+g_R3*exp(a11_R3*t0)+h_R3*exp(a22_R3*t0);
    H2_R3(j)=H2_bar_R3+dH2;     
   
   if H1_R3(j)>0.75*H1ss 
      i_R3_end=i; 
      H1_R3_end=H1_R3(j); 
      H2_R3_end=H2_R3(j); 
      break % out of for i loop
   end % if
   
   j=j+1;
end % i  

% begin set Region IV (12 < H1 < 16) parameters 
R=4;
H1_bar_R4=14;  
F1_bar_R4=c1*sqrt(H1_bar_R4);
F0_bar_R4=F1_bar_R4; 
F2_bar_R4=F1_bar_R4;
H2_bar_R4=(F2_bar_R4/c2)^2;       
a11_R4=-c1/(2*A1*sqrt(H1_bar_R4)); 
a21_R4=c1/(2*A2*sqrt(H1_bar_R4)); 
a22_R4=-c2/(2*A2*sqrt(H2_bar_R4));  
dF0_R4=F0-F0_bar_R4;
H1_init_R4=H1_R3_end; 
H2_init_R4=H2_R3_end; 
dH1_init_R4=H1_init_R4-H1_bar_R4; 
dH2_init_R4=H2_init_R4-H2_bar_R4; 
d_R4=b1*dF0_R4/a11_R4;
e_R4=dH1_init_R4+d_R4;
f_R4=(a21_R4*d_R4/a22_R4);
g_R4=(a21_R4*dH1_init_R4+a21_R4*d_R4)/(a11_R4-a22_R4);
h_R4=dH2_init_R4 + a21_R4*(dH1_init_R4+b1*dF0_R4/a22_R4)/(a22_R4-a11_R4); 
i_R4_start=i_R3_end+1;

j=1;
for i=i_R4_start:ifinal
    t(i)=(i-1)*del_t;  
    t0=t(i)-i_R4_start*del_t; 
    dH1=-d_R4+e_R4*exp(a11_R4*t0);
    H1_R4(j)=H1_bar_R4+dH1; 
    dH2=f_R4+g_R4*exp(a11_R4*t0)+h_R4*exp(a22_R4*t0);
    H2_R4(j)=H2_bar_R4+dH2;  
    j=j+1;
end % i  

figure(3)
H1=[H1_R1 H1_R2 H1_R3 H1_R4]; 
plot(t,H1,'r')
hold on
plot(tt,H1_sim,'b')
axis([0 tfinal 0 17])
plot([0 tfinal],[0.25*H1ss 0.25*H1ss],':k')
plot([0 tfinal],[0.5*H1ss 0.5*H1ss],':k')
plot([0 tfinal],[0.75*H1ss 0.75*H1ss],':k')
plot([0 tfinal],[H1ss H1ss],':k')
text(180,1.5,'Region I','FontSize',12)
text(180,5.5,'Region II','FontSize',12)
text(180,9.5,'Region III','FontSize',12)
text(180,13.5,'Region IV','FontSize',12)
xlabel('\itt  \rm(min)','FontSize',12)
ylabel('\itH_{\rm1}\rm(\itt\rm),  ft','FontSize',12)
title('Tank 1 Level Linearized and Nonlinear System Responses','FontSize',12)
text(275,15,'linearized','FontSize',12)
text(95,15.2,'nonlinear','FontSize',12)
text(-56,15.85,'(\itH_{\rm1}\rm)_{\rmss}=','FontSize',12)

figure(4)
H2=[H2_R1 H2_R2 H2_R3 H2_R4];
plot(t,H2,'r')
hold on
plot(tt,H2_sim,'b')
axis([0 tfinal 0 9.5])
xlabel('\itt \rm(min)','FontSize',12)
ylabel('\itH_{\rm2}\rm(\itt\rm),  ft','FontSize',12)
% plot([0 tfinal],[H2_R1_end H2_R1_end],':k')
% plot([0 tfinal],[H2_R2_end H2_R2_end],':k')
% plot([0 tfinal],[H2_R3_end H2_R3_end],':k')
plot([0 tfinal],[H2ss H2ss],':k')
% text(180,0.65,'Region I','FontSize',11)
% text(180,2.2,'Region II','FontSize',11)
% text(180,4.6,'Region III','FontSize',11)
% text(180,7.0,'Region IV','FontSize',11)
xlabel('\itt  \rm(min)','FontSize',12)
ylabel('\itH_{\rm2}\rm(\itt\rm),  ft','FontSize',12)
title('Tank 2 Level Linearized and Nonlinear System Responses','FontSize',12)
text(275,14.6,'linearized','FontSize',12)
text(95,15.15,'nonlinear','FontSize',12)
text(-50,15.85,'(\itH_{\rm1})_{\rmss}=','FontSize',12) 
text(-52,8.9,'(\itH_{\rm2}\rm)_{\rmss}=','FontSize',12)
text(65,4.5,'linearized','FontSize',12)
text(45,7.0,'nonlinear','FontSize',12) 

figure(5)
x=linspace(0,H1ss,500);
y=c1*sqrt(x);
plot(x,y)
hold on
axis([0 H1ss 0 c1*sqrt(H1ss)])
xlabel('\itH_{\rm1}  \rm(ft)','FontSize',14)
ylabel('\itF_{\rm1}   \rm(ft^{3}/min)','FontSize',14)
plot([H1_bar_R1],[c1*sqrt(H1_bar_R1)],'.r','MarkerSize',14)
plot([H1_bar_R2],[c1*sqrt(H1_bar_R2)],'.r','MarkerSize',14)
plot([H1_bar_R3],[c1*sqrt(H1_bar_R3)],'.r','MarkerSize',14)
plot([H1_bar_R4],[c1*sqrt(H1_bar_R4)],'.r','MarkerSize',14)
text(7.5,6,'\itF_{\rm1} \rm= \itc_{\rm1}\itH_{\rm1}^{\rm 1/2}','FontSize',14)
title('Tank 1 Nonlinear System Operating Characteristic','FontSize',14)
plot([4],[1.5],'.r','MarkerSize',14)
text(4.5,1.5,'(\itH_{\rm1}, \itF_{\rm1}\rm)','FontSize',14)
text(4.85,2.3,'_','FontSize',14)
text(6.00,2.3,'_','FontSize',14)

figure(6)
x=linspace(0,H2ss,500);
y=c2*sqrt(x);
plot(x,y)
hold on
axis([0 H2ss 0 c2*sqrt(H2ss)])
xlabel('\itH_{\rm2}  \rm(ft)','FontSize',14)
ylabel('\itF_{\rm2}   \rm(ft^{3}/min)','FontSize',14)
plot([H2_bar_R1],[c2*sqrt(H2_bar_R1)],'.r','MarkerSize',14)
plot([H2_bar_R2],[c2*sqrt(H2_bar_R2)],'.r','MarkerSize',14)
plot([H2_bar_R3],[c2*sqrt(H2_bar_R3)],'.r','MarkerSize',14)
plot([H2_bar_R4],[c2*sqrt(H2_bar_R4)],'.r','MarkerSize',14)
title('Tank 2 Nonlinear System Operating Characteristic','FontSize',14)
text(4,5.5,'\itF_{\rm2} \rm= \itc_{\rm2}\itH_{\rm2}^{\rm 1/2}','FontSize',14)
plot([2.25],[1.5],'.r','MarkerSize',14)
text(2.5,1.5,'(\itH_{\rm2}\rm, \itF_{\rm2}\rm)','FontSize',14)
text(2.68,2.35,'_','FontSize',14)
text(3.32,2.35,'_','FontSize',14)

figure(7)
plot(H1,H2,'r')
hold on
plot(H1_sim,H2_sim,'b')
ylabel('\itH_{\rm2}   \rm(ft)','FontSize',14)
xlabel('\itH_{\rm1}  \rm(ft)','FontSize',14)
axis([-2 H1ss+2 -2 H2ss+2])
plot([H1_bar_R1],[H2_bar_R1],'.r','MarkerSize',14)
plot([H1_bar_R2],[H2_bar_R2],'.r','MarkerSize',14)
plot([H1_bar_R3],[H2_bar_R3],'.r','MarkerSize',14)
plot([H1_bar_R4],[H2_bar_R4],'.r','MarkerSize',14)
plot([0 0],[0 H2ss],':')
plot([H1_R1_end H1_R1_end],[0 H2ss],':')
plot([H1_R2_end H1_R2_end],[0 H2ss],':')
plot([H1_R3_end H1_R3_end],[0 H2ss],':')
plot([H1ss H1ss],[0 H2ss],':')
title('State Trajectories of Linearized and Nonlinear Systems','FontSize',14)
plot([9.5],[-1],'.r','MarkerSize',14)
text(10.0,-1,'(\itH_{\rm1}, \itH_{\rm2}\rm)','FontSize',14)
text(10.43,-0.10,'_','FontSize',14)
text(11.83,-0.10,'_','FontSize',14)
plot([H1_init_R1],[H2_init_R1],'sk','MarkerSize',4,'MarkerFaceColor','k')
plot([H1ss],[H2ss],'sk','MarkerSize',4,'MarkerFaceColor','k')
text(-1,-1,'\itH_{\rm1}\rm(0), \itH_{\rm2}\rm(0)','FontSize',14)
text(13,9.7,'(\itH_{\rm1}\rm)_{\rmss}\rm, (\itH_{\rm2}\rm)_{\rmss}','FontSize',14)
text(7.1,1.9,'linear','FontSize',14)
plot([5.7 6.8],[1.9 1.9],'r')
text(1.9,2.53,'nonlinear','FontSize',14)
plot([5.66 6.602],[2.5 2.5],'b')
