% m-file Ch7_13.m
% calls Simulink model fishery_4.mdl
% plots Figure 7.13

clc, close all, clear all

r=2; k=4; eps=0.1; alpha=0.75; cE=2; cR=1;
uR=0.3; p=6;
sim('fishery_4')
t=tout; x=xout(:,1); uE=xout(:,2);
subplot(2,1,1)
plot(t,x,'b','LineWidth',1.3)
axis([0 10 2.4 3.5])
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
set(gca,'YTick',[2.5:0.25:3.5])
ylabel('x  (tons per sq mile)','FontSize',13)
text(0.25,3.6,'Transient Response of System to Step Changes in u_R and p','FontSize',11)
text(3,3.05,'u_R =','FontSize',13)                             
text(4.1,3.15,'0.3,  t \leq 1','FontSize',12)
text(4.1,2.95,'1,     t  > 1','FontSize',12)
text(7,3.05,'p =','FontSize',13)
text(7.8,3.15,'6,  t \leq 1','FontSize',12)
text(7.8,2.95,'8,  t  > 1','FontSize',12)

subplot(2,1,2)
plot(t,uE,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:10])
set(gca,'YTick',[10:5:25])
ylabel('u_E   (effort per year)','FontSize',13)
xlabel('t  (years)','FontSize',13)
text(3,15.6,'u_R =','FontSize',13)                             
text(4.1,17.0,'0.3,  t \leq 1','FontSize',12)
text(4.1,14.2,'1,     t  > 1','FontSize',12)
text(7,15.6,'p =','FontSize',13)
text(8.1,17.0,'6,  t \leq 1','FontSize',12)
text(8.1,14.2,'8,  t  > 1','FontSize',12)









