% m-file Ch7_Fig7_24.m
% plots contours of f(x1,x2)=c1(x1-h)^2 + c2(x2-k)^2
% finds gradient at selected points and plots vector
% plots Figure 7.24

clc, close all, clear all

h=5; k=10;
c1=1; c2=4;

hold on
for F=[0.0001 0.1 0.25 0.5 1:5]
x1_min=h-sqrt(F/c1);
x1_max=h+sqrt(F/c1);
x1=linspace(x1_min,x1_max,750);
delx2=sqrt((F-c1*(x1-h).^2)./c2);
x2_lower=k-delx2;
x2_upper=k+delx2;
% plot(x1,x2_lower,'b',x1,x2_upper,'b')
plot(x1,x2_lower,'b','LineWidth',1.3)
axis([0.95*x1_min 1.02*x1_max min(x2_lower) max(x2_upper)])
axis equal
hold on
grid on
plot(x1,x2_upper,'b','LineWidth',1.3)
end % if
set(gca,'FontSize',11)
set(gca,'XTick',[3:0.5:7])
set(gca,'YTick',[8.5:0.5:11.5])
xlabel('x_1','FontSize',13)
ylabel('x_2','FontSize',13)


%%%%% find gradient at selected points
F=[5:-1:1 0.1];
x1=[h-sqrt(5/c1) 4 6 5.5 4.5 h];
x2=k-sqrt((F-c1*(x1-h).^2)./c2); 
x2(4)=k+sqrt((F(4)-c1*(x1(4)-h).^2)./c2);
x2(5)=k+sqrt((F(5)-c1*(x1(5)-h).^2)./c2);
x2(6)=k+sqrt((F(6)-c1*(x1(6)-h).^2)./c2);

plot(x1,x2,'.r','MarkerSize',13)
for i=1:6
 grad(i,1)=real(2*c1*(x1(i)-h));
 grad(i,2)=real(2*c2*(x2(i)-k));
 mag_grad(i)=norm([grad(i,1) grad(i,2)]);
 x1_low(i)=x1(i)+0.5*grad(i,1)/mag_grad(i);
 x2_low(i)=x2(i)+0.5*grad(i,2)/mag_grad(i);
 x1_high(i)=x1(i)-0.5*grad(i,1)/mag_grad(i);
 x2_high(i)=x2(i)-0.5*grad(i,2)/mag_grad(i);
end % for
for i=1:6
    plot([x1_low(i),x1_high(i)],[x2_low(i),x2_high(i)],'k--')
end
text(2.0,11.9,'Objective Function Contours and Negative Gradient Vectors in x_1 - x_2 Plane','FontSize',11)
text(3,11.2,'z = 5 contour','FontSize',13)
text(4.25,8.35,'z = 0 at x_1 = 5, x_2 = 10','FontSize',13)











