% m-file Ch7Fig7_51.m
% plots Figure 7.51

clc; clear all; close all

c=0.5; % tank constant
Hbar=9; % 0perating pt
F0bar=c*sqrt(Hbar);
slope=c/(2*sqrt(Hbar));
H=linspace(0,25,500);
F0=c*sqrt(H);
plot(H,F0,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:25])
set(gca,'YTick',[0:0.5:3])
hold on
xlabel('H  \rm(ft)','FontSize',13)
ylabel('F_0  (ft^3/min)','FontSize',13)

del_H=H-Hbar;
F0_lin=F0bar+slope*(del_H);
plot(H,F0_lin,'r','LineWidth',1.3)
plot([Hbar Hbar],[0 F0bar],'k--')
plot(Hbar,F0bar,'.k','MarkerSize',16)
axis([-1 25 0 3])
plot([0 20],[F0bar F0bar],'k','LineWidth',1.1)
plot([Hbar Hbar],[0.5 2.5],'k','LineWidth',1.1)
text(20.5,1.55,'\DeltaH','FontSize',13)
text(Hbar-0.5,2.6,'\DeltaF_0','FontSize',13)
text(10,1.05,'Operating Pt:','FontSize',13) 
text(10,0.7,'H = 9 ft, F_0 = 1.5 ft^3/min','FontSize',13)
text(1,0.25,'F_0 = 0.5 H^{1/2}','FontSize',13)
text(12.5,2.55,'\DeltaF_0 = (1/12) \DeltaH','FontSize',13)
text(10.115,0.88,'_','FontSize',13)
text(14,0.88,'_','FontSize',13)
text(1,3.15,'Nonlinear Tank Operating Curve and Linearized Model','FontSize',12)