% m-file Ch7_Tank_HT
% Run this file before executing the model Tank_HT.mdl
% plots Figure 7.56 - 7.58

clc; clear all; close all

A=100; % sq ft
cp=1; % Btu /lb-deg F
gamma=62.4; % lb/cu ft
Fbar=25; % cu ft/min
F1bar=Fbar;
F0bar=Fbar;
Hbar=9; % ft
Hinit=Hbar;
c=Fbar/sqrt(Hbar); % Tank constant
Tbar=150; % deg F
Tinit=Tbar;
T1bar=Tbar;
alpha=0.1; beta=0.1;
F0_prime=c/(2*sqrt(Hbar));
a11=-F0_prime/A;
a12=0;
a21=0;
a22=-Fbar/(A*Hbar);
b11=1/A;
b12=0;
b21=0;
b22=Fbar/(A*Hbar);

sim('Tank_HT')
t=H(:,1);
T=T(:,2);
H=H(:,2);

figure(1)
subplot(1,2,1)
plot(t,H,'b','LineWidth',1.3)
grid on
axis([0 300 8.8 11.0])
set(gca,'FontSize',11)
set(gca,'XTick',[0:60:300])
set(gca,'YTick',[8.8:0.2:11.0])
xlabel('t  (min)','FontSize',12)
ylabel('H(t),  (ft)','FontSize',12)
title('Tank Height vs. Time ')

subplot(1,2,2)
plot(t,T,'b','LineWidth',1.3)
grid on
axis([0 200 134 151])
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:200])
set(gca,'YTick',[130:2:150])
xlabel('t  (min)','FontSize',12)
ylabel('T(t),  (\circF)','FontSize',12)
title('Tank Temperature vs. Time')


H_Lin=H_Lin(:,2);
T_Lin=T_Lin(:,2);

figure(2)
subplot(2,1,1)
plot(t,H_Lin,'b','LineWidth',1.3)
grid on
axis([0 300 8.8 11.0])
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:300])
set(gca,'YTick',[8.8:0.4:11.0])
ylabel('H(t),  (ft)','FontSize',12)
title('Linearized Tank Height vs. Time ')

subplot(2,1,2)
plot(t,T_Lin,'b','LineWidth',1.3)
grid on
axis([0 200 134 151])
set(gca,'FontSize',11)
set(gca,'XTick',[0:25:200])
set(gca,'YTick',[130:4:150])
xlabel('t  (min)','FontSize',12)
ylabel('T(t),  (\circF)','FontSize',12)
title('Linearized Tank Temperature vs. Time')

figure(3)
subplot(2,2,1)
plot(t,H,'b','LineWidth',1.3)
grid on
axis([0 300 8.8 11.0])
set(gca,'FontSize',11)
set(gca,'XTick',[0:60:300])
set(gca,'YTick',[8.8:0.4:11.0])
ylabel('H(t),  (ft)','FontSize',12)
text(-60,11.2,'Nonlinear Tank Height vs. Time','FontSize',11)

subplot(2,2,3)
plot(t,H_Lin,'b','LineWidth',1.3)
grid on
axis([0 300 8.8 11.0])
set(gca,'FontSize',11)
set(gca,'XTick',[0:60:300])
set(gca,'YTick',[8.8:0.4:11.0])
ylabel('H(t),  (ft)','FontSize',12)
text(-60,11.2,'Linearized Tank Height vs. Time','FontSize',11)
xlabel('t  (min)','FontSize',12)

subplot(2,2,2)
plot(t,T_Lin,'b','LineWidth',1.3)
grid on
axis([0 200 134 151])
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:200])
set(gca,'YTick',[130:4:150])
ylabel('T(t),  (\circF)','FontSize',12)
text(-50,152.5,'Nonlinear Tank Temperature vs. Time','FontSize',11)

subplot(2,2,4)
plot(t,T_Lin,'b','LineWidth',1.3)
grid on
axis([0 200 134 151])
set(gca,'FontSize',11)
set(gca,'XTick',[0:50:200])
set(gca,'YTick',[130:4:150])
xlabel('t  (min)','FontSize',12)
ylabel('T(t),  (\circF)','FontSize',12)
text(-47,152.5,'Linearized Tank Temperature vs. Time','FontSize',11)



