% Chap7_fishery_w_economics.m
clc, close all, clear all

%%%%% Expanded System
% parameters: r,k,eps,alpha,cE,cR
% inputs: u1=uR, u2=p
% states: x1=x,x2=uE
% outputs: y1=x, y2=uE, y3=R-C

%%%%% Set values of fixed parameters
r=2; k=4; eps=0.1; alpha=0.75; cE=2; cR=1;

uR=0.3; p=6;

%%%%% Check equilibrium states
B4=-k*(p^2)*(eps^3)*cE;
B3=k*((p*eps)^3)*uR + r*(cE^2)*(k*p*eps-cE) - k*(p^2)*(eps^3)*(cR*uR);
B2=2*r*cE*cR*uR*(k*p*eps-cE) - r*(cE^2)*cR*uR;
B1=r*((cR*uR)^2)*(k*p*eps - 3*cE);
B0=-r*(cR*uR)^3;
uE=roots([B4 B3 B2 B1 B0])
x=(cE*uE+cR*uR)./(p*eps*uE)

%%%%% Given inputs uR and p, find equil states x and uE
x10=10.0; x_initial=x10;
x20=20; uE_initial=x20;
[sizes,x0,states]=fishery_3([],[],[],0);
x0=[x10; x20] 
u10=uR;
u20=p;
u0=[u10; u20]; 
y10=0;
y20=0;
y30=0;
y0=[y10; y20; y30];
ix=[];
iu=[1,2];
iy=[];
[xa,ua,y,dx]=trim('fishery_3',x0,u0,y0,ix,iu,iy)

%%%%% Given inputs uR and p, find equil states x and uE
x10=10.0; x_initial=x10;
x20=20; uE_initial=x20;
[sizes,x0,states]=fishery_3([],[],[],0);
x0=[x10; x20] 
u10=2*uR; % double 1st input
u20=2*p; % double 2nd input
u0=[u10; u20]; 
y10=0;
y20=0;
y30=0;
y0=[y10; y20; y30];
ix=[];
iu=[1,2];
iy=[];
[xb,ub,y,dx]=trim('fishery_3',x0,u0,y0,ix,iu,iy) % find new equil states

% %%%%% Given equil states x and uE, find inputs uR and p
% x10=x(1); x_initial=x10;
% x20=uE(1); uE_initial=x20;
% [sizes,x0,states]=fishery_3([],[],[],0);
% x0=[x10; x20] 
% u10=1;
% u20=1;
% u0=[u10; u20]; 
% y10=0;
% y20=0;
% y30=0;
% y0=[y10; y20; y30];
% ix=[1,2];
% iu=[];
% iy=[];
% [x,u,y,dx]=trim('fishery_3',x0,u0,y0,ix,iu,iy)


