% m-file Ch7_globe_fill_surface.m
% calls Simulink model globe.mdl
% plots Figure 7.33 

clc, clear all, close all


F1_min=0; F1_max=10;
c_min=0; c_max=2;
R=5; % globe radius (ft)
T_max=300;
T_design=150; % center of fill time design interval (min)
del=10; % width of design interval centered at T_design (min) 
TL=T_design-del/2; % lower end of design interval (min)
TH=T_design+del/2; % upper end of design interval (min)
A=100; B=50;

numF1=30; numc=30; % may have to increase these values
F1min=0; F1max=10;
cmin=0; cmax=2;
for i=1:numF1
   F1=F1min+((F1max-F1min)/(numF1-1))*(i-1);  
   F11(i)=F1;    
      for j=1:numc;
        c=cmin+((cmax-cmin)/(numc-1))*(j-1);     
        cc(j)=c;  
        sim('globe') 
        t=H(:,1);
        t_fill=t(end);                
      
      if t_fill < TL
        z(i,j)=A*((t_fill/TL)-1)^2;
      elseif t_fill >= TL & t_fill <= TH        
        z(i,j)=0;
      elseif t_fill > TH & t_fill <= T_max     
        z(i,j)= B*((t_fill-TH)/(T_max-TH))^2;
      else
          z(i,j)=B;
      end % if  
      
    end % j
end % i

%%%%% Save cc, F11 and z in .mat file named globe_surface_data.mat
%save globe_surface_data cc F11 z

colormap([0 0 0])
mesh(cc,F11,z) % plot objective function surface
axis([0 2 0 10 0 70])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.4:2])
set(gca,'YTick',[0:2:10])
set(gca,'ZTick',[0:10:70])
h1 = xlabel('c','FontSize',13);
h2 = ylabel('F_1','FontSize',13);
h3 = zlabel('z','FontSize',13);
title('Objective Function Surface: z = F(F_1,c)','FontSize',12)
set(h1, 'Position',[0.75,-3.50]);
set(h2, 'Position',[-0.65,4,0]);
set(h3, 'Position',[-0.1,12,27]);

% figure(2) % plot Figure 7.37
% v=[5 20 60];
% contour(cc,F11,z,v)
% axis([c_min c_max F1_min F1_max])
% 
% xlabel('c  (ft^3/min per ft^{1/2})','FontSize',13)
% ylabel('F_1  (ft^3/min)','FontSize',13)
% title('F_0 = 5, 20, 60 Contours','FontSize',11)






