% m-file Ch7_opt_theta_vT.m
% plots Figure 7.20

clc, close all, clear all

L=5000; % ft
m=2000/32.2; % slugs
mu=0.1; % lb per ft/sec
vT=15*5280/3600; % target speed (fps)
vP_initial=45; % projectile initial speed (mph)
vP_initial=vP_initial*(5280/3600); % projectile initial speed (ft/sec)
T=0.05; % step size (sec)vT=15; % mph

for i=1:8
  vT_mph(i)=10*i-5; % target speed (mph)
  vT_fps=vT_mph(i)*(5280/3600); % ft/sec
  angle_init_deg=45; % initial projectile firing angle (deg)
  angle_init_rad=angle_init_deg*(pi/180); % initial projectile firing angle (rad)
  opt_angle_rad=fminunc(@obj_fcn_D,angle_init_rad,[ ],L,m,mu,vT_fps,vP_initial);  % optimum firing angle (rad)
  opt_angle_deg(i)=opt_angle_rad*180/pi  % opt firing angle (deg)
end % for

plot(vT_mph,opt_angle_deg,'b.--','MarkerSize',10)
grid on
axis([0 80 -20 100])
set(gca,'FontSize',11)
set(gca,'XTick',[0:10:80])
set(gca,'YTick',[-20:20:100])])
xlabel('Target speed,  v_T   (mph)','Fontsize',12)
ylabel('Optimum Firing Angle,  \theta_{opt},  (deg)','Fontsize',12)
title('Optimum Firing Angle (deg) vs Target Speed (mph)','Fontsize',11)


