% m-file Ch7_target.m
% calls Simulink mdel target_projectile.m
% plots Figure 7.16

clc, close all, clear all

L=5000; % ft
m=2000/32.2; % slugs
mu=0.1; % lb per ft/sec
vT=15; % mph
vT=vT*(5280/3600); % ft/sec
vP_initial=45; % projectile initial speed (mph)
vP_initial=vP_initial*(5280/3600); % projectile initial speed (ft/sec)
theta=45 ;% projectile firing angle (deg)
theta=theta*(pi/180); % projectile firing angle (rad)
T=0.025; % step size (sec)

%%%% simulate and generate points for plot of D_final vs theta
nruns=50;
theta1=0;
theta2=90;
for i=1:nruns
    theta_deg(i)=(theta2-theta1)/(nruns-1)*(i-1)+theta1; 
    theta=theta_deg(i)*(pi/180); % parameter theta in SIMULINK block (rad)
    sim('target_projectile')
    Dist(i)=D(end);
end
figure(1) % plot Figure 7.16
plot(theta_deg,Dist,'b.','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:10:90])
set(gca,'YTick',[0:500:6000])
xlabel('Firing Angle,  \theta (deg)','FontSize',12)
ylabel('Miss Distance,   D_{final}  (ft)','FontSize',12)
title('Miss Distance vs Firing Angle','FontSize',11)
text(30,5600,'v_T  = 15 mph, v_P(0) = 45 mph','FontSize',13)
text(13,5150,'L = 5000 ft, m = 2000/32.2 slugs, \mu = 0.1 lb-s/ft','FontSize',13)


    