% m-file Ch7_target_projectile_opt_search.m
% calls Simulink model target_projectile.mdl
% plots Figures *****
clc, close all, clear all

L=5000; % ft
m=2000/32.2; % slugs
mu=0.1; % lb per ft/sec
vT=15; % mph
vT=vT*(5280/3600); % ft/sec
vP_initial=45; % projectile initial speed (mph)
vP_initial=vP_initial*(5280/3600); % projectile initial speed (ft/sec)
theta=45 ;% projectile firing angle (deg)
theta=theta*(pi/180); % projectile firing angle (rad)
T=0.05; % step size (sec)

%%%%% begin search for optimum theta
theta_old=0; % old theta value (rad)
theta=theta_old; 
theta_deg(1)=theta*180/pi;
iter(1)=1;
sim('target_projectile')
f_old=D(end); 
f(1)=f_old;

step=10*pi/180; % theta increment (rad)
theta_new=theta_old+step; % new theta value (rad)
theta=theta_new; 
theta_deg(2)=theta*180/pi;
iter(2)=2;
sim('target_projectile')
f_new=D(end); 
f(2)=f_new;

count=3;
while min(f_old,f_new)>10 & count<75     
      
     if f_new<f_old   
         theta_new=theta_new+step;     
     else 
         theta_new=theta_new-step;
     end % if   
  step=0.985*step;
  f_old=f_new;   
  theta=theta_new;  
  theta_deg(count)=theta*180/pi;
  sim('target_projectile')   
  f_new=D(end);
  f(count)=f_new;
  iter(count)=count;
  count=count+1;
  
end % while

subplot(2,1,1)
plot(iter,theta_deg)
ylabel('\theta')
subplot(2,1,2)
plot(iter,f)
ylabel('\itD_{final}')

