function f=obj_fcn_kinetics(k_n,x_obs)
% Objective function (squared error) for finding optimum rate constant and order in chemical reaction

T_step=0.1;
tfinal=60; % final sim time (min)
k=k_n(1); % k for SIMULINK CON block in model 'chemical.mdl'
n=k_n(2); % n for SIMULINK CON block in model 'chemical.mdl' 
opts=simset('SrcWorkSpace','current','DstWorkSpace','current','FixedStep',T_step);
[T,X]=sim('chemical',tfinal,opts); % run sim and return squared error
x=X(1:10:end); % simulated concentrations for t=0,1,2,...,60 min
f=sum((x-x_obs).^2);
