function f=obj_fcn_ship(Kp_Kd,Kg,L,Ks,tau,t1,theta_com,c)
% Objective function for finding optimum P-D parameters for ship control

T=0.5;
tfinal=100; % final sim time (sec)
Kp=Kp_Kd(1); % Kp for SIMULINK PID block in model 'ship.mdl'
Kd=Kp_Kd(2); % Kd for SIMULINK PID block in model 'ship.mdl' 
Ki=0; % Ki for SIMULINK PID block in model 'ship.mdl'
opts=simset('SrcWorkSpace','current','DstWorkSpace','current','FixedStep',T);
sim('ship',tfinal,opts); % run sim and return IAE,ISE and heading arrays

t=heading(:,1);
theta=heading(:,2);
max_theta=max(theta);
threshold1=0.1*theta_com;
threshold2=0.9*theta_com;
        
flag=0; rise_time=0;
  for k=2:length(t)
     if theta(k)>threshold1 & theta(k-1)<threshold1 & flag==0
        t10=t(k);
     elseif  theta(k)>threshold2 & theta(k-1)<threshold2 & flag==0                
        t90=t(k); 
        rise_time=t90-t10; 
        flag=1;
      end % if
   end % for k  
   
   if flag==0
   % Kp,Kd,max_theta,disp('No Rise Time Found')
     rise_time=100; 
   end
  
  if max_theta+0.1>=theta_com            
    max_heading_overshoot=max_theta-theta_com;
  else 
    max_heading_overshoot=theta_com-max_theta;
    % Kp,Kd,max_theta,disp('Commanded Heading Not Attained')
  end    
            
max_heading_rate=abs(max(heading_rate(:,2))); 

f=c(1)*max_heading_overshoot+c(2)*max_heading_rate+c(3)*rise_time+c(4)*IAE(end,2)+c(5)*ISE(end,2);

