% m-file Ch8_AB_Stabilty_Boundaries.m
% plots Figure 8.21

clc, close all, clear all

theta=linspace(0,pi,500); 
x=exp(j*theta);

%%%%% AB-1 %%%%%
lamT_AB1=x-1;
plot(lamT_AB1,'b','LineWidth',1.3)
grid on
hold on
axis([-2.1 0.2 -0.1 1.1])
set(gca,'FontSize',11)
axis equal
set(gca,'FontSize',11)
plot([-2.1 0.2],[0 0],'k','LineWidth',1.0)
plot([0 0],[-0.5 1.5],'k','LineWidth',1.0)
 
% %%%%% AB-2 %%%%%
lamT_AB2=2*(x-x.^2)./(1-3*x); 
plot(lamT_AB2,'r','LineWidth',1.3)
 
% %%%%% AB-3 %%%%%
lamT_AB3=12*(x.^3-x.^2)./(5-16*x+23*x.^2);
plot(lamT_AB3,'m','LineWidth',1.3)

%%%%% AB-4 %%%%%
clear theta
lamT_AB4=[ ];
for theta=0:pi/500:pi    
x=exp(j*theta);
lamT=24*(x^3-x^4)/(9-37*x+59*x^2-55*x^3); 
a4=1; a3=-(1+(55/24)*lamT); a2=(59/24)*lamT; a1=-(37/24)*lamT; a0=(9/24)*lamT;
z=roots([a4 a3 a2 a1 a0]);
angz=angle(z)*180/pi;
magz=abs(z);
  if max(magz)<=1
      lamT_AB4=[lamT_AB4 lamT];
  end % if
end % for
plot(lamT_AB4,'k','LineWidth',1.3)
text(-0.24,0.15,'AB-4','FontSize',12)
text(-0.41,0.35,'AB-3','FontSize',12)
text(-0.83,0.45,'AB-2','FontSize',12)
text(-1.70,0.65,'AB-1','FontSize',12)
text(-1.9,1.5,'Stability Boundaries for AB-1 thru AB-4 Integrators','FontSize',12)
text(-1.15,1.25,'\lambdaT Plane','FontSize',13)
xlabel('Re (\lambdaT)','FontSize',13)
ylabel('Im (\lambdaT)','FontSize',13)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta=[0 pi];  % z=1 and z=-1
x=exp(j*theta);
lamT=2*(x-x.^2)./(1-3*x) 








