% m-file Ch8_AM_Stability_Boundaries.m
% plots Figure 8.26

clc, close all, clear all

theta=linspace(0,pi,2000); 
hold on
grid on
x=exp(j*theta);

axis([-6.5 0.5 -0.5 3.5])
axis equal
plot([-6.5 0.5],[0 0],'k','LineWidth',1.1)
plot([0 0],[-2 0],'k','LineWidth',1.1)
plot([0 0],[0 5],'m','LineWidth',1.3)
plot([-0.3 0],[3.25 3.25],'k')

  
%%%%% AM-3 %%%%%
lamT_AM3=12*(x.^2 - x)./(5*x.^2 + 8*x -1);
plot(lamT_AM3,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[-6:0],'YTick',[-1:0.5:4])

%%%%% AM-4 %%%%%
lamT_AM4=24*(x.^3 - x.^2)./(9*x.^3 + 19*x.^2 - 5*x +1);
plot(lamT_AM4,'r','LineWidth',1.3)
text(-3.2,1.60,'AM-4','FontSize',13)
text(-4.90,3.10,'AM-3','FontSize',13)
text(-1,3.25,'AM-2','FontSize',13)
text(-6,4.5,'Stability Boundaries for AM-2 thru AM-4 Integrators','FontSize',12)
text(-4.92,1.15,'\lambdaT Plane','FontSize',13)
xlabel('Re (\lambdaT)','FontSize',13)
ylabel('Im (\lambdaT)','FontSize',13)

 








