% m-file Ch8_Ex8_1.m
% plots Figure 8.4 and Figure 8.5

clc, close all, clear all

lamT=linspace(-1.5,-0.001,750);
elam_exact=(1./lamT).*log((1+0.5*lamT)./(1-0.5*lamT))-1;
elam_asym=(lamT.^2)/12;

% figure(1) % plot Figure 8.4
% plot(lamT,elam_exact,'b','LineWidth',1.3)
% grid on
% hold on
% set(gca,'FontSize',11)
% set(gca,'XTick',[-1.5:0.25:0])
% set(gca,'YTick',[0:0.05:0.3])
% plot(lamT,elam_asym,'r','LineWidth',1.3)
% axis([-1.5 0 0 0.31])
% xlabel('\lambdaT','FontSize',13)
% text(-1.15,0.205,'e_{\lambda}  (exact)','FontSize',13)
% plot([-1.33 -1.17],[0.205 0.205],'k','LineWidth',1.1) 
% text(-1.45,0.055,'e_{\lambda}  (asymptotic)','FontSize',13)
% plot([-1.02 -0.82],[0.055 0.055],'k','LineWidth',1.1)
% text(-1.47,0.325,'Exact and Asymptotic Fractional Characteristic Root Errors','FontSize',12)


figure(2) % plot Figure 8.5
lam=-0.5; x0=1;
T1=0.015; T2=0.15; T3=1.5; T4=2.5;
lamT1=lam*T1; lamT2=lam*T2; lamT3=lam*T3; lamT4=lam*T4;
tfinal=5*(-1/lam);
t=0:0.01:tfinal;
x=x0.*exp(lam*t);

subplot(2,2,1)
plot(t,x,'b','Linewidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:10])
set(gca,'YTick',[0:0.2:1])
axis([0 tfinal 0 1])
hold on
z=(1+lamT1/2)/(1-lamT1/2);
n_final=round(tfinal/T1);
n=0:n_final;
xA=(z.^n)*x0;
ti=n*T1;
del=25;
plot(ti(1:del:end),xA(1:del:end),'r.','MarkerSize',8)
lam_eq1=(1/T1)*log(z) 
e_lam1=(lam_eq1-lam)/lam;
e_lam1_asym=(lamT1^2)/12;
text(4,0.855,'\lambda = -0.5','FontSize',13)
text(4,0.655,'T = 0.015','FontSize',13)
text(4,0.455,'\lambdaT = -0.0075','FontSize',13)
title('Table 2.1 Row 1 Responses','FontSize',11)

subplot(2,2,2)
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:10])
set(gca,'YTick',[0:0.2:1])
axis([0 tfinal 0 1])
hold on
z=(1+lamT2/2)/(1-lamT2/2);
n_final=round(tfinal/T2);
n=0:n_final;
xA=(z.^n)*x0;
ti=n*T2;
del=3;
plot(ti(1:del:end),xA(1:del:end),'r.','MarkerSize',8)
lam_eq2=(1/T2)*log(z); 
e_lam2=(lam_eq2-lam)/lam;
e_lam2_asym=(lamT2^2)/12;
text(4,0.855,'\lambda = -0.5','FontSize',13)
text(4,0.655,'T = 0.15','FontSize',13)
text(4,0.455,'\lambdaT = -0.075','FontSize',13)
title('Table 2.1 Row 2 Responses','FontSize',11)

subplot(2,2,3)
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:10])
set(gca,'YTick',[0:0.2:1])
axis([0 tfinal 0 1])
hold on
z=(1+lamT3/2)/(1-lamT3/2);
n_final=round(tfinal/T3);
n=0:n_final;
xA=(z.^n)*x0;
ti=n*T3;
del=1;
plot(ti(1:del:end),xA(1:del:end),'.r','MarkerSize',8)
lam_eq3=(1/T3)*log(z) 
x_eq=x0.*exp(lam_eq3*t);
%plot(t,x_eq,':r')
xlabel('t','FontSize',13)
lamT3;
e_lam3=(lam_eq3-lam)/lam
e_lam33=(1/lamT3)*log((1+0.5*lamT3)/(1-0.5*lamT3))-1
e_lam3_asym=(lamT3^2)/12
text(4,0.855,'\lambda = -0.5','FontSize',13)
text(4,0.655,'T = 1.5','FontSize',13)
text(4,0.455,'\lambdaT = -0.75','FontSize',13)
title('Table 2.1 Row 3 Responses','FontSize',11)

subplot(2,2,4)
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:2.5:10])
set(gca,'YTick',[0:0.2:1])
axis([0 tfinal 0 1])
hold on
z=(1+lamT4/2)/(1-lamT4/2);
n_final=round(tfinal/T4);
n=0:n_final;
xA=(z.^n)*x0;
ti=n*T4;
del=1;
plot(ti(1:del:end),xA(1:del:end),'r.','MarkerSize',8)
lamT4;
lam_eq4=(1/T4)*log(z); 
x_eq=x0.*exp(lam_eq4*t);
% plot(t,x_eq,':r')
xlabel('t','FontSize',13)
e_lam4=(lam_eq4-lam)/lam;
e_lam44=(1/lamT4)*log((1+0.5*lamT4)/(1-0.5*lamT4))-1;
e_lam4_asym=(lamT4^2)/12;
text(4,0.855,'\lambda = -0.5','FontSize',13)
text(4,0.655,'T = 2.5','FontSize',13)
text(4,0.455,'\lambdaT = -1.25','FontSize',13)
title('Table 2.1 Row 4 Responses','FontSize',11)


