% m-file Ch8_Ex8_10.m
% plots Figures 8.81 - 8.84 

clc, clear all, close all
hold on

%%%%% Part a) %%%%%

T=0.1;
ncycles=2;

%%%%% wT=0.1
wT=0.1; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
tfinal=ncycles*(2*pi/w);
ti=linspace(0,tfinal,750);
ui=sin(w*ti);

nfinal=round(tfinal/T);

for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end

uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end

figure(1) % plot Figure 8.81
subplot(1,2,1)
plot(ti,ui,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal -1.75 1.25])
set(gca,'FontSize',11,'XTick',[0:2:12],'YTick',[-1.75:0.25:1.25])
plot(t(2:3:end),uhat(1:3:end-1),'ks','MarkerSize',4,'MarkerFaceColor','k')
plot(t(1:3:end),u(1:3:end),'r.','MarkerSize',10)

text(0.75,1.15,'T = 0.1 s,  \omegaT = 0.1 rad ','FontSize',12)
text(7,-1.10,'u(t)','FontSize',12)
plot([5 6],[-1.12 -1.12],'b','LineWidth',1.3)
text(7,-1.35,'u_n','FontSize',12)
plot(5.5,-1.37,'r.','MarkerSize',10)
text(7,-1.60,'u_{n+1}','FontSize',12)
text(6.9,-1.48,'\wedge','FontSize',11)
plot(5.5,-1.60,'ks','MarkerSize',4,'MarkerFaceColor','k')
xlabel('t  (s)','FontSize',12)
text(2.65,1.42,'Continuous-time, Sampled and Extrapolated Inputs','FontSize',12)

%%%% WT=0.25
clear t u ui uhat

wT=0.25; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
% tfinal=2*ncycles*(2*pi/w);
tfinal=12.5664;
ti=linspace(0,tfinal,750);
ui=sin(w*ti);

nfinal=round(tfinal/T);

for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end

uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end

subplot(1,2,2)
plot(ti,ui,'b','LineWidth',1.3)
grid on
hold on
% axis([0 tfinal -1.75 1.25])
axis([0 12.5664 -1.75 1.25])
set(gca,'FontSize',11,'XTick',[0:2:12],'YTick',[-1.75:0.25:1.25])
plot(t(2:3:end),uhat(1:3:end-1),'ks','MarkerSize',4,'MarkerFaceColor','k')
plot(t(1:3:end),u(1:3:end),'r.','MarkerSize',10)

text(0.50,1.15,'T = 0.1 s,  \omegaT = 0.25 rad ','FontSize',12)
text(7,-1.10,'u(t)','FontSize',12)
plot([5 6],[-1.12 -1.12],'b','LineWidth',1.3)
text(7,-1.35,'u_n','FontSize',12)
plot(5.5,-1.37,'r.','MarkerSize',10)
text(7,-1.60,'u_{n+1}','FontSize',12)
text(6.9,-1.48,'\wedge','FontSize',11)
plot(5.5,-1.60,'ks','MarkerSize',4,'MarkerFaceColor','k')
xlabel('t  (s)','FontSize',12)


figure(2) % plot Figure 8.82

%%%% WT=0.5
clear t u ui uhat
hold on
wT=0.5; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
tfinal=ncycles*(2*pi/w);
ti=linspace(0,tfinal,750);
ui=sin(w*ti);

nfinal=round(tfinal/T);

for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end

uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end

subplot(1,2,1)
plot(ti,ui,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal -2.25 1.75])
set(gca,'FontSize',11,'XTick',[0:0.4:2.4],'YTick',[-2:0.5:1.5])
plot(t,u,'r.','MarkerSize',10)
plot(t(2:end),uhat(1:end-1),'ks:','MarkerSize',4,'MarkerFaceColor','k')

text(0.2,1.60,'T = 0.1 s,  \omegaT = 0.5 rad','FontSize',12)
text(1.6,-1.30,'u(t)','FontSize',12)
plot([1.3 1.5],[-1.33 -1.33],'b','LineWidth',1.3)
text(1.6,-1.65,'u_n','FontSize',12)
plot(1.4,-1.65,'r.','MarkerSize',10)
text(1.6,-2.05,'u_{n+1}','FontSize',12)
plot(1.4,-2.05,'ks','MarkerSize',4,'MarkerFaceColor','k')
text(1.6,-1.90,'\bf\wedge','FontSize',10)
xlabel('t  (s)','FontSize',12)
text(0.6,2.0,'Continuous-time, Sampled and Extrapolated Inputs','FontSize',12)


%%%% WT=1 %%%%
clear t u ui uhat
hold on
wT=1; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
tfinal=2.5133;
% tfinal=ncycles*(2*pi/w);
ti=linspace(0,tfinal,750);
ui=sin(w*ti);

nfinal=round(tfinal/T);

for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end

uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end

subplot(1,2,2)
plot(ti,ui,'b','LineWidth',1.3)
grid on
hold on
% axis([0 tfinal -2.25 1.75])
axis([0 2.5133 -2.25 1.75])
set(gca,'FontSize',11,'XTick',[0:0.4:2.4],'YTick',[-2:0.5:1.5])
plot(t,u,'r.','MarkerSize',10)
plot(t(2:end),uhat(1:end-1),'ks:','MarkerSize',4,'MarkerFaceColor','k')
text(0.2,-1.90,'T = 0.1 s,  \omegaT = 1 rad','FontSize',12)
xlabel('t  (s)','FontSize',12)

%%%%% Part b) %%%%%

figure(3) % plot Figure 8.83
lambda=-0.5;
T=0.1;
tau=-1/lambda;
tfinal=10*tau;
wT=0.1; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
nfinal=round(tfinal/T);
for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end
uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end
x(1)=0;
for n=2:nfinal+1
    xhat(n)=x(n-1)+T*(lambda*x(n-1)+u(n-1));
    x(n)=x(n-1)+0.5*T*(lambda*x(n-1)+u(n-1)+lambda*xhat(n)+uhat(n-1));
end
  
hold on
ti=linspace(0,tfinal,1000);
a=lambda^2+w^2;
xi=(w/a)*(exp(lambda*ti)-cos(w*ti)-(lambda/w)*sin(w*ti));
phi=pi+atan(w/(lambda));
% xii=(w/a)*exp(lambda*ti)-(1/sqrt(a))*sin(w*ti+phi);
% xss=sin(w*ti+phi)/(sqrt(a));

subplot(1,2,1)
plot(ti,xi,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal -1.5 1.5])
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[-1.5:0.5:1.5])
% plot(ti,xii,'g') % alternate form of exact soln
% plot(ti,xss,'k')
plot(t(1:2:end),x(1:2:end),'r.','MarkerSize',10)
xlabel('t  (s)','FontSize',12)
text(-3.5,1.7,'Simulated Output with Extrapolated Input for Real-time Compatability','FontSize',12)
% a=1/(w*sqrt((lambda^2+w^2))); % check ss amplitude
% plot([0 tfinal],[a a],'k')
text(1.50,1.35,'T = 0.1 s,  \omegaT = 0.1 rad','FontSize',12)
text(6,-1.25,'x(t)','FontSize',12)
plot([3 5],[-1.28 -1.28],'b','LineWidth',1.3)
text(14,-1.25,'x_n','FontSize',12)
plot(12.7,-1.265,'r.','MarkerSize',10)

% plot(17.3,1,'r.','MarkerSize',9)
% text(7.5,1.2,'\itT \rm= 0.1 sec','FontSize',12)
% text(7.5,1.05,'\omega\itT \rm= 0.1 rad','FontSize',12)
% 
clear t x ti xi
% tfinal=6*tau;
tfinal=20;
wT=0.25; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
nfinal=round(tfinal/T);
for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end
uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end
x(1)=0;
for n=2:nfinal+1
    xhat(n)=x(n-1)+T*(lambda*x(n-1)+u(n-1));
    x(n)=x(n-1)+0.5*T*(lambda*x(n-1)+u(n-1)+lambda*xhat(n)+uhat(n-1));
end
hold on
ti=linspace(0,tfinal,1000);
a=lambda^2+w^2;
xi=(w/a)*(exp(lambda*ti)-cos(w*ti)-(lambda/w)*sin(w*ti));
phi=pi+atan(w/(lambda));
xii=(w/a)*exp(lambda*ti)-(1/sqrt(a))*sin(w*ti+phi);
xss=sin(w*ti+phi)/(sqrt(a));

subplot(1,2,2)
plot(ti,xi,'b','LineWidth',1.3)
grid on
hold on
% axis([0 tfinal -1.5 1.5])
axis([0 20 -1.5 1.5])
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[-1.5:0.5:1.5])
plot(t(1:2:end),x(1:2:end),'r.','MarkerSize',10)
xlabel('t  (s)','FontSize',12)
text(0.75,1.35,'T = 0.1 s,  \omegaT = 0.25 rad','FontSize',12)
text(6,-1.25,'x(t)','FontSize',12)
plot([3 5],[-1.28 -1.28],'b','LineWidth',1.3)
text(14,-1.25,'x_n','FontSize',12)
plot(12.7,-1.265,'r.','MarkerSize',10)

figure(4) % plot Figure 8.83
clear t x ti xi
tfinal=4*tau;
wT=0.5; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
nfinal=round(tfinal/T);
for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end
uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end
x(1)=0;
for n=2:nfinal+1
    xhat(n)=x(n-1)+T*(lambda*x(n-1)+u(n-1));
    x(n)=x(n-1)+0.5*T*(lambda*x(n-1)+u(n-1)+lambda*xhat(n)+uhat(n-1));
end

ti=linspace(0,tfinal,1000);
a=lambda^2+w^2;
xi=(w/a)*(exp(lambda*ti)-cos(w*ti)-(lambda/w)*sin(w*ti));
phi=pi+atan(w/(lambda));
xii=(w/a)*exp(lambda*ti)-(1/sqrt(a))*sin(w*ti+phi);
xss=sin(w*ti+phi)/(sqrt(a));

subplot(1,2,1)
plot(ti,xi,'b','LineWidth',1.3)
grid on
axis([0 tfinal -0.3 0.4])
hold on
set(gca,'FontSize',11,'XTick',[0:8],'YTick',[-0.3:0.1:0.4])
plot(t,x,'r.','MarkerSize',10)
xlabel('t  (s)','FontSize',12)
text(-1,0.44,'Simulated Output with Extrapolated Input for Real-time Compatability','FontSize',12)
text(0.8,0.37,'T = 0.1 s,  \omegaT = 0.5 rad','FontSize',12)
text(2.5,-0.25,'x(t)','FontSize',12)
plot([1 2],[-0.255 -0.255],'b','LineWidth',1.3)
text(5.5,-0.25,'x_n','FontSize',12)
plot(5,-0.25,'r.','MarkerSize',9)


clear t x ti xi
% tfinal=2*tau;
tfinal=8;
wT=1; % rad
w=wT/T; % sinusoidal frequency (rad/sec)
nfinal=round(tfinal/T);
for n=1:nfinal+1
  t(n)=(n-1)*T;
  u(n)=sin(w*(n-1)*T);
end
uhat(1)=2*u(1);
for n=2:nfinal+1     
  uhat(n)=2*u(n)-u(n-1);
end
x(1)=0;
for n=2:nfinal+1
    xhat(n)=x(n-1)+T*(lambda*x(n-1)+u(n-1));
    x(n)=x(n-1)+0.5*T*(lambda*x(n-1)+u(n-1)+lambda*xhat(n)+uhat(n-1));
end
hold on
ti=linspace(0,tfinal,1000);
a=lambda^2+w^2;
xi=(w/a)*(exp(lambda*ti)-cos(w*ti)-(lambda/w)*sin(w*ti));
phi=pi+atan(w/(lambda));
xii=(w/a)*exp(lambda*ti)-(1/sqrt(a))*sin(w*ti+phi);
xss=sin(w*ti+phi)/(sqrt(a));

subplot(1,2,2)
plot(ti,xi,'b','LineWidth',1.3)
grid on
hold on
% axis([0 tfinal -0.3 0.4])
axis([0 8 -0.3 0.4])
set(gca,'FontSize',11,'XTick',[0:8],'YTick',[-0.3:0.1:0.4])
plot(t,x,'r.:','MarkerSize',10)
xlabel('t  (s)','FontSize',12)
text(0.8,0.37,'T = 0.1 s,  \omegaT = 1 rad','FontSize',12)
text(2.5,-0.25,'x(t)','FontSize',12)
plot([1 2],[-0.255 -0.255],'b','LineWidth',1.3)
text(5.5,-0.25,'x_n','FontSize',12)
plot(5,-0.25,'r.','MarkerSize',9)


% plot([3.372 3.528],[0.22 0.22],'k')
% text(3.6,0.19,'\itx_{n}','FontSize',12)
% plot(3.45,0.19,'r.','MarkerSize',9)
% text(1.75,0.22,'\itT \rm= 0.1 sec','FontSize',12)
% text(1.75,0.19,'\omega\itT \rm= 1 rad','FontSize',12)
