% m-file Ch8_Ex8_11.m
% plots Figure 8.90 and Figure 8.91

close all, clear all, clc

C=200;
R=0.005;
tau=R*C;
T0_bar=50;
del_T0=20;
period=24;
w=2*pi/period;
Tinit=50;
T=0.25;
tau, T_over_tau=T/tau, wT=w*T
a0=1-(T/tau)+0.5*(T/tau)^2;
b0=0.5*(T/tau)*(1-(T/tau));
b1=0.5*(T/tau);
ncycles=2;
tfinal=ncycles*(2*pi/w);
nfinal=round(tfinal/T);
for n=1:nfinal+1
  t(n)=(n-1)*T;
  T0(n)=T0_bar+del_T0*sin(w*(n-1)*T);
end

T_hat(1)=Tinit;
for n=1:nfinal
  T_hat(n+1)= a0*T_hat(n)+b0*T0(n)+b1*T0(n+1); 
end

T_hat_RT(1)=Tinit;
T_hat_RT(2)=Tinit;
for n=2:nfinal
  T_hat_RT(n+1)= a0*T_hat_RT(n)+b0*T0(n-1)+b1*T0(n); 
end

ti=linspace(0,tfinal,1000);
tauw=tau*w;
y=tauw*del_T0/(1+tauw^2);
T_hati=T0_bar+(Tinit-T0_bar+y)*exp(-ti/tau)+(y/tauw)*(sin(w*ti)-tauw*cos(w*ti));
T0i=T0_bar+del_T0*sin(w*ti);

figure(1) % plot Figure 8.90
subplot(2,1,1)
plot(ti,T0i,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal 25 75])
set(gca,'FontSize',11,'XTick',[0:4:48],'YTick',[30:10:70])
plot(t(1:4:end),T0(1:4:end),'.r','MarkerSize',10)
ylabel('Temperature  (deg F)','FontSize',13)
text(2,80,'Continuous-time Input T_0(t) and Sampled Values T_{0,n}','FontSize',12)
text(2.5,45,'T_0(t)','FontSize',12)
text(2.5,35,'T_{0,n}','FontSize',12)
text(10,68,'f_0 = 1 cycle per 24 h','FontSize',12)
text(12,58,'\omegaT = 0.065 rad','FontSize',12)
text(14,48,'T = 0.25 h','FontSize',12)
plot([1.0 2.0],[45.5 45.5],'b','LineWidth',1.3)
plot([1.5],[35],'.r','MarkerSize',10)

subplot(2,1,2)
plot(ti,T_hati,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal 25 75])
set(gca,'FontSize',11,'XTick',[0:4:48],'YTick',[30:10:70])
plot(t(1:4:end),T_hat(1:4:end),'.r','MarkerSize',10)
plot(t(1:4:end),T_hat_RT(1:4:end),'sk','MarkerSize',2.9,'MarkerFaceColor','k')
text(6,53,'T(t)','FontSize',12)
text(6.0,57.6,'\bf\wedge')
text(3,43,'T_n','FontSize',11)
text(3.00,49.1,'\bf\wedge')
text(3,31,'T_{R/T,n}','FontSize',12)
text(3.00,37.3,'\bf\wedge')
text(28,45,'\tau = 1 h','FontSize',12)
text(28,35,'T = 0.25 h','FontSize',12)
plot([4.5 5.5],[53 53],'b','LineWidth',1.3)
plot(2,43,'.r','MarkerSize',10)
plot(2,31,'sk','MarkerSize',2.9,'MarkerFaceColor','k')
xlabel('t  (h)','FontSize',13)
ylabel('Temperature  (deg F)','FontSize',13)
text(-3,80,'Continuous-time Output T(t) and Discrete-time Outputs T_n and T_{R/T,n}','FontSize',12)
text(16.2,86,'\bf\wedge')
text(40.5,86,'\bf\wedge')
text(46.3,86,'\bf\wedge')

%%%%% Part e)
period=3;
w=2*pi/period;
wT=w*T
tfinal=ncycles*(2*pi/w);
nfinal=round(tfinal/T);
clear t T0 T_hat T_hat_RT
for n=1:nfinal+1
  t(n)=(n-1)*T;
  T0(n)=T0_bar+del_T0*sin(w*(n-1)*T);
end

T_hat(1)=Tinit;
for n=1:nfinal
  T_hat(n+1)= a0*T_hat(n)+b0*T0(n)+b1*T0(n+1); 
end

T_hat_RT(1)=Tinit;
T_hat_RT(2)=Tinit;
for n=2:nfinal
  T_hat_RT(n+1)= a0*T_hat_RT(n)+b0*T0(n-1)+b1*T0(n); 
end

ti=linspace(0,tfinal,1000);
tauw=tau*w;
y=tauw*del_T0/(1+tauw^2);
T_hati=T0_bar+(Tinit-T0_bar+y)*exp(-ti/tau)+(y/tauw)*(sin(w*ti)-tauw*cos(w*ti));
T0i=T0_bar+del_T0*sin(w*ti);

figure(2) % plot Figure 8.91
subplot(2,1,1)
plot(ti,T0i,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal 25 75])
set(gca,'FontSize',11,'XTick',[0:0.5:6],'YTick',[30:10:70])
plot(t,T0,'.r','MarkerSize',10)
ylabel('Temperature  (deg F)','FontSize',13)
text(0.6,80.5,'Continuous-time Input T_0(t) and Sampled Values T_{0,n}','FontSize',12)
text(0.55,50,'T_0(t)','FontSize',12)
text(0.55,40,'T_{0,n}','FontSize',12)
text(1.3,68,'f_0 = 1 cycle per 3 h','FontSize',12)
text(1.55,58,'\omegaT = 0.524 rad','FontSize',12)
text(1.75,48,'T = 0.25 h','FontSize',12)
plot([0.25 0.45],[50.5 50.5],'b','LineWidth',1.3)
plot([0.35],[40],'.r','MarkerSize',10)

subplot(2,1,2)
plot(ti,T_hati,'b','LineWidth',1.3)
grid on
hold on
axis([0 tfinal 25 75])
set(gca,'FontSize',11,'XTick',[0:0.5:6],'YTick',[30:10:70])

plot(t,T_hat,'.r','MarkerSize',10)
plot(t,T_hat_RT,'sk','MarkerSize',3,'MarkerFaceColor','k')
text(2.4,68,'\tau = 1 h','FontSize',12)
text(2.4,58,'T = 0.25 h','FontSize',11)
xlabel('t  (h)','FontSize',13)
ylabel('Temperature  (deg F)','FontSize',13)

text(-0.5,80.5,'Continuous-time Output T(t) and Discrete-time Outputs T_n and T_{R/T,n}','FontSize',12)
text(1.9,86.5,'\bf\wedge')
text(4.93,86.5,'\bf\wedge')
text(5.67,86.5,'\bf\wedge')

text(1.2,51,'T(t)','FontSize',12)
plot([0.90 1.10],[51 51],'b','LineWidth',1.3)
text(1.20,55.7,'\bf\wedge')

text(1.2,40,'T_n','FontSize',12)
plot(1.00,40,'.r','MarkerSize',10)
text(1.20,46.0,'\bf\wedge')

text(1.2,30.5,'T_{R/T,n}','FontSize',12)
plot(1.00,30.5,'sk','MarkerSize',3,'MarkerFaceColor','k')
text(1.20,36.4,'\bf\wedge')

