% m-file Ch8_Ex8_12.m
% plots Figure 8.95

clc, close all, clear all

T=0.05;
a1=-2*exp(-T)*cos(3*T);
a2=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b2=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
tfinal=5;
kfinal=round(tfinal/T);
t(1)=T;
u(1)=5*(1-exp(-2*T));
y(1)=b1*u(1);
t(2)=2*T;
u(2)=5*(1-exp(-4*T));
y(2)=-a1*y(1)+b1*u(2)+b2*u(1);
for k=3:kfinal
    t(k)=k*T;
    u(k)=5*(1-exp(-2*k*T));
    u(k-1)=5*(1-exp(-2*(k-1)*T));
    y(k)=-a1*y(k-1)-a2*y(k-2)+b1*u(k)+b2*u(k-1);
end
t=[0 t];
y=[0 y];
subplot(2,2,1)
ti=linspace(0,5,300);
yi=5-5*exp(-2*ti)-(10/3)*exp(-ti).*sin(3*ti);

figure(1) % plot Figure 8.95
plot(ti,yi,'b','LineWidth',1.3)
grid on
axis([0 5 0 6])
set(gca,'FontSize',11,'XTick',[0:5],'YTick',[0:6])
hold on
del1=2;
end1=30;
plot(t(1:del1:end1),y(1:del1:end1),'.r','MarkerSize',9)
del2=5;
plot(t(end1:del2:end),y(end1:del2:end),'.r','MarkerSize',9)
text(0.5,6.75,'Continuous-time and Discrete-time System Responses','FontSize',12)

text(2,3.35,'T = 0.05 s','FontSize',12)
text(2,2.3,'y(t)','FontSize',12)
plot([1.4 1.8],[2.2 2.2],'b','LineWidth',1.3)
text(2,1.2,'y_k','FontSize',12)
plot(1.6,1.2,'.r','MarkerSize',9)

clear t y
T=0.1;
a1=-2*exp(-T)*cos(3*T);
a2=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b0=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
kfinal=round(tfinal/T);
t(1)=T;
u(1)=5*(1-exp(-2*T));
y(1)=b1*u(1);
t(2)=2*T;
u(2)=5*(1-exp(-4*T));
y(2)=-a1*y(1)+b1*u(2)+b0*u(1);
for k=3:kfinal
    t(k)=k*T;
    u(k)=5*(1-exp(-2*k*T));
    u(k-1)=5*(1-exp(-2*(k-1)*T));
    y(k)=-a1*y(k-1)-a2*y(k-2)+b1*u(k)+b0*u(k-1);
end
t=[0 t];
y=[0 y];

subplot(2,2,2)
ti=linspace(0,5,300);
yi=5-5*exp(-2*ti)-(10/3)*exp(-ti).*sin(3*ti);
plot(ti,yi,'b','LineWidth',1.3)
grid on
axis([0 5 0 6])
set(gca,'FontSize',11,'XTick',[0:5],'YTick',[0:6])
hold on
del1=1;
end1=15;
plot(t(1:del1:end1),y(1:del1:end1),'.r','MarkerSize',9)
del2=2;
plot(t(end1:del2:end),y(end1:del2:end),'.r','MarkerSize',9)
text(2,3.35,'T = 0.1 s','FontSize',12)
text(2,2.3,'y(t)','FontSize',12)
plot([1.4 1.8],[2.2 2.2],'b','LineWidth',1.3)
text(2,1.2,'y_k','FontSize',12)
plot(1.6,1.2,'.r','MarkerSize',9)

clear t y
T=0.25;
a1=-2*exp(-T)*cos(3*T);
a2=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b0=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
kfinal=round(tfinal/T);
t(1)=T;
u(1)=5*(1-exp(-2*T));
y(1)=b1*u(1);
t(2)=2*T;
u(2)=5*(1-exp(-4*T));
y(2)=-a1*y(1)+b1*u(2)+b0*u(1);
for k=3:kfinal
    t(k)=k*T;
    u(k)=5*(1-exp(-2*k*T));
    u(k-1)=5*(1-exp(-2*(k-1)*T));
    y(k)=-a1*y(k-1)-a2*y(k-2)+b1*u(k)+b0*u(k-1);
end
t=[0 t];
y=[0 y];

subplot(2,2,3)
ti=linspace(0,5,300);
yi=5-5*exp(-2*ti)-(10/3)*exp(-ti).*sin(3*ti);
plot(ti,yi,'b','LineWidth',1.3)
grid on
axis([0 5 0 6])
set(gca,'FontSize',11,'XTick',[0:5],'YTick',[0:6])
hold on
plot(t,y,'.r','MarkerSize',9)
text(2,3.35,'T = 0.25 s','FontSize',12)
text(2,2.3,'y(t)','FontSize',12)
plot([1.4 1.8],[2.2 2.2],'b','LineWidth',1.3)
text(2,1.2,'y_k','FontSize',12)
plot(1.6,1.2,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)

clear t y
T=0.5;
a1=-2*exp(-T)*cos(3*T);
a2=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b2=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
kfinal=round(tfinal/T);
t(1)=T;
u(1)=5*(1-exp(-2*T));
y(1)=b1*u(1);
t(2)=2*T;
u(2)=5*(1-exp(-4*T));
y(2)=-a1*y(1)+b1*u(2)+b2*u(1);
for k=3:kfinal
    t(k)=k*T;
    u(k)=5*(1-exp(-2*k*T));
    u(k-1)=5*(1-exp(-2*(k-1)*T));
    y(k)=-a1*y(k-1)-a2*y(k-2)+b1*u(k)+b2*u(k-1);
end
t=[0 t];
y=[0 y];

subplot(2,2,4)
ti=linspace(0,5,300);
yi=5-5*exp(-2*ti)-(10/3)*exp(-ti).*sin(3*ti);
plot(ti,yi,'b','LineWidth',1.3)
grid on
axis([0 5 0 6])
set(gca,'FontSize',11,'XTick',[0:5],'YTick',[0:6])
hold on
plot(t,y,'.r','MarkerSize',9)
text(2,3.35,'T = 0.5 s','FontSize',12)
text(2,2.3,'y(t)','FontSize',12)
plot([1.4 1.8],[2.2 2.2],'b','LineWidth',1.3)
text(2,1.2,'y_k','FontSize',12)
plot(1.6,1.2,'.r','MarkerSize',9)
xlabel('t  (s)','FontSize',12)




    
    
    
    