% m-file Ch8_Ex8_2.m
% plots Figure 8.10

close all, clear all, clc

Ti=[0.001 0.002 0.004 0.005];
wn=50; zeta=0.1;
wnTi=wn*Ti;
zwn=zeta*wn;  
wd=sqrt(1-zeta^2)*wn  
a=1-zeta*wnTi;  
b=wd*Ti; 
R=sqrt(a.^2 + b.^2); 
theta=atan(b./a); 
a_star=log(R)./Ti; 
b_star=theta./Ti; 
wn_star_exact=sqrt(a_star.^2 + b_star.^2);   
wn_star_asym=(1+0.5*zeta*wnTi).*wn;   
zeta_star_exact=-a_star./wn_star_exact;
zeta_star_asym=zeta-0.5*(1-zeta^2)*wnTi;
wd_star_exact=sqrt(1-zeta_star_exact.^2).*wn_star_exact;
wd_star_asym=sqrt(1-zeta_star_asym.^2).*wn_star_asym;

tfinal=5/zwn;
ti=linspace(0,tfinal,1500);
xi=1-exp(-zwn.*ti).*(cos(wd*ti)+(zwn/wd)*sin(wd*ti));

subplot(2,2,1)
plot(ti,xi,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[0:0.5:2])
hold on
axis([0 1 0 2])
text(-0.25,2.3,'Step Response of Continuous-time and Discrete-time (Explicit Euler) System ','FontSize',11)
T=0.001;
wnT=wn*T;
nfinal=round(tfinal/T);
xA1(1)=0; t1(1)=0;
xA1(2)=0; t1(2)=T;
for n=3:nfinal
    t1(n)=n*T;
    xA1(n)=2*(1-zwn*T)*xA1(n-1)-(1-2*zwn*T+(wnT)^2)*xA1(n-2)+wnT^2;
end
del=4; 
plot(t1(1:del:end),xA1(1:del:end),'r.','MarkerSize',7)
text(0.5,1.58,'\omega_nT = 0.05','FontSize',12)
text(0.55,0.6,'continuous','FontSize',12)
plot([0.42 0.52],[0.58 0.58],'b','LineWidth',1.3)
text(0.55,0.25,'discrete','FontSize',12)
plot(0.47,0.23,'r.','MarkerSize',7)

subplot(2,2,2)
plot(ti,xi,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[0:0.5:2])
hold on
axis([0 1 0 2])
T=0.002;
wnT=wn*T;
nfinal=round(tfinal/T);
xA2(1)=0; t2(1)=0;
xA2(2)=0; t2(2)=T;
for n=3:nfinal
    t2(n)=n*T;
    xA2(n)=2*(1-zwn*T)*xA2(n-1)-(1-2*zwn*T+(wnT)^2)*xA2(n-2)+wnT^2;
end
del=2; 
plot(t2(1:del:end),xA2(1:del:end),'r.','MarkerSize',7)
text(0.5,1.58,'\omega_nT = 0.1','FontSize',12)
text(0.55,0.6,'continuous','FontSize',12)
plot([0.42 0.52],[0.58 0.58],'b','LineWidth',1.3)
text(0.55,0.25,'discrete','FontSize',12)
plot(0.47,0.23,'r.','MarkerSize',7)

subplot(2,2,3)
plot(ti,xi,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[0:3])
hold on
axis([0 1 -0.5 3])
T=0.004;
wnT=wn*T;
nfinal=round(tfinal/T);
xA3(1)=0; t3(1)=0;
xA3(2)=0; t3(2)=T;
for n=3:nfinal
    t3(n)=n*T;
    xA3(n)=2*(1-zwn*T)*xA3(n-1)-(1-2*zwn*T+(wnT)^2)*xA3(n-2)+wnT^2;
end
del=1;
plot(t3(1:del:end),xA3(1:del:end),'.r','MarkerSize',7)
text(0.3,2.5,'\omega_nT = 0.2','FontSize',12)
xlabel('t  (s)','FontSize',12)

subplot(2,2,4)
plot(ti,xi,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[-3:2:5])
hold on
axis([0 1 -0.5 3])
hold on
axis([0 1 -3 5])
hold on
xlabel('t  (s)','FontSize',12)
T=0.005;
wnT=wn*T;
nfinal=round(tfinal/T);
xA4(1)=0; t4(1)=0;
xA4(2)=0; t4(2)=T;
for n=3:nfinal
    t4(n)=n*T;
    xA4(n)=2*(1-zwn*T)*xA4(n-1)-(1-2*zwn*T+(wnT)^2)*xA4(n-2)+wnT^2;
end
del=1;
plot(t4(1:del:end),xA4(1:del:end),'r.','MarkerSize',7)
text(0.1,3.75,'\omega_nT = 0.25','FontSize',12)

