% m-file Ch8_Ex8_3.m
% plots Figure 8.20

clc, clear all, close all

T=1e-6;
tau=25e-6;
w_nyq=pi/T;
w_low=1e3; w_high=w_nyq;
w=linspace(w_low,w_high,1000);
H=1./(1+j*w*tau);
MagH=abs(H);
GainH=20*log10(MagH);
PhaseH=angle(H)*180/pi;

subplot(2,1,1)
semilogx(w,GainH,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[1e3 1e4 1e5 1e6],'YTick',[-60:20:0])
axis([w_low w_high -60 2])
hold on
ylabel('Gain  (db)','FontSize',13)
wT=w*T;
c1=1+(wT.^2)/12; 
H_asym=1./(j*w*tau.*c1+1);
MagH_asym=abs(H_asym);
GainH_asym=20*log10(MagH_asym);
PhaseH_asym=angle(H_asym)*180/pi;
semilogx(w,GainH_asym,'r','LineWidth',1.3)
c2=exp(j*w*T);
c3=T/tau;
H_exact=c3*(c2+1)./((2+c3)*c2-(2-c3));
MagH_exact=abs(H_exact);
GainH_exact=20*log10(MagH_exact);
PhaseH_exact=angle(H_exact)*180/pi;
semilogx(w,GainH_exact,'k','LineWidth',1.3)
text(4.65e5,-18,'continuous','FontSize',11)
plot([1.9e6 2.5e6],[-18.3 -18.3],'k')
plot([2.5e6 2.5e6],[-18.3 -35.92],'k')
text(1e5,-41,'discrete (asymptotic)','FontSize',11)
plot([1.4e6 10^6.45],[-41.3 -41.3],'k')
text(2e5,-50,'discrete (exact)','FontSize',11)
plot([1.5e6 10^6.453],[-50.3 -50.3],'k')
title('Gain of Continuous-time and Discrete-time Frequency Response Functions','FontSize',11)
text(1.25e3,-15,'Trapezoidal Integration of','FontSize',11) 
text(1.25e3,-24,'first-order Order System','FontSize',11)
text(1.25e3,-39, 'H(s) = 1/(\taus + 1),   \tau = 25 \mus','FontSize',11)
text(1.25e3,-51,'T = 1 \mus','FontSize',11)

subplot(2,1,2)
semilogx(w,PhaseH,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[1e3 1e4 1e5 1e6],'YTick',[-90:15:0])
hold on
axis([w_low w_high -95 5])
semilogx(w,PhaseH_asym,'r','LineWidth',1.3)
semilogx(w,PhaseH_exact,'k','LineWidth',1.3)
xlabel('\omega  (rad/s)','FontSize',13)
ylabel('Phase  (deg)','FontSize',13)
title('Phase of Continuous-time and Discrete-time Frequency Response Functions','FontSize',11)
text(4e4,-20,'continuous','FontSize',11)
plot([10^4.17 3.5e4],[-20.6 -20.6],'k')
text(6.5e4,-40,'discrete (asymptotic)','FontSize',11)
plot([10^4.535 5.7e4],[-40.6 -40.6],'k')
text(1.45e5,-60,'discrete (exact)','FontSize',11)
plot([10^4.86 1.25e5],[-60.6 -60.6],'k')

clear all
T=1e-6;
tau=25e-6;
w=2e5*pi;
H=1/(tau*j*w+1)
MagH=abs(H)  
PhaseH=angle(H)
PhaseH_deg=angle(H)*180/pi 
wT=w*T;
c1=1+(wT^2)/12; 
H_asym=1/(j*w*tau*c1+1);
MagH_asym=abs(H_asym) 
PhaseH_asym=angle(H_asym) 
PhaseH_asym_deg=angle(H_asym)*180/pi 
fge=(MagH_asym/MagH)-1
phase_error=(PhaseH_asym-PhaseH)
phase_error_deg=PhaseH_asym_deg-PhaseH_deg 
