% m-file Ch8_Ex8_4.m
% plots Figure 8.24 and Figure 8.25

clc, close all, clear all

%%%%% plot AB-2 stability boundary %%%%%
theta=linspace(0,2*pi,2000); 
x=exp(j*theta); 
lamT=2*(x-x.^2)./(1-3*x); 

figure(1) % plot Figure 8.24
subplot(1,2,1)
plot(lamT,'b','LineWidth',1.3)
grid on
axis([-10e-3 2e-3 -0.45 0.45])
set(gca,'FontSize',11,'XTick',[-10e-3:5e-3:0],'YTick',[-0.4:0.1:0.4])
text(-15.2e-3,0.50,'Close-up of Stability Boundary for AB-2 Integrator Near Origin of \lambda\itT\rm Plane','FontSize',12)
text(-7.5e-3,0.02,'\lambdaT Plane','FontSize',13)
xlabel('Re (\lambdaT)','FontSize',13)
ylabel('Im (\lambdaT)','FontSize',13)

subplot(1,2,2)
plot(lamT,'b','LineWidth',1.3)
grid on
axis([-7e-7 0.1e-6 -0.045 0.045])
set(gca,'FontSize',11,'XTick',[-6e-7:2e-7:0],'YTick',[-0.04:0.01:0.04])
text(-5e-7,0.002,'\lambdaT Plane','FontSize',13)
xlabel('Re (\lambda\itT)','FontSize',13)
ylabel('Im (\lambda\itT)','FontSize',13)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear lamT
z=[1  sqrt(2)*(1+j)/2  j  -1 exp(j*4*pi/3)  -j  sqrt(2)*(1-j)/2]; 
lamT=2*(z-z.^2)./(1-3*z);
Mag_lamT=abs(lamT); 
Arg_lamT=angle(lamT);  
Arg_lamT_deg=Arg_lamT*180/pi;  

clear lamT
theta=angle(z);
x=exp(j*theta);
lamT=(4*x-x.^2-3)./(5-3*cos(theta));
Re_num=4*sin(theta)-sin(2*theta); 
Im_num=4*cos(theta)-cos(2*theta)-3; 
Arg_lamT=atan2(Im_num,Re_num);
a=Re_num./(5-3*cos(theta));
b=Im_num./(5-3*cos(theta));
Arg_lamT=Arg_lamT*180/pi;
n=1-cos(theta);
d=5-3*cos(theta);
M=2*sqrt(n./d);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% wnT=0.75 
% wnTsq=wnT.^2;
% zpoles=roots([1 -2 1+2.25*wnTsq -1.5*wnTsq 0.25*wnTsq]) 
% Mag_zpoles=abs(zpoles)
figure(2) % plot Figure 8.25

for i=1:40
    wnT=0.025*i;
    wnTsq=wnT^2;
    zpoles=roots([1 -2 1+2.25*wnTsq -1.5*wnTsq 0.25*wnTsq]);
    z1(i)=zpoles(1);
    z2(i)=zpoles(2);
    z3(i)=zpoles(3);
    z4(i)=zpoles(4);
end
hold on
del=2;
plot(z1(2:del:end),'b.','MarkerSize',8)
grid on
set(gca,'FontSize',11,'XTick',[-1:0.5:1],'YTick',[-1:0.25:1])
axis([-1.1 1.1 -1.1 1.1])
axis equal
plot(z2(2:del:end),'r.','MarkerSize',8)
del=5;
plot(z3(2:del:end),'m.','MarkerSize',8)
plot(z4(2:del:end),'k.','MarkerSize',8)

plot(z1(12),'b*','MarkerSize',8)
plot(z2(12),'r*','MarkerSize',8)
plot(z3(12),'m*','MarkerSize',8)
plot(z4(12),'k*','MarkerSize',8)
phi=linspace(0,2*pi, 1000);
x=cos(phi);
y=sin(phi);
plot(x,y,'k','LineWidth',1.2)
plot([-2 2],[0 0],'k')
plot([0 0],[-2 2],'k')
text(-1.1,0.9,'z-plane','FontSize',13)
xlabel('Re (z)','FontSize',13)
ylabel('Im (z)','FontSize',13)
text(-1.85,1.20,'Locus of z-plane Poles z_1, z_2, z_3,z_4, for AB-2 Simulation of System x + \omega^2_nx = u','FontSize',12)
text(1.227,1.3,'..','FontSize',14)
text(1.03,0.33,'\omega_nT = 0.3','FontSize',11)
text(1.03,-0.33,'\omega_nT = 0.3','FontSize',11)
text(0.85,0.8,'z_1 locus','FontSize',12)
text(0.85,-0.8,'z_2 locus','FontSize',12)
text(0.2,0.3,'z_3 locus','FontSize',12)
text(0.2,-0.3,'z_4 locus','FontSize',12)
text(-1.25,-0.85,'Unit Circle','FontSize',13)