% m-file Ch8_Ex8_5.m
% plots Figure 8.28 and Figure 8.29

clc, close all, clear all

Q=25;
V=150;
c0=5;
c1=60;
tau=V/Q;
tfinal=5*tau;

%%%%% AM-2 %%%%%
T=1.5*tau;
nfinal=round(tfinal/T)+1;
alpha=(1-0.5*T/tau)/(1+0.5*T/tau);
beta=(T/tau)/(1+0.5*T/tau);
t(1)=0;
cA(1)=c0;
for n=2:nfinal
    t(n)=(n-1)*T;
    cA(n)=alpha*cA(n-1)+beta*c1;
end

figure(1) % plot Figure 8.28
subplot(2,2,1)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(7.5,14.5,'T = 1.5\tau = 9 min','FontSize',13)
ylabel('Concentration  (mg/m^3)','FontSize',12)
text(5,76,'Analytical and Simulated (AM-2) Concentration Responses','FontSize',12)

T=1.25*tau;
nfinal=round(tfinal/T)+1;
alpha=(1-0.5*T/tau)/(1+0.5*T/tau);
beta=(T/tau)/(1+0.5*T/tau);
t(1)=0;
cA(1)=c0;
for n=2:nfinal
    t(n)=(n-1)*T;
    cA(n)=alpha*cA(n-1)+beta*c1;
end

subplot(2,2,2)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(5,14.5,'T = 1.25\tau = 7.5 min','FontSize',13)
ylabel('Concentration  (mg/m^3)','FontSize',12)

T=1*tau;
nfinal=round(tfinal/T)+1;
alpha=(1-0.5*T/tau)/(1+0.5*T/tau);
beta=(T/tau)/(1+0.5*T/tau);
t(1)=0;
cA(1)=c0;
for n=2:nfinal
    t(n)=(n-1)*T;
    cA(n)=alpha*cA(n-1)+beta*c1;
end


subplot(2,2,3)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(7.5,14.5,'T = \tau = 6 min','FontSize',13)
xlabel('t  (min)','FontSize',12)
ylabel('Concentration  (mg/m^3)','FontSize',12)

T=0.75*tau;
nfinal=round(tfinal/T)+1;
alpha=(1-0.5*T/tau)/(1+0.5*T/tau);
beta=(T/tau)/(1+0.5*T/tau);
t(1)=0;
cA(1)=c0;
for n=2:nfinal
    t(n)=(n-1)*T;
    cA(n)=alpha*cA(n-1)+beta*c1;
end

subplot(2,2,4)

plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
axis([0 tfinal 0 65])
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
set(gca,'FontSize',11)
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(5,14.5,'T = 0.75\tau = 4.5 min','FontSize',13)
xlabel('t  (min)','FontSize',12)
ylabel('Concentration  (mg/m^3)','FontSize',12)


%%%%% AM-3 %%%%%
clear t cA 
T=1.5*tau;
nfinal=round(tfinal/T)+1;
alpha=12*(tau/T)+5;
beta=12*(tau/T)-8;
t(1)=0;
cA(1)=c0;
t(2)=T;
cA(2)=c0*exp(-T/tau)+c1*(1-exp(-T/tau));
for n=3:nfinal
    t(n)=(n-1)*T;
    cA(n)=(beta*cA(n-1)+cA(n-2)+12*c1)/alpha;
end

figure(2) % plot Figure 8.30
subplot(2,2,1)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
ylabel('Concentration  (mg/m^3)','FontSize',12)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(7.5,14.5,'T = 1.5\tau = 9 min','FontSize',13)
text(5,76,'Analytical and Simulated (AM-3) Concentration Responses','FontSize',12)

clear t cA 
T=1.25*tau;
nfinal=round(tfinal/T)+1;
alpha=12*(tau/T)+5;
beta=12*(tau/T)-8;
t(1)=0;
cA(1)=c0;
t(2)=T;
cA(2)=c0*exp(-T/tau)+c1*(1-exp(-T/tau));
for n=3:nfinal
    t(n)=(n-1)*T;
    cA(n)=(beta*cA(n-1)+cA(n-2)+12*c1)/alpha;
end

subplot(2,2,2)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(5,14.5,'T = 1.25\tau = 7.5 min','FontSize',13)
ylabel('Concentration  (mg/m^3)','FontSize',12)

clear t cA 
T=1*tau;
nfinal=round(tfinal/T)+1;
alpha=12*(tau/T)+5;
beta=12*(tau/T)-8;
t(1)=0;
cA(1)=c0;
t(2)=T;
cA(2)=c0*exp(-T/tau)+c1*(1-exp(-T/tau));
for n=3:nfinal
    t(n)=(n-1)*T;
    cA(n)=(beta*cA(n-1)+cA(n-2)+12*c1)/alpha;
end

subplot(2,2,3)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
axis([0 tfinal 0 65])
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
xlabel('t  (min)','FontSize',12)
plot(ti,ci,'b','LineWidth',1.3)
ylabel('Concentration  (mg/m^3)','FontSize',12)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(7.5,14.5,'T = \tau = 6 min','FontSize',13)

clear t cA 
T=0.75*tau;
nfinal=round(tfinal/T)+1;
alpha=12*(tau/T)+5;
beta=12*(tau/T)-8;
t(1)=0;
cA(1)=c0;
t(2)=T;
cA(2)=c0*exp(-T/tau)+c1*(1-exp(-T/tau));
for n=3:nfinal
    t(n)=(n-1)*T;
    cA(n)=(beta*cA(n-1)+cA(n-2)+12*c1)/alpha;
end

subplot(2,2,4)
plot(t(1:end),cA(1:end),'.r','MarkerSize',10)
grid on
axis([0 tfinal 0 65])
set(gca,'XTick',[0:5:30])
set(gca,'YTick',[0:10:60])
set(gca,'FontSize',11)
hold on
ti=linspace(0,tfinal,1000);
ci=c0*exp(-ti/tau)+c1*(1-exp(-ti/tau));
plot(ti,ci,'b','LineWidth',1.3)
text(7.5,33.5,'\tau = 6 min','FontSize',13)
text(5,14.5,'T = 0.75\tau = 4.5 min','FontSize',13)
xlabel('t  (min)','FontSize',12)
ylabel('Concentration  (mg/m^3)','FontSize',12)


















