% m-file Ch8_Ex8_7.m
% calls Simulink model speed_control.mdl
% plots Figures 8.34 - 8.37
clc, close all, clear all

a=2; b=5;

%%%%% RK-2 %%%%%
K1=100; K2=250;
T1=0.025; T2=0.10;
TFinal(1:3)=2; TFinal(4)=3;
i=0;
for K=[K1 K2]
   for T=[T1 T2] 
       i=i+1;
       r=roots([1 a+b a*b+K]);  
       lamT1=r(1)*T ;
       TIMESPAN=[0 TFinal(i)];
       OPTIONS=simset('Solver','ode2','FixedStep',T);
       sim('speed_control',TIMESPAN,OPTIONS) 
       
       %%%%% exact solution %%%%%
       ti=linspace(0,TFinal(i),1000);
       wn=sqrt(a*b+K);  
       zeta=(a+b)/(2*wn);  
       wd=sqrt(1-zeta^2)*wn;
       phi=atan(wd/(zeta*wn));
       Kss=K/wn^2;
       vi=Kss*(1-(wn/wd)*exp(-zeta*wn*ti).*sin(wd*ti+phi));
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       
       figure(1) % plot Figure 8.34
       subplot(2,2,i)
       plot(ti,vi,'b','LineWidth',1.3)
       grid on
       set(gca,'FontSize',11,'XTick',[0:0.5:2],'YTick',[0:0.25:1.5])
       hold on
              
       switch i
           case 1
               del1=1; end1=21;
               plot(tout(1:del1:end1),vout(1:del1:end1),'r.','MarkerSize',7)
               del2=3; 
               plot(tout(end1:del2:end),vout(end1:del2:end),'r.','MarkerSize',7)           
               text(0.30,1.65,'K = 100, T = 0.025 s','FontSize',12)
               ylabel('v  (ft/s)','FontSize',12)
               text(1,1.20,'RK-2','FontSize',12)
               text(0.19,0.62,'\omega_n = 10.49 rad/s, \zeta=0.33','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j9.8869','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.0875+j0.2472','FontSize',11)
               
           case 2               
               plot(tout(1:end),vout(1:end),'r.','MarkerSize',7)               
               text(0.30,1.65,'K = 100, T = 0.1 s','FontSize',12)
               text(1,1.20,'RK-2','FontSize',12)
               text(0.19,0.62,'\omega_n = 10.49 rad/s, \zeta=0.33','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j9.8869','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.35+j0.9887','FontSize',11)
%                 
           case 3
               del1=1; end1=21;
               plot(tout(1:del1:end1),vout(1:del1:end1),'r.','MarkerSize',7)
               grid on
               axis([0 2 0 1.5])               
               del2=3; 
               plot(tout(end1:del2:end),vout(end1:del2:end),'r.')                
               text(0.30,1.65,'K = 250, T = 0.025 s','FontSize',12) 
               xlabel('t  (s)','FontSize',12)
               ylabel('v  (ft/s)','FontSize',12)
               text(1,1.20,'RK-2','FontSize',12)
               text(0.19,0.62,'\omega_n = 16.12 rad/s, \zeta=0.22','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j15.7401','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.0875+j0.3935','FontSize',11)
                                
           case 4               
               plot(tout(1:end),vout(1:end),'r.:','MarkerSize',7)
               grid on
               axis([0 3 -50 100])
               set(gca,'FontSize',11,'XTick',[0:0.5:3],'YTick',[-50:25:100])
                
               xlabel('t  (s)','FontSize',12)
               text(1,82,'RK-2','FontSize',12)
               text(0.5,115,'K = 250, T = 0.1 s','FontSize',12) 
               text(0.1,54,'\omega_n = 16.12 rad/s, \zeta = 0.22','FontSize',11)               
               text(0.1,30,'\lambda = -3.5+j15.7401','FontSize',11) 
               text(0.1,-25,'\lambdaT = -0.35+j1.5740','FontSize',11)
       end    
  
   end % T   
end % K

%%%% RK-4 %%%%%
figure(2) % plot Figure 8.35
K1=100; K2=250;
T1=0.1; T2=0.20;
TFinal(1:3)=2; TFinal(4)=2;
i=0;
for K=[K1 K2]
   for T=[T1 T2] 
       i=i+1; 
       r=roots([1 a+b a*b+K])  
       lamT1=r(1)*T  
       TIMESPAN=[0 TFinal(i)];
       OPTIONS=simset('Solver','ode4','FixedStep',T);
       sim('speed_control',TIMESPAN,OPTIONS) 
       
       %%%%% exact solution %%%%%
       ti=linspace(0,TFinal(i),1000);
       wn=sqrt(a*b+K)  
       zeta=(a+b)/(2*wn)  
       wd=sqrt(1-zeta^2)*wn;
       phi=atan(wd/(zeta*wn));
       Kss=K/wn^2;
       vi=Kss*(1-(wn/wd)*exp(-zeta*wn*ti).*sin(wd*ti+phi));
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       
       subplot(2,2,i)
       plot(ti,vi,'b','LineWidth',1.3)
       grid on
       set(gca,'FontSize',11,'XTick',[0:0.5:2])
       hold on
              
       switch i
           case 1
               del1=1; end1=21;
               plot(tout(1:del1:end1),vout(1:del1:end1),'r.','MarkerSize',7)
               del2=1; 
               plot(tout(end1:del2:end),vout(end1:del2:end),'r.')
               axis([0 2 0 1.5])
               set(gca,'YTick',[0:0.25:1.5])
               text(0.3,1.65,'K = 100, T = 0.1 s','FontSize',12)
               ylabel('v  (ft/s)','FontSize',12)
               text(1,1.25,'RK-4','FontSize',12)
               text(0.19,0.62,'\omega_n =10.49 rad/s, \zeta = 0.34','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j9.8869','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.35+j0.9887','FontSize',11)
               
           case 2
               plot(tout(1:end),vout(1:end),'r.','MarkerSize',7)
               axis([0 2 0 1.5])
               set(gca,'YTick',[0:0.25:1.5])
               text(0.3,1.65,'K = 100, T = 0.2 s','FontSize',12)
               text(1,1.25,'RK-4','FontSize',12)
               text(0.19,0.62,'\omega_n =10.49 rad/s, \zeta = 0.34','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j9.8869','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.7+j1.9774','FontSize',11)
           
           case 3
               
               plot(tout(1:end),vout(1:end),'r.','MarkerSize',7)
               axis([0 2 0 1.5])
               set(gca,'YTick',[0:0.25:1.5])
               text(0.3,1.65,'K = 250, T = 0.1 s','FontSize',12) 
               xlabel('t  (s)','FontSize',12)
               ylabel('v  (ft/s)','FontSize',12)
               text(1,1.25,'RK-4','FontSize',12)
               text(0.19,0.62,'\omega_n =16.12 rad/s, \zeta = 0.22','FontSize',11) 
               text(0.19,0.37,'\lambda = -3.5+j15.7401','FontSize',11) 
               text(0.19,0.12,'\lambdaT = -0.35+j1.5740','FontSize',11)         
          
           case 4               
               
               plot(tout(1:end),vout(1:end),'r.:','MarkerSize',7)
               axis([0 2 -600 200])
               set(gca,'YTick',[-600:200:200])
               text(0.3,280,'K = 250, T = 0.2 s','FontSize',12) 
               xlabel('t  (s)','FontSize',12)
               text(1,100,'RK-4','FontSize',12)
               text(0.05,-225,'\omega_n =16.12 rad/s, \zeta = 0.22','FontSize',11) 
               text(0.10,-375,'\lambda = -3.5+j15.7401','FontSize',11) 
               text(0.10,-525,'\lambdaT = -0.7+j3.1480','FontSize',11)     
       end    
  
   end % T   
end % K

%%%%% Part d) %%%%%

figure(3) % plots Figure 8.36
phi_des=atan(15.7401/(-3.5))+pi  
phi_des_deg=phi_des*180/pi
num=5000;
for i=1:num+1
   theta=((i-1)/num)*2*pi; 
   % theta_deg=theta*180/pi;
   x=exp(j*theta);
   r=roots([1/6 1/2 1 1-x]); 
   lamT_RK3_1(i)=r(1);       
   lamT_RK3_2(i)=r(2); 
   
   r1=r(1);
   phi=angle(r1);
   if abs(phi_des-phi)<0.0001
     lamT_des=r1;
     Arg_lamT_des=angle(lamT_des);
     Arg_lamT_des_deg=Arg_lamT_des*180/pi;
     Mag_lamT_des=abs(lamT_des);
     Real_lamT_des=real(lamT_des);
     Imag_lamT_des=imag(lamT_des);      
   end  
   
   lamT_RK3_3(i)=r(3);
end
% lamT_RK3_3;
lamT_RK3_3=lamT_RK3_3(2:round(num/2)+1);
% lamT_RK3_2;
lamT_RK3_2=lamT_RK3_2(1:round(num/2)+1);
% lamT_RK3_1; 
lamT_RK3_1=lamT_RK3_1(round(num/2)+2:num);
% plot(lamT_RK3_1,'*b-')
% plot(lamT_RK3_2,'*r-')
% plot(lamT_RK3_3,'*g-')
lamT_RK3=[0 lamT_RK3_3 lamT_RK3_1 lamT_RK3_2];
plot(lamT_RK3,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[-3:0.5:0.5],'YTick',[0:0.5:2.5])
axis([-3 0.75 0 2.75])
hold on
grid on
text(-3.2,2.85,'Stability Boundary for RK-3 Integrator and Locus of \lambda\itT \rmPoints for System','FontSize',11)
text(-2.5,2.08,'\lambdaT Plane','FontSize',13)
xlabel('Re(\lambdaT)','FontSize',13)
ylabel('Im(\lambdaT)','FontSize',13)
plot([0 -3.5],[0 15.7401],'r','LineWidth',1.3)
plot(lamT_des,'k.','MarkerSize',15)
text(-2.20,0.75,'Ray: \lambdaT = (-3.5+j15.7401)T','FontSize',13)
plot([-0.4 -0.167],[0.75 0.75],'k','LineWidth',1.1)
text(-0.45,2.4,'-0.5198+\itj\rm2.3386','FontSize',13)

TIMESPAN=[0 4];
T=0.1485;
OPTIONS=simset('Solver','ode3','FixedStep',T);
sim('speed_control',TIMESPAN,OPTIONS)

figure(4) % plots Figure 8.37
plot(tout,vout,'r.','MarkerSize',13)
grid on
hold on
axis([0 4 0 2.5])
set(gca,'FontSize',11,'XTick',[0:0.5:4],'YTick',[0:0.25:2.5])
plot(tout,vout,'k--','LineWidth',0.5)
ti=linspace(0,4,1000);
vi=Kss*(1-(wn/wd)*exp(-zeta*wn*ti).*sin(wd*ti+phi));
plot(ti,vi,'b','LineWidth',1.3)
xlabel('t  (s)','FontSize',13)
ylabel('v  (ft/s)','FontSize',13)
text(-0.6,2.65,'Analytical Solution and RK-3 Simulated Response with \lambdaT on Stability Boundary','FontSize',12)
text(1.0,2.32,'v(n),  RK-3 simulated response','FontSize',13)
plot(0.8,2.3,'.r','MarkerSize',13)
text(1.0,2.07,'v(t),  Analytical solution','FontSize',13)
plot([0.7 0.9],[2.05 2.05],'b','LineWidth',1.3)