% m-file Ch8_Ex8_9.m
% plots Figure 8.74 and Figure 8.75

clear all, close all, clc

lambda=-0.25;
tfinal=-5/lambda;
u=1;

figure(1) % plot Figure 8.74
%%%%% Part a)  modified Euler
T=-0.25/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
ta(1)=0;
xa(1)=0;
for n=1:nfinal
   ta(n+1)=n*T;
   xa(n+1)=(1+lamT*(1+0.5*lamT))*xa(n)+T*(0.5*lamT*u+u);
end % for

subplot(3,1,1)
%%%%% exact solution x(t)
ti=linspace(0,tfinal,1000);
xi=(exp(lambda*ti)-1)/lambda;

plot(ti,xi,'b','LineWidth',1.3)
grid on
axis([0 tfinal 0 4.2])
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
hold on
plot(ta,xa,'.r','MarkerSize',10)
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'Modified Euler (RK-2), \lambdaT = -0.25','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)

%%%%% Part b) AB-2
T=-0.125/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
tb(1)=0;
xb(1)=0;
tb(2)=T;

%%first step with Improved Euler
x_hat=xb(1)+T*(lambda*xb(1)+u);
xb(2)=xb(1)+0.5*T*((lambda*xb(1)+u)+(lambda*x_hat+u));
for n=2:nfinal  
   tb(n+1)=n*T;
   xb(n+1)=(1+1.5*lamT)*xb(n)-0.5*lamT*xb(n-1)+1.5*T*u-0.5*T*u;     
end % for

subplot(3,1,2)
plot(ti,xi,'b','LineWidth',1.3)
grid on
axis([0 tfinal 0 4.2])
hold on
plot(tb,xb,'r.','MarkerSize',10)
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'AB-2, \lambdaT = -0.25','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)

%%%%% Part c) real-time predictor-corrector
T=-0.25/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
tc(1)=0;
xc(1)=0;
tc(2)=T;

%% first step with Improved Euler
x_hat=xc(1)+T*(lambda*xc(1)+u);
xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
a=1+lamT*(1+0.625*lamT);
for n=2:nfinal
   tc(n+1)=n*T;    
   xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
end % for

subplot(3,1,3)
plot(ti,xi,'b','LineWidth',1.3)
grid on
axis([0 tfinal 0 4.2])
hold on
plot(tc,xc,'r.','MarkerSize',10)
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
xlabel('t','FontSize',13)
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'Real-time predictor-corrector, \lambdaT = -0.25','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)


figure(2) % plot Figure 8.75
hold on
clear ta xa tb xb tc xc xhat

%%%%% Part a)  modified Euler
T=-1/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
ta(1)=0;
xa(1)=0;
for n=1:nfinal
   ta(n+1)=n*T;
   xa(n+1)=(1+lamT*(1+0.5*lamT))*xa(n)+T*(0.5*lamT*u+u);
end % for

subplot(3,1,1)
plot(ta,xa,'.r','MarkerSize',10)
grid on
axis([0 tfinal 0 4.2])
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
hold on
plot(ti,xi,'b','LineWidth',1.3)
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'Modified Euler (RK-2), \lambdaT = -1','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)

%%%%% Part b) AB-2
T=-0.5/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
tb(1)=0;
xb(1)=0;
tb(2)=T;

%%first step with Improved Euler
x_hat=xb(1)+T*(lambda*xb(1)+u);
xb(2)=xb(1)+0.5*T*((lambda*xb(1)+u)+(lambda*x_hat+u));
for n=2:nfinal  
   tb(n+1)=n*T;
   xb(n+1)=(1+1.5*lamT)*xb(n)-0.5*lamT*xb(n-1)+1.5*T*u-0.5*T*u;     
end % for

subplot(3,1,2)
plot(tb,xb,'.r','MarkerSize',10)
grid on
axis([0 tfinal 0 4.2])
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
hold on
plot(ti,xi,'b','LineWidth',1.3)
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'AB-2, \lambdaT = -0.5','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)

%%%%% Part c) real-time predictor-corrector
T=-1/lambda;
nfinal=round(tfinal/T);
lamT=lambda*T;
tc(1)=0;
xc(1)=0;
tc(2)=T;

x_hat=xc(1)+T*(lambda*xc(1)+u);
xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
a=1+lamT*(1+0.625*lamT);
for n=2:nfinal
   tc(n+1)=n*T;    
   xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
end % for

% first step with Improved Euler
x_hat=xc(1)+T*(lambda*xc(1)+u);
xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
a=1+lamT*(1+0.625*lamT);
for n=2:nfinal
   tc(n+1)=n*T;    
   xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
end % for

subplot(3,1,3)
plot(ti,xi,'b','LineWidth',1.3)
grid on
axis([0 tfinal 0 4.1])
hold on
plot(tc,xc,'r.','MarkerSize',10)
set(gca,'FontSize',11,'XTick',[0:4:20],'YTick',[0:1:4])
xlabel('t','FontSize',13)
text(8,2.65,'\lambda = -0.25','FontSize',12)
text(6,1.65,'Real-time predictor-corrector, \lambdaT = -1','FontSize',12)
plot(5.5,1.60,'r.','MarkerSize',10)
text(6,0.65,'Exact','FontSize',12)
plot([5.2 5.8],[0.63 0.63],'b','LineWidth',1.3)

























% figure(2) % plot Figure 8.75
hold on
clear ta xa tb xb tc xc xhat
%%%%% Part a)  modified Euler
% T=-0.5/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% ta(1)=0;
% xa(1)=0;
% for n=1:nfinal
%    ta(n+1)=n*T;
%    xa(n+1)=(1+lamT*(1+0.5*lamT))*xa(n)+T*(0.5*lamT*u+u);
% end % for
% plot(ta,xa,'.b','MarkerSize',5)
% 
% %%%%% Part b) AB-2
% T=-0.25/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tb(1)=0;
% xb(1)=0;
% tb(2)=T;
% %% first step with Improved Euler
% x_hat=xb(1)+T*(lambda*xb(1)+u);
% xb(2)=xb(1)+0.5*T*((lambda*xb(1)+u)+(lambda*x_hat+u));
% for n=2:nfinal  
%    tb(n+1)=n*T;
%    xb(n+1)=(1+1.5*lamT)*xb(n)-0.5*lamT*xb(n-1)+1.5*T*u-0.5*T*u;     
% end % for
% plot(tb,xb,'sr','MarkerSize',3)
% 
% %%%%% Part c) real-time predictor-corrector
% T=-0.5/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tc(1)=0;
% xc(1)=0;
% tc(2)=T;
% %% first step with Improved Euler
% x_hat=xc(1)+T*(lambda*xc(1)+u);
% xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
% a=1+lamT*(1+0.625*lamT);
% for n=2:nfinal
%    tc(n+1)=n*T;    
%    xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
% end % for
% plot(tc,xc,'og','MarkerSize',5)
% 
% %%%%% exact solution x(t)
% ti=linspace(0,tfinal,1000);
% xi=(exp(lambda*ti)-1)/lambda;
% plot(ti,xi,'k')
% 
% xlabel('\itt','FontSize',11)
% ylabel('\itx\rm(\itt\rm)')
% title('Step Response with Modified Euler, AB-2, Real-time Predictor Corrector','FontSize',11)
% legend('Modified Euler (RK-2), \lambda\itT \rm= -0.5','AB-2, \lambda\itT \rm= -0.25','Real-time predictor-corrector, \lambda\itT \rm= -0.5','Exact',4)
% text(11,2,'\lambda = -0.25','FontSize',11)

% 
% figure(3)
% hold on
% clear ta xa tb xb tc xc xhat
% %%%%% Part a)  modified Euler
% T=-0.75/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% ta(1)=0;
% xa(1)=0;
% for n=1:nfinal
%    ta(n+1)=n*T;
%    xa(n+1)=(1+lamT*(1+0.5*lamT))*xa(n)+T*(0.5*lamT*u+u);
% end % for
% plot(ta,xa,'.b','MarkerSize',5)
% 
% %%%%% Part b) AB-2
% T=-0.375/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tb(1)=0;
% xb(1)=0;
% tb(2)=T;
% %% first step with Improved Euler
% x_hat=xb(1)+T*(lambda*xb(1)+u);
% xb(2)=xb(1)+0.5*T*((lambda*xb(1)+u)+(lambda*x_hat+u));
% for n=2:nfinal  
%    tb(n+1)=n*T;
%    xb(n+1)=(1+1.5*lamT)*xb(n)-0.5*lamT*xb(n-1)+1.5*T*u-0.5*T*u;     
% end % for
% plot(tb,xb,'sr','MarkerSize',3)
% 
% %%%%% Part c) real-time predictor-corrector
% T=-0.75/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tc(1)=0;
% xc(1)=0;
% tc(2)=T;
% %% first step with Improved Euler
% x_hat=xc(1)+T*(lambda*xc(1)+u);
% xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
% a=1+lamT*(1+0.625*lamT);
% for n=2:nfinal
%    tc(n+1)=n*T;    
%    xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
% end % for
% plot(tc,xc,'og','MarkerSize',5)
% 
% %%%%% exact solution x(t)
% ti=linspace(0,tfinal,1000);
% xi=(exp(lambda*ti)-1)/lambda;
% plot(ti,xi,'k')
% 
% xlabel('\itt','FontSize',11)
% ylabel('\itx\rm(\itt\rm)')
% title('Step Response with Modified Euler, AB-2, Real-time Predictor Corrector','FontSize',11)
% legend('Modified Euler (RK-2), \lambda\itT \rm= -0.75','AB-2, \lambda\itT \rm= -0.375','Real-time predictor-corrector, \lambda\itT \rm= -0.75','Exact',4)
% text(11,2,'\lambda = -0.25','FontSize',11)
% 
% figure(4) 
% hold on
% clear ta xa tb xb tc xc xhat
% %%%%% Part a)  modified Euler
% T=-1/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% ta(1)=0;
% xa(1)=0;
% for n=1:nfinal
%    ta(n+1)=n*T;
%    xa(n+1)=(1+lamT*(1+0.5*lamT))*xa(n)+T*(0.5*lamT*u+u);
% end % for
% plot(ta,xa,'.b','MarkerSize',5)
% 
% %%%%% Part b) AB-2
% T=-0.5/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tb(1)=0;
% xb(1)=0;
% tb(2)=T;
% %% first step with Improved Euler
% x_hat=xb(1)+T*(lambda*xb(1)+u);
% xb(2)=xb(1)+0.5*T*((lambda*xb(1)+u)+(lambda*x_hat+u));
% for n=2:nfinal  
%    tb(n+1)=n*T;
%    xb(n+1)=(1+1.5*lamT)*xb(n)-0.5*lamT*xb(n-1)+1.5*T*u-0.5*T*u;     
% end % for
% plot(tb,xb,'sr','MarkerSize',4,'MarkerFaceColor','r')
% 
% %%%%% Part c) real-time predictor-corrector
% T=-1/lambda;
% nfinal=round(tfinal/T);
% lamT=lambda*T;
% tc(1)=0;
% xc(1)=0;
% tc(2)=T;
% %% first step with Improved Euler
% x_hat=xc(1)+T*(lambda*xc(1)+u);
% xc(2)=xc(1)+0.5*T*((lambda*xc(1)+u)+(lambda*x_hat+u));
% a=1+lamT*(1+0.625*lamT);
% for n=2:nfinal
%    tc(n+1)=n*T;    
%    xc(n+1)=a*xc(n)-0.125*(lamT^2)*xc(n-1)+lamT*(0.625*T*u-0.125*T*u)+T*u;
% end % for
% plot(tc,xc,'dg','MarkerSize',4,'MarkerFaceColor','g')
% 
% %%%%% exact solution x(t)
% ti=linspace(0,tfinal,1000);
% xi=(exp(lambda*ti)-1)/lambda;
% plot(ti,xi,'k')
% 
% xlabel('\itt','FontSize',11)
% ylabel('\itx\rm(\itt\rm)','FontSize',11)
% title('Step Response (Modified Euler, AB-2, Real-time Predictor-Corrector and Exact)','FontSize',11)
% text(7,1.5,'Modified Euler (RK-2), \lambda\itT \rm= -1','FontSize',11)
% plot(6,1.5,'.b','MarkerSize',5)
% axis([0 tfinal 0 4.1])
% text(7,1.2,'AB-2, \lambda\itT \rm= -0.5','FontSize',11)
% plot(6,1.2,'rs','MarkerSize',4,'MarkerFaceColor','r')
% text(7,0.9,'Real-time predictor-corrector, \lambda\itT \rm= -1','FontSize',11)
% plot(6,0.9,'dg','MarkerSize',4,'MarkerFaceColor','g')
% text(7,0.6,'Exact','FontSize',11)
% plot([5.6 6.4],[0.6 0.6],'k')
% text(7,2,'\lambda = -0.25','FontSize',11)
