% m-file Ch8_Fig2_1.m
% plots Figure 8.1

clc; close all; clear all

lambda_c=-2; % characteristic root of continuous system
T=0.05; % step size
lambda_e=log(1+lambda_c*T)/T; % characteristic root of equivalent system
tfinal=-5*(1/lambda_c);
nfinal=round(tfinal/T);
ni=0:nfinal;
z1=1+lambda_c*T;
xAi=(1/lambda_c)*((z1.^ni)-1);
ti=ni*T;
plot(ti,xAi,'.r','MarkerSize',10)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.25:2.5])
set(gca,'YTick',[0:0.05:0.5])
axis([0 tfinal 0 1.05*(-1/lambda_c)])
hold on
K=lambda_e/lambda_c;
nfinal=round(tfinal/T);
delt=0.005;
ti=0:delt:tfinal;
xci=(1/lambda_c).*(exp(lambda_c*ti)-1);
xei=(K/lambda_e).*(exp(lambda_e*ti)-1);
plot(ti,xci,'b','LineWidth',1.3)
plot(ti,xei,'k','LineWidth',1.3)
xlabel('t  (s)','FontSize',13)
title({'Continuous-time, Discrete-time and' 'Equivalent Continuous-time System Responses'},'FontSize',11)

text(0.45,0.16,'x_A(n),  Euler Integration (T = 0.05)','FontSize',13)
plot(0.4,0.16,'.r','MarkerSize',10)

text(0.75,0.265,'x(t),  (\lambda = -2)','FontSize',13)
plot([0.375 0.675],[0.262 0.262],'k','LineWidth',1.1)

text(0.90,0.383,'x^*(t),  (\lambda^* = -2.1072, K = 1.0536)','FontSize',13)
plot([0.67 0.88],[0.378 0.378],'k','LineWidth',1.1)

 
