% m-file Chap8_100.m
% plots Figure 8.100

clc, close all, clear all

T=0.05;
a1=-2*exp(-T)*cos(3*T);
a0=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b0=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
K_prime=1-2*exp(-T)*cos(3*T)+exp(-2*T);
w_nyq1=pi/T  

w=linspace(0,w_nyq1,400);
s=j*w;
Gs=10./(s.^2 + 2*s +10);
Mag_Gs=abs(Gs);
z=exp(j*w*T);
Gz1=(b1*z+b0)./(z.^2 + a1*z +a0);
Mag_Gz1=abs(Gz1);
Gz2=K_prime*z.^2./(z.^2 +a1*z +a0);
Mag_Gz2=abs(Gz2);

figure(1) % plot Figure 8.100
subplot(2,2,1)
plot(w,Mag_Gs,'b','LineWidth',1.3)
grid on
axis([0 w_nyq1 0 1.85])
set(gca,'FontSize',11,'XTick',[0:10:60],'YTick',[0:0.25:1.75])
hold on
plot(w,Mag_Gz2,'r','LineWidth',1.3)
plot(w,Mag_Gz1,'k','LineWidth',1.3)
text(15,1.25,'|G(j\omega)|','FontSize',11)
plot([4.08 13],[1.25 1.25],'k','LineWidth',1.1)
text(15,0.75,'|G_1(e^{j\omegaT})|','FontSize',11)
plot([4.80 13],[0.75 0.75],'k','LineWidth',1.1)
text(15,0.25,'|G_2(e^{j\omegaT})|','FontSize',11)
plot([6.635 13],[0.25 0.25],'k','LineWidth',1.1)
text(30,1.6,'T = 0.05 s','FontSize',11)
text(-27.5,2.05,'Frequency Response of Continuous-time and Approximate Discrete-time Systems','FontSize',11)
xlabel('\omega  (rad/s)','FontSize',12)
ylabel('Magnitude','FontSize',12)

subplot(2,2,3)
Phase_Gs=angle(Gs)*180/pi;
plot(w,Phase_Gs,'b','LineWidth',1.3)
grid on
axis([0 w_nyq1 -260 20])
set(gca,'FontSize',11,'XTick',[0:10:60],'YTick',[-250:50:0])
hold on
xlabel('\omega  (rad/s)','FontSize',12)
ylabel('Phase  (deg)','FontSize',12)
Phase_Gz1=angle(Gz1)*180/pi;
for i=1:length(w)
    if Phase_Gz1(i)>0
        Phase_Gz1(i)=Phase_Gz1(i)-360;
    end
end
plot(w,Phase_Gz1,'r','LineWidth',1.3)
Phase_Gz2=angle(Gz2)*180/pi;
plot(w,Phase_Gz2,'k','LineWidth',1.3)
text(22,-150,'Arg G(j\omega)','FontSize',11)
text(7,-50,'Arg G_2(e^{j\omegaT})','FontSize',11) 
text(1,-235,'Arg G_1(e^{j\omegaT})','FontSize',11)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T=0.25;
a1=-2*exp(-T)*cos(3*T);
a0=exp(-2*T);
b1=1-exp(-T)*(cos(3*T)+sin(3*T)/3);
b0=exp(-2*T)-exp(-T)*(cos(3*T)-sin(3*T)/3);
K_prime=1-2*exp(-T)*cos(3*T)+exp(-2*T);
w_nyq2=pi/T  
w=linspace(0,w_nyq2,500);
s=j*w;
Gs=10./(s.^2 + 2*s +10);
Mag_Gs=abs(Gs);
z=exp(j*w*T);
Gz1=(b1*z+b0)./(z.^2 + a1*z +a0);
Mag_Gz1=abs(Gz1);
Gz2=K_prime*z.^2./(z.^2 +a1*z +a0);
Mag_Gz2=abs(Gz2);

subplot(2,2,2)
plot(w,Mag_Gs,'b','LineWidth',1.3)
grid on
axis([0 w_nyq2 0 1.85])
set(gca,'FontSize',11,'XTick',[0:2:12],'YTick',[0:0.25:1.75])
xlabel('\omega  (rad/s)','FontSize',12)
ylabel('Magnitude','FontSize',12)
hold on
plot(w,Mag_Gz1,'r','LineWidth',1.3)
plot(w,Mag_Gz2,'k','LineWidth',1.3)
text(9.0,0.5,'|G(j\omega)|','FontSize',11)
plot([7.5 8.7],[0.5 0.5],'k','LineWidth',1.1)
plot([7.5 7.5],[0.21 0.5],'k','LineWidth',1.1)
text(6.5,0.9,'|G_2(e^{j\omegaT})|','FontSize',11)
plot([5.25 6.2],[0.9 0.9],'k','LineWidth',1.1)
plot([5.25 5.25],[0.59 0.9],'k','LineWidth',1.1)
text(1,0.18,'|G_1(e^{j\omegaT})|','FontSize',11)
plot([5.2 7.8],[0.15 0.15],'k','LineWidth',1.1)
text(6,1.6,'T = 0.25 s','FontSize',11)

subplot(2,2,4)
Phase_Gs=angle(Gs)*180/pi;
plot(w,Phase_Gs,'b','LineWidth',1.3)
grid on
axis([0 w_nyq2 -260 20])

set(gca,'FontSize',11,'XTick',[0:2:12],'YTick',[-250:50:0])
xlabel('\omega  (rad/s)','FontSize',12)
ylabel('Phase  (deg)','FontSize',12)
hold on
Phase_Gz1=angle(Gz1)*180/pi;
for i=1:length(w)
    if Phase_Gz1(i)>0
        Phase_Gz1(i)=Phase_Gz1(i)-360;
    end
end
plot(w,Phase_Gz1,'r','LineWidth',1.3)
Phase_Gz2=angle(Gz2)*180/pi;
plot(w,Phase_Gz2,'k','LineWidth',1.3)
text(7,-130,'Arg G(j\omega)','FontSize',11)
text(3.5,-15,'Arg G_2(e^{j\omegaT})','FontSize',11) 
text(0.5,-225,'Arg G_1(e^{j\omegaT})','FontSize',11)




