% m-file Ch8_Fig2_11.m
% plots Figures 8.11 - 8.13

clc, close all, clear all

zeta=linspace(0,1,750);
wnT_max=2*zeta;

% figure(1) %plot Figure 8.11
% plot(zeta,wnT_max,'b','LineWidth',1.3)
% grid on
% axis([0 1.1 -0.1 2])
% set(gca,'FontSize',11,'XTick',[0:0.1:1],'YTIck',[0:0.2:2])
% hold on
% xlabel('\zeta','FontSize',13)
% ylabel('(\omega_nT)_{max}','FontSize',13) 
% zeta1=sqrt(2)/2;
% wnT_max1=2*zeta1;
% plot([zeta1 zeta1],[0 wnT_max1],'k--') 
% plot(zeta1,0,'.r','MarkerSize',13)
% plot(zeta1,0.25*wnT_max1,'.r','MarkerSize',13)
% plot(zeta1,0.5*wnT_max1,'.r','MarkerSize',13)
% plot(zeta1,0.75*wnT_max1,'.r','MarkerSize',13)
% plot(zeta1,wnT_max1,'.r','MarkerSize',13)
% title('\omega_nT_{max} vs. \zeta','FontSize',12)

clear all
zeta=sqrt(2)/2;
wn=10;
wd=sqrt(1-zeta^2)*wn;
tau=1/(zeta*wn);
tfinal=7.5*tau;
t=linspace(0,tfinal,750);
x=(wn/(sqrt(1-zeta^2)))*exp(-zeta*wn.*t).*sin(wd*t);
% text(0.75,0.025,'\omega_nT=0.01','FontSize',12)
% text(0.75,0.34,'0.25(\omega_nT)_{max}','FontSize',12)
% text(0.75,0.69,'0.5(\omega_nT)_{max}','FontSize',12)
% text(0.75,1.04,'0.75(\omega_nT)_{max}','FontSize',12)
% text(0.75,1.4,'(\omega_nT)_{max}=1.414','FontSize',12)

% figure(2) % plot Figure8.12
% subplot(2,2,1)
% plot(t,x,'b','LineWidth',1.3)
% grid on
% set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[-1:5])
% hold on
% T=0.001;
% xA(1)=-(wn^2)*T; tn(1)=-T;
% xA(2)=0; tn(2)=0;
% nfinal=round(tfinal/T);
% for n=3:nfinal+2 
%   tn(n)=(n-2)*T;
%   xA(n)=2*(1-zeta*wn*T)*xA(n-1)-(1-2*zeta*wn*T+(wn*T)^2)*xA(n-2);    
% end
% del=5; end1=70;
% plot(tn(2:del:end1),xA(2:del:end1),'.r','MarkerSize',7)
% del=15; end2=300;
% plot(tn(end1:del:end2),xA(end1:del:end2),'.r','MarkerSize',7)
% del=25;
% plot(tn(end2:del:end),xA(end2:del:end),'.r','MarkerSize',7)
% axis([0 tn(end) -1 5])
% hold on
% text(0.5,4.18,'\omega_nT = 0.01','FontSize',12)
% text(-0.37,5.65,'Simulated Impulse Responses of Second-Order System, \zeta = 0.707, (\omega_nT)_{max} = 2\zeta = 1.414','FontSize',11)
% text(0.6,2.5,'x(t)','FontSize',12)
% plot([0.45 0.55],[2.4 2.4],'b','LineWidth',1.3)
% text(0.6,1.2,'x_A(n)','FontSize',12)
% plot(0.5,1.2,'r.','MarkerSize',7)
% 
% subplot(2,2,2)
% plot(t,x,'b','LineWidth',1.3)
% grid on
% set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[-1:5])
% hold on
% clear tn xA
% wnT_max=2*zeta;
% T=0.25*wnT_max/wn; 
% xA(1)=-(wn^2)*T; tn(1)=-T;
% xA(2)=0; tn(2)=0;
% nfinal=round(tfinal/T);
% for n=3:nfinal+2 
%   tn(n)=(n-2)*T;
%   xA(n)=2*(1-zeta*wn*T)*xA(n-1)-(1-2*zeta*wn*T+(wn*T)^2)*xA(n-2);    
% end
% axis([0 tn(end) -1 5])
% plot(tn(2:end),xA(2:end),'.r','MarkerSize',7)
% text(0.4,4.18,'\omega_nT = 0.3536','FontSize',12)
% text(0.6,2.5,'x(t)','FontSize',12)
% plot([0.45 0.55],[2.4 2.4],'b','LineWidth',1.3)
% text(0.6,1.2,'x_A(n)','FontSize',12)
% plot(0.5,1.2,'r.','MarkerSize',7)
% 
% subplot(2,2,3)
% plot(t,x,'b','LineWidth',1.3)
% grid on
% set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[-1:5])
% hold on
% clear tn xA
% wnT_max=2*zeta;
% T=0.5*wnT_max/wn;
% xA(1)=-(wn^2)*T; tn(1)=-T;
% xA(2)=0; tn(2)=0;
% nfinal=round(tfinal/T);
% for n=3:nfinal+2 
%   tn(n)=(n-2)*T;
%   xA(n)=2*(1-zeta*wn*T)*xA(n-1)-(1-2*zeta*wn*T+(wn*T)^2)*xA(n-2);    
% end
% plot(tn(2:end),xA(2:end),'.r','MarkerSize',7)
% xlabel('t','FontSize',12)
% axis([0 tn(end) -1 5])
% text(0.4,4.18,'\omega_nT = 0.7071','FontSize',12)
% text(0.6,2.5,'x(t)','FontSize',12)
% plot([0.45 0.55],[2.4 2.4],'b','LineWidth',1.3)
% text(0.6,1.2,'x_A(n)','FontSize',12)
% plot(0.5,1.2,'r.','MarkerSize',7)
% 
% subplot(2,2,4)
% plot(t,x,'b','LineWidth',1.3)
% grid on
% set(gca,'FontSize',11,'XTick',[0:0.2:1],'YTick',[-4:2:8])
% hold on
% clear tn xA
% wnT_max=2*zeta;
% T=0.75*wnT_max/wn;
% xA(1)=-(wn^2)*T; tn(1)=-T;
% xA(2)=0; tn(2)=0;
% nfinal=round(tfinal/T);
% for n=3:nfinal+2 
%   tn(n)=(n-2)*T;
%   xA(n)=2*(1-zeta*wn*T)*xA(n-1)-(1-2*zeta*wn*T+(wn*T)^2)*xA(n-2);    
% end
% plot(tn(2:end),xA(2:end),'.r','MarkerSize',7)
% xlabel('t','FontSize',1)
% axis([0 tn(end) -4 8])
% text(0.4,6.4,'\omega_nT = 1.0607','FontSize',12)
% text(0.5,4.0,'x(t)','FontSize',12)
% plot([0.35 0.45],[3.8 3.8],'b','LineWidth',1.3)
% text(0.77,4.0,'x_A(n)','FontSize',12)
% plot(0.72,4.0,'r.','MarkerSize',7)



figure(3) % plot Figure 8.13
tfinal=15*tau;
t=linspace(0,tfinal,750);
x=(wn/(sqrt(1-zeta^2)))*exp(-zeta*wn.*t).*sin(wd*t);
plot(t,x,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.2:1.6],'YTick',[-15:5:20])
hold on
clear tn xA
wnT_max=2*zeta;
T=wnT_max/wn;
xA(1)=-(wn^2)*T; tn(1)=-T;
xA(2)=0; tn(2)=0;
nfinal=round(tfinal/T);
for n=3:nfinal+2 
  tn(n)=(n-2)*T;
  xA(n)=2*(1-zeta*wn*T)*xA(n-1)-(1-2*zeta*wn*T+(wn*T)^2)*xA(n-2);    
end
plot(tn(2:end),xA(2:end),'.r','MarkerSize',15)
plot(tn(2:end),xA(2:end),'--k','LineWidth',1.2)
xlabel('t','FontSize',13)
axis([0 1.6 -15 20])
text(0.35,2,'x(t)','FontSize',13)
text(0.77,12,'x_A(n)','FontSize',13)
text(0.08,17,'\zeta = 0.707, \omega_n = 10 rad/s,  T =0.1414 s,   \omega_nT = 1.414','FontSize',13) 
text(-0.21,22,'Simulated Impulse Response of Second-Order System,  (\omega_nT)_{max} = 2, \zeta = 1.414','FontSize',11)
