% m-file Ch8_Fig8_14andFig8_15
% plots Figure 8.14 and Figure 8.15

clc, close all, clear all

wT=linspace(0,1,1000);
% plot(wT,e_M,'r')
% hold on
% plot(wT,frac_gain_error,'b')

H_star_div_H=j*wT./(exp(j*wT)-1);
frac_error_transfer_fcn=H_star_div_H-1;
eM_1=real(frac_error_transfer_fcn); % method 1 for finding approximate expression for fractional gain error
eA_1=imag(frac_error_transfer_fcn); % method 1 for finding approximate expression for phase error
eA_2=-wT/2; % method 2 for finding approximate expression for phase error
phase_error=-angle(exp(j*wT)-1)-(-pi/2); % exact expression for phase error
c1=wT.*sin(wT);
c2=2*(1-cos(wT));
eM_2=(c1./c2)-1; % method 2 for finding approximate expression for fractional gain error

frac_gain_error_1=(wT./abs(exp(j*wT)-1))-1; % method 1 for finding exact expression for fractional gain error
frac_gain_error_2=(wT./sqrt(c2))-1; % method 2 for finding exact expression for fractional gain error

% figure(1)
% subplot(2,1,1)
% plot(wT,eM_1,'r')
% hold on
% plot(wT(1:20:end),eM_2(1:20:end),'b*')
% 
% subplot(2,1,2)
% plot(wT,frac_gain_error_1,'r')
% hold on
% plot(wT(1:20:end),frac_gain_error_2(1:20:end),'b*')
% figure
% plot(wT,eA_1,'r')
% hold on
% plot(wT(1:50:end),eA_2(1:50:end),'b*')
% plot(wT(2:25:end),phase_error(2:25:end),'g.')

figure(1) % plot Figure 8.14
wT=linspace(0,1,1000);
e_H=(j*wT./(exp(j*wT)-1))-1;
e_M=real(e_H);
e_A=imag(e_H);
frac_gain_error=(wT./(abs(exp(j*wT)-1)))-1;
plot(wT,e_M,'b','LineWidth',1.3)
grid on
hold on
set(gca,'FontSize',11,'XTick',[0:0.1:1],'YTick',[-0.08:0.02:0.04])
plot(wT,frac_gain_error,'r','LineWidth',1.3)
axis([0 1 -0.09 0.05])
xlabel('\omegaT  (rad)','FontSize',13)
ylabel('Fractional Error in Gain of  H(e^{j\omegaT})','FontSize',13)
text(0.5,0.024,'exact','FontSize',13)
text(0.40,-0.057,'e_M (approximate)','FontSize',13)
text(-0.161,0.0565,'Approximate and Exact Fractional Error in Gain of H(e^{j\omegaT}), Explicit Euler Integration','FontSize',11)


figure(2) % plot Figure 2.15
subplot(2,1,1)
angle_H_star=-angle((exp(j*wT)-1));
angle_H_star(1)=-pi/2;
% c3=sin(wT)./(cos(wT)-1);
% angle_H_star=-atan(c3)-pi;
angle_H=-pi/2;
plot(wT,angle_H_star,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.1:1],'YTick',[-2:0.2:-1.4])
hold on
plot([0 1],[angle_H angle_H],'r','LineWidth',1.3)
axis([0 1 -2.1 -1.35])
text(0.3,-1.94,'Arg[H(e^{j\omegaT})]','FontSize',13)
text(0.4,-1.475,'Arg[H(j\omega)] = -\pi/2','FontSize',13)
% text(0.365,-1.675,'Phase Error=Arg[\itH^{*}\rm(\ite^{j\omegaT}\rm)]-Arg\itH\rm(\itj\omega\rm)','FontSize',11)
% hold on
% wt=0.9;
% ArgH_star=-atan(sin(wt)/(cos(wt)-1))-pi;
% plot([0.9 0.9],[ArgH_star -pi/2],':k') 
title('Phase Angle of Continuous-time Integrator and Explicit Euler Integrator','FontSize',11)
ylabel('Phase Angle  (rad)','FontSize',12)

subplot(2,1,2)
eA=-0.5*wT;
phase_error=angle_H_star-angle_H; 
plot(wT,eA,'b','LineWidth',1.3)
grid on
hold on
set(gca,'FontSize',11,'XTick',[0:0.1:1],'YTick',[-0.6:0.2:0])
plot(wT(1:25:end),phase_error(1:25:end),'r.','MarkerSize',9)
xlabel('\omegaT','FontSize',13)
text(0.13,-0.37,'e_A (approximate)','FontSize',13)
plot([0.05 0.1],[-0.37 -0.37],'b','LineWidth',1.3)
text(0.13,-0.5,'exact','FontSize',13)
plot(0.075,-0.5,'r.','MarkerSize',9)
title('Approximate and Exact Error in Phase Angle of H(e^{j\omegaT})','FontSize',11)
ylabel('Phase Error  (rad)','FontSize',13)


