% m-file Ch8_Fig8_17.m
% plots Figure 8.17

clc, clear all, close all

figure(1) % plots Figure 8.17
w=2;
P=2*pi/w;
T=0.025; % integration step size
tfinal=2*P;
nfinal=round(tfinal/T);
xA(1)=0; 

for n=1:nfinal
    u(n)=sin(w*(n-1)*T);
    xA(n+1)=xA(n)+T*u(n);
    %x(n)=(1-cos(w*(n-1)*T))/w;
    t(n)=(n-1)*T;
end
t(n+1)=n*T;

ti=linspace(0,2*P,1000);
ui=sin(w*ti);
xi=(1-cos(w*ti))/w;

subplot(2,1,1)  
plot(ti,ui,'k','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.5:6],'YTick',[-1:0.5:1])
hold on
del=5;
plot(t(1:del:end),xA(1:del:end),'.r','MarkerSize',9)
plot(ti,xi,'b','LineWidth',1.3)
title({'Input u(t) = sin2t', 'Output: x_A(n,) Explicit Euler Integrator (T = 0.025 s), Output: x(t)'},'FontSize',11)
axis([0 2*P -1.25 1.4])
text(1.15,-0.30,'u(t)','FontSize',13)
text(2.4,0.75,'x_A(n)','FontSize',13)
text(3.5,-0.75,'\omegaT = 0.05','FontSize',13)
text(1.7,0.48,'x(t)','FontSize',13)

A=xA(161)
t0=(1/w)*acos(1-w*A)+P 
delay_1=4-t0 
delay_2=T/2  

clear t xA
T=0.25; % integration step size
nfinal=round(tfinal/T);
xA(1)=0; 
for n=1:nfinal
    u(n)=sin(w*(n-1)*T);
    xA(n+1)=xA(n)+T*u(n);
    x(n)=(1-cos(w*(n-1)*T))/w;
    t(n)=(n-1)*T;
end
t(n+1)=n*T;

subplot(2,1,2) 
plot(ti,ui,'k','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[0:0.5:6],'YTick',[-1:0.5:1])
hold on
plot(t(1:end),xA(1:end),'.r','MarkerSize',9)
plot(ti,xi,'b','LineWidth',1.3)
xlabel('t  (s)','FontSize',12)
title({'Input u(t) = sin2t', 'Output: x_A(n,) Explicit Euler Integrator (T = 0.25 s), Output: x(t)'},'FontSize',11)
axis([0 2*P -1.25 1.4])
text(1.15,-0.30,'u(t)','FontSize',13)
text(2.45,0.75,'x_A(n)','FontSize',13)
text(3.5,-0.75,'\omegaT = 0.5','FontSize',13)
text(1.8,0.48,'x(t)','FontSize',13)

A=xA(17)
t0=(1/w)*acos(1-w*A)+P 
delay_1=4-t0 
delay_2=T/2  


wT=w*T;
fge=(wT/sqrt(2*(1-cos(wT))))-1;


for P=[1 2 5 10 25 50 100]
    clear xA u
   nfinal=round(50*P/T);
  xA(1)=0;    
   for n=1:nfinal
       u(n)=sin(w*(n-1)*T);
       xA(n+1)=xA(n)+T*u(n);    
   end % for n
   P; pp_swing=max(xA)-min(xA);   
end % for P
