% m-file Ch8_Fig8_18abcd.m
% plots Figures 8.18a - 8.18d

clc, close all, clear all

e(1)=1/2; e(2)=5/12; e(3)=3/8; e(4)=251/720; e(5)=475/1440;
T=1;
w_nyq=pi/T; 
U=log10(w_nyq);
for k=1:4              
              
    if k==1 
       L=-2;
       w=logspace(L,U,2000);
       z=exp(j*w*T);
       H_star_exact=T./(z-1);
    elseif k==2
       L=-1;
       w=logspace(L,U,2000);
       z=exp(j*w*T);
       H_star_exact=(T/2)*(3*z-1)./(z.^2-z);
    elseif k==3
       L=-1;
       w=logspace(L,U,2000);
       z=exp(j*w*T);
       H_star_exact=(T/12)*(23*z.^2 - 16*z + 5)./(z.^3 - z.^2);
    elseif k==4
       L=-1;
       w=logspace(L,U,2000);
       z=exp(j*w*T);
       H_star_exact=(T/24)*(55*z.^3 -59*z.^2 + 37*z - 9)./(z.^4 - z.^3);
    end % if k    
          
    s=j*w;
    H_I=1./s;
    H_star_asy=(1./(1+e(k)*(s*T).^k))./s;
    
    magH_I=20*log10(abs(H_I));
    argH_I=(180/pi)*angle(H_I);
    magH_star_exact=20*log10(abs(H_star_exact));
    argH_star_exact=(180/pi)*angle(H_star_exact);  
    magH_star_asy=20*log10(abs(H_star_asy));
    argH_star_asy=(180/pi)*angle(H_star_asy);    
    
    figure(k)
    subplot(2,1,1)    
    semilogx(w,magH_I,'b','LineWidth',1.3)
    grid on
    set(gca,'FontSize',11)
    hold on
    xlabel('\omega  (rad/s)','FontSize',12)
    ylabel('Magnitude  (db)','FontSize',12)
        
    switch k
       case 1         
         text(0.01,46,'Frequency Response of Continuous and Euler (T = 1 s) Integrators','Fontsize',11)
         text(0.25,-12,'Euler (asymptotic)','FontSize',11)
         semilogx([1.25 10^0.41],[-12.35 -12.35],'k','LineWidth',1.1)
         text(0.87,25,'Euler','FontSize',11)
         semilogx([1.5 2.75],[24.5 24.5],'k','LineWidth',1.1)
         semilogx([2.75 2.75],[24.5 -5.85],'k','LineWidth',1.1)
         text(0.55,15,'continuous','FontSize',11)
         semilogx([1.5 2.2],[14.5 14.5],'k','LineWidth',1.1)
         semilogx([2.2 2.2],[14.5 -6.8],'k','LineWidth',1.1)
         axis([10^L,w_nyq,-20,40])
         set(gca,'YTick',[-20:10:40])
         
       case 2
         text(0.1,46,'Frequency Response of Continuous and AB-2 (T = 1 s) Integrators','Fontsize',11)
         text(0.65,-12,'AB-2 (asymptotic)','FontSize',11)
         semilogx([1.8 10^0.4],[-12.35 -12.35],'k','LineWidth',1.1)
         text(0.93,25,'AB-2','FontSize',11)
         semilogx([1.30 2.75],[24.5 24.5],'k','LineWidth',1.1)
         semilogx([2.75 2.75],[24.5 0.05],'k','LineWidth',1.1)
         text(0.70,15,'continuous','FontSize',11)
         semilogx([1.3 2.5],[14.5 14.5],'k','LineWidth',1.1)
         semilogx([2.5 2.5],[14.5 -7.95],'k','LineWidth',1.1)
         axis([10^L,w_nyq,-20,40])
         set(gca,'YTick',[-20:10:40])
                    
     case 3
         text(0.095,30,'Frequency Response of Continuous and AB-3 (T = 1 s) Integrators','Fontsize',11)
         text(0.4,-12,'AB-3 (asymptotic)','FontSize',11)
         semilogx([1.1 10^0.25],[-12.35 -12.35],'k','LineWidth',1.1)
         text(1.4,18,'AB-3','FontSize',11)
         semilogx([1.90 2.5],[17.5 17.5],'k','LineWidth',1.1)
         semilogx([2.5 2.5],[17.5 4.87],'k','LineWidth',1.1)
         text(0.70,10,'continuous','FontSize',11)
         semilogx([1.3 1.65],[9.5 9.5],'k','LineWidth',1.1)
         semilogx([1.65 1.65],[9.5 -4.35],'k','LineWidth',1.1)
         axis([10^L,w_nyq,-20,25]) 
         set(gca,'YTick',[-20:10:20])
         
       case 4
         text(0.095,30,'Frequency Response of Continuous and AB-4 (T = 1 s) Integrators','Fontsize',11)
         text(0.3,-12,'AB-4 (asymptotic)','FontSize',11)
         semilogx([0.82 10^0.175],[-12.35 -12.35],'k','LineWidth',1.1)
         text(1.4,18,'AB-4','FontSize',11)
         semilogx([1.90 2.5],[17.5 17.5],'k','LineWidth',1.1)
         semilogx([2.5 2.5],[17.5 9.45],'k','LineWidth',1.1)
         text(0.70,10,'continuous','FontSize',11)
         semilogx([1.3 1.65],[9.5 9.5],'k','LineWidth',1.1)
         semilogx([1.65 1.65],[9.5 -4.35],'k','LineWidth',1.1)
         axis([10^L,w_nyq,-20,25]) 
         set(gca,'YTick',[-20:10:20])
    end
    
    hold on
    semilogx(w,magH_star_exact,'r','LineWidth',1.3)
    semilogx(w,magH_star_asy,'k','LineWidth',1.3)  
        
    subplot(2,1,2)
    semilogx(w,argH_I,'b','LineWidth',1.3) 
    grid on
    set(gca,'FontSize',11)
    hold on
    xlabel('\omega  (rad/s)','FontSize',12)
    ylabel('Phase  (deg)','FontSize',12)
        
     switch k
       case 1
         text(0.2,-140,'Euler (asymptotic)','FontSize',11)
         semilogx([1.10 10^0.393],[-141 -141],'k','LineWidth',1.1)
         grid on
         text(0.9,-163,'Euler','FontSize',11)
         semilogx([1.55 10^0.41],[-163.5 -163.5],'k','LineWidth',1.1)
         text(0.8,-80,'continuous','FontSize',11)   
         axis([10^-2,w_nyq,-180,-70])
         set(gca,'YTick',[-180:45:0])
         set(gca,'YTick',[-180:20:-80])
         
       case 2
         text(0.42,-10,'AB-2 (asymptotic)','FontSize',11)
         semilogx([1.13 10^0.19],[-10.5 -10.5],'k','LineWidth',1.1)
         text(0.78,-140,'AB-2','FontSize',11)
         semilogx([1.10 10^0.35],[-141.5 -141.5],'k','LineWidth',1.1)
         text(0.15,-65,'continuous','FontSize',11)           
         axis([10^L,w_nyq,-180,115])
         set(gca,'YTick',[-180:45:90])
         
       case 3
         text(0.375,-25,'AB-3 (asymptotic)','FontSize',11)
         semilogx([1.03 10^0.25],[-26 -26],'k','LineWidth',1.1)
         text(1.2,-140,'AB-3','FontSize',11)
         semilogx([1.65 10^0.4],[-141.5 -141.5],'k','LineWidth',1.1)
         text(0.15,-72,'continuous','FontSize',11)           
         axis([10^L,w_nyq,-180,25])
         set(gca,'YTick',[-180:45:0])
         
       case 4
         text(0.15,-112,'AB-4 (asymptotic)','FontSize',11)
         text(1.38,-140,'AB-4','FontSize',11)
         semilogx([1.90 10^0.43],[-141.5 -141.5],'k','LineWidth',1.1)
         text(0.15,-72,'continuous','FontSize',11)           
         axis([10^L,w_nyq,-180,-45])
         set(gca,'YTick',[-180:45:-45])
       end
       
    hold on
    semilogx(w,argH_star_exact,'r','LineWidth',1.3)
    semilogx(w,argH_star_asy,'k','LineWidth',1.3)
    
end % for k

% figure
% n1=T;
% d1=[1 -1];
% sys1=tf(n1,d1,T)
% bode(sys1,{10^L,w_nyq})
% 
% figure
% n2=0.5*T*[3 -1];
% d2=[1 -1 0];
% sys2=tf(n2,d2,T)
% bode(sys2,{10^L,w_nyq})