% m-file Ch8_Fig8_23_right_half.m
% plots right half of Figure 8.23 

clc, close all, clear all

%%%%% plot AB-2 stability boundary %%%%%
theta=linspace(0,2*pi,2000); 
x=exp(j*theta); 
lamT=2*(x-x.^2)./(1-3*x); 

figure % plot Figure 8.23
plot(lamT,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[-1:0.2:0.2],'YTIck',[-1:0.2:1])
hold on
x1=exp(j*0.7*pi);
lamT1=2*(x1-x1^2)/(1-3*x1);
r1=real(lamT1); i1=imag(lamT1);
axis([-1.1 0.25 -1 1])
plot([-1.1 0.25],[0 0],'k')
plot([0 0],[-1 1],'k')
plot([0 r1],[0 i1],'k','LineWidth',1.2)
plot(r1,i1,'.r','MarkerSize',13)
text(-0.9,1.08,'Stability Boundary for AB-2 Integrator','FontSize',12)
text(-0.6,-0.55,'\lambdaT Plane','FontSize',13)
text(-1,0.665,'\lambdaT = Me^{j\psi}','FontSize',13)

text(-0.45,0.45,'M','FontSize',13)
theta=0:140;
theta=theta*pi/180; % theta in rad
r=0.15;
xi=r*cos(theta);
yi=r*sin(theta);
plot(xi,yi,'k','LineWidth',1.1)
text(0.035,0.08,'\psi','FontSize',13)
xlabel('Re (\lambdaT)','FontSize',13)
ylabel('Im (\lambdaT)','FontSize',13)