% m-file Ch8_Fig8_65.m
% plots Figure 8.65

clc,  close all, clear all

global A1 A2 L1 L2 c1 c2 gam p0 

delta_f=1e-4; % sec
T=0.01; % sec
alpha=1;
t_final=1000; % sec

hold on
alpha_min=0.5; alpha_max=2.5;
N_max=50;
for alpha=alpha_min:0.5:alpha_max
N=1:N_max;  
T_exec(N)=(t_final/T)*delta_f.*(1+alpha./N);

incr1=1;
plot(N(1:incr1:end),T_exec(1:incr1:end),'.b:','MarkerSize',8)
grid on

set(gca,'FontSize',11,'XTick',[0:5:50],'YTick',[10:5:35])
plot(1,T_exec(1),'s','MarkerFaceColor','k','MarkerSize',5,'MarkerEdgeColor','none')
end % alpha
T_exec_min=(t_final/T)*delta_f*(1+alpha_min/N_max);
T_exec_max=(t_final/T)*delta_f*(1+alpha_max);
axis([-1 50 0.925*T_exec_min 1.025*T_exec_max])
xlabel('frame ratio  (N)','FontSize',13)
ylabel('cpu execution time,   \Gamma  (s)','FontSize',13)
text(3,37,'Total Simulation cpu Execution Time vs Frame Ratio','FontSize',12)
text(10,15.75,'\alpha = 0.5, 1, 1.5, 2, 2.5','FontSize',13)
text(10,25.7,'t_{final}/T = 1000,000 frames','FontSize',13)
text(10,20.5,'\Delta_f = 100 \mums','FontSize',13)
text(10,34,'single rate integration (step size T)','FontSize',13)
plot(9,33.9,'s','MarkerFaceColor','k','MarkerSize',5,'MarkerEdgeColor','none')
text(3.5,30.5,'multirate integration (fast state T_f=T, slow state T_s=NT_f)','FontSize',12)
plot(2.5,30.5,'.b','MarkerSize',8)
%%%%%%


% baseline parameter values
% gam=62.4; % specific wt of water (lb per cu ft) 
% p0=14.7*144; % atm pressure (lb/sq ft)
% R1=15; % ft
% A1=pi*R1^2;
% L1=25; % ft
% R2=5; % ft
% A2=pi*R2^2;
% L2=7.5; % ft
% c1=4; % cu ft/min per psf^1/2
% c2=2; % 
% 
% 
% H1=25; H2=2.5; F0=50;
% lim=25000;
% 
% t1=cputime;
% for i=1:lim    
% H1_dot=deriv_H1(H1,H2,F0);
% end
% H1_dot_exec_time=(cputime-t1)/lim
% 
% t2=cputime;
% for i=1:lim
% H2_dot=deriv_H2(H1,H2,F0);
% end
% H2_dot_exec_time=(cputime-t2)/lim
