% m-file Ch8_Fig8_79.m
% plots Figure 8.79

clc, clear all, close all


wTmax=0.5;
wT=linspace(0,wTmax,500);
G=2-exp(-j*wT);
G_I=exp(j*wT);

magG=abs(G);
angleG=angle(G);

magG_I=abs(G_I);
angleG_I=angle(G_I);

subplot(2,1,1)
plot(wT,magG,'b','LineWidth',1.3)
grid on
axis([0 wTmax 0.9 1.3])
set(gca,'FontSize',11,'XTick',[0:0.05:0.5],'YTick',[0.9:0.1:1.3])
hold on
plot([0 wTmax],[1 1],'r','LineWidth',1.3)
ylabel('Magnitude','FontSize',13)
text(-0.06,1.36,'Magnitude of Real and Ideal Extrapolator Frequency Response Functions','FontSize',12)
text(0.22,1.15,'|G(e^{j\omegaT})|','FontSize',13)
text(0.3,0.94,'|G_I(j\omega)|','FontSize',13)
% x=(sqrt(5-4*cos(wT))-1)-wT.^2;
% plot(wT,x,'g') % check asymptotic formula

subplot(2,1,2)
plot(wT,angleG,'b','LineWidth',1.3)
grid on
axis([0 wTmax 0 0.55])
set(gca,'FontSize',11,'XTick',[0:0.05:0.5],'YTick',[0:0.1:0.5])

hold on
plot(wT,angleG_I,'r','LineWidth',1.3)

xlabel('\omegaT  (rad)','FontSize',13)
ylabel('Phase Angle (rad)','FontSize',13)
text(-0.07,0.62,'Phase Angle of Real and Ideal Extrapolator Frequency Response Functions','FontSize',12)
text(0.17,0.34,'Arg [G_I(j\omega)]','FontSize',13)
text(0.34,0.25,'Arg [G(e^{j\omegaT})]','FontSize',13)
