% m-file Ch8_Fig8_7thruFig8_9.m
% plots Figures 8.7 - 8.9

clc,close all, clear all
warning off

T=0.01;

figure(1) % plot Figure 8.7
subplot(2,2,1)
wn_max=0.15/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T;
zeta=0.1;    
wd=sqrt(1-zeta^2)*wn;
a=1-zeta*wnT;  
b=wd*T; 
R=sqrt(a.^2 + b.^2); 
theta=atan(b./a); 
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);  
error_wn=(wn_star./wn)-1;
plot(wnT,error_wn,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.05:0.15])
set(gca,'YTick',[0:0.5e-3:3e-3])
% axis([0 1.05*max(wnT) 1.05*min(error_wn) 1.05*max(error_wn)])
axis([0 0.15 0 3.15e-3])
hold on
wn_star_asym=(1+0.5*zeta*wnT).*wn;  
error_wn_asym=(wn_star_asym./wn)-1;
plot(wnT,error_wn_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',12)
ylabel('e_{\omega_n}','FontSize',13)
text(0.075,0.68e-3,'\zeta=0.1','FontSize',13)
text(0.04,0.0035,'Exact and Asymptotic Fractional Error in Natural Frequency','FontSize',11)
text(0.08,2.3e-3,'asymptotic','FontSize',12)
plot([0.045 0.072],[2.25e-3 2.25e-3],'k','LineWidth',1.1)
text(0.08,1.695e-3,'exact','FontSize',12)
plot([0.040 0.072],[1.685e-3 1.685e-3],'k','LineWidth',1.1)

subplot(2,2,2)
wn_max=0.4/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T;
zeta=0.25;    
wd=sqrt(1-zeta^2)*wn;
a=1-zeta*wnT;  
b=wd*T; 
R=sqrt(a.^2 + b.^2); 
theta=atan(b./a); 
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);  
error_wn=(wn_star./wn)-1;
plot(wnT,error_wn,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.1:0.4])
set(gca,'YTick',[0:0.005:0.02])
%axis([0 1.05*max(wnT) 1.05*min(error_wn) 1.05*max(error_wn)])
axis([0 0.4 0 0.021])
hold on
wn_star_asym=(1+0.5*zeta*wnT).*wn;  
error_wn_asym=(wn_star_asym./wn)-1;
plot(wnT,error_wn_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',12)
text(0.2,0.006,'\zeta=0.25','FontSize',13)
text(0.22,0.0163,'asymptotic','FontSize',12)
plot([0.125 0.2],[0.0158 0.0158],'k','LineWidth',1.1)
text(0.22,0.0113,'exact','FontSize',12)
plot([0.105 0.2],[0.011 0.011],'k','LineWidth',1.1)

subplot(2,2,3)
wn_max=0.7/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T;
zeta=0.5;    
wd=sqrt(1-zeta^2)*wn;
a=1-zeta*wnT;  
b=wd*T; 
R=sqrt(a.^2 + b.^2); 
theta=atan(b./a); 
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);  
error_wn=(wn_star./wn)-1;
plot(wnT,error_wn,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.2:0.6])
set(gca,'YTick',[0:0.02:0.1])
axis([0 0.7 0 0.1])
% axis([0 1.05*max(wnT) 1.05*min(error_wn) 1.05*max(error_wn)])
hold on
wn_star_asym=(1+0.5*zeta*wnT).*wn;  
error_wn_asym=(wn_star_asym./wn)-1;
plot(wnT,error_wn_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',13)
ylabel('e_{\omega_n}','FontSize',13)
text(0.375,0.07,'asymptotic','FontSize',12)
plot([0.268 0.35],[0.068 0.068],'k','LineWidth',1.1)
text(0.375,0.05,'exact','FontSize',12)
plot([0.21 0.35],[0.048 0.048],'k','LineWidth',1.1)
text(0.375,0.026,'\zeta=0.5','FontSize',13)

subplot(2,2,4)
wn_max=1/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T;
zeta=0.9;    
wd=sqrt(1-zeta^2)*wn;
a=1-zeta*wnT;  
b=wd*T; 
R=sqrt(a.^2 + b.^2); 
theta=atan(b./a); 
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);  
error_wn=(wn_star./wn)-1;
plot(wnT,error_wn,'b','LineWidth',1.3)
grid on
axis([0 1 0 0.6])
% axis([0 1.05*max(wnT) 1.05*min(error_wn) 1.05*max(error_wn)])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.25:1])
set(gca,'YTick',[0:0.1:0.6])
hold on
wn_star_asym=(1+0.5*zeta*wnT).*wn;  
error_wn_asym=(wn_star_asym./wn)-1;
plot(wnT,error_wn_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',13)
text(0.5,0.14,'asymptotic','FontSize',12)
plot([0.31 0.45],[0.135 0.135],'k','LineWidth',1.1)
text(0.35,0.535,'exact','FontSize',12)
plot([0.6 0.855],[0.535 0.535],'k','LineWidth',1.1)
text(0.1,0.33,'\zeta=0.9','FontSize',13)

%%%%%%%%%%%%%% Damping Ratio = 0 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(2) % plot Figure 8.9
zeta=0;  % Damping ratio equals zero  
wn_max=1/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T; 
a=1;  
b=wn*T ; 
R=sqrt(a.^2 + b.^2);  
theta=atan(b./a);  
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);   
zeta_star=-a_star./wn_star;  
error_zeta=zeta_star-zeta; 
plot(wnT,error_zeta,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.1:1])
set(gca,'YTick',[-0.5:0.05:0])
hold on
error_zeta_asym=-0.5*wnT;
plot(wnT,error_zeta_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',13)
ylabel('\zeta^*','FontSize',13)
text(0.72,-0.287,'Exact','FontSize',13)
text(0.51,-0.388,'Asymptotic','FontSize',13)
text(0.35,-0.085,'\zeta = 0,  Explicit Euler Integration','FontSize',13)
title('Equivalent Continuous-time System Damping Ratio, \zeta^*','FontSize',11)

% %%%%%%%%%%%%%% Damping ratio = 0.1  %%%%%%%%%%%%%%%%%%%%%%%%%
figure(3) % Figure 8.8
zeta=0.1;  
wd=sqrt(1-zeta^2)*wn;
wn_max=1/T;
wn=linspace(0,wn_max,1000);
wnT=wn*T; 
a=1-zeta*wnT;  
b=wd*T ; 
R=sqrt(a.^2 + b.^2);  
theta=atan(b./a);  
a_star=log(R)/T; 
b_star=theta/T; 
wn_star=sqrt(a_star.^2 + b_star.^2);   
zeta_star=-a_star./wn_star;  
zeta_star_asym=zeta-0.5*(1-zeta^2)*wnT;
error_zeta=zeta_star-zeta;
error_zeta_asym=-0.5*(1-zeta^2)*wnT;

subplot(2,1,1)
plot(wnT,zeta_star,'b','LineWidth',1.3)
hold on
plot(wnT,zeta_star_asym,'r','LineWidth',1.3)
grid on
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.1:1])
set(gca,'YTick',[-0.4:0.1:0.1])
axis([0 1 -0.4 0.1])
plot([0 0.202],[0 0],'--k','LineWidth',1.1)
plot([0.202 0.202],[-0.4 0],'--k','LineWidth',1.1)
ylabel('\zeta^*','FontSize',13)
text(0.6,-0.13,'Exact','FontSize',11)
plot([0.7 0.75],[-0.135 -0.135],'k','LineWidth',1.1)
plot([0.75 0.75],[-0.135 -0.246],'k','LineWidth',1.1)
text(0.77,-0.2,'Asymptotic','FontSize',11)
plot([0.947 0.98],[-0.203 -0.203],'k','LineWidth',1.1)
plot([0.98 0.98],[-0.203 -0.385],'k','LineWidth',1.1)
text(0.45,0.02,'\zeta = 0.1','FontSize',11)
text(0.025,-0.1,'Equivalent','FontSize',11)
text(0.03,-0.175,'System','FontSize',11)
text(0.03,-0.25,'Stable','FontSize',11)
text(0.03,-0.325,'\zeta^{*}>0','FontSize',11)
text(0.225,-0.25,'Equivalent System Unstable','FontSize',11)
text(0.45,-0.325,'\zeta^{*}<0','FontSize',11)
title('Equivalent Continuous-time System Damping Ratio, \zeta^{*}','FontSize',11)

subplot(2,1,2) 
plot(wnT,error_zeta,'b','LineWidth',1.3)
grid on
axis([0 1 -0.6 0])
set(gca,'FontSize',11)
set(gca,'XTick',[0:0.1:1])
set(gca,'YTick',[-0.6:0.1:0])
hold on
plot(wnT,error_zeta_asym,'r','LineWidth',1.3)
xlabel('\omega_nT','FontSize',13)
ylabel('e_{\zeta}','FontSize',13)
text(0.75,-0.267,'Exact','FontSize',13)
text(0.60,-0.46,'Asymptotic','FontSize',13)
text(0.1,-0.367,'\zeta = 0.1','FontSize',13)
title('Equivalent Continuous-time System Damping Ratio Error, \ite_{\zeta}','FontSize',11)
