% m-file Ch8_Fig8_87andFig8_88.m
% plots Figure 8.87 and Figure 8.88

clc, close all, clear all

T=0.1;
lambda=-0.5;
lamT=lambda*T;
a0=1+lamT+0.5*lamT^2;
b0=0.5*T*(1+lamT);
b1=0.5*T;

w_Tfinal=0.5;
wfinal=w_Tfinal/T;
w=linspace(0,wfinal,250);
wT=w*T;

z=exp(j*wT);
s=j*w;

Gz=(b1*z+b0)./(z-a0);
Gz_RT=Gz./z;
Gs=1./(s-lambda);

e_mag_Gz=(abs(Gz)./abs(Gs))-1;
e_mag_Gz_RT=(abs(Gz_RT)./abs(Gs))-1;

e_phase_Gz=angle(Gz)-angle(Gs);
e_phase_Gz_RT=angle(Gz_RT)-angle(Gs);


figure(1) % plot Figure 8.87
subplot(2,1,1)
hold on
plot(wT,e_mag_Gz,'b','LineWidth',1.3)
grid on
axis([0 w_Tfinal -0.025 0.005])
set(gca,'FontSize',11,'XTick',[0:0.10:0.5],'YTick',[-0.025:0.005:0.005])
plot([0.16 0.1792],[-0.005 -0.00306],'k','LineWidth',1.1)
plot(wT,e_mag_Gz_RT,'r','LineWidth',1.3)
plot([0.2555 0.293],[-0.006 -0.002],'k','LineWidth',1.1)
ylabel('Fractional Gain Error','FontSize',13)
text(-0.035,0.01,'Fractional Gain Error in Discrete-time Frequency Response Functions','FontSize',12)  
text(0.15,-0.007,'e_{|G|}','FontSize',13)
text(0.3,-0.003,'e_{|G_{\rmR/T}|}','FontSize',13)


subplot(2,1,2)
plot(wT,e_phase_Gz,'b','LineWidth',1.3)
grid on
% plot([0 0.5],[0 0],'b')
axis([0 w_Tfinal -0.5 0.1])
hold on
set(gca,'FontSize',11,'XTick',[0:0.10:0.5],'YTick',[-0.5:0.1:0.1])
plot(wT,e_phase_Gz_RT,'r','LineWidth',1.3)
xlabel('\omegaT  (rad)','FontSize',13)
ylabel('Phase Error (rad)','FontSize',13)
text(-0,0.175,'Phase Error in Discrete-time Frequency Response Functions','FontSize',12)
text(0.25,-0.05,'e_{   G}','FontSize',13)
text(0.1,-0.20,'e_{   G_{R/T}}','FontSize',13)
text(0.11,-0.185,'_','FontSize',15)
text(0.258,-0.0561,'_','FontSize',15)



%  x=angle((b1*z+b0)./(z-a0));
%  y=angle(1./(s-lambda));
%  plot(wT,x,'b')
%  hold on
%  plot(wT,y,'r')

figure(2) % plot Figur 8.88
fact=180/pi;
phase_Gz=angle(Gz)*fact;
phase_Gs=angle(Gs)*fact;
phase_Gz_RT=angle(Gz_RT)*fact;
plot(wT,phase_Gz,'r','LineWidth',1.3)
grid on
hold on
axis([0 0.5 -120 0])
set(gca,'FontSize',11,'XTick',[0:0.10:0.5],'YTick',[-120:20:0])
plot(wT,phase_Gs,'b','LineWidth',1.3)
plot(wT,phase_Gz_RT,'m','LineWidth',1.3)
xlabel('\omegaT  (rad)','FontSize',13)
ylabel('Phase Angle  (deg)','FontSize',13)
text(0.005,7.0,'Phase Angle of Discrete-time and Continuous-time Systems','FontSize',12)
text(0.2,-69,'G(e^{j\omegaT})','FontSize',13)
text(0.35,-74,'G(j\omega)','FontSize',13)
text(0.12,-95,'G_{R/T}(e^{j\omegaT}\rm)','FontSize',13)
wwTT=0.3;
zz=exp(j*wwTT);
ss=j*wwTT;
x=angle((b1*zz+b0)./(zz-a0)) 
y=x-wwTT 
x=x*fact;
y=y*fact 
plot([wwTT wwTT],[x y],'k--','LineWidth',1.1)
text(0.307,-91,'\omegaT = 0.3 rad (17.2 deg)','FontSize',12)

plot([0.1 0.117],[-97 -97],'k','LineWidth',1.1)

plot([0.177 0.197],[-72 -72],'k','LineWidth',1.1)

plot([0.328 0.348],[-77 -77],'k','LineWidth',1.1)




