% m-file Ch8_Fig8_96.m
% plots Figure 8.96

clc, close all, clear all
tfinal=5;
T=0.05;
sim('ZOH')
tt=u_tilde(:,1);
uu=u_tilde(:,2);
ti=linspace(0,tfinal,1000);
ui=5*(1-exp(-2*ti));
subplot(2,1,1)
hold on
plot(ti,ui,'b')
axis([0 3 -0.5 5.5])
text(0.25,6,'Output of ZOH Driven by Sampled Input \itu_{k}\rm  (\itT \rm= 0.05 sec)','FontSize',11)
text(1.25,1.0,'ZOH output, \itu\rm(\itt\rm)','FontSize',11)
plot([1.05 1.15],[1 1],'r')
plot([1.15 1.15],[1.05 1.75],'r:')
text(1.825,1.35,'\sim','FontSize',11)
text(1.25,2.5,'Continuous-time input \itu\rm(\itt\rm)','FontSize',11)
plot([1.05 1.15],[2.5 2.5],'b')
for i=1:length(tt)-1
    plot([tt(i) tt(i+1)],[uu(i) uu(i)],'r')
    plot([tt(i+1) tt(i+1)],[uu(i) uu(i+1)],'r:')
end

T=0.5;
sim('ZOH')
tt=u_tilde(:,1);
uu=u_tilde(:,2);
ti=linspace(0,tfinal,1000);
ui=5*(1-exp(-2*ti));

subplot(2,1,2)
hold on
plot(ti,ui,'b')
axis([0 3 -0.5 5.5])
xlabel('\itt  \rm(sec)','FontSize',11)
text(0.25,6.0,'Output of ZOH Driven by Sampled Input \itu_{k}\rm (\itT \rm= 0.5 sec)','FontSize',11)
text(1.5,1.0,'ZOH output, \itu\rm(\itt\rm)','FontSize',11)
plot([1.3 1.4],[1 1],'r')
plot([1.4 1.4],[1 1.75],'r:')
text(2.085,1.40,'\sim','FontSize',11)
text(1.5,2.5,'Continuous-time input \itu\rm(\itt\rm)','FontSize',11)
plot([1.3 1.4],[2.5 2.5],'b')

for i=1:length(tt)-1
    plot([tt(i) tt(i+1)],[uu(i) uu(i)],'r')
    plot([tt(i+1) tt(i+1)],[uu(i) uu(i+1)],'r:')
end