% m-file Chap8_Fig8_98.m
% plots Figure 8.98

clc, clear all, close all
T=0.05;
ws=2*pi/T;
w=linspace(0,4*ws,1000);
x=pi*w/ws;
M=abs((2*pi/ws)*(sin(x)./x));

figure(1) % plot Figure 8.98
subplot(2,1,1)
plot(w,M,'b','LineWidth',1.3)
grid on
axis([0 550 0 0.06])
set(gca,'FontSize',11,'XTick',[0:50:500],'YTick',[0:0.01:0.06])
hold on

text(25,0.02,'0.5\omega_s','FontSize',12)
plot([ws/2 ws/2],[0 0.015],'k--','LineWidth',1.1)

text(117,0.03,'\omega_s','FontSize',12)
plot([ws ws],[0 0.025],'k--','LineWidth',1.1)

text(242,0.03,'2\omega_s','FontSize',12)
plot([2*ws 2*ws],[0 0.025],'k--','LineWidth',1.1)

text(366,0.03,'3\omega_s','FontSize',12)
plot([3*ws 3*ws],[0 0.025],'k--','LineWidth',1.1)

text(490,0.03,'4\omega_s','FontSize',12)
plot([4*ws 4*ws],[0 0.025],'k--','LineWidth',1.1)

text(175,0.048,'\omega_0 = 0.5\omega_s,    T = 0.05 s','FontSize',12)

text(95,0.066,'Frequency Response of Zero-order Hold','FontSize',12)

ylabel('|G_{ZOH} (j\omega)|','FontSize',12)
xlabel('\omega  (rad/s)','FontSize',12)

subplot(2,1,2)
w1=linspace(0,ws,300);
fact=180/pi;
x1=pi*w1/ws;
P1=-x1*fact;
plot(w1,P1,'b','LineWidth',1.3)
grid on
axis([0 525 -1300 0])
hold on
set(gca,'FontSize',11,'XTick',[0:50:500],'YTick',[-1250:250:0])
ylabel('Arg [G_{ZOH} (j\omega)],  deg','FontSize',12)
xlabel('\omega  (rad/s)','FontSize',12)

w2=linspace(ws,2*ws,300);
x2=pi+pi*w2/ws;
P2=-x2*fact;
plot(w2,P2,'b','LineWidth',1.3)
plot([ws ws],[-360 -180],'k:')

w3=linspace(2*ws,3*ws,300);
x3=2*pi+pi*w3/ws;
P3=-x3*fact;
plot(w3,P3,'b','LineWidth',1.3)
plot([2*ws 2*ws],[-720 -540],'k:')

w4=linspace(3*ws,4*ws,300);
x4=3*pi+pi*w4/ws;
P4=-x4*fact;
plot(w4,P4,'b','LineWidth',1.3)
plot([3*ws 3*ws],[-1080 -900],'k:')

% % figure
% % s=j*w;
% % Mag=abs((1-exp(-T*s))./s);
% % Arg=angle((1-exp(-T*s))./s);
% % subplot(2,1,1)
% % plot(w,Mag)
% % subplot(2,1,2)
% % plot(w,Arg)
% 
% % figure
% % w=linspace(0.05,2,300);
% % s=j*w;
% % U=10./(s.*(s+2));
% % mag_U=abs(U);
% % power_U=mag_U.^2; 
% % subplot(2,1,1)
% % plot(w,mag_U)
% % subplot(2,1,2)
% % plot(w,power_U)