% m-file Chap8_RK_Stability_Boundaries.m
% plots Figure 8.31

clc, close all, clear all

num=2000;
%%%%% RK-2 %%%%%
for i=1:num+1
   theta=((i-1)/num)*2*pi;  
   x=exp(j*theta);
   r=roots([0.5 1 1-x]); 
   lamT_RK2_1(i)=r(1);   
   lamT_RK2_2(i)=r(2);   
end
lamT_RK2_1=lamT_RK2_1(round(num/2)+2:num+1); 
lamT_RK2_2=lamT_RK2_2(2:round(num/2)+1);
lamT_RK2=[0 lamT_RK2_2 lamT_RK2_1];
plot(lamT_RK2,'b','LineWidth',1.3)
grid on
set(gca,'FontSize',11,'XTick',[-3:0.5:0.5],'YTick',[0:0.5:3])
hold on
axis([-3 0.5 0 3])
axis equal
grid on

%%%%% RK-3 %%%%%
for i=1:num+1
   theta=((i-1)/num)*2*pi;  
   x=exp(j*theta);
   r=roots([1/6 1/2 1 1-x]); 
   lamT_RK3_1(i)=r(1);   
   lamT_RK3_2(i)=r(2);  
   lamT_RK3_3(i)=r(3);
end
% lamT_RK3_3;
lamT_RK3_3=lamT_RK3_3(2:round(num/2)+1);
% lamT_RK3_2;
lamT_RK3_2=lamT_RK3_2(1:round(num/2)+1);
% lamT_RK3_1; 
lamT_RK3_1=lamT_RK3_1(round(num/2)+2:num);
% plot(lamT_RK3_1,'*b-')
% plot(lamT_RK3_2,'*r-')
% plot(lamT_RK3_3,'*g-')
lamT_RK3=[0 lamT_RK3_3 lamT_RK3_1 lamT_RK3_2];
plot(lamT_RK3,'r','LineWidth',1.3)

%%%%% RK-4 %%%%%

num=100;
for i=1:num+1
   theta=((i-1)/num)*2*pi;  
   x=exp(j*theta);
   r=roots([1/24 1/6 1/2 1 1-x]); 
   lamT_RK4_1(i)=r(1);   
   lamT_RK4_2(i)=r(2);  
   lamT_RK4_3(i)=r(3);
   lamT_RK4_4(i)=r(4);
end

% lamT_RK4_4; 
lamT_RK4_4=lamT_RK4_4(2:round(num/2)+1);
% lamT_RK4_3; 
lamT_RK4_3=lamT_RK4_3(1:round(num/2)+1);
% lamT_RK4_2; 
lamT_RK4_2=lamT_RK4_2(round(num/2)+2:num+1);
% lamT_RK4_1;  
lamT_RK4_1=lamT_RK4_1(round(num/2)+2:num);
hold on
% plot(lamT_RK4_1,'*b-')
% plot(lamT_RK4_2,'*r-')
% plot(lamT_RK4_3,'*g-')
% plot(lamT_RK4_4,'*m-')

lamT_RK4=[0 lamT_RK4_4 lamT_RK4_1 lamT_RK4_3 lamT_RK4_2];
plot(lamT_RK4,'k','LineWidth',1.3)

text(-2.20,2.07,'RK-4','FontSize',13)
text(-2.55,1.07,'RK-3','FontSize',13)
text(-1.90,0.57,'RK-2','FontSize',13)
text(-2.85,3.15,'Stability Boundaries for RK-2 thru RK4 Integrators','FontSize',12)
text(-2.5,2.57,'\lambdaT Plane','FontSize',13)
xlabel('Re (\lambdaT)','FontSize',13)
ylabel('Im (\lambdaT)','FontSize',13)

 








