% Chap8_Prob2_2.m

clc, clear all, close all
% Trapezoidal integration of 2nd order system with damping ratio zeta

%%%% zeta=0
zeta=0;
T=0.1;
wnT=linspace(0,1,1000);
wnTsq=wnT.^2;
a=4*(1+zeta*wnT)+wnTsq;
b=2*(wnTsq-4);
c=4*(1-zeta*wnT)+wnTsq;
z=(-b+sqrt(b.^2-4*a.*c))./(2*a);
s_star=log(z)/T;
a_star=real(s_star);
b_star=imag(s_star);
wn_star=sqrt(a_star.^2 + b_star.^2);
zeta_star=-a_star./wn_star;
plot(wnT,zeta_star)
axis([0 1 -0.01 0.01])
xlabel('\omega_{\rmn}\itT','FontSize',11)
ylabel('\zeta^{*}','FontSize',11)
title('Equivalent Continuous-time System Damping Ratio  \zeta^{*} vs. \omega_{\rmn}\itT','FontSize',11)
text(0.1,0.006,'Trapezoidal Integration of 2nd Order System with \zeta = 0', 'FontSize',11)

figure(2)
wn=wnT/T;
plot(wn,wn_star)
xlabel('\omega_{\rmn}  (rad/sec)','FontSize',11)
ylabel('\omega_{\rmn}^{*}  (rad/sec)','FontSize',11)
title('Equivalent Continuous-time System Natural Frequency  \omega_{\rmn}^{*} vs. \omega_{\rmn}','FontSize',11)
text(0.5,9,'Trapezoidal Integration of 2nd Order System with \zeta = 0', 'FontSize',11)
text(0.5,8,'\itT \rm= 0.1 sec','FontSize',11)


%%%%% zeta=0.1
figure(3)
zeta=0.1;
T=0.1;
wnT=linspace(0,1,1000);
wnTsq=wnT.^2;
a=4*(1+zeta*wnT)+wnTsq;
b=2*(wnTsq-4);
c=4*(1-zeta*wnT)+wnTsq;
z=(-b+sqrt(b.^2-4*a.*c))./(2*a);
s_star=log(z)/T;
a_star=real(s_star);
b_star=imag(s_star);
wn_star=sqrt(a_star.^2 + b_star.^2);
zeta_star=-a_star./wn_star;
plot(wnT,zeta_star)
xlabel('\omega_{\rmn}\itT','FontSize',11)
ylabel('\zeta^{*}','FontSize',11)
title('Equivalent Continuous-time System Damping Ratio  \zeta^{*} vs. \omega_{\rmn}\itT','FontSize',11)
text(0.035,0.088,'Trapezoidal Integration of 2nd Order System with \zeta = 0.1', 'FontSize',11)

figure(4)
wn=wnT/T;
plot(wn,wn_star)
xlabel('\omega_{\rmn}  (rad/sec)','FontSize',11)
ylabel('\omega_{\rmn}^{*}  (rad/sec)','FontSize',11)
title('Equivalent Continuous-time System Natural Frequency  \omega_{\rmn}^{*} vs. \omega_{\rmn}','FontSize',11)
text(0.5,9,'Trapezoidal Integration of 2nd Order System with \zeta = 0.1', 'FontSize',11)
text(0.5,8,'\itT \rm= 0.1 sec','FontSize',11)

%%%%% zeta=1
figure(5)
zeta=1;
T=0.1;
wnT=linspace(0,1,1000);
wnTsq=wnT.^2;
a=4*(1+zeta*wnT)+wnTsq;
b=2*(wnTsq-4);
c=4*(1-zeta*wnT)+wnTsq;
z=(-b+sqrt(b.^2-4*a.*c))./(2*a);
s_star=log(z)/T;
a_star=real(s_star);
b_star=imag(s_star);
wn_star=sqrt(a_star.^2 + b_star.^2);
zeta_star=-a_star./wn_star;
plot(wnT,zeta_star)
axis([0 1 0.99 1.01])
xlabel('\omega_{\rmn}\itT','FontSize',11)
ylabel('\zeta^{*}','FontSize',11)
title('Equivalent Continuous-time System Damping Ratio  \zeta^{*} vs. \omega_{\rmn}\itT','FontSize',11)
text(0.08,1.005,'Trapezoidal Integration of 2nd Order System with \zeta = 1', 'FontSize',11)

figure(6)
wn=wnT/T;
plot(wn,wn_star)
xlabel('\omega_{\rmn}  (rad/sec)','FontSize',11)
ylabel('\omega_{\rmn}^{*}  (rad/sec)','FontSize',11)
title('Equivalent Continuous-time System Natural Frequency  \omega_{\rmn}^{*} vs. \omega_{\rmn}','FontSize',11)
text(0.5,11,'Trapezoidal Integration of 2nd Order System with \zeta = 1', 'FontSize',11)
text(0.5,10,'\itT \rm= 0.1 sec','FontSize',11)