function w= RK4(tj,u_interp,w_old)
% RK4 integrates fast state w given
% tj current time
% interpolated slow state u_interp 
% current fast state w_old

global Tf theta_com_amp tau_com

theta_com=theta_com_amp*(1-exp(-tj/tau_com));  % compute input theta_com at tj
[k1f(1),k1f(2),k1f(3),k1f(4)]=deriv_fast(u_interp,w_old,theta_com);% compute k1 for fast states w1,w2,w3,w4
%k1f
theta_com=theta_com_amp*(1-exp(-(tj+0.5*Tf)/tau_com));  % compute input theta_com at tj+0.5*Tf
del=0.5*Tf; 
w_temp(1)=w_old(1)+k1f(1)*del; 
w_temp(2)=w_old(2)+k1f(2)*del; 
w_temp(3)=w_old(3)+k1f(3)*del; 
w_temp(4)=w_old(4)+k1f(4)*del;
%w_temp
[k2f(1),k2f(2),k2f(3),k2f(4)]=deriv_fast(u_interp,w_temp,theta_com); % compute k2 for fast states w1,w2,w3,w4
%k2f
w_temp(1)=w_old(1)+k2f(1)*del; 
w_temp(2)=w_old(2)+k2f(2)*del; 
w_temp(3)=w_old(3)+k2f(3)*del; 
w_temp(4)=w_old(4)+k2f(4)*del;
%w_temp
[k3f(1),k3f(2),k3f(3),k3f(4)]=deriv_fast(u_interp,w_temp,theta_com);  % compute k3 for fast states w1,w2,w3,w4
%k3f
theta_com=theta_com_amp*(1-exp(-(tj+Tf)/tau_com)); % compute input theta_com at tj+Tf 
w_temp(1)=w_old(1)+k3f(1)*Tf; 
w_temp(2)=w_old(2)+k3f(2)*Tf; 
w_temp(3)=w_old(3)+k3f(3)*Tf; 
w_temp(4)=w_old(4)+k3f(4)*Tf;
%w_temp
[k4f(1),k4f(2),k4f(3),k4f(4)]=deriv_fast(u_interp,w_temp,theta_com);  % compute k4 for fast states w1,w2,w3,w4
%k4f
w(1)=w_old(1)+(Tf/6)*(k1f(1)+2*k2f(1)+2*k3f(1)+k4f(1));  % update fast state w1
w(2)=w_old(2)+(Tf/6)*(k1f(2)+2*k2f(2)+2*k3f(2)+k4f(2));  % update fast state w1
w(3)=w_old(3)+(Tf/6)*(k1f(3)+2*k2f(3)+2*k3f(3)+k4f(3));  % update fast state w1
w(4)=w_old(4)+(Tf/6)*(k1f(4)+2*k2f(4)+2*k3f(4)+k4f(4));  % update fast state w1
%w

return